{ Example : parallel port command
  Command the parallel port and uses the very accuracy timer
  Can generate a frequency on the parallel port

  --------------------------------------------}
program tEx069;

// To tell FreePascal that the application is a Graphical User Interface
// i.e. is running in windows, not in text mode.
{$APPTYPE GUI}

Uses
  wApplication0
 ,wWindow0
 ,wDialog0
 ,wPopupWindow0
 ,wDialogCreatorLOW2
 ,wDialogCreator2
 ,wVariableNumLink2
 ,wWindowBase0
 ,wErrors0
 ,wGlobals2
 ,wDebug0
 ,Windows
 ,zlportio  // to access the parallel port or any other port
 ,wReadTime // to read time intervals with accuracy.
 ;

const
  id_D0_OFF   = 100;
  id_D0_ON    = 101;
  id_D1_OFF   = 110;
  id_D1_ON    = 111;
  id_GetSpeed = 201;
  idQUIT      = 999;

  wPortAdr = $378;  // choix entre : $278, $378, $3BC

var bPortState : byte;  // bits stats of the parallel port

type
  PMyDialog = ^TMyDialog;
  TMyDialog = object(TDialog)
  //"""""""""""""""""""""""""

  vXValue : Float;
  // the value shown in the edit box, must be different if we don't
  // want rounding errors to occure.

  fClearNext : boolean;
  // The next digit clears the avValue[1] and replaces it by the digit

  fAddNext : boolean;
  // The next digit push the stack up and
  //  clears the avValue[1] and replaces it by the digit

  vPeriode : Float;
  // If the periode has been pressed, indicate how many digits are after the
  // period.

  vMemory : Float;
  // A simple memory.

  dnFrequency : int64;  // Generator frequency in [milli-Hz]
  vFrequency  : Float;  // Frequency in [Hz]

  nFrequencyDelta : int32;
  // Frequency variation in [milli-Hz per second]

  nStateACK   : int32;  // read the ACK pin 10 state of the parallel port
  nStateBUSY  : int32;  // BUSY pin 11 state of the parallel port
  nStatePE    : int32;  // pin 12
  nStateSEL   : int32;  // pin 13
  nStateERR   : int32;  // pin 15

  vInFrequency  : Float;  // Frequency in [Hz] ridden from the BUSY pin 11
  vInPeriod     : Float;  // Period between two pulses from the BUSY pin 11

  constructor Init(poParentW:PWindowBase);

  procedure Start_Generator;
  // Start the generator of pulses to the D0 (pin 2) of the parallel port.
  // Used to generate a stroboscope

  procedure Inputs_Measure;
  // Measure the state of the five inputs of the parallel port

  procedure Frequency_Measure;
  // Measure the frequency on a signal.
  // In input is given through the BUSY pin 11 of the parallel port.

  function WMCommand(wPar:WPARAM; lPar:LPARAM):BOOL; virtual;
  // Handles the menu messages

  function DialogProc(hDialog:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  // Handles the dialog messages. See comments in  wDialog0.pp
  end; // TMyDialog = object(TDialog)

type
  PMyWindow = ^TMyWindow;
  TMyWindow = object(TWindow)
  //"""""""""""""""""""""""""
  constructor Init(strWinTitlePrm:ShortString);

  destructor Done; virtual;

  procedure WinCreate(strWinClass:ShortString); virtual;
  // When creating the window, we ask to show the dialog box, not the window

  procedure WMPaint; virtual;
  // the system want the program to repaint the client area.

  function WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  // Handles the menu messages

  function WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  end; // TMyWindow = object(TWindow)

var
  oApp        : TApplication;
  poMyMainWin : PMyWindow;

  glfStopGenerator : boolean;
  // The Start_Generator procedure loops, until one click in the dialog box to stop it

  glfStopMeasure : boolean;
  // Allow to stop the Measurement

  glvInPeriod     : Float;
  // Period between two pulses from the BUSY pin 11,  to be Displayed in big in the main window

procedure SWAP(var v1,v2:float);
//==============================
// Swaps the variables v1 and v2
var vTemp : float;
begin
vTemp:= v1;  v1:=v2;  v2:=vTemp;
end; // SWAP

function Select(var avNb:array of float; nLeft,nRight,nSel:integer):float;
//========================================================================
// From the array  avNb[nLeft..nRight], select the  nSel smallest value.
// The array must be defined as :  array[0.. any number] of float.  !!! the start  0  is important !!!
var vPivot : float;
var  nLL, nRR : integer;
begin
while (nRight > nLeft+1) do begin
  SWAP(avNb[(nLeft + nRight) div 2], avNb[nLeft+1]);
  if (avNb[nLeft  ] > avNb[nRight ]) then SWAP(avNb[nLeft  ], avNb[nRight ]);
  if (avNb[nLeft+1] > avNb[nRight ]) then SWAP(avNb[nLeft+1], avNb[nRight ]);
  if (avNb[nLeft  ] > avNb[nLeft+1]) then SWAP(avNb[nLeft  ], avNb[nLeft+1]);
  // here avNb[nLeft] <= <avNb[nLeft+1] <= avNb[nRight]

  nLL:=nLeft + 1;
  nRR:=nRight;
  vPivot:=avNb[nLL];
  while (nRR >= nLL) do begin
    repeat nLL:=nLL+1; until (avNb[nLL] >= vPivot);
    repeat nRR:=nRR-1; until (avNb[nRR] <= vPivot);
    if (nRR > nLL) then SWAP(avNb[nLL], avNb[nRR]);
    end; // while
  // Here  nRR < nLL   and   avNb[min..nLL] <= vPivot <= avNb[nRR..max]

  // vPivot:=abNb[nLeft+1];  already done,  thus we do a : SWAP(avNb[nLeft+1]), avNb[RR]);
  avNb[nLeft+1]:=avNb[nRR];
  avNb[nRR  ]:=vPivot;
  if (nRR >= nSel) then nRight:=nRR-1;
  if (nRR <= nSel) then nLeft:=nLL;
  end; // while

// Last check before returning the selected number.  Case of 2 elements.
if ((nRight = nLeft + 1) and (avNb[nRight] < avNb[nLeft])) then SWAP(avNb[nLeft], avNb[nRight]);

Select:=avNb[nSel];
end; // Select

function myCreateDialogObj(poParent:Pointer):Pointer;
//===================================================
var poObj : PMyDialog;
begin
new(poObj, Init(poParent));
myCreateDialogObj:=poObj;
end;  // myCreateDialogObj

//******************************************************************
// TMyDialog = object(TDialog)
//******************************************************************

constructor TMyDialog.Init(poParentW:PWindowBase);
//================================================
begin
// must be done, even if it seems useless.
inherited Init(poParentW);

vXValue:=0.0;
FloatField(100, vXValue);

fClearNext :=FALSE;
fAddNext   :=FALSE;
vPeriode   :=1; // no digits after the period.
vMemory    :=0;
glfStopGenerator :=true;  // When starting, the generator is not running
glfStopMeasure   := true; // No measurements are done at the beginning.
dnFrequency :=10000; // [mHz]

vFrequency:=dnFrequency / 1000.0;  // [Hz]
FloatField(900, vFrequency);

nFrequencyDelta:=0; // [mHz / s]
Int32Field(901, nFrequencyDelta);

// The five input bits of the parallel port
nStateACK:=0;
nStateBUSY:=0;
nStatePE:=0;
nStateSEL:=0;
nStateERR:=0;
Int32Field(910, nStateACK);
Int32Field(911, nStateBUSY);
Int32Field(912, nStatePE);
Int32Field(913, nStateSEL);
Int32Field(915, nStateERR);

vInFrequency :=1.0;  // Frequency in [Hz] ridden from the BUSY pin 11
vInPeriod    :=1.0;  // Period between two pulses from the BUSY pin 11
FloatField(921, vInFrequency);
FloatField(922, vInPeriod);
end;  // TMyDialog.Init

procedure Frequency_Generator_Symetric;
//=====================================
// Generate symetric pulses on the Do (pin 2) parallel port
// The frequency is given in a dialog box
var
  dnTickStart,  // number of computer ticks since it started
  dnTickLast   // number of computer ticks since it started
           : int64;
//  dwTimeStart_ms,  // time [ms] when the frequency Generator started
//  dwTimeStartNS,   // time [ns] when the frequency Generator started
  dwTimeElapsedNS  // time [ns] elapsed since last "dnTick1:=cpugettick;"
           : word32;
  nD0State       // State of the D0 (pin 2) parallel port output. Either 0 or 1.
           : integer;
  bPortState : byte;  // bits stats of the parallel port

begin
dnTickStart:=cpugettick;  // get number of CPU clock since computer started
//dwTimeStartNS:=cpugetNS(dnTick1); // time in nano seconds  ~=  0 [ns]
//dwTimeStart_ms:=cpugetms(dnTick1); // time in milli seconds ~= 0 [ms]

nD0State:=0;    // Initial D0 state
bPortState:=0;  // Initial port state

// Sets D0 to 0
bPortState:=bPortState and ($FF - $01);
portwriteb(wPortAdr, bPortState);
DBW(0, 'Start');

repeat
  dnTickLast:=cpugettick;  // get number of CPU clock since computer started

  // wait half a periode to change the D0 state
  repeat
    dwTimeElapsedNS:=cpugetNS(dnTickLast); // get time since last cpugettick
    until (dwTimeElapsedNS > 15*1000000);

    // change the D0 state
    if (nD0State = 0) then begin
      // Sets D0 to 1
      bPortState:=bPortState or $01;
      portwriteb(wPortAdr, bPortState);
      nD0State:=1;
//      DBW(0, 'Set to 1');
      end
    else begin
      // Sets D0 to 0
      bPortState:=bPortState and ($FF - $01);
      portwriteb(wPortAdr, bPortState);
      nD0State:=0;
//      DBW(0, 'Set to 0');
      end;

  // stops after the given time in milliseconds
  until (cpugetms(dnTickStart) > 5000);

// End with D0 set to 0
bPortState:=bPortState and ($FF - $01);
portwriteb(wPortAdr, bPortState);

DBW(0, 'Finished');
end;  // Frequency_Generator_Symetric

procedure Frequency_Generator;
//============================
var
  dnTickStart,  // number of computer ticks since it started
  dnTickLast   // number of computer ticks since it started
           : int64;
  dwTimeElapsedNS  // time [ns] elapsed since last "dnTick1:=cpugettick;"
           : word32;
  bPortState : byte;  // bits stats of the parallel port

begin
dnTickStart:=cpugettick;  // get number of CPU clock since computer started

bPortState:=0;  // Initial port state

DBW(0, 'Start');

repeat
  dnTickLast:=cpugettick;  // get number of CPU clock since computer started

  // Sets D0 to 1
  bPortState:=bPortState or $01;
  portwriteb(wPortAdr, bPortState);

  // wait 0.5 ms before setting D0 to 0 again
  repeat
    dwTimeElapsedNS:=cpugetNS(dnTickLast); // get time since last cpugettick
    until (dwTimeElapsedNS > 500000);

  // Sets D0 to 0
  bPortState:=bPortState and ($FF - $01);
  portwriteb(wPortAdr, bPortState);
  // DBW(0, 'Set to 0');

  // wait a periode before setting D0 to 1 again
  repeat
    dwTimeElapsedNS:=cpugetNS(dnTickLast); // get time since last cpugettick
    until (dwTimeElapsedNS > 20*1000000);

  // stops after the given time in milliseconds
  until (cpugetms(dnTickStart) > 6000);

// End with D0 set to 0
bPortState:=bPortState and ($FF - $01);
portwriteb(wPortAdr, bPortState);

DBW(0, 'Finished');
end;  // Frequency_Generator

procedure TMyDialog.Start_Generator;
//==================================
var
  rMessage    : Msg;
  dnOneBillion,  // = 1000'000'000'000
  dnTickStart,   // number of computer ticks since it started
  dnTickLast     // number of computer ticks since it started
           : int64;
//  dwTimeStart_ms,  // time [ms] when the frequency Generator started
//  dwTimeStartNS,   // time [ns] when the frequency Generator started
  dwTimeUpdate_ms,   // to update the frequency every regular time
  dwTimeElapsedNS  // time [ns] elapsed since last "dnTick1:=cpugettick;"
           : word32;
  bPortState : byte;  // bits stats of the parallel port
  dn : int32; // to avoid a problem

begin
dnOneBillion:=1000000000000;

// Start with the given frequency.
dnFrequency:=round(vFrequency * 1000.0);  // [mHz]
if (dnFrequency < 250) then dnFrequency:=1000;
vFrequency:=dnFrequency / 1000.0;  // [Hz]
UpdateFromVar; // update the dialog box

dnTickStart:=cpugettick;  // get number of CPU clock since computer started
//dnTickStart:=dnTickStart;  // to avoid a warning while compiling

// will stop the generator when asked by the user setting this variable to true.
glfStopGenerator:=false;

bPortState:=0;  // Initial port state

DBW(0, 'Start');

// Let the dialog box being redrawn
while (PeekMessage(@rMessage, 0, // any messages for this application
                    0, 0,         // Let the dialog box being updated
                    PM_REMOVE))   // remove the message from the queue
                    do begin
  TranslateMessage(rMessage);
//      DBW(0, ITS(rMessage.message) + '  ' + ITS(LoWord(rMessage.wParam)) + '  ' + ITS(HiWord(rMessage.wParam)) + '  ' + ITS(LoWord(rMessage.lParam)) + '  ' + ITS(HiWord(rMessage.lParam)) + '  ' + ITS(rMessage.hwnd));
  DispatchMessage(rMessage);
  end;

dwTimeUpdate_ms:=100;  // time when the frequency update has to be done

repeat
  dnTickLast:=cpugettick;  // get number of CPU clock since computer started

  // Sets D0 to 1
  bPortState:=bPortState or $01;
  portwriteb(wPortAdr, bPortState);

  // wait 0.5 ms before setting D0 to 0 again
  repeat
    dwTimeElapsedNS:=cpugetNS(dnTickLast); // get time since last cpugettick
    until (dwTimeElapsedNS > 500000);

  // Sets D0 to 0
  bPortState:=bPortState and ($FF - $01);
  portwriteb(wPortAdr, bPortState);
//  DBW(0, 'Set to 0');

  // Every second, change the frequency
  if (cpugetms(dnTickStart) > dwTimeUpdate_ms) then begin
    dwTimeUpdate_ms:=dwTimeUpdate_ms + 100;
    dn:=nFrequencyDelta div 10;
    dnFrequency:=dnFrequency + int64(dn);

    if (dnFrequency < 250) then dnFrequency:=250; // minimal frequency

    vFrequency:=dnFrequency / 1000.0;  // [Hz]
    UpdateFromVar; // update the dialog box

    while (PeekMessage(@rMessage, 0, // any messages for this application
                    0, 0,         // Let the dialog box being updated
                    PM_REMOVE))   // remove the message from the queue
                    do begin
      TranslateMessage(rMessage);
      // DBW(0, ITS(rMessage.message) + '  ' + ITS(LoWord(rMessage.wParam)) + '  ' + ITS(HiWord(rMessage.wParam)) + '  ' + ITS(LoWord(rMessage.lParam)) + '  ' + ITS(HiWord(rMessage.lParam)) + '  ' + ITS(rMessage.hwnd));
      DispatchMessage(rMessage);
      end; // while

    end; // if

  // wait a periode before setting D0 to 1 again
  repeat
    // let Windows messages be treated
    if (PeekMessage(@rMessage, 0, // any messages for this application
                    WM_MOUSEFIRST+1, WM_MOUSELAST, // only mouse messages, without WWM_MouseMove
                    PM_REMOVE))   // remove the message from the queue
                    then begin
      TranslateMessage(rMessage);
//      DBW(0, ITS(rMessage.message) + '  ' + ITS(LoWord(rMessage.wParam)) + '  ' + ITS(HiWord(rMessage.wParam)) + '  ' + ITS(LoWord(rMessage.lParam)) + '  ' + ITS(HiWord(rMessage.lParam)) + '  ' + ITS(rMessage.hwnd));
      DispatchMessage(rMessage);
      end;

    dwTimeElapsedNS:=cpugetNS(dnTickLast); // get time since last cpugettick
    until (dwTimeElapsedNS > dword(dnOneBillion div dnFrequency));

  // stops when the user clicked on the STOP button.
  until glfStopGenerator; // or (cpugetms(dnTickStart) > 30000);

// End with D0 set to 0
bPortState:=bPortState and ($FF - $01);
portwriteb(wPortAdr, bPortState);

DBW(0, 'Finished');
glfStopGenerator:=true;  // Generator stoped
end;  // TMyDialog.Start_Generator

procedure TMyDialog.Inputs_Measure;
//====================================
// Measure the state of the five inputs of the parallel port
var
  rMessage    : Msg;
  dnTickStart,   // number of computer ticks since it started
  dnTickLast     // number of computer ticks since it started
           : int64;
  dwTimeElapsedNS  // time [ns] elapsed since last "dnTick1:=cpugettick;"
           : word32;
  bPortState : byte;  // bits stats of the parallel port

begin
// default values at the beginning
nStateACK   :=0;
nStateBUSY  :=0;
nStatePE    :=0;
nStateSEL   :=0;
nStateERR   :=0;

UpdateFromVar; // update the dialog box

dnTickStart:=cpugettick;  // get number of CPU clock since computer started
dnTickStart:=dnTickStart;  // to avoid a warning while compiling

// will stop the measurements when asked by the user setting this variable to true.
glfStopMeasure:=false;

//DBW(0, 'Start');

repeat
  dnTickLast:=cpugettick;  // get number of CPU clock since computer started

  // Read the Status the parallel port
  // ACK pin 10, Busy pin 11, PE pin 12, SEL pin 13,
  // Err pin 15  are INPUTS
  bPortState:=portreadb(wPortAdr+1);
  if ((bPortState and $40) = 0) then nStateACK:=0  else nStateACK:=1;  // pin 10
  if ((bPortState and $80) = 0) then nStateBUSY:=1 else nStateBUSY:=0; // pin 11  inverted
  if ((bPortState and $20) = 0) then nStatePE:=0   else nStatePE:=1;   // pin 12
  if ((bPortState and $10) = 0) then nStateSEL:=0  else nStateSEL:=1;  // pin 13
  if ((bPortState and $08) = 0) then nStateERR:=0  else nStateERR:=1;  // pin 15

  UpdateFromVar; // update the dialog box

  while (PeekMessage(@rMessage, 0, // any messages for this application
                    0, 0,         // Let the dialog box being updated
                    PM_REMOVE))   // remove the message from the queue
                    do begin
    TranslateMessage(rMessage);
    // DBW(0, ITS(rMessage.message) + '  ' + ITS(LoWord(rMessage.wParam)) + '  ' + ITS(HiWord(rMessage.wParam)) + '  ' + ITS(LoWord(rMessage.lParam)) + '  ' + ITS(HiWord(rMessage.lParam)) + '  ' + ITS(rMessage.hwnd));
    DispatchMessage(rMessage);
    end; // while

  // wait a while before updating the dialog box state
  repeat
    // let Windows messages be treated
    if (PeekMessage(@rMessage, 0, // any messages for this application
                    WM_MOUSEFIRST+1, WM_MOUSELAST, // only mouse messages, without WWM_MouseMove
                    PM_REMOVE))   // remove the message from the queue
                    then begin
      TranslateMessage(rMessage);
//      DBW(0, ITS(rMessage.message) + '  ' + ITS(LoWord(rMessage.wParam)) + '  ' + ITS(HiWord(rMessage.wParam)) + '  ' + ITS(LoWord(rMessage.lParam)) + '  ' + ITS(HiWord(rMessage.lParam)) + '  ' + ITS(rMessage.hwnd));
      DispatchMessage(rMessage);
      end;

    dwTimeElapsedNS:=cpugetNS(dnTickLast); // get time since last cpugettick
    until (dwTimeElapsedNS > 100000000);

  // stops when the user clicked on the STOP button.
  until glfStopMeasure; // or (cpugetms(dnTickStart) > 10000);

//DBW(0, 'Finished');
glfStopMeasure:=true;  // Measurements stopped
PostMessage(hWin, WM_Close, 0, 0);
end;  // TMyDialog.Inputs_Measure

procedure TMyDialog.Frequency_Measure;
//====================================
// Measure the frequency on a signal.
// In input is given through the ERR pin 15 of the parallel port.
var
  rMessage    : Msg;
  dnTickStart,   // number of computer ticks since it started
  dnTickLast,    // number of computer ticks since it started
  dnTickBeg,     // to measure the time between two changes of the ERR state
  dnTickWait     // to wait a short time
           : int64;
//  dwTimeStart_ms,  // time [ms] when the frequency Generator started
//  dwTimeStartNS,   // time [ns] when the frequency Generator started
  dwTimeIntervall_ns,   // time between two ERR state changes in [ns]
  dwTimeElapsedNS  // time [ns] elapsed since last "dnTick1:=cpugettick;"
           : word32;
  bState1,
  bState2
             : byte;  // bits stats of the parallel port
  avTime : array[0..1000] of float;  // all the time measured during 1/2 second
  nCount : integer;  // Count the number of time measured
  rRec        : RECT;

begin
dnTickStart:=cpugettick;  // get number of CPU clock since computer started
dnTickStart:=dnTickStart;  // to avoid a warning while compiling

// will stop the measurements when asked by the user setting this variable to true.
glfStopMeasure:=false;

//DBW(0, 'Start');

// Read the Status the parallel port from the ERR pin 15
bState1:=PORTREADB(wPortAdr+1) and $08;
dnTickBeg:=cpugettick;
dwTimeIntervall_ns:=4000000000;  // if no changes occured

repeat
  dnTickLast:=cpugettick;  // get number of CPU clock since computer started
  dwTimeIntervall_ns:=4000000000;  // if no changes occured
  nCount:=0;

  // Reading the ERR input to measure the time between two changes
  // Loop duting 1/2 second
  repeat
    // Read the Status the parallel port from the ERR pin 15
    bState2:=portreadb(wPortAdr+1) and $08;

    if (bState2 <> 0) then bState1 := 1; // A state change occured

    if (bState1 = 1) and (bState2 = 0) then begin
       // ERR state changed from 1 to 0
      dwTimeIntervall_ns:=cpugetNS(dnTickBeg);  // time in [ns] between the previous state at 0.
      dnTickBeg:=cpugettick;
      bState1 := 0;

      // Memorise this time period
      if (nCount < 1000) then nCount:=nCount+1;
      avTime[nCount]:=dwTimeIntervall_ns / 1000000.0; // in [ms]

      // PROBABLY USELESS !!!   OR should be done in the  if (bState2 <> 0) ...
      // wait 1 [ms] to avoid pulses which are too near
      repeat
        dwTimeElapsedNS:=cpugetNS(dnTickBeg);
        until (dwTimeElapsedNS > 1000000);

      end; // if

    // PROBABLY USELESS !!!
    // wait 2 [micro seconds] to let time between two port read
    dnTickWait:=cpugettick;
    repeat
      dwTimeElapsedNS:=cpugetNS(dnTickWait);
      until (dwTimeElapsedNS > 2000);

    dwTimeElapsedNS:=cpugetNS(dnTickLast); // get time since last cpugettick
    until (dwTimeElapsedNS > 500000000);

  // Select the median Period measured
  if (nCount = 0) then vInPeriod:=4000 // [ms]
  else vInPeriod:=Select(avTime, 1, nCount, (nCount + 1) div 2);

  // to display in the dialog box the period and the frequency
  if (vInPeriod = 0) then vInPeriod:=1000000.0;  // security
  vInFrequency :=1000.0 / vInPeriod;

  UpdateFromVar; // update the dialog box

  // To force the main window to be redrawn
//  glvInPeriod:=glvInPeriod + 1.123; // POUR LES TESTS
  glvInPeriod:=vInPeriod;
  GetClientRect(gglpoMainWindow^.hWin, @rRec);
  InvalidateRect(gglpoMainWindow^.hWin, rRec, TRUE);

  while (PeekMessage(@rMessage, 0, // any messages for this application
                    0, 0,         // Let the dialog box being updated
                    PM_REMOVE))   // remove the message from the queue
                    do begin
    TranslateMessage(rMessage);
    // DBW(0, ITS(rMessage.message) + '  ' + ITS(LoWord(rMessage.wParam)) + '  ' + ITS(HiWord(rMessage.wParam)) + '  ' + ITS(LoWord(rMessage.lParam)) + '  ' + ITS(HiWord(rMessage.lParam)) + '  ' + ITS(rMessage.hwnd));
    DispatchMessage(rMessage);
    end; // while

  // stops when the user clicked on the STOP button.
  until glfStopMeasure; // or (cpugetms(dnTickStart) > 10000);

//DBW(0, 'Finished');
glfStopMeasure:=true;  // Measurements stopped
PostMessage(hWin, WM_Close, 0, 0);
end;  // TMyDialog.Frequency_Measure

function TMyDialog.WMCommand(wPar:WPARAM; lPar:LPARAM):BOOL;
//==========================================================
// Handles the menu messages
var
  rMessage    : Msg;
  wCtrlID     : word32;
  wSpeed,
  wCpt        : word32;
  dnTick1, dnTick2  // to read the time
              : int64;
  dwTimeNS  // elapsed time in nano seconds
              : dword;
  pDial       : PWindowBase;  // Pointer on a new dialog box

  nn : integer;
  wPort : word;
  bT1, bT2, bSaveIt : byte;

begin
{
if (HiWord(wPar) <> EN_UPDATE) and (HiWord(wPar) <> EN_CHANGE) then
  DBW(0, 'WMCommand=' + DBNotifToStr(HiWord(wPar)) + ITS5(LoWord(wPar)));
}
if (HiWord(wPar) <> BN_CLICKED) then begin
   WMCommand:=inherited WMCommand(wPar, lPar);
   exit;
   end;
wCtrlID:=LoWord(wPar);

// do only accept the Message to stop the Generator if it is not running
if ((not glfStopGenerator) and (wCtrlID < 1010)) then exit;

//MessageBeep(0);

//DBW(1, 'Button clicked=' + ITS(poBtn^.wCtrlID));

// Ground are pins 18 to 25 on a 25 pins connector.

// test the presence of a parallel port :
if (wCtrlID = id_D0_OFF) then begin
  for nn:=1 to 4 do begin
    if (nn = 1) then wPort:=$278;
    if (nn = 2) then wPort:=$378;
    if (nn = 3) then wPort:=$3BC;
    if (nn = 4) then wPort:=$2BC;
    bSaveIt:=PortReadb(wPort);
    PortWriteb(wPort, $ff);
    bT1:=PortReadb(wPort);
    DBW(0, 'Port=' + ITS5(wPort) + ' 255 = ' + ITS(bT1));
    PortWriteb(wPort, $00);
    bT2:=PortReadb(wPort);
    DBW(0, 'Port=' + ITS5(wPort) + ' 000 = ' + ITS(bT2));
    PortWriteb(wPort, bSaveIt);
    end;
  end;


// sets output D0 to 0 [V]  (pin 2)
if (wCtrlID = id_D0_OFF) then begin
   DBW(0, 'set D0 to off');
   bPortState:=bPortState and ($FF - $01);
   portwriteb(wPortAdr, bPortState);
   end;

// sets output D0 to more than 2 [V] (pin 2)
if (wCtrlID = id_D0_ON) then begin
   DBW(0, 'set D0 to on');
   bPortState:=bPortState or $01;
   portwriteb(wPortAdr, bPortState);
   end;

// sets output D1 to 0 [V] (pin 3)
if (wCtrlID = id_D1_OFF) then begin
   DBW(0, 'set D1 to off');
   bPortState:=bPortState and ($FF - $02);
   portwriteb(wPortAdr, bPortState);
   end;

// sets output D1 to more than 2 [V] (pin 3)
if (wCtrlID = id_D1_ON) then begin
   DBW(0, 'set D1 to on');
   bPortState:=bPortState or $02;
   portwriteb(wPortAdr, bPortState);
   end;

// Test the accuracy timer to measure the time.
if (wCtrlID = id_GetSpeed) then begin
   wCpt:=0;

   // CPU frequency in MHz
   wSpeed:=CPUGetSpeed;
   DBW(0, 'CPU Frequency in MHz = ' + WTS(wSpeed));
   DBW(0, 'CPU time periode in ns = ' + FTS(_1CPUFrequencyNS));

   dnTick1:=cpugettick;  // get number of CPU clock since computer started
   for wCpt:=1 to 10000 do begin wSpeed:=wSpeed; end;  // loose some time

   dnTick2:=cpugettick;  // get number of CPU clock since computer started
   dwTimeNS:=cpugetNS(dnTick1); // get elapsed time in nano seconds


   DBW(0, 'Number of CPU clock =' + WTS(dnTick2) + ' - ' + WTS(dnTick1) + ' = ' +  WTS(dnTick2 - dnTick1));
   DBW(0, 'Delta time [ns] =' + WTS(dwTimeNS-37) + ' ~= ' + FTS((dnTick2 - dnTick1)*_1CPUFrequencyNS));
   end;

// Generate a frequency on D0 (pin 2) of the parallel port.
if (wCtrlID = 301) then Frequency_Generator;

// Open a new modeless dialog box to control the frequency
if (wCtrlID = 401) then DialogCreateMSG(11299, @Self);

// Open a new modeless dialog box to measure the inputs of the parallel port
if (wCtrlID = 411) then begin
  pDial:=DialogCreateMSG(11399, @Self);
  PostMessage(pDial^.hWin, WM_Command, 1011, 0);  // Inputs_Measure; is started
  end;

// Open a new modeless dialog box to measure the frequency of a signal
if (wCtrlID = 412) then begin
  pDial:=DialogCreateMSG(11499, @Self);
  PostMessage(pDial^.hWin, WM_Command, 1012, 0);  // Frequency_Measure; is started
  end;

// Start generating pulses
if (wCtrlID = 1001) then Start_Generator;

// Stop generating pulses
if (wCtrlID = 1010) then begin
  glfStopGenerator:=true;
  DBW(0, 'STOPPING');
  end;

// Start the measurements of the inputs of the parallel port
if (wCtrlID = 1011) then Inputs_Measure;

// Start the measurements of the frequency from the parallel port
if (wCtrlID = 1012) then Frequency_Measure;

// Stop the measurements
if (wCtrlID = 1019) then begin
  glfStopMeasure:=true;
//  PostMessage(hWin, WM_Close, 0, 0);
  end;

// Frequency variation in [mili-Hz per second]
if (wCtrlID = 4001) then nFrequencyDelta:=nFrequencyDelta +    1;
if (wCtrlID = 4005) then nFrequencyDelta:=nFrequencyDelta +   10;
if (wCtrlID = 5001) then nFrequencyDelta:=nFrequencyDelta -    1;
if (wCtrlID = 5005) then nFrequencyDelta:=nFrequencyDelta -   10;

// Frequency in [milli-Hz]
if (wCtrlID = 2001) then dnFrequency:=dnFrequency +    10;
if (wCtrlID = 2005) then dnFrequency:=dnFrequency +   100;
if (wCtrlID = 2010) then dnFrequency:=dnFrequency +  1000;
if (wCtrlID = 2020) then dnFrequency:=dnFrequency + 10000;
if (wCtrlID = 3001) then dnFrequency:=dnFrequency -    10;
if (wCtrlID = 3005) then dnFrequency:=dnFrequency -   100;
if (wCtrlID = 3010) then dnFrequency:=dnFrequency -  1000;
if (wCtrlID = 3020) then dnFrequency:=dnFrequency - 10000;
if (dnFrequency < 250) then dnFrequency:=250; // minimal frequency
//if (dnFrequency > 10000000) then dnFrequency:=10000000; // maximal frequency

vFrequency:=dnFrequency / 1000.0;  // [Hz]
UpdateFromVar; // update the dialog box

while (PeekMessage(@rMessage, 0, // any messages for this application
                    0, 0,         // Let the dialog box being updated
                    PM_REMOVE))   // remove the message from the queue
                    do begin
  TranslateMessage(rMessage);
//      DBW(0, ITS(rMessage.message) + '  ' + ITS(LoWord(rMessage.wParam)) + '  ' + ITS(HiWord(rMessage.wParam)) + '  ' + ITS(LoWord(rMessage.lParam)) + '  ' + ITS(HiWord(rMessage.lParam)) + '  ' + ITS(rMessage.hwnd));
  DispatchMessage(rMessage);
  end;

// Did we click on the quit button ?
// Close the main window, thus quit the application.
if (wCtrlID = idQUIT) then begin
  // Quit the programme if no measurements are in progress.
  if (glfStopGenerator and glfStopMeasure) then PostMessage(poMyMainWin^.hWin, WM_CLOSE, 0, 0);
  glfStopGenerator:=true;
  glfStopMeasure:=true;
  exit;
  end;

WMCommand:=inherited WMCommand(wPar, lPar);
end;  // TMyDialog.WMCommand

function TMyDialog.DialogProc(hDialog:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT;
//======================================================================================
// Accept the  WM_CLOSE  message, only if no measurements are in action.
begin
{
if (wMsg <> WM_COMMAND) and
   (wMsg <> WM_MOUSEMOVE) and
   (wMsg <> WM_MOVE) and
   (wMsg <> WM_NCCALCSIZE) and
//   (wMsg <> WM_WINDOWPOSCHANGE) and
   (wMsg <> WM_NCHITTEST) and
   (wMsg <> WM_ACTIVATEAPP) and
   (wMsg <> WM_ACTIVATE) and
   (wMsg <> 674) and
   (wMsg <> WM_CTLCOLORBTN) and
   (wMsg <> WM_NCACTIVATE) and
   (wMsg <> WM_GETICON) and
   (wMsg <> WM_SETTEXT) and
   (wMsg <> 70) and  // WM_WINDOWPOSCHANGING
   (wMsg <> WM_INITDIALOG) and
   (wMsg <> WM_NCPAINT) and
   (wMsg <> WM_WINDOWPOSCHANGED) and
   (wMsg <> WM_SIZE) and
   (wMsg <> WM_GETTEXT) and
   (wMsg <> WM_PARENTNOTIFY) and
   (wMsg <> WM_STYLECHANGING) and
   (wMsg <> WM_STYLECHANGED) and
   (wMsg <> WM_SHOWWINDOW) and
   (wMsg <> WM_ERASEBKGND) and
   (wMsg <> WM_CTLCOLORDLG) and
   (wMsg <> WM_PAINT) and
   (wMsg <> 295) and
   (wMsg <> WM_CTLCOLOREDIT) and
   (wMsg <> WM_NCMOUSEMOVE) and
   (wMsg <> WM_MOUSEACTIVATE) and
   (wMsg <> WM_PSD_PAGESETUPDLG) and
   (wMsg <> 296) and
   (wMsg <> 174) and
   (wMsg <> 136) and
   (wMsg <> WM_SYSCOMMAND) and
   (wMsg <> WM_CAPTURECHANGED) and
   (wMsg <> WM_SETCURSOR) then Begin
  DBW(0, 'Proc=' + DBMsgToStr(wMsg) + ITS5(HiWord(wPar)) + ITS5(LoWord(wPar)));
  end;
}
Case wMsg Of
   WM_Close   : if ((not glfStopGenerator) or (not glfStopMeasure)) then begin
                   // Do not procede the Close message if measurements are in progress.
                   // But stop the measurements, which will generate a WM_CLOSE
                   glfStopGenerator:=true;
                   glfStopMeasure:=true;
                   exit;
                   end;
   End; // Case wMsg Of

DialogProc:=inherited DialogProc(hDialog, wMsg, wPar, lPar);
end;  // TMyDialog.DialogProc

//******************************************************************
// TMyWindow = object(TWindow)
//******************************************************************

constructor TMyWindow.Init(strWinTitlePrm:ShortString);
//=====================================================
begin
inherited Init(strWinTitlePrm);
bPortState:=0;
glvInPeriod:=0;
end;  // TMyWindow.Init

destructor TMyWindow.Done;
//========================
begin
glfStopGenerator:=true;
glfStopMeasure:=true;

inherited Done;
end;

procedure TMyWindow.WinCreate(strWinClass:ShortString);
//=====================================================
//var strName : string[50];
Begin
// We don't want to see the main window
//wSizeState := SIZE_MINIMIZED;

inherited WinCreate(strWinClass);

// Here calling :  DialogExecMSG(11199, @Self);  doesn't work,
// But posting a message to open the dialog box at startup is possible.
// Opens also the help window, indicating the key action.
//PostMessage(hWin, WM_COMMAND, 121, 0);
PostMessage(hWin, WM_COMMAND, 101, 0);

//strName:='zlportio' + char(0);
//DBW(0, 'result= ' + ITS(driverstart(@strName[1])));

end;  // TMyWindow.WinCreate

procedure TMyWindow.WMPaint;
//==========================
Var
  hDcPaint    : hdc;
  rPS         : paintstruct;

// shows some character fonts.
var
  strS        : string[80];
  rLogFont    : TLogFont;
  hFontNew1,  // four style of font, for normal, bold and italic.
  hFontOld    : HFONT;
  astrFont    : array[1..4] of string[30];
  vFrequency  : Float;
  vRPM        : Float; // Round Per Minute

begin
// Get a device context.
// Here we have a facility, during the WMPaint, we must always
// begin with  "BeginPaint", which gives a Device Context to paint, and
// end with "EndPaint", to tell that the painting is done.
hDcPaint:=BeginPaint(hWin, @rPS);
// fonts to be used :
astrFont[1]:='Arial';
astrFont[2]:='Times New Roman';
astrFont[3]:='Courier New';
astrFont[4]:='Comic Sans MS';  // if you have it.

// define a new font.
strS:=astrFont[1]+#0;
with rLogFont do  begin
   lfHeight         := 0;                // Default logical height of font
   lfWidth          := 0;                // Default logical average character width
   lfEscapement     := 0;                // angle of escapement
   lfOrientation    := 0;                // base-line orientation angle
   lfWeight         := FW_NORMAL;        // font weight = 400
   lfItalic         := 0;                // italic attribute flag
   lfUnderline      := 0;                // underline attribute flag
   lfStrikeOut      := 0;                // strikeout attribute flag
   lfCharSet        := DEFAULT_CHARSET;  // character set identifier
   lfOutPrecision   := OUT_DEFAULT_PRECIS;  // output precision
   lfClipPrecision  := CLIP_DEFAULT_PRECIS; // clipping precision
   lfQuality        := DEFAULT_QUALITY;     // output quality
   lfPitchAndFamily := DEFAULT_PITCH;    // pitch and family
   lfFaceName       :=PCHAR(@strS[1]);         // pointer to typeface name string
   end; // with

// creates the new Font.
// CreateFont(...) could also be used.
rLogFont.lfWeight:=700; // bold, could go up to 1000 for very bold
rLogFont.lfHeight:=-36;
hFontNew1 := CreateFontIndirect(@rLogFont);

// If you want to draw text in the selected font.
hFontOld:=SelectObject(hDcPaint, hFontNew1);
strS:='Period = ' + FloatToStr(glvInPeriod,8,3) + ' [ms]';
TextOut(hDcPaint, 10, 10, @strS[1], length(strS));

if (glvInPeriod <> 0) then vFrequency:=1000.0 / glvInPeriod else vFrequency:=0;
strS:='Frequency = ' + FloatToStr(vFrequency,8,3) + ' [Hz]';
TextOut(hDcPaint, 10, 70, @strS[1], length(strS));

vRPM:=60*vFrequency;
strS:='Round per Minute = ' + FloatToStr(vRPM,9,2);
TextOut(hDcPaint, 10, 130, @strS[1], length(strS));

// As always, you must select the original font, the delete
// the created "objects" to free resources.
SelectObject(hDcPaint, hFontOld);
DeleteObject(hFontNew1);

EndPaint(hWin, rPS);
end;  // TMyWindow.WMPaint

function TMyWindow.WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT;
//=============================================================
// There are no menus treatment, only one dialog box
begin
// Execute the dialog box at starting
if (lPar = 0) and (wPar =101) then DialogCreateMSG(11199, @Self);
//if (lPar = 0) and (wPar =121) then DialogCreateMSG(21199, @Self);

// Accelerators act as button click.
// Send the command to the active dialog
case LoWord(wPar) of
  idQUIT
          : if (gglpoActiveDialog <> NIL) then
               gglpoActiveDialog^.WMCommand(LoWord(wPar), 0);

  end; // case

WMCommand:=inherited WMCommand(wPar, lPar);
end;  // TMyWindow.WMCommand

function TMyWindow.WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT;
//=======================================================================================
// All window messages are send here.
Begin
WindowProc := 0; // Default return value when processing a message

Case wMsg Of
   WM_Paint   : WMPaint; // must redraw the client area part.
   WM_Command : WindowProc:=WMCommand(wPar, lPar);
   else begin // Case wMsg Of
      // Default processing of the messages.
      WindowProc:=inherited WindowProc(hWindow, wMsg, wPar, lPar);
      end; // Case wMsg Of
   End; // Case wMsg Of

End;  // TMyWindow.WindowProc

//**********************************************************************
Begin // MAIN ******
// Assign the pointer on the function which will create the dialog.
// It is used by the library. So the library will construct
// a user defined object.
gglfnCreateDialogObj:=@myCreateDialogObj;

// Name under which the main window is registered. Spaces are not allowed
oApp.Init('Example069');

// Creation of the main window
new(poMyMainWin, Init('tEx069_Parallel_port_command.pp'));

// The App.WindowClass can be modified here, if wanted. (Not usual)
oApp.Run;
oApp.Done;  // The main window object is disposed here.
End.


{
AUTRE : //procedure Out32(PortAddress:smallint; Value:smallint); external 'InpOut32' name 'Out32';


type
  TInp32 = function(PortAddress: SmallInt): SmallInt; stdcall;
  TOut32 = procedure(PortAddress: SmallInt; Data: SmallInt); stdcall;

var
    hInpout32: THandle;
    Inp32: TInp32;
    Out32: TOut32;


DANS le INIT :
hInpout32 := LoadLibrary('inpout32.dll');
if (hInpout32 <> 0) then begin
   // needs overtyping, plain Delphi's @Inp32 = GetProc... leads to compile errors
   Inp32 := TInp32(GetProcAddress(hInpout32, 'Inp32'));
   if (@Inp32 = nil) then DBW(0, 'Error for Inp32');

   Out32 := TOut32(GetProcAddress(hInpout32, 'Out32'));
   if (@Out32 = nil) then DBW(0, 'Error for Out32');
  end
  else DBW(0, 'Error loading the inpout32 dll');


Dans le done : FreeLibrary(hInpout32);
}
