{ Uses the PCS10 "4 channel signal recorder" from Velleman do detect a signal
  in one of a list of many detectors.
  The files FASTTIME32.DLL, K8047D.DLL and K8047E.EXE
  must be located in the program file folder or in the Windows' SYSTEM32 folder.
  --------------------------------------------}
program tEx071;

// To tell FreePascal that the application is a Graphical User Interface
// i.e. is running in windows, not in text mode.
{$APPTYPE GUI}

Uses
  wApplication0
 ,wWindowText0
 ,wWindow0
 ,wDialog0
 ,wPopupWindow0
 ,wDialogCreatorLOW2
 ,wDialogCreator2
 ,wVariableNumLink2
 ,wWindowBase0
 ,wErrors0
 ,wGlobals2
 ,wDebug0
 ,Windows
 ,Strings
 ,wReadTime // to read time intervals with accuracy.
 ;

const
  idQUIT      = 999;

type
  PMyDialog = ^TMyDialog;
  TMyDialog = object(TDialog)
  //"""""""""""""""""""""""""

  vXValue : Float;
  // the value shown in the edit box, must be different if we don't
  // want rounding errors to occure.

  fClearNext : boolean;
  // The next digit clears the avValue[1] and replaces it by the digit

  fAddNext : boolean;
  // The next digit push the stack up and
  //  clears the avValue[1] and replaces it by the digit

  vPeriode : Float;
  // If the periode has been pressed, indicate how many digits are after the
  // period.

  vMemory : Float;
  // A simple memory.

  constructor Init(poParentW:PWindowBase);

  function WMCommand(wPar:WPARAM; lPar:LPARAM):BOOL; virtual;
  // Handles the menu messages

//  function DialogProc(hDialog:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
    // Not used
  // Handles the dialog messages. See comments in  wDialog0.pp
  end; // TMyDialog = object(TDialog)

type
  PMyWindow = ^TMyWindow;
  TMyWindow = object(TWindow)
  //"""""""""""""""""""""""""

  wNb_msStart : word32;
  // to set the starting time

  constructor Init(strWinTitlePrm:ShortString);

  destructor Done; virtual;

  procedure WinCreate(strWinClass:ShortString); virtual;
  // When creating the window, we ask to show the dialog box, not the window

  function WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  // Handles the menu messages

  procedure DoMeasurements;
  // Do measurements until a key is pressed.

  function WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  end; // TMyWindow = object(TWindow)

var
  oApp        : TApplication;
  poMyMainWin : PMyWindow;

PROCEDURE StartDevice; stdcall; external 'K8047d.dll';
PROCEDURE StopDevice; stdcall; external 'K8047d.dll';
PROCEDURE ReadData(Buffer:Pointer); stdcall; external 'K8047d.dll';
PROCEDURE SetGain(Channel: Longint ; Gain: Longint); stdcall; external 'K8047d.dll';
PROCEDURE LEDon; stdcall; external 'K8047d.dll';
PROCEDURE LEDoff; stdcall; external 'K8047d.dll';


function myCreateDialogObj(poParent:Pointer):Pointer;
//===================================================
var poObj : PMyDialog;
begin
new(poObj, Init(poParent));
myCreateDialogObj:=poObj;
end;  // myCreateDialogObj

//******************************************************************
// TMyDialog = object(TDialog)
//******************************************************************

constructor TMyDialog.Init(poParentW:PWindowBase);
//================================================
begin
// must be done, even if it seems useless.
inherited Init(poParentW);

vXValue:=0.0;
FloatField(100, vXValue);

fClearNext :=FALSE;
fAddNext   :=FALSE;
vPeriode   :=1; // no digits after the period.
vMemory    :=0;
end;  // TMyDialog.Init

function TMyDialog.WMCommand(wPar:WPARAM; lPar:LPARAM):BOOL;
//==========================================================
// Handles the menu messages
var
  wCtrlID     : word32;
  wSpeed,
  wCpt        : word32;
  dnTick1, dnTick2  // to read the time
              : int64;
  dwTimeNS  // elapsed time in nano seconds
              : dword;
  nn          : integer;
  aanDataBuffers: array[1..100] of array[0..7] of Int32;

begin
if (HiWord(wPar) <> BN_CLICKED) then begin
   WMCommand:=inherited WMCommand(wPar, lPar);
   exit;
   end;
//DBW(1, 'WMCommand=' + DBNotifToStr(HiWord(wPar)) + ITS5(LoWord(wPar)));
wCtrlID:=LoWord(wPar);

//MessageBeep(0);

//DBW(1, 'Button clicked=' + ITS(poBtn^.wCtrlID));

// sets Led OFF on the PCS10
if (wCtrlID = 300) then begin
   DBW(0, 'set LED off');
   LEDOff;
end;

// sets Led ON on the PCS10
if (wCtrlID = 301) then begin
   DBW(0, 'set LED on');
   LEDOn;
   end;

// sets the gain to 1 on all channels on the PCS10
if (wCtrlID = 401) then begin
   SetGain(1, 1);   SetGain(2, 1);   SetGain(3, 1);   SetGain(4, 1);
   end;

// sets the gain to 2 on all channels on the PCS10
if (wCtrlID = 402) then begin
   SetGain(1, 2);   SetGain(2, 2);   SetGain(3, 2);   SetGain(4, 2);
   end;

// sets the gain to 5 on all channels on the PCS10
if (wCtrlID = 405) then begin
   SetGain(1, 5);   SetGain(2, 5);   SetGain(3, 5);   SetGain(4, 5);
   end;

// sets the gain to 10 on all channels on the PCS10
if (wCtrlID = 410) then begin
   SetGain(1, 10);   SetGain(2, 10);   SetGain(3, 10);   SetGain(4, 10);
   end;

// Read voltage from the PCS10
if (wCtrlID = 700) then begin
   poMyMainWin^.DoMeasurements;
   end;

// Read voltage from the PCS10
if (wCtrlID = 710) then begin
   for nn:=1 to 5 do ReadData(@aanDataBuffers[nn]);  // reads the data

   DBW(0, '');
   for nn:=1 to 5 do begin
      DBW(0, ITS(aanDataBuffers[nn,0]+256*aanDataBuffers[nn,1]) + ' ' + ITS(aanDataBuffers[nn,2]) + ' ' + ITS(aanDataBuffers[nn,3])
     + ' ' + ITS(aanDataBuffers[nn,4]) + ' ' + ITS(aanDataBuffers[nn,5]));
      end;
   end;

// sets output D0 to more than 2 [V]
if (wCtrlID = 801) then begin
   wCpt:=0;
   wSpeed:=CPUGetSpeed;
   DBW(0, 'Speed = ' + WTS(wSpeed));
   dnTick1:=cpugettick;
   for wCpt:=1 to 5 do begin  end;
   dnTick2:=cpugettick;

   dwTimeNS:=cpugetNS(dnTick1); // get elapsed time in nano seconds

   DBW(0, 'Tick1, Tick2 & diff =' + WTS(dnTick1) + ' & ' + WTS(dnTick2) + WTS(dnTick2 - dnTick1));
   DBW(0, 'Delta time [ns] =' + WTS(dwTimeNS) + '  ' + FTS(_1CPUFrequencyNS));
   end;

// Did we click on the quit button ?
// Close the main window, thus quit the application.
if (wCtrlID = idQUIT) then  PostMessage(poMyMainWin^.hWin, WM_CLOSE, 0, 0);

WMCommand:=inherited WMCommand(wPar, lPar);
end;  // TMyDialog.WMCommand

//******************************************************************
// TMyWindow = object(TWindow)
//******************************************************************

constructor TMyWindow.Init(strWinTitlePrm:ShortString);
//=====================================================
begin
inherited Init(strWinTitlePrm);
StartDevice;  // for the PCS10
end;  // TMyWindow.Init

destructor TMyWindow.Done;
//========================
begin
LEDOff;
StopDevice; // for the PCS10
inherited Done;
end;

procedure TMyWindow.WinCreate(strWinClass:ShortString);
//=====================================================
//var strName : string[50];
var
  poWrWin     : PWindowText;  // pointer on the window where the measurements are written.
  TheLogFont            : TLogFont;
  TheFont               : HFont;

Begin
// We don't want to see the main window
//wSizeState := SIZE_MINIMIZED;

inherited WinCreate(strWinClass);

// Here calling :  DialogExecMSG(11199, @Self);  doesn't work,
// But posting a message to open the dialog box at startup is possible.
PostMessage(hWin, WM_COMMAND, 101, 0);

//strName:='zlportio' + char(0);
//DBW(0, 'result= ' + ITS(driverstart(@strName[1])));

WriteWin(1, '');
poWrWin:=GetWriteWinNr(1);
with TheLogFont do begin
   lfHeight         := 18;                // Default logical height of font
   lfWidth          := 0;                // Default logical average character width
   lfEscapement     := 0;                // angle of escapement
   lfOrientation    := 0;                // base-line orientation angle
   lfWeight         := FW_NORMAL;        // font weight
   lfItalic         := 0;                // italic attribute flag
   lfUnderline      := 0;                // underline attribute flag
   lfStrikeOut      := 0;                // strikeout attribute flag
   lfCharSet        := DEFAULT_CHARSET;  // character set identifier
   lfOutPrecision   := OUT_DEFAULT_PRECIS;  // output precision
   lfClipPrecision  := CLIP_DEFAULT_PRECIS; // clipping precision
   lfQuality        := DEFAULT_QUALITY;     // output quality
   lfPitchAndFamily := DEFAULT_PITCH;    // pitch and family
   Strcopy(lfFaceName,'Courier New');    // pointer to typeface name string
   end; // with
//      TheColor := GetSysColor(COLOR_WINDOWTEXT);
TheFont  := CreateFontIndirect(@TheLogFont);
SendMessage(poWrWin^.oRichEditFrame.hWin,WM_SETFONT,TheFont,1);
// ShowWindow(poWrWin^.hWin, SW_Show);
// UpdateWindow(poWrWin^.hWin);

WriteWin(1, 'Time_[s]  Distance_[cm]  Value_[/]  Last_Val_[/]');
end;  // TMyWindow.WinCreate

procedure TMyWindow.DoMeasurements;
//=================================
// Do measurements until a key is pressed.
var
  wNb_ms      : word32;  // time in [ms]
  wNbLast_ms  : word32;  // time in [ms]
  wDist_cm    : word32;  // distance in [cm]
  anDataBuffer: array[0..7] of Int32;
  nLastState  : integer;  // last value ridden
  rMsg        : MSG; // read messages from the keyboard


begin
wNb_msStart :=GetTickCount;
wDist_cm:=0;
WriteWin(1, FloatToStr(0.0 / 1000, 7,2) + #9 + IntToStr(wDist_cm, 12) + #9 + IntToStr(0, 9) + #9 + IntToStr(0, 9));
nLastState:=0;
wNbLast_ms:=0;
repeat
   wNb_ms:=(GetTickCount - wNb_msStart);

   ReadData(@anDataBuffer);

   if (anDataBuffer[2] >= 10) and (nLastState < 10) and (wNb_ms > wNbLast_ms + 100) then begin
      wDist_cm:=wDist_cm + 25;
      WriteWin(1, FloatToStr(wNb_ms / 1000, 7,2) + #9 + IntToStr(wDist_cm, 12) + #9
                  + IntToStr(anDataBuffer[2], 9)+ #9 + IntToStr(nLastState, 9));
      wNbLast_ms:=wNb_ms;
//      WriteWin(1, IntToStr(wNb_ms, 8) + #9 + IntToStr(wDist_cm, 13) + #9 + IntToStr(anDataBuffer[2], 10));
      // IntToStr(anDataBuffer[0]+256*anDataBuffer[1], 7)  = time ridden from the PCS10

      // let the text being written on the screen  USEFULL ?????
      PeekMessage( @rMsg, 0, // any messages for this application
                   WM_KEYFIRST, WM_KEYLAST, // only keyboard messages
                   PM_REMOVE); // remove the message from the queue
      end;

   // remember last ridden state
   nLastState:=anDataBuffer[2];

   // save the measurement file every ... minutes.
(*   if (wNb_ms mod 8 = 0) then begin
      poWrWin:=GetWriteWinNr(1);
      poWrWin^.oRichEditFrame.SaveRICH;
      end;
*)
   until (wNb_ms > 20000) or (wDist_cm >= 125);  // measurement last for 20 [s] or for 1,25 [m]
end;  // TMyWindow.DoMeasurements

function TMyWindow.WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT;
//=============================================================
// treats the menu commands
begin
// Execute the dialog box at starting
// And the help window
if (lPar = 0) and (wPar =101) then DialogCreateMSG(11199, @Self);
//if (lPar = 0) and (wPar =121) then DialogCreateMSG(21199, @Self);

// Accelerators act as button click.
// Send the command to the active dialog
case LoWord(wPar) of
  idQUIT : if (gglpoActiveDialog <> NIL) then
               gglpoActiveDialog^.WMCommand(LoWord(wPar), 0);

  end; // case

WMCommand:=inherited WMCommand(wPar, lPar);
end;  // TMyWindow.WMCommand

function TMyWindow.WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT;
//=======================================================================================
// All window messages are send here.  The timer command also
//var
//  poWrWin     : PWindowText;  // pointer on the window where the measurements are written.
//  poWrWin:=GetWriteWinNr(1);

Begin
WindowProc := 0; // Default return value when processing a message

{ if (wMsg <> WM_MouseMove)   and (wMsg <> WM_NCMouseMove) and
   (wMsg <> WM_MENUSELECT )   and (wMsg <> WM_ENTERIDLE ) and
   (wMsg <> WM_SetCursor)   and (wMsg <> WM_NCHittest) and
   (wMsg <> WM_SetFocus) and (wMsg <> WM_KillFocus) and
   (wMsg <> WM_KEYDOWN) and (wMsg <> WM_KEYUP) and
   (wMsg <> WM_Move)        and (wMsg <> WM_NCActivate) then
   DBW0(32, DBMsgToStr(wMsg) + ITS(wPar) + ITS(lPar)); }

if (wMsg = WM_Destroy) then begin
   // saves the text file where the measurements have been done
//   poWrWin:=GetWriteWinNr(1);
//   if (poWrWin <> NIL) then poWrWin^.oRichEditFrame.SaveRICH;
   end;

Case wMsg Of
//   WM_Command : WindowProc:=WMCommand(wPar, lPar);  // done by default
   WM_Timer   : begin {treat messages } end;

else begin // Case wMsg Of
      // Default processing of the messages.
      WindowProc:=inherited WindowProc(hWindow, wMsg, wPar, lPar);
      end; // Case wMsg Of
   End; // Case wMsg Of

End;  // TMyWindow.WindowProc

//**********************************************************************
Begin // MAIN ******
// Assign the pointer on the function which will create the dialog.
// It is used by the library. So the library will construct
// a user defined object.
gglfnCreateDialogObj:=@myCreateDialogObj;

// Name under which the main window is registered. Spaces are not allowed
oApp.Init('Example071');



// Creation of the main window
new(poMyMainWin, Init('tEx071_Detectors_with_PCS10_Velleman.pp'));

// The App.WindowClass can be modified here, if wanted. (Not usual)
oApp.Run;
oApp.Done;  // The main window object is disposed here.
End.

