{ File format of a wave file :
  in Hex :  for a 8 bit, mono, 22'050 Hz
  52 49 46 46 bb aa dd cc     aabbccdd = length of the data in bytes = file length in bytes - 8 bytes
  57 41 56 45 66 6D 74 20
  10 00 00 00 01 00 01 00
  22 56 00 00 22 56 00 00   // 00 00 56 22  = 22'050 in hexadecimal  = $5622
  01 00 08 00 64 61 74 61  ....data
  bb aa dd cc                 aabbccdd = length of the data in bytes = file length in bytes - $90 bytes

  DATA BEGINS...  list of bytes...

  4c 49 53 54 5c 00 00 00  LIST\...
  49 4e 46 4f 49 43 52 44  INFOICRD
  0c 00 00 00 32 30 30 38  ....2008
  2d 30 34 2d 31 34 00 00  -04-14..
  49 45 4e 47 0f 00 00 00  IENG....
  42 65 72 6e 61 72 64 20  Bernard
  47 69 73 69 6e 00 00 01  Gisin...
  49 53 46 54 23 00 00 00  ISFT#...
  53 6f 6e 79 20 53 6f 75  Sony Sou
  6e 64 20 46 6f 72 67 65  nd Forge
  20 41 75 64 69 6f 20 53   Audio S
  74 75 64 69 6f 20 38 2e  tudio 8.
  30 00 00 02              0...

-----------------------------------------
  in Hex :  for a 8 bit, mono, 48'000 Hz
  52 49 46 46 bb aa dd cc     aabbccdd = length of the data in bytes = file length in bytes - 8 bytes
  57 41 56 45 66 6D 74 20
  10 00 00 00 01 00 01 00
  80 bb 00 00 80 bb 00 00   // 00 00 80 bb  = 48'000 in hexadecimal  = $bb80
  01 00 08 00 64 61 74 61  ....data
  bb aa dd cc                 aabbccdd = length of the data in bytes = file length in bytes - $90 bytes

  DATA BEGINS...  list of bytes...

  4c 49 53 54 5c 00 00 00  LIST\...
  49 4e 46 4f 49 43 52 44  INFOICRD
  0c 00 00 00 32 30 30 38  ....2008
  2d 30 34 2d 31 34 00 00  -04-14..
  49 45 4e 47 0f 00 00 00  IENG....
  42 65 72 6e 61 72 64 20  Bernard
  47 69 73 69 6e 00 00 01  Gisin...
  49 53 46 54 23 00 00 00  ISFT#...
  53 6f 6e 79 20 53 6f 75  Sony Sou
  6e 64 20 46 6f 72 67 65  nd Forge
  20 41 75 64 69 6f 20 53   Audio S
  74 75 64 69 6f 20 38 2e  tudio 8.
  30 00 00 02              0...

  Creates a .wav file with changing frequency.
  --------------------------------------------}
program tEx073_Sound_Frequ_Variable;

// To tell FreePascal that the application is a Graphical User Interface
// i.e. is running in windows, not in text mode.
{$APPTYPE GUI}

Uses
  wApplication0
 ,wWindowText0
 ,wWindow0
 ,wDialog0
 ,wPopupWindow0
 ,wDialogCreatorLOW2
 ,wDialogCreator2
 ,wVariableNumLink2
 ,wWindowBase0
 ,wErrors0
 ,wGlobals2
 ,wDebug0
 ,Windows
 ;
// cette partie est une rcupration des constantes de playsound,
// j'ai laiss les commentaires originaux qui peuvent etre utiles
const
SND_SYNC = $0000; // play synchronously (default)
SND_ASYNC = $0001; // play asynchronously
SND_NODEFAULT = $0002; // don't use default sound
SND_MEMORY = $0004; // lpszSoundName points to a memory file
SND_LOOP = $0008; // loop the sound until next sndPlaySound
SND_NOSTOP = $0010; // don't stop any currently playing sound
SND_NOWAIT = $00002000; // don't wait if the driver is busy
SND_ALIAS = $00010000; // name is a registry alias
SND_ALIAS_ID = $00110000; // alias is a predefined ID
SND_FILENAME = $00020000; // name is file name
SND_RESOURCE = $00040004; // name is resource name or atom
SND_PURGE = $0040; // purge non-static events for task
SND_APPLICATION = $0080; // look for application specific association

// declaration de la fonction playsound contenue dans la dll winmm.dll
function PlaySound(pszSound: PChar; hmod: HMODULE; fdwSound: DWORD): BOOL;
stdcall; external 'winmm.dll' name {$ifdef unicode}'PlaySoundW' {$else}
'PlaySoundA' {$endif};


type
  PMyDialog = ^TMyDialog;
  TMyDialog = object(TDialog)
  //"""""""""""""""""""""""""
  constructor Init(poParentW:PWindowBase);

  function WMCommand(wPar:WPARAM; lPar:LPARAM):BOOL; virtual;
  // Handles the menu messages

//  function DialogProc(hDialog:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
    // Not used
  // Handles the dialog messages. See comments in  wDialog0.pp
  end; // TMyDialog = object(TDialog)

type
  PMyWindow = ^TMyWindow;
  TMyWindow = object(TWindow)
  //"""""""""""""""""""""""""
  constructor Init(strWinTitlePrm:ShortString);

  destructor Done; virtual;

  procedure WinCreate(strWinClass:ShortString); virtual;
  // When creating the window, we ask to show the dialog box, not the window

  procedure CreateSoundFile_22050Hz;
  // creates a .wav sound file at 22050 Hz sampling

  procedure CreateSoundFile_48000Hz;
  // creates a .wav sound file at 48000 Hz sampling

  procedure CreateSoundFile_100000Hz;
  // creates a .wav sound file at a rate near 100'000 Hz sampling

  function WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  // Handles the menu messages

  function WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  end; // TMyWindow = object(TWindow)

var
  oApp        : TApplication;
  poMyMainWin : PMyWindow;

function myCreateDialogObj(poParent:Pointer):Pointer;
//===================================================
var poObj : PMyDialog;
begin
new(poObj, Init(poParent));
myCreateDialogObj:=poObj;
end;  // myCreateDialogObj

//******************************************************************
// TMyDialog = object(TDialog)
//******************************************************************

constructor TMyDialog.Init(poParentW:PWindowBase);
//================================================
begin
// must be done, even if it seems useless.
inherited Init(poParentW);
end;  // TMyDialog.Init

function TMyDialog.WMCommand(wPar:WPARAM; lPar:LPARAM):BOOL;
//==========================================================
// Handles the menu messages
var
  wCtrlID     : word32;

begin
if (HiWord(wPar) <> BN_CLICKED) then begin
   WMCommand:=inherited WMCommand(wPar, lPar);
   exit;
   end;
//DBW(1, 'WMCommand=' + DBNotifToStr(HiWord(wPar)) + ITS5(LoWord(wPar)));
wCtrlID:=LoWord(wPar);


if (wCtrlID = 100) then begin
   MessageBeep($FFFFFFFF);
   end;

if (wCtrlID = 402) then begin
   MessageBeep(0);
   end;


if (wCtrlID = 405) then begin
   PlaySound('Self_defined_sound_1.wav', 0, SND_ASYNC or SND_FILENAME);
   end;

if (wCtrlID = 111) then  PostMessage(poMyMainWin^.hWin, WM_COMMAND, 111, 0);
if (wCtrlID = 112) then  PostMessage(poMyMainWin^.hWin, WM_COMMAND, 112, 0);
if (wCtrlID = 121) then  PostMessage(poMyMainWin^.hWin, WM_COMMAND, 121, 0);
if (wCtrlID = 211) then  PostMessage(poMyMainWin^.hWin, WM_COMMAND, 211, 0);
if (wCtrlID = 311) then  PostMessage(poMyMainWin^.hWin, WM_COMMAND, 311, 0);

// Did we click on the quit button ?
// Close the main window, thus quit the application.
if (wCtrlID = 999) then  PostMessage(poMyMainWin^.hWin, WM_CLOSE, 0, 0);

WMCommand:=inherited WMCommand(wPar, lPar);
end;  // TMyDialog.WMCommand

//******************************************************************
// TMyWindow = object(TWindow)
//******************************************************************

constructor TMyWindow.Init(strWinTitlePrm:ShortString);
//=====================================================
begin
inherited Init(strWinTitlePrm);
end;  // TMyWindow.Init

destructor TMyWindow.Done;
//========================
begin
inherited Done;
end;

procedure TMyWindow.WinCreate(strWinClass:ShortString);
//=====================================================
//var strName : string[50];
Begin
// We don't want to see the main window
//wSizeState := SIZE_MINIMIZED;

inherited WinCreate(strWinClass);

// Here calling :  DialogExecMSG(11199, @Self);  doesn't work,
// But posting a message to open the dialog box at startup is possible.
PostMessage(hWin, WM_COMMAND, 101, 0);

//strName:='zlportio' + char(0);
//DBW(0, 'result= ' + ITS(driverstart(@strName[1])));

end;  // TMyWindow.WinCreate

procedure TMyWindow.CreateSoundFile_22050Hz;
//==========================================
// creates a .wav sound file  at 22050 Hz sampling
var
  fOut : file of byte;
  nLenData : int32;  // number of bytes coding the sound, without the heading and footing.
  nLen : int32;
  b1, b2, b3, b4 : byte;
  n1, n1Max : int32;
  vT0, vT1  : Float;

begin
// Create a file to write the sound in it
assign(fOut, 'Tacs.wav');
rewrite(fOut);

write(fOut, $52, $49, $46, $46);
//write(fOut, $bb, $aa, $dd, $cc); // aabbccdd = length of the data in bytes = file length in bytes - 8 bytes
nLenData:= 0;
nLen := nLenData + 144 - 8;
b1:= nLen         mod $100;
b2:=(nLen div $100) mod $100;
b3:=(nLen div $10000) mod $100;
b4:=(nLen div $1000000) mod $100;
write(fOut, b1, b2, b3, b4);
write(fOut, $57, $41, $56, $45, $66, $6D, $74, $20);
write(fOut, $10, $00, $00, $00, $01, $00, $01, $00);
write(fOut, $22, $56, $00, $00, $22, $56, $00, $00);  // $22 $56 $00 $00  = 22'050 in hexadecimal = $5622
write(fOut, $01, $00, $08, $00, $64, $61, $74, $61);
//write(fOut, $bb, $aa, $dd, $cc); // aabbccdd = length of the data in bytes = file length in bytes - $90 bytes
nLen := nLenData;
b1:= nLen         mod $100;
b2:=(nLen div $100) mod $100;
b3:=(nLen div $10000) mod $100;
b4:=(nLen div $1000000) mod $100;
write(fOut, b1, b2, b3, b4 );

// DATA BEGINS...  list of bytes...
nLenData:=0;

vT1:=0;
repeat
  vT0:=vT1;
  vT1:=vT0 + exp(-vT0 * ln(2)/4);

  n1Max:=Round(22050 * (vT1 - vT0));
  for n1:=1 to n1Max do begin inc(nLenData); write(fOut, $10); end;
  for n1:=1 to n1Max do begin inc(nLenData); write(fOut, $f0); end;
  until (vT1 - vT0 < 0.002);

(*
for n2:=1 to 10 do begin
  //  n2 is the frequency in [Hz]
  n1Max:=22050 div n2;
  for n1:=1 to n1Max do begin inc(nLenData); write(fOut, $10); end;
  for n1:=1 to n1Max do begin inc(nLenData); write(fOut, $f0); end;
  end;
*)
// end of the file
write(fOut, $4c, $49, $53, $54, $5c, $00, $00, $00);
write(fOut, $49, $4e, $46, $4f, $49, $43, $52, $44);
write(fOut, $0c, $00, $00, $00, $32, $30, $30, $38);
write(fOut, $2d, $30, $34, $2d, $31, $34, $00, $00);
write(fOut, $49, $45, $4e, $47, $0f, $00, $00, $00);
write(fOut, $42, $65, $72, $6e, $61, $72, $64, $20);
write(fOut, $47, $69, $73, $69, $6e, $00, $00, $01);
write(fOut, $49, $53, $46, $54, $23, $00, $00, $00);
write(fOut, $53, $6f, $6e, $79, $20, $53, $6f, $75);
write(fOut, $6e, $64, $20, $46, $6f, $72, $67, $65);
write(fOut, $20, $41, $75, $64, $69, $6f, $20, $53);
write(fOut, $74, $75, $64, $69, $6f, $20, $38, $2e);
write(fOut, $30, $00, $00, $02);


// writing the data length into the file.
seek(fOut, 4);
nLen := nLenData + 144 - 8;
b1:= nLen         mod $100;
b2:=(nLen div $100) mod $100;
b3:=(nLen div $10000) mod $100;
b4:=(nLen div $1000000) mod $100;
write(fOut, b1, b2, b3, b4);

seek(fOut, 40);
nLen := nLenData;
b1:= nLen         mod $100;
b2:=(nLen div $100) mod $100;
b3:=(nLen div $10000) mod $100;
b4:=(nLen div $1000000) mod $100;
write(fOut, b1, b2, b3, b4);

close(fOut);
end;  // TMyWindow.CreateSoundFile_22050Hz

procedure TMyWindow.CreateSoundFile_48000Hz;
//==========================================
// creates a .wav sound file at 48000 Hz sampling

var
  fOut : file of byte;
  nLenData : int32;  // number of bytes coding the sound, without the heading and footing.
  nLen : int32;
  b1, b2, b3, b4 : byte;
  n1, n1Max : int32;
  vT0, vT1  : Float;
  vDT       : Float;

begin
// Create a file to write the sound in it
assign(fOut, 'Tacs.wav');
rewrite(fOut);

write(fOut, $52, $49, $46, $46);
//write(fOut, $bb, $aa, $dd, $cc); // aabbccdd = length of the data in bytes = file length in bytes - 8 bytes
nLenData:= 0;
nLen := nLenData + 144 - 8;
b1:= nLen         mod $100;
b2:=(nLen div $100) mod $100;
b3:=(nLen div $10000) mod $100;
b4:=(nLen div $1000000) mod $100;
write(fOut, b1, b2, b3, b4);
write(fOut, $57, $41, $56, $45, $66, $6D, $74, $20);
write(fOut, $10, $00, $00, $00, $01, $00, $01, $00);
write(fOut, $80, $bb, $00, $00, $80, $bb, $00, $00); // $80 $bb $00 $00  = 48'000 in hexadecimal  = $bb80
write(fOut, $01, $00, $08, $00, $64, $61, $74, $61);
//write(fOut, $bb, $aa, $dd, $cc); // aabbccdd = length of the data in bytes = file length in bytes - $90 bytes
nLen := nLenData;
b1:= nLen         mod $100;
b2:=(nLen div $100) mod $100;
b3:=(nLen div $10000) mod $100;
b4:=(nLen div $1000000) mod $100;
write(fOut, b1, b2, b3, b4 );

// DATA BEGINS...  list of bytes...
nLenData:=0;

vDT:=0;
vT1:=0;
repeat
  vT0:=vT1;
  vT1:=vT0 + exp(-vT0 * ln(2)/1);

  n1Max:=Round(48000*(vT1 - vT0) + vDT);
  vDT  :=48000*(vT1 - vT0) + VDT - n1Max;  // correct the discretisation of the frequency
// for square waves
//  for n1:=1 to n1Max do begin inc(nLenData); write(fOut, $10); end;
//  for n1:=1 to n1Max do begin inc(nLenData); write(fOut, $f0); end;

// for "dents de scies"
//  for n1:=1 to n1Max do begin inc(nLenData); write(fOut, $10 + Round($e0 * n1/n1Max)); end;
//  for n1:=1 to n1Max do begin inc(nLenData); write(fOut, $f0 - Round($e0 * n1/n1Max)); end;

// for sin waves
  for n1:=1 to 2*n1Max do begin inc(nLenData); write(fOut, $10 + Round($e0 * (1 - cos(3.1415926*n1/n1Max)) / 2)); end;

  until (vT1 - vT0 < 0.00001);

(*
for n2:=1 to 10 do begin
  //  n2 is the frequency in [Hz]
  n1Max:=22050 div n2;
  for n1:=1 to n1Max do begin inc(nLenData); write(fOut, $10); end;
  for n1:=1 to n1Max do begin inc(nLenData); write(fOut, $f0); end;
  end;
*)
// end of the file
write(fOut, $4c, $49, $53, $54, $5c, $00, $00, $00);
write(fOut, $49, $4e, $46, $4f, $49, $43, $52, $44);
write(fOut, $0c, $00, $00, $00, $32, $30, $30, $38);
write(fOut, $2d, $30, $34, $2d, $31, $34, $00, $00);
write(fOut, $49, $45, $4e, $47, $0f, $00, $00, $00);
write(fOut, $42, $65, $72, $6e, $61, $72, $64, $20);
write(fOut, $47, $69, $73, $69, $6e, $00, $00, $01);
write(fOut, $49, $53, $46, $54, $23, $00, $00, $00);
write(fOut, $53, $6f, $6e, $79, $20, $53, $6f, $75);
write(fOut, $6e, $64, $20, $46, $6f, $72, $67, $65);
write(fOut, $20, $41, $75, $64, $69, $6f, $20, $53);
write(fOut, $74, $75, $64, $69, $6f, $20, $38, $2e);
write(fOut, $30, $00, $00, $02);


// writing the data length into the file.
seek(fOut, 4);
nLen := nLenData + 144 - 8;
b1:= nLen         mod $100;
b2:=(nLen div $100) mod $100;
b3:=(nLen div $10000) mod $100;
b4:=(nLen div $1000000) mod $100;
write(fOut, b1, b2, b3, b4);

seek(fOut, 40);
nLen := nLenData;
b1:= nLen         mod $100;
b2:=(nLen div $100) mod $100;
b3:=(nLen div $10000) mod $100;
b4:=(nLen div $1000000) mod $100;
write(fOut, b1, b2, b3, b4);

close(fOut);
MessageBeep(0);
end;  // TMyWindow.CreateSoundFile_48000Hz

procedure TMyWindow.CreateSoundFile_100000Hz;
//==========================================
// creates a .wav sound file at a rate near 100'000 Hz sampling

var
  fOut : file of byte;
  nLenData : int32;  // number of bytes coding the sound, without the heading and footing.
  nLen : int32;
  b1, b2, b3, b4 : byte;
  n1, n1Max : int32;
  vT0, vT1  : Float;
  vDT       : Float;

begin
// Create a file to write the sound in it
assign(fOut, 'Tacs.wav');
rewrite(fOut);

write(fOut, $52, $49, $46, $46);
//write(fOut, $bb, $aa, $dd, $cc); // aabbccdd = length of the data in bytes = file length in bytes - 8 bytes
nLenData:= 0;
nLen := nLenData + 144 - 8;
b1:= nLen         mod $100;
b2:=(nLen div $100) mod $100;
b3:=(nLen div $10000) mod $100;
b4:=(nLen div $1000000) mod $100;
write(fOut, b1, b2, b3, b4);
write(fOut, $57, $41, $56, $45, $66, $6D, $74, $20);
write(fOut, $10, $00, $00, $00, $01, $00, $01, $00);
write(fOut, $00, $00, $01, $00, $ff, $ff, $00, $00); // $FF $FF $00 $00  = 65'535 in hexadecimal
write(fOut, $01, $00, $08, $00, $64, $61, $74, $61);
//write(fOut, $bb, $aa, $dd, $cc); // aabbccdd = length of the data in bytes = file length in bytes - $90 bytes
nLen := nLenData;
b1:= nLen         mod $100;
b2:=(nLen div $100) mod $100;
b3:=(nLen div $10000) mod $100;
b4:=(nLen div $1000000) mod $100;
write(fOut, b1, b2, b3, b4 );

// DATA BEGINS...  list of bytes...
nLenData:=0;

vDT:=0;
vT1:=0;
repeat
  vT0:=vT1;
  vT1:=vT0 + exp(-vT0 * ln(2)/1);

  n1Max:=Round(65535*(vT1 - vT0) + vDT);
  vDT  :=65535*(vT1 - vT0) + VDT - n1Max;  // correct the discretisation of the frequency
// for square waves
//  for n1:=1 to n1Max do begin inc(nLenData); write(fOut, $10); end;
//  for n1:=1 to n1Max do begin inc(nLenData); write(fOut, $f0); end;

// for "dents de scies"
//  for n1:=1 to n1Max do begin inc(nLenData); write(fOut, $10 + Round($e0 * n1/n1Max)); end;
//  for n1:=1 to n1Max do begin inc(nLenData); write(fOut, $f0 - Round($e0 * n1/n1Max)); end;

// for sin waves
  for n1:=1 to 2*n1Max do begin inc(nLenData); write(fOut, $10 + Round($e0 * (1 - cos(3.1415926*n1/n1Max)) / 2)); end;

  until (vT1 - vT0 < 0.00001);

(*
for n2:=1 to 10 do begin
  //  n2 is the frequency in [Hz]
  n1Max:=22050 div n2;
  for n1:=1 to n1Max do begin inc(nLenData); write(fOut, $10); end;
  for n1:=1 to n1Max do begin inc(nLenData); write(fOut, $f0); end;
  end;
*)
// end of the file
write(fOut, $4c, $49, $53, $54, $5c, $00, $00, $00);
write(fOut, $49, $4e, $46, $4f, $49, $43, $52, $44);
write(fOut, $0c, $00, $00, $00, $32, $30, $30, $38);
write(fOut, $2d, $30, $34, $2d, $31, $34, $00, $00);
write(fOut, $49, $45, $4e, $47, $0f, $00, $00, $00);
write(fOut, $42, $65, $72, $6e, $61, $72, $64, $20);
write(fOut, $47, $69, $73, $69, $6e, $00, $00, $01);
write(fOut, $49, $53, $46, $54, $23, $00, $00, $00);
write(fOut, $53, $6f, $6e, $79, $20, $53, $6f, $75);
write(fOut, $6e, $64, $20, $46, $6f, $72, $67, $65);
write(fOut, $20, $41, $75, $64, $69, $6f, $20, $53);
write(fOut, $74, $75, $64, $69, $6f, $20, $38, $2e);
write(fOut, $30, $00, $00, $02);


// writing the data length into the file.
seek(fOut, 4);
nLen := nLenData + 144 - 8;
b1:= nLen         mod $100;
b2:=(nLen div $100) mod $100;
b3:=(nLen div $10000) mod $100;
b4:=(nLen div $1000000) mod $100;
write(fOut, b1, b2, b3, b4);

seek(fOut, 40);
nLen := nLenData;
b1:= nLen         mod $100;
b2:=(nLen div $100) mod $100;
b3:=(nLen div $10000) mod $100;
b4:=(nLen div $1000000) mod $100;
write(fOut, b1, b2, b3, b4);

close(fOut);
MessageBeep(0);
end;  // TMyWindow.CreateSoundFile_100000Hz

function TMyWindow.WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT;
//=============================================================
// treats the menu commands
begin
// Execute the dialog box at starting
// And the help window
if (lPar = 0) and (wPar =101) then DialogCreateMSG(11199, @Self);
//if (lPar = 0) and (wPar =121) then DialogCreateMSG(21199, @Self);

// Accelerators act as button click.
// Send the command to the active dialog
case LoWord(wPar) of
  111 : CreateSoundFile_22050Hz;

  121 : PlaySound('Tacs.wav', 0, SND_ASYNC or SND_FILENAME);

  211 : CreateSoundFile_48000Hz;

  311 : CreateSoundFile_100000Hz;

  999 : if (gglpoActiveDialog <> NIL) then
               gglpoActiveDialog^.WMCommand(LoWord(wPar), 0);
  end; // case

WMCommand:=inherited WMCommand(wPar, lPar);
end;  // TMyWindow.WMCommand

function TMyWindow.WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT;
//=======================================================================================
// All window messages are send here.

Begin
{ if (wMsg <> WM_MouseMove)   and (wMsg <> WM_NCMouseMove) and
   (wMsg <> WM_MENUSELECT )   and (wMsg <> WM_ENTERIDLE ) and
   (wMsg <> WM_SetCursor)   and (wMsg <> WM_NCHittest) and
   (wMsg <> WM_SetFocus) and (wMsg <> WM_KillFocus) and
   (wMsg <> WM_KEYDOWN) and (wMsg <> WM_KEYUP) and
   (wMsg <> WM_Move)        and (wMsg <> WM_NCActivate) then
   DBW0(32, DBMsgToStr(wMsg) + ITS(wPar) + ITS(lPar)); }

//if (wMsg = WM_Destroy) then begin
//   end;

Case wMsg Of
//   WM_Command : WindowProc:=WMCommand(wPar, lPar);  // done by default
   WM_Timer   : begin end;

else begin // Case wMsg Of
      // Default processing of the messages.
      WindowProc:=inherited WindowProc(hWindow, wMsg, wPar, lPar);
      end; // Case wMsg Of
   End; // Case wMsg Of

End;  // TMyWindow.WindowProc

//**********************************************************************
Begin // MAIN ******
// Assign the pointer on the function which will create the dialog.
// It is used by the library. So the library will construct
// a user defined object.
gglfnCreateDialogObj:=@myCreateDialogObj;

// Name under which the main window is registered. Spaces are not allowed
oApp.Init('Example073');

// Creation of the main window
new(poMyMainWin, Init('tEx073_Sound_Frequ_Variable.pp'));

// The App.WindowClass can be modified here, if wanted. (Not usual)
oApp.Run;
oApp.Done;  // The main window object is disposed here.
End.

