{ To do some statistics simulation

  --------------------------------------------}
program tEx075;

// To tell FreePascal that the application is a Graphical User Interface
// i.e. is running in windows, not in text mode.
{$APPTYPE GUI}

Uses

  wApplication0
 ,wWindowText0 // To write text in an independent window
 ,wWindow0
 ,wDialog0
 ,wGlobals2
 ,wVariableNumLink2
 ,wDialogCreatorLOW2
 ,wDialogCreator2
// ,wUtiles0
 ,wMessages2
 ,wDebug0
 ,Windows;

type
  PMyWindow = ^TMyWindow;
  TMyWindow = object(TWindow)
  //"""""""""""""""""""""""""
  // To do simulations, some parameters that can be changed in a dialog box.
  nIter     : int32;  // number of iteration
  nNbFaces  : int32;  // number of faces, between 1 and 40
  nNbPieces : int32;  // number of pieces (number) taken during one experiment

  constructor Init(strWinTitlePrm:ShortString);
  destructor Done; virtual;

  procedure Test1;
  procedure Test2;
  procedure Test3;
  procedure Test4;

  function WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  // Handles the menu messages

  function WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  end; // TMyWindow = object(TWindow)

var
  oApp        : TApplication;
  poMyMainWin : PMyWindow;

constructor TMyWindow.Init(strWinTitlePrm:ShortString);
//=====================================================
begin
inherited Init(strWinTitlePrm);

// This line is all what is needed to have a status line.
new(poStatusLine, Init(@Self));

// Default values
nIter:=100000;
nNbFaces:=6;
nNbPieces:=80;
end;  // TMyWindow.Init

destructor TMyWindow.Done;
//=========================
begin

inherited Done;
end;  // TMyWindow.Done

procedure TMyWindow.Test1;
//========================
// Simulate the throw of a dice
var
  wRep     : word32; // answer of the dialog box
  nn       : int32;  // to count the number of throws
  anCount  : array[0..40] of int32; // to count the occurences
  nVal     : int32;  // the value of one throw of the dice
  vSum1    : float;  // sum of the results;
  vSum2    : float;  // sum of the square of the results
  vMean    : float;  // mean of the results
  vSigma   : float;  // standard deviation of the results

begin
// initialisation
for nn:=0 to 40 do anCount[nn]:=0;
vSum1:=0;
vSum2:=0;

Int32Field(101, nIter);
Int32Field(102, nNbFaces);
// Ask the number of wanted iteration
wRep:=DialogExecMSG(11199, @Self);

if (wRep <> IDOK) then exit; // CANCELED the operation

if (nIter < 1) then nIter:=1;
if (nIter > 2000000000) then nIter:=2000000000;

if (nNbFaces <  1) then nNbFaces:= 1;
if (nNbFaces > 40) then nNbFaces:=40;

// do the simulations
for nn:=1 to nIter do begin
   nVal:=Random(nNbFaces)+1;
   inc(anCount[nVal]);
   vSum1:=vSum1 + nVal;
   vSum2:=vSum2 + sqr(nVal);
   end;

vMean:=vSum1 / nIter;
vSigma:= sqrt((vSum2/nIter - sqr(vMean)));
WriteWin(1, 'Number of throws =' + ITS(nIter) + '    mean value=' + FloatToStr(vMean,8,3) + '    sigma=' + FloatToStr(vSigma, 8, 4));
end;  // TMyWindow.Test1

procedure TMyWindow.Test2;
//========================
// Simulate the following experiment :
// Takes 50 numbers between 1 and 36 with repetition
// See how many times the 36 numbers have been choosen.
var
  wRep     : word32; // answer of the dialog box
  nn       : int32;  // counts the number of experiments
  n2       : int32;  // counts the number of objects taken in an experiment
  anCount  : array[0..36] of int32; //  count the number of time the  nn  number has been choosen
  anMax    : array[0..36] of int32; // counts the number of time exactly  nn  objects have been taken
  nNbtaken : int32;  // number of objects taken during one experiment
  nVal     : int32;  // the value of the choosen number
  vSum1    : float;  // sum of the results;
  vSum2    : float;  // sum of the square of the results
  vMean    : float;  // mean of the results
  vSigma   : float;  // standard deviation of the results

begin
// initialisation
for nn:=0 to 36 do anMax[nn]:=0;
vSum1:=0;
vSum2:=0;

Int32Field(101, nIter);
Int32Field(102, nNbPieces);
// Ask the number of wanted iteration
wRep:=DialogExecMSG(11299, @Self);

if (wRep <> IDOK) then exit; // CANCELED the operation

if (nIter < 1) then nIter:=1;
if (nIter > 2000000000) then nIter:=2000000000;

if (nNbPieces <    1) then nNbPieces:=   1;
if (nNbPieces > 1000) then nNbPieces:=1000;

// do the simulations
for nn:=1 to nIter do begin
  // initialisation
  for n2:=0 to 36 do anCount[n2]:=0;
  nNbtaken:=0;

  for n2:=1 to nNbPieces do begin
    nVal:=Random(36)+1;  // random number between 1 and 36
    if (anCount[nVal] = 0) then inc(nNbtaken);  // one new numbers has been taken
    inc(anCount[nVal]);
    end;

  inc(anMax[nNbtaken]);
  if (nNbtaken = 36) then vSum1:=vSum1 + 1;  // all objects has been taken
  end;

vSum2:=vSum1;

vMean:=vSum1 / nIter;
vSigma:= sqrt((vSum2/nIter - sqr(vMean)));
WriteWin(1, 'Number of experiments =' + ITS(nIter) + '    number of pieces=' + ITS5(nNbPieces));
WriteWin(1, 'mean value=' + FloatToStr(vMean,9,6) + '    sigma=' + FloatToStr(vSigma, 9, 6));
WriteWin(1, 'Number of times all 36 numbers have been taken=' + FloatToStr(vSum1,8,0));

// write the number of time  nn  numbers have been choosen
for nn:=25 to 36 do WriteWin(1, ITS5(nn) + ITS(anMax[nn]));
end;  // TMyWindow.Test2

procedure TMyWindow.Test3;
//========================
begin
end;  // TMyWindow.Test3

procedure TMyWindow.Test4;
//========================
begin
end;  // TMyWindow.Test4

function TMyWindow.WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT;
//=============================================================
// Handles the menu messages
Var wNrMenu     : word;
begin
WMCommand := 0; // Default return value when processing a message

if (lPar <> 0) then begin
   // call the parent WMCommand method.
   WMCommand:=inherited WMCommand(wPar, lPar);
   exit;
   end;

// for the menus,  lPar = 0
//=========================
wNrMenu   := LoWord(wPar);
Case wNrMenu Of
   101 : Test1;
   102 : Test2;
   103 : Test3;
   104 : Test4;

   else WMCommand:=inherited WMCommand(wPar, lPar);
   end;  // Case NrMenu Of
end;  // TMyWindow.WMCommand

function TMyWindow.WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT;
//======================================================================================
begin
// Default treatment of a message. Does nearly nothing
WindowProc := inherited WindowProc(hWindow, wMsg, wPar, lPar);
end;  // TMyWindow.WindowProc

Begin // MAIN ******
// Name under which the main window is registered. Spaces are not allowed
oApp.Init('Example075');

// Creation of the main window
new(poMyMainWin, Init('tEx075_Statistics_simulations.pp'));

oApp.Run;
oApp.Done;  // The main window object is disposed here.
End.

