{ Simulate series of 100 throws of a piece,
  in order to compute the probability of 
  some characteristique, as the number of
  occurences of 5 identical faces or
  the number of alternances.
  --------------------------------------------}
program tEx077;

// To tell FreePascal that the application is a Graphical User Interface
// i.e. is running in windows, not in text mode.
{$APPTYPE GUI}

Uses

  wApplication0
 ,wWindowText0 // To write text in an independent window
 ,wWindow0
 ,wDialog0
 ,wGlobals2
 ,wVariableNumLink2
 ,wDialogCreatorLOW2
 ,wDialogCreator2
// ,wUtiles0
 ,wMessages2
 ,wDebug0
 ,Windows
 ,commDlg;   { !!!  AJOUTER A LA VERSION 2.40 de Freeplascal, sinon problme !!! }

type
  PMyWindow = ^TMyWindow;
  TMyWindow = object(TWindow)
  //"""""""""""""""""""""""""
  // To do simulations, some parameters that can be changed in a dialog box.
  nIter     : int32;  // number of iteration
  nNbFaces  : int32;  // number of faces, between 1 and 40
  nNbPieces : int32;  // number of pieces (number) taken during one experiment

  constructor Init(strWinTitlePrm:ShortString);
  destructor Done; virtual;

  procedure Test1;
  procedure Test2;
  procedure Test3;
  procedure Test4;

  function WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  // Handles the menu messages

  function WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  end; // TMyWindow = object(TWindow)

type
  TArrayInt = array[0..1000] of int32;
  TArrayFlo = array[0..1000] of Float;

var
  oApp        : TApplication;
  poMyMainWin : PMyWindow;

constructor TMyWindow.Init(strWinTitlePrm:ShortString);
//=====================================================
begin
inherited Init(strWinTitlePrm);

// This line is all what is needed to have a status line.
new(poStatusLine, Init(@Self));

// Default values
nIter:=100000;
nNbFaces:=6;
nNbPieces:=80;
end;  // TMyWindow.Init

destructor TMyWindow.Done;
//=========================
begin

inherited Done;
end;  // TMyWindow.Done

//####################################################################################

{$R-}  // Range check error off  if  $R-

procedure MySetWriteFont;
//=======================
// dfini la police en courrier new
var
  strS        : string[80];
  astrFont    : array[1..4] of string[30];
  rLogFont    : TLogFont;
  pWinText    : PWindowText0;

begin
astrFont[1]:='Arial';
astrFont[2]:='Times New Roman';
astrFont[3]:='Courier New';
astrFont[4]:='Comic Sans MS';  // if you have it.

// define a new font.
strS:=astrFont[3]+#0;
with rLogFont do  begin
   lfHeight         := 0;                // Default logical height of font
   lfWidth          := 0;                // Default logical average character width
   lfEscapement     := 0;                // angle of escapement
   lfOrientation    := 0;                // base-line orientation angle
   lfWeight         := FW_NORMAL;        // font weight = 400
   lfItalic         := 0;                // italic attribute flag
   lfUnderline      := 0;                // underline attribute flag
   lfStrikeOut      := 0;                // strikeout attribute flag
   lfCharSet        := DEFAULT_CHARSET;  // character set identifier
   lfOutPrecision   := OUT_DEFAULT_PRECIS;  // output precision
   lfClipPrecision  := CLIP_DEFAULT_PRECIS; // clipping precision
   lfQuality        := DEFAULT_QUALITY;     // output quality
   lfPitchAndFamily := DEFAULT_PITCH;    // pitch and family
   lfFaceName       :=PCHAR(@strS[1]);         // pointer to typeface name string
   lfWeight:=700; // bold, could go up to 1000 for very bold
   lfHeight:=-12;
   end; // with

pWinText:=GetWriteWinNr(1);
if (pWinText <> NIL) then pWinText^.oRichEditFrame.SetActualFont(rLogFont);
//if (pWinText <> NIL) then pWinText^.oRichEditFrame.SetActualFont(pWinText^.oRichEditFrame.TheLogFont);
end; //  MySetWriteFont

procedure GetPileFaceSeries(Nbig:integer; var anS:TarrayInt);
//===========================================================
{ Retoune la simulation de Nbig lancs pile ou face }
var nn : integer;
begin { -  GetPileFaceSeries - }
//for nn:=1 to Nbig do anS[nn]:=integer(RandUnif01 < 0.5);
for nn:=1 to Nbig do anS[nn]:=integer(Random(32768) < 16384);  // 6 fois plus rapide!
end;  // GetPileFaceSeries

procedure CompteOccurences(Nbig:integer; var anS:TarrayInt; var anX:TarrayInt);
//=============================================================================
// Compte dans la suite anS le nombre d'occurences de certaines suites :
// anX[n] = nombre de squences ou "x" apparait exactement  n  fois de suite, "x" = "0"  ou  "x" = "1".
// Exemple :  0011101100011011  anX[1] = 2  anX[2] = 4  anX[3] = 2  anX[4] = 0
//             2 3 1 2 3 2 1 2
// anX[11] = nombre de squences ou "x" apparait 11  fois de suite ou plus, "x" = "0"  ou  "x" = "1".

var nn     : integer;
    nOut   : integer;
    nCpt   : integer;

begin
//OLD for nn:=1 to 12 do anX[nn]:=0;  // initialisation
for nn:=1 to 31 do anX[nn]:=0;  // initialisation

nOut:=anS[1];
nCpt:=0;

for nn:=2 to Nbig do begin
  inc(nCpt);  // augmente la longueur de la squence.

//  inc(anX[nCpt]);

  if (anS[nn] <> nOut) then begin
    // fin d'une squence
    if (nCpt > 30) then nCpt:=31;  // toutes les squences de plus de 30 identiques sont mises ensemble.
    inc(anX[nCpt]);
    nOut:=anS[nn];
    nCpt:=0;
    end;
  end; // for

// il faut tenir compte de la dernire squence.
inc(nCpt);  // augmente la longueur de la squence.
inc(anX[nCpt]);
anX[0]:=nCpt;  // = longueur de la dernire squence.
end;  // CompteOccurences


//####################################################################################


procedure TMyWindow.Test1;
//========================
// Simulate the throw of a dice
var
  nn       : int32; 
  n2       : int32;
  wRep     : word32; // answer of the dialog box
  anLances : TArrayInt; // suite de 100 lancs d'une piece
  anX      : TArrayInt; // nombre d'occurence de squences.
  Nbig     : int32;   // longueur de la suite = nombre de lancs de pice.  100 en gnral.
  nNbSimul : int32;   // nombre de simulation de Nbig lancs de pices.
  anSum01  : TArrayInt; // anSum01[nn] = nombre de fois qu'une simulation de Nbig lancs
                        // a donn  nn  fois une squences de 1 cot identique.
  anSum02  : TArrayInt; // anSum02[nn] = nombre de fois qu'une simulation de Nbig lancs
                        // a donn  nn  fois une squences de 2 cots identique.
  anSum03  : TArrayInt; // anSum03[nn] = nombre de fois qu'une simulation de Nbig lancs
                        // a donn  nn  fois une squences de 3 cots identique.
  anSum04  : TArrayInt; // anSum04[nn] = nombre de fois qu'une simulation de Nbig lancs
                        // a donn  nn  fois une squences de 4 cots identique.
  anSum05  : TArrayInt; // anSum05[nn] = nombre de fois qu'une simulation de Nbig lancs
                        // a donn  nn  fois une squences de 5 cots identique.
  anSum06  : TArrayInt; // anSum06[nn] = nombre de fois qu'une simulation de Nbig lancs
                        // a donn  nn  fois une squences de 6 cots identique.
  anSum07  : TArrayInt; // anSum07[nn] = nombre de fois qu'une simulation de Nbig lancs
                        // a donn  nn  fois une squences de 7 cots identique.
  anSum08  : TArrayInt; // anSum08[nn] = nombre de fois qu'une simulation de Nbig lancs
                        // a donn  nn  fois une squences de 8 cots identique.
  anSum09  : TArrayInt; // anSum09[nn] = nombre de fois qu'une simulation de Nbig lancs
                        // a donn  nn  fois une squences de 9 cots identique.
  anSum10  : TArrayInt; // anSum10[nn] = nombre de fois qu'une simulation de Nbig lancs
                        // a donn  nn  fois une squences de 10 cots identique.
  anSum11  : TArrayInt; // anSum11[nn] = nombre de fois qu'une simulation de Nbig lancs
                        // a donn  nn  fois une squences de 11 ou plus cots identique.
  anAdd01  : TArrayInt; // anAdd01[nn] = nombre de fois qu'une simulation de Nbig lancs
                        // a donn  nn  fois une squences de 1 cot ou plus identique.
  anAdd02  : TArrayInt; // anAdd02[nn] = nombre de fois qu'une simulation de Nbig lancs
                        // a donn  nn  fois une squences de 2 cots ou plus identique.
  anAdd03  : TArrayInt; // anAdd03[nn] = nombre de fois qu'une simulation de Nbig lancs
                        // a donn  nn  fois une squences de 3 cots ou plus identique.
  anAdd04,anAdd05,anAdd06,anAdd07,anAdd08,anAdd09,anAdd10,anAdd11  : TArrayInt;
  anZZZ02  : TArrayInt; // anZZZ02[nn] = nombre de fois qu'une simulation de Nbig lancs
                        // a donn  nn  fois une squences de 1 ou 2 cots identique.
  strS     : string;

begin
// initialisation
for nn:=0 to 1000 do begin
  anSum01[nn]:=0;  anSum02[nn]:=0;  anSum03[nn]:=0;  anSum04[nn]:=0;  anSum05[nn]:=0;  anSum06[nn]:=0;
  anSum07[nn]:=0;  anSum08[nn]:=0;  anSum09[nn]:=0;  anSum10[nn]:=0;  anSum11[nn]:=0;
  anAdd01[nn]:=0;  anAdd02[nn]:=0;  anAdd03[nn]:=0;  anAdd04[nn]:=0;  anAdd05[nn]:=0;  anAdd06[nn]:=0;
  anAdd07[nn]:=0;  anAdd08[nn]:=0;  anAdd09[nn]:=0;  anAdd10[nn]:=0;  anAdd11[nn]:=0;
  anZZZ02[nn]:=0;
  end;


Nbig:=100;
nNbSimul:=1;

Int32Field(101, Nbig);
Int32Field(102, nNbSimul);
// Ask the number of wanted iteration
wRep:=DialogExecMSG(11199, @Self);

if (wRep <> IDOK) then exit; // CANCELED the operation

if (Nbig > 1000) then Nbig:=1000;
if (nNbSimul > 2000) then nNbSimul:=2000;

nNbSimul:=nNbSimul * 1000000;

WriteWin(1, '  Xk = "nombre de squences de exactement  k  cts identiques."');
WriteWin(1, '  Z2 = "nombre de squences de au plus     2  cts identiques."');
MySetWriteFont;  // pour dfinir le type de police de caractres.
WriteWin(1, '   n   P(X1>=n)  P(X2>=n)  P(X3<=n)  P(X4<=n)  P(X5<=n)  P(X6<=n)  P(X7<=n)  P(X8<=n)  P(Z2>=n)');
// WriteWin(1, 'sequ.  1   2   3   4   5   6   7   8   9  10  11');

// rpte plusieurs sries de Nbig lancs
for n2:=1 to nNbSimul do begin

  GetPileFaceSeries(Nbig, anLances);
  CompteOccurences(Nbig, anLances, anX);
{
  strS:='';
  for nn:=1 to Nbig do strS:=strS + IntToStr(anLances[nn],2);
  WriteWin(1, strS);


  strS:='    ';
  for nn:=1 to 11 do strS:=strS + IntToStr(anX[nn],4);
  WriteWin(1, strS);
}
  //  anX[ii] = nombre de squence de exactement ii faces identiques.
  inc(anSum01[anX[1]]);
  inc(anSum02[anX[2]]);
  inc(anSum03[anX[3]]);
  inc(anSum04[anX[4]]);
  inc(anSum05[anX[5]]);
  inc(anSum06[anX[6]]);
  inc(anSum07[anX[7]]);
  inc(anSum08[anX[8]]);
  inc(anSum09[anX[9]]);
  inc(anSum10[anX[10]]);
  inc(anSum11[anX[11]]);

  inc(anZZZ02[anX[1] + anX[2]]);

  inc(anAdd11[anX[11]]);  anX[10]:=anX[10] + anX[11];
  inc(anAdd10[anX[10]]);  anX[ 9]:=anX[ 9] + anX[10];
  inc(anAdd09[anX[ 9]]);  anX[ 8]:=anX[ 8] + anX[ 9];
  inc(anAdd08[anX[ 8]]);  anX[ 7]:=anX[ 7] + anX[ 8];
  inc(anAdd07[anX[ 7]]);  anX[ 6]:=anX[ 6] + anX[ 7];
  inc(anAdd06[anX[ 6]]);  anX[ 5]:=anX[ 5] + anX[ 6];
  inc(anAdd05[anX[ 5]]);  anX[ 4]:=anX[ 4] + anX[ 5];
  inc(anAdd04[anX[ 4]]);  anX[ 3]:=anX[ 3] + anX[ 4];
  inc(anAdd03[anX[ 3]]);  anX[ 2]:=anX[ 2] + anX[ 3];
  inc(anAdd02[anX[ 2]]);  anX[ 1]:=anX[ 1] + anX[ 2];
  inc(anAdd01[anX[ 1]]);

  end; // longue boucle
//******************************************************************************3

// WriteWin(1, '');

{
for nn:=1 to 40 do begin
  strS:=IntToStr(nn,8) + IntToStr(anSum01[nn],10) + IntToStr(anSum02[nn],10) + IntToStr(anSum03[nn],10) +
                         IntToStr(anSum04[nn],10) + IntToStr(anSum05[nn],10) + IntToStr(anSum06[nn],10) +
                         IntToStr(anSum07[nn],10) + IntToStr(anSum08[nn],10) + IntToStr(anSum09[nn],10) +
                         IntToStr(anSum10[nn],10) + IntToStr(anSum11[nn],10);
  WriteWin(1, strS);
  end;

WriteWin(1, '');
}
for nn:=0 to 68 do begin
  strS:=IntToStr(nn,4) + FloatToStr(100.0-100.0*(anSum01[nn]/nNbSimul),10,4) + FloatToStr(100.0-100.0*(anSum02[nn]/nNbSimul),10,4) +
                         FloatToStr(100.0*(anSum03[nn]/nNbSimul),10,4) + FloatToStr(100.0*(anSum04[nn]/nNbSimul),10,4) +
                         FloatToStr(100.0*(anSum05[nn]/nNbSimul),10,4) + FloatToStr(100.0*(anSum06[nn]/nNbSimul),10,4) +
                         FloatToStr(100.0*(anSum07[nn]/nNbSimul),10,4) + FloatToStr(100.0*(anSum08[nn]/nNbSimul),10,4) +
                         FloatToStr(100.0-100.0*(anZZZ02[nn]/nNbSimul),10,4);
  WriteWin(1, strS);

  // cumulatif
  anSum01[nn+1]:=anSum01[nn+1] + anSum01[nn];
  anSum02[nn+1]:=anSum02[nn+1] + anSum02[nn];
  anSum03[nn+1]:=anSum03[nn+1] + anSum03[nn];
  anSum04[nn+1]:=anSum04[nn+1] + anSum04[nn];
  anSum05[nn+1]:=anSum05[nn+1] + anSum05[nn];
  anSum06[nn+1]:=anSum06[nn+1] + anSum06[nn];
  anSum07[nn+1]:=anSum07[nn+1] + anSum07[nn];
  anSum08[nn+1]:=anSum08[nn+1] + anSum08[nn];
  anSum09[nn+1]:=anSum09[nn+1] + anSum09[nn];
  anSum10[nn+1]:=anSum10[nn+1] + anSum10[nn];
  anSum11[nn+1]:=anSum11[nn+1] + anSum11[nn];
  anZZZ02[nn+1]:=anZZZ02[nn+1] + anZZZ02[nn];
  end;

WriteWin(1, '  Yk = "nombre de squences de au moins  k  cts identiques."');
WriteWin(1, '  Z2 = "nombre de squences de au plus     2  cts identiques."');
WriteWin(1, '   n   P(Y1>=n)  P(Y2>=n)  P(Y3<=n)  P(Y4<=n)  P(Y5<=n)  P(Y6<=n)  P(Y7<=n)  P(Y8<=n)  P(Z2>=n)');

for nn:=0 to 68 do begin
  strS:=IntToStr(nn,4) + FloatToStr(100.0-100.0*(anAdd01[nn]/nNbSimul),10,4) + FloatToStr(100.0-100.0*(anAdd02[nn]/nNbSimul),10,4) +
                         FloatToStr(100.0*(anAdd03[nn]/nNbSimul),10,4) + FloatToStr(100.0*(anAdd04[nn]/nNbSimul),10,4) +
                         FloatToStr(100.0*(anAdd05[nn]/nNbSimul),10,4) + FloatToStr(100.0*(anAdd06[nn]/nNbSimul),10,4) +
                         FloatToStr(100.0*(anAdd07[nn]/nNbSimul),10,4) + FloatToStr(100.0*(anAdd08[nn]/nNbSimul),10,4) +
                         FloatToStr(100.0-100.0*(anZZZ02[nn]/nNbSimul),10,4);
  WriteWin(1, strS);

  // cumulatif
  anAdd01[nn+1]:=anAdd01[nn+1] + anAdd01[nn];
  anAdd02[nn+1]:=anAdd02[nn+1] + anAdd02[nn];
  anAdd03[nn+1]:=anAdd03[nn+1] + anAdd03[nn];
  anAdd04[nn+1]:=anAdd04[nn+1] + anAdd04[nn];
  anAdd05[nn+1]:=anAdd05[nn+1] + anAdd05[nn];
  anAdd06[nn+1]:=anAdd06[nn+1] + anAdd06[nn];
  anAdd07[nn+1]:=anAdd07[nn+1] + anAdd07[nn];
  anAdd08[nn+1]:=anAdd08[nn+1] + anAdd08[nn];
  anAdd09[nn+1]:=anAdd09[nn+1] + anAdd09[nn];
  anAdd10[nn+1]:=anAdd10[nn+1] + anAdd10[nn];
  anAdd11[nn+1]:=anAdd11[nn+1] + anAdd11[nn];

  end;

WriteWin(1, '');
{
strS:='';
for nn:=1 to 8 do strS:=strS + IntToStr(anSum04[nn],4);
WriteWin(1, strS);

strS:='';
for nn:=1 to 8 do strS:=strS + IntToStr(anSum05[nn],4);
WriteWin(1, strS);
}
end;  // TMyWindow.Test1

procedure TMyWindow.Test2;
//========================
// Simulate the following experiment :
// Takes 50 numbers between 1 and 36 with repetition
// See how many times the 36 numbers have been choosen.
var
  wRep     : word32; // answer of the dialog box
  nn       : int32;  // counts the number of experiments
  n2       : int32;  // counts the number of objects taken in an experiment
  anCount  : array[0..36] of int32; //  count the number of time the  nn  number has been choosen
  anMax    : array[0..36] of int32; // counts the number of time exactly  nn  objects have been taken
  nNbtaken : int32;  // number of objects taken during one experiment
  nVal     : int32;  // the value of the choosen number
  vSum1    : float;  // sum of the results;
  vSum2    : float;  // sum of the square of the results
  vMean    : float;  // mean of the results
  vSigma   : float;  // standard deviation of the results

begin
// initialisation
for nn:=0 to 36 do anMax[nn]:=0;
vSum1:=0;
vSum2:=0;

Int32Field(101, nIter);
Int32Field(102, nNbPieces);
// Ask the number of wanted iteration
wRep:=DialogExecMSG(11299, @Self);

if (wRep <> IDOK) then exit; // CANCELED the operation

if (nIter < 1) then nIter:=1;
if (nIter > 2000000000) then nIter:=2000000000;

if (nNbPieces <    1) then nNbPieces:=   1;
if (nNbPieces > 1000) then nNbPieces:=1000;

// do the simulations
for nn:=1 to nIter do begin
  // initialisation
  for n2:=0 to 36 do anCount[n2]:=0;
  nNbtaken:=0;

  for n2:=1 to nNbPieces do begin
    nVal:=Random(36)+1;  // random number between 1 and 36
    if (anCount[nVal] = 0) then inc(nNbtaken);  // one new numbers has been taken
    inc(anCount[nVal]);
    end;

  inc(anMax[nNbtaken]);
  if (nNbtaken = 36) then vSum1:=vSum1 + 1;  // all objects has been taken
  end;

vSum2:=vSum1;

vMean:=vSum1 / nIter;
vSigma:= sqrt((vSum2/nIter - sqr(vMean)));
WriteWin(1, 'Number of experiments =' + ITS(nIter) + '    number of pieces=' + ITS5(nNbPieces));
WriteWin(1, 'mean value=' + FloatToStr(vMean,9,6) + '    sigma=' + FloatToStr(vSigma, 9, 6));
WriteWin(1, 'Number of times all 36 numbers have been taken=' + FloatToStr(vSum1,8,0));

// write the number of time  nn  numbers have been choosen
for nn:=25 to 36 do WriteWin(1, ITS5(nn) + ITS(anMax[nn]));
end;  // TMyWindow.Test2

procedure TMyWindow.Test3;
//========================
// Simulation d'une suite de lancer d'une pice de monnaie, pour
// dterminer des propabilits d'occurences.
var
  nn       : int32;
  n2       : int32;
  wRep     : word32; // answer of the dialog box
  anLances : TArrayInt; // suite de 100 lancs d'une piece
  anX      : TArrayInt; // nombre d'occurence de squences.
  Nbig     : int32;   // longueur de la suite = nombre de lancs de pice.  100 en gnral.
  nNbSimul : int32;   // nombre de simulation de Nbig lancs de pices.
  strS     : string;
  nNum2,   // nombre de squence de 2 ou plus occurences. = nombre de "ppf" + nombre de "ffp"
  nDen2,   // nombre de squence de "pp" + nombre de "ff".  "ffff" = 3 tels occurences !
  nNum3,   // nombre de squence de 3 ou plus occurences. = nombre de "pppf" + nombre de "fffp"
  nDen3,   // nombre de squence de "ppp" + nombre de "fff".  "ffff" = 2 tels occurences !
  nNum4,   // nombre de squence de 4 ou plus occurences. = nombre de "ppppf" + nombre de "ffffp"
  nDen4    // nombre de squence de "pppp" + nombre de "ffff".  "ffffff" = 3 tels occurences !
  // L'effet de bord droit fait que l'on considre toujours qu'il y a alternance aprs le dernier lanc.
           : int32;

  anW2    // anW2[nn] = nombre de squences telles que nNum2 / nDen2 >= nn / 100
 ,anW3    // anW3[nn] = nombre de squences telles que nNum3 / nDen3 >= nn / 100
 ,anW4    // anW4[nn] = nombre de squences telles que nNum4 / nDen4 >= nn / 100
        : TArrayInt; // nombre d'occurence de squences.
  wNb_ms
 ,wNb_msStart // pour mesurer la dure de la simulation
        : word32;
begin
// initialisation
for nn:=0 to 100 do begin
  anW2[nn]:=0;
  anW3[nn]:=0;
  anW4[nn]:=0;
  end;

Nbig:=100;
nNbSimul:=1;

Int32Field(101, Nbig);
Int32Field(102, nNbSimul);
// Ask the number of wanted iteration
wRep:=DialogExecMSG(11199, @Self);

if (wRep <> IDOK) then exit; // CANCELED the operation

if (Nbig > 1000) then Nbig:=1000;
if (nNbSimul > 2000) then nNbSimul:=2000;

nNbSimul:=nNbSimul * 1000000;

WriteWin(1, '  Wk = "nombre de squences de exactement  k  cts identiques  divis par"');
WriteWin(1, '       "nombre de squences de exactement  k  cts identiques suivit d''une face oppose."');
MySetWriteFont;  // pour dfinir le type de police de caractres.
WriteWin(1, '  nn   P(W2 >= nn%)  P(W3 >= nn%)  P(W4 >= nn%)');

wNb_msStart:=GetTickCount;

// rpte plusieurs sries de Nbig lancs
for n2:=1 to nNbSimul do begin

  GetPileFaceSeries(Nbig, anLances);
  CompteOccurences(Nbig, anLances, anX);
{
  strS:='';
  for nn:=1 to Nbig do strS:=strS + IntToStr(anLances[nn],2);
  WriteWin(1, strS);

  strS:='    ';
  for nn:=1 to 11 do strS:=strS + IntToStr(anX[nn],4);
  WriteWin(1, strS);
}
  //  anX[ii] = nombre de squence de exactement ii faces identiques.
//  nNum2:=anX[2];
  nDen2:=anX[2] + anX[3]*2;
  nDen3:=anX[3];
  nDen4:=0;
  nNum4:=0;
  for nn:=4 to 31 do begin
    nNum4:=nNum4 + anX[nn];
    nDen4:=nDen4 + anX[nn] * (nn - 3);
    nDen3:=nDen3 + anX[nn] * (nn - 2);
    nDen2:=nDen2 + anX[nn] * (nn - 1);
    end;

  nNum3:=anX[3] + nNum4;
  nNum2:=anX[2] + nNum3;

{ Si anX[0] >= 4, on a compt une alternance de trop dans les 3 dcomptes
  Si anX[0]  = 3, on a compt une alternance de trop dans les dcomptes nNum3 et nNum2
  Si anX[0]  = 2, on a compt une alternance de trop dans les dcomptes nNum2
  Dans ces cas, l'alternance ne devrait avoir lieu qu'une fois sur 2.
  Elle interviendrait bien une fois, mais le nombre de non alternances augmenterait
  Il faudrait donc ajouter  nDenx : 1*(1/2) + 2*(1/4) + 3*(1/8) + 4*(1/16) + ... = 2
  Mais cela complique l'analyse, sans changements importants.
  
  if (anX[0] >= 2) then nDen2:=nDen2 + 2;
  if (anX[0] >= 3) then nDen3:=nDen3 + 2;
  if (anX[0] >= 4) then nDen4:=nDen4 + 2;
}
  if (nDen2 > 0) then for nn:=0 to ((100*nNum2) div nDen2) do inc(anW2[nn]);
  if (nDen3 > 0) then for nn:=0 to ((100*nNum3) div nDen3) do inc(anW3[nn]);
  if (nDen4 > 0) then for nn:=0 to ((100*nNum4) div nDen4) do inc(anW4[nn]);
  end; // longue boucle
//******************************************************************************3

// affiche les rsultats
for nn:=45 to 90 do begin
  strS:=IntToStr(nn,4) + FloatToStr(100.0*(anW2[nn]/nNbSimul),14,4) +
                         FloatToStr(100.0*(anW3[nn]/nNbSimul),14,4) +
                         FloatToStr(100.0*(anW4[nn]/nNbSimul),14,4);
  WriteWin(1, strS);
  end;

wNb_ms:=GetTickCount - wNb_msStart;
WriteWin(1, '-----------  Time -----------' + FloatToStr(wNb_ms/1000,9,3) + ' [s]');
WriteWin(1, '');
end;  // TMyWindow.Test3

procedure TMyWindow.Test4;
//========================
begin
end;  // TMyWindow.Test4

function TMyWindow.WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT;
//=============================================================
// Handles the menu messages
Var wNrMenu     : word;
begin
WMCommand := 0; // Default return value when processing a message

if (lPar <> 0) then begin
   // call the parent WMCommand method.
   WMCommand:=inherited WMCommand(wPar, lPar);
   exit;
   end;

// for the menus,  lPar = 0
//=========================
wNrMenu   := LoWord(wPar);
Case wNrMenu Of
   101 : Test1;
   102 : Test2;
   103 : Test3;
   104 : Test4;

   else WMCommand:=inherited WMCommand(wPar, lPar);
   end;  // Case NrMenu Of
end;  // TMyWindow.WMCommand

function TMyWindow.WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT;
//======================================================================================
begin
// Default treatment of a message. Does nearly nothing
WindowProc := inherited WindowProc(hWindow, wMsg, wPar, lPar);
end;  // TMyWindow.WindowProc

Begin // MAIN ******
// Name under which the main window is registered. Spaces are not allowed
oApp.Init('Example077');

// Creation of the main window
new(poMyMainWin, Init('tEx077_Statistics_piece_lances.pp'));

oApp.Run;
oApp.Done;  // The main window object is disposed here.
End.

