Function SelectFile(Var strFName:ShortString; Open:Boolean): Boolean;
//===================================================================
Const
  Filter : PChar = 'Text files (*.des)'#0'*.des'#0+
                   'All files (*.*)'#0'*.*'#0#0;
  Ext    : PChar = 'des';
Var
  NameRec : OpenFileName;
Begin
FillChar(NameRec,SizeOf(NameRec),0);
strFName := #0;
With NameRec Do Begin
   LStructSize := SizeOf(NameRec);
   HWndOwner   := 0; // hParent;
   LpStrFilter := Filter;
   LpStrFile   := @strFName[1];
   NMaxFile    := Max_Path;
   Flags       := OFN_Explorer Or OFN_HideReadOnly;
   If Open Then Begin
      Flags := Flags Or OFN_FileMustExist;
      End;

    LpStrDefExt := Ext;
  End;

If Open Then SelectFile := GetOpenFileName(@NameRec)
Else         SelectFile := GetSaveFileName(@NameRec);

// Convert null terminated string to ShortString
strFName[0]:=Char(StrLen(@strFName[1]));
End;  // SelectFile

procedure TMyWindow.SaveFile;
//===========================
var
  strFName : ShortString;
  fOut     : file of byte;
  lResult  : int32;
  wErr     : word;
  nn       : integer;
  strS     : string[32];

begin
{$i-}
strFName:='serie_6f_201203.des';
if not SelectFile(strFName, false) then exit;

assign(fOut, strFName);
FileMode:=2; // read / write
Rewrite(fOut,1);
wErr:=IOResult;
if (wErr <> 0) then DBW(1, 'Error Rewrite : ' + strFName + '  Err=' + ITS5(wErr));

// Save the file header
strS:='De 6 faces, version :';
BlockWrite(fOut, strS[0], 30, lResult);

// Version
nn:=129;
BlockWrite(fOut, nn, sizeOf(nn), lResult);

BlockWrite(fOut, nScrollPos, sizeOf(nScrollPos), lResult);
BlockWrite(fOut, nSumTot, sizeOf(nSumTot), lResult);
for nn:=0 to 6 do BlockWrite(fOut, anSumX[nn], sizeOf(anSumX[nn]), lResult);

// Doit limiter le nombre d'images s'il y en a trop.
if (nIndImage >= MAX_IMAGE) then nIndImage:=MAX_IMAGE-1;

BlockWrite(fOut, nIndImage, sizeOf(nIndImage), lResult);
nIndImageLast:=nIndImage;
BlockWrite(fOut, pabDeVal^[0], (nIndImage+1)*SizeOf(pabDeVal^[0]), lResult);
BlockWrite(fOut, panDeCptLance^[0], (nIndImage+1)*SizeOf(panDeCptLance^[0]), lResult);

for nn:=0 to nIndImage+1 do
  BlockWrite(fOut, apaImage[nn]^, SizeOf(apaImage[nn]^), lResult);

close(fOut);
// Return the Input Output error
wErr:=IOResult;
if (wErr <> 0) then DBW(1, 'Error saving : ' + strFName + '  Err=' + ITS5(wErr));
end; // TMyWindow.SaveFile

procedure TMyWindow.OpenFile;
//===========================
var
  strFName  : ShortString;
  fIn       : file of byte;
  wErr      : word;
  rRec      : RECT;
  strS      : string[32];
  nVersion
 ,nn          :integer;

begin // TMyWindow.OpenFile
{$i-}
strFName:='serie_6f_201203.des';
if not SelectFile(strFName, true) then exit;

assign(fIn, strFName);
FileMode:=0; // read only
reset(fIn, 1);
// FileMode:=2; // read / write

// Save the file header
BlockRead(fIn, strS[0], 30);
DBW(1, 'Header = ' + strS);
wErr:=IOResult;
if (wErr <> 0) then DBW(1, 'Error BlockWrite : ' + strFName + '  Err=' + ITS5(wErr));

// Version
BlockRead(fIn, nVersion, sizeOf(nVersion));
DBW(1, 'Version = ' + ITS5(nVersion));

BlockRead(fIn, nScrollPos, sizeOf(nScrollPos));
BlockRead(fIn, nSumTot, sizeOf(nSumTot));
for nn:=0 to 6 do BlockRead(fIn, anSumX[nn], sizeOf(anSumX[nn]));

BlockRead(fIn, nIndImage, sizeOf(nIndImage));
nIndImageLast:=nIndImage;
BlockRead(fIn, pabDeVal^[0], (nIndImage+1)*SizeOf(pabDeVal^[0]));
BlockRead(fIn, panDeCptLance^[0], (nIndImage+1)*SizeOf(panDeCptLance^[0]));

for nn:=0 to nIndImage+1 do
  BlockRead(fIn, apaImage[nn]^, SizeOf(apaImage[nn]^));

SetScrollRange(
    hWin,	// handle of window with scroll bar
    SB_VERT, // scroll bar flag
    0, // minimum scrolling position
    nIndImage, // maximum scrolling position
    true 	// redraw flag
    );

if (nScrollPos >= nIndImageLast) then begin
  nScrollPos:=nIndImage;
  SetScrollPos(
      hWin,	// handle of window with scroll bar
      SB_VERT,	// scroll bar flag
      nIndImage,	// new position of scroll box
      true 	// redraw flag
      );
  // ask to redraw the complete window
  GetClientRect(hWin, rRec); // get the size of the client area, to redraw it
  invalidateRect(hWin, rRec, TRUE); // TRUE => redraw the backgroud (white) also
  PostMessage(hWin, WM_PAINT, 0, 0);
  end;

nIndImageLast:=nIndImage;  // pour la gestion du scroll bar.

close(fIn);
wErr:=IOResult; // clear any IO errors
if (wErr <> 0) then DBW(1, 'Error loading : ' + strFName);
end; // TMyWindow.OpenFile

(*
Procedure AskSave;
//==========================
Const
  BoxType = MB_IconQuestion Or MB_YesNo;
Begin
If (SendMessage(hWin, EM_GetModify, 0 ,0) <> 0) Then Begin
   If MessageBox(hParent, 'Save text?', 'Edited', BoxType)=IdYes Then Begin
      SaveText;
      End;
   End;
End;  // AskSave
*)
