{ Developpement of a graphic windows for plotting graphics.
  --------------------------------------------}
program tEx087_Test_AutoAxes;

// To tell FreePascal that the application is a Graphical User Interface
// i.e. is running in windows, not in text mode.
{$APPTYPE GUI}

Uses
  wAutoAxes0
 ,wGrBase0
 ,wApplication0
 ,wWindow0
 ,wDialog0
 ,wWindowBase0
 ,wDialogCreatorLow2
 ,wDialogCreator2
 ,wVariableNumLink2
// ,wUtiles0 // for the AccelTableMSGCreate function
 ,wGlobals2
 ,wParamApplic2
 ,wDebug0
 ,Windows
 ,commDlg;   { !!!  AJOUTER A LA VERSION 2.40 de Freeplascal, sinon problme !!! }

type
  PWindowGraphic = ^TWindowGraphic;
  TWindowGraphic = object(TWindow)
  //""""""""""""""""""""""""""""""

  pWinParent : PWindow; // Memorise the parent window who created this window

  pGrBase : PGraphicBase; // pointer on the base routine to draw graphics

  pAxes  : PAutoAxes;

  constructor Init(pWinPar:PWindow; strWinTitlePrm:ShortString);

  destructor Done; virtual;

  procedure WinCreate(strWinClass:ShortString); virtual;
  // Create the window, which will contain the graphics.

  procedure RepaintDelayed;
  // To repaint the window, but only with a delay

  procedure Repaint;
  // Repaint the window, without any delay

  procedure WMPaint;
  // the system want the program to repaint the client area.

  function WindowProcFirst(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  // Handles messages for the library, before calling  WindowProc
  // It is usually not overriden

  function WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  end; // TWindowGraphic = object(TWindow)
//########################################################################################

  PMyWindow = ^TMyWindow;
  TMyWindow = object(TWindow)
  //"""""""""""""""""""""""""

  pWinGr : PWindowGraphic;

  constructor Init(strWinTitlePrm:ShortString);
  destructor Done; virtual;

  procedure Test01;

  function WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  // Handles the menu messages
  end; // TMyWindow = object(TWindow)

var
  oApp        : TApplication;
  poMyMainWin : PMyWindow;

// var nNotUsed : integer; // only to avoid an error message while compliling in DevPascal 1.9

//**********************************************************************
//********  OBJECT TWindowGraphic = object(TWindow)
//**********************************************************************

constructor TWindowGraphic.Init(pWinPar:PWindow; strWinTitlePrm:ShortString);
//==========================================================================
begin
inherited Init(strWinTitlePrm);

wMsgDefaultMenu:=10010;

// Give a name to this window, to remember its position
strWindowName:='A Graphic Window';

pWinParent:=pWinPar;
end;

destructor TWindowGraphic.Done;
//=============================
begin
dispose(pGrBase, done);

PMyWindow(pWinParent)^.pWinGr:=nil; // Tell the parent that this window has been destroyed.

dispose(pAxes, done);

inherited Done;
end; // TWindowGraphic.Done

procedure TWindowGraphic.WinCreate(strWinClass:ShortString);
//==========================================================
// Create the window, which will contain the graphics.
var
  wD1,wD2,wD3,wD4,wD5, // data associated with the dialog file name
  wErrorL     : Word32;
begin
if (strWindowName <> '') and (gglpoPrm <> NIL) then begin
   gglpoPrm^.oSDL.GetStringDataW5(strWindowName, wD1,wD2,wD3,wD4,wD5,wErrorL);
   if (wErrorL = 0) then begin
      // Position set by the last position of the window
      // But size remains as computed (or set) otherwise.
      nLeft   :=wD1;
      nTop    :=wD2;
      nWidth  :=wD3;
      nHeight :=wD4;
      wSizeState:=wD5;
      end; // if (wErrorL = 0) then begin
   end; // if (strWindowName <> '') then begin

// here strWinClass=''.
inherited WinCreate(strWinClass);

// doit tre cr ici, pour que le hWin soit dfinit
new(pGrBase, Init(@Self));
new(pAxes, init(pGrBase));
end;  // TWindowGraphic.WinCreate

procedure TWindowGraphic.RepaintDelayed;
//=====================================
// To repaint the window, but only with a delay
begin { - TGapWindow.RepaintDelayed - }
InvalidateRect(hWin, NIL, TRUE);
end;  // TWindowGraphic.RepaintDelayed

procedure TWindowGraphic.Repaint;
//===============================
// Repaint the window, without any delay
var
  Msg              : TMsg;

begin // TWindowGraphic.Repaint
InvalidateRect(hWin, NIL, TRUE);

{ pour laisser le Repaint faire sont action de dessiner }
while PeekMessage(Msg, 0, 0, 0, pm_Remove) do begin
   if not IsDialogMessage(0, Msg) then begin
      TranslateMessage(Msg);
      DispatchMessage(Msg);
      end;
   end;
end;  // TWindowGraphic.Repaint

procedure TWindowGraphic.WMPaint;
//===============================
Var
  hDcPaint    : hdc;
  rPS         : paintstruct;
  nn,nIndMax : integer;
  avX,avY : array[0..500] of float;

begin // TWindowGraphic.WMPaint

hDcPaint:=BeginPaint(hWin, @rPS);

// While redrawing the window, tells the basic graphic the usable device context
pGrBase^.hDC0:=hDcPaint;

pGrBase^.fClippingAuto:=false; // pas de clipping

// Dfini les coordonnes utilisateur
pGrBase^.useXMin:= -20;
pGrBase^.useXMax:= 100;
pGrBase^.useYMin:=-1.2;
pGrBase^.useYMax:= 1.3;

pGrBase^.mmX1Left   :=0;
pGrBase^.relX1Left  :=0.05;
pGrBase^.mmY1Top    :=0;
pGrBase^.relY1Top   :=0.05;
pGrBase^.mmX1Width  :=0;
pGrBase^.relX1Width :=0.90;
pGrBase^.mmY1Height :=0;
pGrBase^.relY1Height:=0.90;

pGrBase^.mmX2Left   :=0;
pGrBase^.relX2Left  :=0.05;
pGrBase^.mmY2Top    :=0;
pGrBase^.relY2Top   :=0.05;
pGrBase^.mmX2Width  :=0;
pGrBase^.relX2Width :=0.90;
pGrBase^.mmY2Height :=0;
pGrBase^.relY2Height:=0.90;

pGrBase^.UpdateWin12Pos;

nIndMax:=500;
for nn:=0 to nIndMax do begin
  avX[nn]:=-15 + 110 * nn / nIndMax;
  avY[nn]:=sin(avX[nn]);
  end;
//pAxes^.AutoAxes(nIndMax, avX,avY, 0);

avX[0]:=pGrBase^.useXMin;
avX[1]:=pGrBase^.useXMax;
avY[0]:=pGrBase^.useYMin;
avY[1]:=pGrBase^.useYMax;
//pAxes^.AutoAxes(2, avX,avY, 0);
pAxes^.AutoAxes(2, avX,avY, flaAxesInterceptX0Y0 or flaAxesWithFrame);

// Secondary grid
pAxes^.DrawGrid( 2, 2,
                 PS_DOT,  {=PS_SOLID, PS_DASH, PS_DOT, PS_DASHDOT, c.f. CreatePen }
                 1,        { 1..infinity, paisseur minimale en pixels }
                 0.01,        { paisseur minimale en milimtres }
                 64 + 256*196 + 65536*128 { nRed + 256*nGreen + 65536*nBlue =RGB(0..255, 0..255, 0..255) }
                 );

// Main Grid
pAxes^.DrawGrid( 1, 1,
                 PS_SOLID,  {=PS_SOLID, PS_DASH, PS_DOT, PS_DASHDOT, c.f. CreatePen }
                 1,        { 1..infinity, paisseur minimale en pixels }
                 0.01,        { paisseur minimale en milimtres }
                 196 + 256*128 + 65536*128 { nRed + 256*nGreen + 65536*nBlue =RGB(0..255, 0..255, 0..255) }
                 );

// Ligne en coordonne utilisateur
nn:=-151;
pGrBase^.MoveTo0(nn*0.1, sin(nn*0.1));
for nn:=-150 to 950 do pGrBase^.LineTo0(nn*0.1, sin(nn*0.1));

EndPaint(hWin, rPS);

pGrBase^.hDC0:=0;
end;  // TWindowGraphic.WMPaint

function TWindowGraphic.WindowProcFirst(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT;
//===========================================================================================
// Handles messages for the library, before calling  WindowProc
var
  wErrorL     : word32;
begin
if (wMsg = WM_NCDestroy) then begin
   // If the window has a name, then its size and position can be associated
   // with it in the String - Data Link file. Save these values
   if (strWindowName <> '') and (gglpoPrm <> NIL) then begin
      gglpoPrm^.oSDL.SetStringDataW5(strWindowName, nLeft,nTop,nWidth,nHeight,wSizeState,wErrorL);
      end; // if (strWindowName <> '') then begin
   end;

WindowProcFirst:=inherited WindowProcFirst(hWindow, wMsg, wPar, lPar);
end;  // TWindowGraphic.WindowProcFirst

function TWindowGraphic.WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT;
//============================================================================================
// All window messages are send here.
Begin
Case wMsg Of
   WM_Paint   : WMPaint; // must redraw the client area part.
   End; // Case wMsg Of

// Default processing of the messages.
WindowProc:=inherited WindowProc(hWindow, wMsg, wPar, lPar);
End;  // TWindowGraphic.WindowProc

//**********************************************************************
//********  OBJECT TMyWindow = object(TWindow)
//**********************************************************************

constructor TMyWindow.Init(strWinTitlePrm:ShortString);
//=====================================================
begin
inherited Init(strWinTitlePrm);
//dwStyle := dwStyle or WS_VScroll; // to have a vertical scroll bar

pWinGr:=nil;

new(poStatusLine, Init(@Self));
end;  // TMyWindow.Init

destructor TMyWindow.Done;
//========================
//var nn : integer;
begin

if (pWinGr <> nil) then dispose(pWinGr, Done);

dispose(poStatusLine, Done);

inherited Done;
end;  // TMyWindow.Done

procedure TMyWindow.Test01;
//=========================
var
  fOK : boolean;

begin
if (pWinGr = nil) then begin
  new(pWinGr, init(@self, 'Hello in my test graphic window')); // Maximum of 5 graphics in this window. 1 is usually enough
  pWinGr^.WinCreate('');
  end;

// Redraw the window
fOK:=InvalidateRect(pWinGr^.hWin, nil, TRUE);  fOK:=fOK;
end; // TMyWindow.Test01

function TMyWindow.WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT;
//=============================================================
// Handles the menu messages
Var
  wNrMenu     : word;

begin
WMCommand := 0; // Default return value when processing a message

if (lPar <> 0) then begin
   // call the parent WMCommand method.
   WMCommand:=inherited WMCommand(wPar, lPar);
   exit;
   end;

// for the menus,  lPar = 0
//=========================
wNrMenu   := LoWord(wPar);
Case wNrMenu Of

   101 : Test01;

   // Parameters
   301 : begin
         DialogExecMSG(30199, @Self);
         end;

   // A help information
   901 : DialogExecMSG(90199, @Self);

   else WMCommand:=inherited WMCommand(wPar, lPar);
   end;  // Case NrMenu Of
end;  // TMyWindow.WMCommand

Begin // MAIN ******
// to use the application parameters defined here.
//new(poMyAppPrm, Init);
//gglpoPrm:=poMyAppPrm; // it will be destroyed in the TApplication automatically

// Name under which the main window is registered. Spaces are not allowed
oApp.Init('tEx087_Test_AutoAxes');

// Creation of the main window
new(poMyMainWin, Init('tEx087_Test_AutoAxes'));

// The App.WindowClass can be modified here, if wanted. (Not usual)
oApp.Run;
oApp.Done;  // The main window object is disposed here.
End.
