unit wUtiles2;

{ Feel free to use this unit as you want.
  First developped by Bernard Gisin

  Some utilities, Windows independent
  ----------------------------------------------------------------}

INTERFACE
//"""""""

uses  wGlobals2;

procedure QSort(nMin,nMax:int32; var avNum:TypeArrayFloat);
//=========================================================
// Sort the array of numbers avNum[nMin..nMax].
// do it recursively.
// We use quicksort, the fastest sorting algorithme.

IMPLEMENTATION
//""""""""""""

procedure QSort(nMin,nMax:int32; var avNum:TypeArrayFloat);
//=========================================================
// Sort the array of numbers avNum[nMin..nMax].
// do it recursively.
// We use quicksort, the fastest sorting algorithme.
var
  nL,nR
              : int32;
  vPivot      : Float;
  vMemory     : Float;  // to exchange to Float numbers

begin
nL :=nMin;
nR :=nMax;
vPivot := avNum[(nMin + nMax) div 2];

// Separate the distances smaller to the  vPivot  from those greater.
repeat
   // look for a number smaller than vPivot and
   // another greater than vPivot, to exange their places
   while (avNum[nL] < vPivot) do inc(nL);
   while (avNum[nR] > vPivot) do dec(nR);

   if (nL <= nR) then begin
      // In case of equality, (rare), the swap is useless, but
      // the  inc(nL) and  dec(nR) are usefull
      if (nL <> nR) then begin
         // Exange the two numbers.
         vMemory   :=avNum[nR];
         avNum[nR] :=avNum[nL];
         avNum[nL] :=vMemory;
         end;

      inc(nL);
      dec(nR);
      end;
   until (nL > nR);

// nMin .. nR vPivot nL .. nMax
// The test assure that the recurence level is at most = Log2(nMax - nMin).
// The smaller interval must always be sorted first, to go out faster
// from recurence levels
if (nR - nMin < nMax - nL) then begin
   if (nMin < nR)   then QSort(nMin, nR, avNum); // this is done first
   if (nL   < nMax) then QSort(nL, nMax, avNum);
   end
else begin
   if (nL   < nMax) then QSort(nL, nMax, avNum);
   if (nMin < nR)   then QSort(nMin, nR, avNum); // this is done in second this time
   end;
end;  // QSort


End.  // unit wUtiles2;

