unit wGraphic0;

(*Unit pour la gestion simplifie de graphiques, avec leurs courbes et
  des informations correspondantes.

  TGAPInfo = object
  { Il contient de l'information gnrale, tel que des commentaires,
    nom de l'utilisateur, date, nom de fichier, nom de rpertoire.

  TGAPCurve = object
  { Il contient l'information sur des courbes }

  TGAPGraphic = object
  { Il contient l'information sur des graphiques }

  TGAPWindow = object(TWindow0)
  { Il contiend des graphiques, et du texte. }

------------------------------------------------------------------------*)

// To tell FreePascal that the application is a Graphical User Interface
// i.e. is running in windows, not in text mode.
{$APPTYPE GUI}

interface
{"""""""}

Uses
  wAutoAxes0
 ,wGrBase0
 ,wWindow0
 ,wFontManager
// ,wPrinter0
 ,wErrors0
 ,wWindowBase0
 ,wUtiles0
 ,wMessages2
 ,wParamApplic2
 ,wGlobals2
 ,wDebug0
 ,Strings
 ,Windows;

const
msgNewWindowTitle                      = 59000;
msgLoadGraphicWinTitle                 = 59001;

msgGAPGrZoomXY                         = 59060;
msgGAPGrZoomOnlyX                      = 59065;
msgGAPGrZoomOnlyY                      = 59070;

{ Erreurs possibles : 300..599 }
{ ------------------------------ }
{TGAPInfo 300..319}

{TGAPCurve 320..399}
errTooManyGraphics                     =  320;
errCurveNotCreated                     =  321;
errCurveDoesNotExist                   =  322;

{TGAPGraphic 400..449}
errTooManyCurves                       =  400;
errCurveNotInit                        =  401;
errBadFileGraphic                      =  402;
errGraphicNotCreated                   =  403;

{TGAPWindow 450..499}
errTooManyGraphicsInWin                =  450;
errWindowNotCreated                    =  451;

{Gnral 500..599}
errEOFTooEarly                         =  500;
{ Si fin de fichier atteind avant la normale }

const
  errInAddNewGraphic = 452;  { A DEFINIR }
  errInAddNewCurve   = 404;  { A DEFINIR }

{ De manire gnrale, on utilise des Flags >= 256, et on laisse libre
  les flags <= 255 pour l'utilisateur dveloppeur }
const
{ pour TGAPInfo }
flaInfoCopyNoUserName                  =   8;

const
{ pour TGAPCurve }
flaCurveSaveNoCurves                   = 1 shl 10;
{ Indique que l'on ne veut pas sauver les courbes, uniquement
  l'information sur les courbe, mais pas les tableau pXD^[nn] et pYD^[nn]. }

flaCurveWithoutAllocateXData           = 1 shl  11;
flaCurveWithoutAllocateYData           = 1 shl  12;

flaCurveSaveOnlyY                      = 1 shl  13;
{ indique au save de ne sauver que les donnes pYD^[nn], pas pXD^[nn] }

flaCurveLoadDefineX                    = 1 shl  14;
{ indique au load de reconstruire les donnes pXD^[nn]  l'aide
  de vXMin, vXMax et nIndMax qui sont lue du fichier.
  Suppose avoir pXD^[nn]:=vXMin + nn*(vXMax - vXMin) / nIndMax }

{flaCurveCopyFields                     = 0;EFFACER}
{ Pour copier les champs d'une courbe sur une autre }

{flaCurveSaveNoCurves                  = 1 shl 10; }
{ EST AUSSI UTILISE DANS LES FLAGS DE TGAPGRAPHIC. }
{ Indique que l'on ne veut pas sauver les courbes, uniquement
  l'information sur les courbe, mais pas les tableau pXD^[nn] et pYD^[nn]. }

flaGraphicSaveOnlyDisplayed            = 1 shl  9;
{ Flags de sauvegarde, doit tre compatible avec les flags de sauvegarde
  de courbes }

flaNoCopyY                             = 1 shl  14;
flaNoCopyX                             = 1 shl  15;

const
{ pour TGAPGraphic }
flaGraphicZoomAutoX                    = 1 shl   9;
{ Pour indiquer que le zoom de l'axe X doit tre enleve quand on ne
  zoom que en Y }

flaGraphicOnWindow                     = 1 shl  10;
{ indique que le graphique est affich dans une Window }

flaGraphicZoomOnlyX                    = 1 shl  11;
{ indique au ZoomXYDefine que le Zoom ne se fait que sur X.
 Le calcul de l'axe Y doit se fera automatiquement. }

flaGraphicZoomOnlyY                    = 1 shl  12;
{ indique au ZoomXYDefine que le Zoom ne se fait que sur Y. }

flaAutoDisposeGrBase                    = 1 shl 13;
{ indique que un  Dispose  de l'objet TGraphicBase
  sera fait au Done du TGAPGraphic ou du TGAPWindow }

flaAutoDisposeAxes                     = 1 shl 14;
{ indique que un  Dispose  de l'objet TAutoAxes sera fait
  au Done du TGAPGraphic. }

flaAutoDisposeGrAxes      = flaAutoDisposeGrBase or flaAutoDisposeAxes;
flaAutoDisposeInfoGrAxes  = flaAutoDisposeGrBase or flaAutoDisposeAxes;

flaAutoDisposeSelf                     = 1 shl 15;
{ indique que un  Dispose de l'objet sera fait au Done de l'objet qui
  contient celui-ci. Exemple, l'info d'un courbe ou d'un graphique,
  la courbe d'un graphique ou le graphique d'une Window. }

flaNoLoadOtherData                     = 1 shl 13;
{ Indique que au LoadGraphicName, de ne pas essayer de charger
  d'autres types de fichiers que les fichiers de GAPGraphic }

flaNoChangeWindowTitle                 = 1 shl 14;
{ Indique que au LoadGraphicName, le nom de la fentre n'est pas
  mis au nom du fichier }

flaGrNoCopyCurves                        = 1 shl 15;
{ Indication dans CopyGrTo de ne pas copier les courbes du graphique }

{ pour TGAPWindows }
flaNoGrBase                              = 1 shl 9;

flaWinNoCopyGr                           = 1 shl 14;
{ Indication dans CopyWinTo de ne pas copier les graphiques }

{c.f. flaGrNoCopyCurves                        = 1 shl 15;}
{ Indication dans CopyWinTo de ne pas copier les courbes des graphiques }

{flaAutoDisposeGrBase                    = 1 shl 13; }
{ indique que un  Dispose  de l'objet TGraphicBase
  sera fait au Done du TGAPGraphic ou du TGAPWindow }

const
  DIX              = 10;
  VINGT            = 20;
  TRENTE           = 30;
  cteIndMaxFloat   = 32766; // Taille maximale des tableaux de float
  cteTypeTGAPWindow            = 11;

 { dcalage des messages utilisateurs,
   cf. remarque sur le message WmU_CbnSetFocus, plus bas }
 Wm_GapUser = Wm_User + 500;  { = 1024 + 500 }

 { Message envoy  une fentre pour savoir sont type.
   Chaque application (comme PMDWin) doit implmenter sont utilisation de
   ce message }
 WmU_GetObjectType  = Wm_GapUser + 15;

type
TStr10 = String[10];
TStr30 = String[30];
TStr60 = String[60];
TStr80 = String[80];
TStr120 = String[120];
TStr160 = String[160];
TStrFilePath = String[150];
TPathStr = String[150];
PArrayFloat = PTypeArrayFloat;

PGAPInfo = ^TGAPInfo;
TGAPInfo = object
{===============}
  wIdentity        : word;
  { NE PAS MODIFIER.
    = 7384 si l'objet a t init. et n a pas t dtruit par Done.
    Utile pour vrifier si on peut
    accder  cette objet ou non. (A utiliser avec IsBadWritePtr?) }

  { Il contient de l'information gnrale, tel que des commentaires, nom de l'utilisateur,
  date, heure, nom de fichier, nom de rpertoire. }
  strDate          : TStr30;
  strTime          : TStr30;
  strUserName      : TStr60;

  strComment1      : TStr80;
  strComment2      : TStr80;

  strFileDir       : TStr80;
  strFileName      : TStr10;
  strFileExt       : TStr10;

  {fIsSaveCu = not fHasChangedInfo }
  fHasChangedInfo     { =TRUE si il a t modifi depuis le dernier save }
                   : boolean;

  { Date et heure, sous forme code, par ordre croissant.
    utiliser PackTime et UnPackTime pour convertir en claire }
  lDateTime        : longint;

  nKind            : integer;
  { Peut tre utilis par des sous objets pour dfinir de
    quel objets il s'agit. l'anctre=0, les enfants grandissent le No. }

  constructor Init(Flags:word);
  Destructor  Done; virtual; {ne fait rien, mais utile pour futur}

  procedure Standardize; virtual;
  { Standardise le nom de rpertoire strFileDir (termine par un '\',
    et le nom d'extention (commence par un '.' }

  function GetFileNameExt:string;
  { retourne le nom de fichier avec extension }

  function GetFilePath:TStrFilePath;
  { retourne le nom de fichier avec extension et rpertoire. }

  procedure UpdateStrFile(strFilePath:TStrFilePath);
  { Met  jours strFileDir, strFileName et strFileExt,
    en fonction de strFilePath }

  procedure SaveMoreInfo(var fOut:Text; var nErr:integer); virtual;
  { Cette procdure est destine a tre redfinie par l'utilisateur.
    Elle va de paire avec la procedure LoadMoreInfo(fIn, nErr).
    Ne pas appeler le inherited SaveMoreInfo(fOut, nErr);
    ni le inherited LoadMoreInfo(fIn, nErr);
    nErr = IOResult;
  -------------------------------------------------------------------------}

  procedure SaveInfo(var fOut:Text; var nErr:integer); {virtual;}
  {  surclasser SaveMoreInfo, mais pas cette procdure.
    nErr = IOResult }

  procedure LoadMoreInfo(var fIn:Text; var nErr:integer); virtual;
  { Cette procdure est destine a tre redfinie par l'utilisateur.
    Elle va de paire avec la procedure SaveMoreInfo(fOut, nErr).
    Ne pas appeler le inherited SaveMoreInfo(fOut, nErr);
    ni le inherited LoadMoreInfo(fIn, nErr);
    nErr = IOResult;
  -------------------------------------------------------------------------}

  procedure LoadInfo(var fIn :Text; var nErr:integer); {virtual;}
  {  surclasser LoadMoreInfo, mais pas cette procdure
    nErr = IOResult ou
   errEOFTooEarly. }

  procedure CopyInfoTo(pInfo:PGAPInfo; Flags:word); virtual;
  { Nouveau, copie toutes les donnes dans pInfo^.
    Flags = 0 => copie tout!
    Flags = 1 => copie sauf lDateTime.
    Flags = 2 => copie sauf strTime.
    Flags = 4 => copie sauf strDate.
    Flags = 8 => ne copie pas le username
      (8=flaInfoCopyNoUserName)
  ------------------------------------------------------}
(*???
  procedure PutFields(nFirstNum:integer; pFiche:PFiche); virtual;
  { Met les paramtres dans  Fiche....Field pour les traiter
    dans des boites de dialogues.
    nFirstNum = 1er numro utilis pour mettre les champs.
  --------------------------------------------------------------------}
???*)
  end; { - TGAPInfo = object - }

{ Dfini ici, car les courbes mmorise les graphiques qui les contiennent,
  et les graphiques mmorisent les Windows qui les contiennent.
  Bien sur les Window mmorisent les grapihques qui mmorisent les courbes. }
PGAPCurve = ^TGAPCurve;
PGAPGraphic = ^TGAPGraphic;
PGAPWindow = ^TGAPWindow;
//???PZoomDlg = ^TZoomDlg;

TGAPCurve = object
{================}

  wIdentity        : word;
  { NE PAS MODIFIER.
    = 9725 si l'objet a t init. et n a pas t dtruit par Done.
    Utile pour vrifier si on peut
    accder  cette objet ou non. A utiliser avec IsBadWritePtr. }

  pInfo            : pGAPInfo;
  { Il contient l'information sur des courbes }
  { information li  la courbe, tel que commentaire, nom d'utilisateur, ...}

  fAutoDisposeInfo : boolean;
  { indique si au dispose il faut aussi disposer de l'info }

  isInit           : boolean;
  { indique si le constructeur init  t appel.
    Si non, la donnes est inutilisable }

  isLoaded         : boolean;
  { indique si la donne a t dfinie, ne doit pas etre
    mis a TRUE, sans qu'il y ait des donnes disponibles }

  { n'est pas mis  jours, car trop d'endroit  contrler! }
  {fIsSaveCu = not fHasChangedCu }
  fHasChangedCu     { =TRUE si il a t modifi depuis le dernier save }
                    : boolean;

  fDraw            : boolean;
  { indique si on veut le dessin de la courbe, ceci peut etre modifi
    si on veut le graphique de la courbe ou non. }

  nIndMaxAbs       : integer; {A lire uniquement}
  { Les donnes pXD^ et pYD^, sont des array[0..nIndMaxAbs] of Float }

  { --- Les trois champs suivants sont modifi frquemment --- }
  pXD              : PArrayFloat;
  pYD              : PArrayFloat;
  { donnes en X et Y de la courbe }

  nIndMax          : integer;
  { nombre de donne : 0..nIndMax.
    Est gnralement uniquement modifi dans InitForDraw. }

  { indication sur la couleur et le style de la courbe du graphique,
    est dfini dans l'Init, mais est modifiable }
  fDrawCurveCu     : boolean; { indique si il faut dessiner les lignes }
  styleLineCu      : TStyle;    {=PS_SOLID, PS_DASH, PS_DOT, PS_DASHDOT, c.f. CreatePen }
  pixWidthLineCu   : integer;   { 0..infinity }
  mmWidthLineCu    : Float;     { paisseur minimale en milimtres }
  colLineCu        : TColorRef; { =RGB(0..255, 0..255, 0..255) }

  { Pour des Marques  la place des points }
  fDrawMarkCu        : boolean; { indique si il faut dessiner les marques }
  styleMarkCu        : TStyle;    {=PS_SOLID, PS_DASH, PS_DOT, PS_DASHDOT, c.f. CreatePen }
  pixWidthMarkCu     : integer;     { 0..infinity }
  mmWidthMarkCu      : Float;     { paisseur minimale en milimtres }
  colMarkCu          : TColorRef; { =RGB(0..255, 0..255, 0..255) }
  sizeMarkCu         : Float;     { = taille de la marque en milimtres }
  nMarkStyleCu       : integer;   { Type de marque, c.f. markPlus,... de wGrBase }

  strLegend        : TStr60;
  { Lgende associe  la courbe }

  apGr             : array[1..DIX] of PGAPGraphic;
  nbGr             : integer;
  { graphiques contenant la courbe. }

  { au save de la courbe, cherche les indices indXMin et indXMax de pXD^
     l'aide de  SearchMinMax(nIndMax+1, pXD^[0], indXMin, indXMax);
    sauve vXMin et vXMax, utile pour recalculer XData si XData espac rgulirement.
    Au Load, charge vXMin et vXMax. }
  indXMin,
  indXMax          : integer;
  vXMin,
  vXMax            : Float;

  fNoXOrder        : boolean;
  { indique que les donnes en X ne sont pas ordonnes. En particulier, lors
    d'un zoom de graphique, il ne faut pas rechercher des indices min et max
    pour un affichage plus rapide. }

  fDoAutoDispose   : boolean;
  { Read Only.
    Indique si il faut librer automatiquement la mmoire alloue
    pour cette courbe au Done du dernier graphique qui la contient.
    Est dfini  l'init. }

  { pour le formattage des donnes pXD^ et pYD^  la sauvegarde dans des
    fichiers }
  rXFmt,dXFmt,                { writeln(pXD^[nn]:rXFmt:dXFmt, pYD^[nn]:rYFmt:dYFmt); }
  rYFmt,dYFmt      : integer;

  nKind            : integer;
  { Read Only.
    Peut tre utilis par des sous objets pour dfinir de
      quel objets il s'agit }

  { - Donnes prives }
  { ----------------- }
  Private  { NE PAS MODIFIER CES VALEURS }
  {""""""""""""""""""""""""""""""""""""""}
  wMemSizeX        : word;
  wMemSizeY        : word;
  { Mmorisation de dimension.
    = (nIndMaxAbs + 1) * word(SizeOf(Float)) ou
    = 0, selon le Flags  l'init. }

  pXDMem           : PArrayFloat;
  pYDMem           : PArrayFloat;
  { mmorise les pointeurs d'allocation mmoire, pour librer la mmoire
    au bonne endroit, si pXD ou pYD  t modifi }

  fCalled          : boolean;
  { pour viter des boucles d'appels circulaire }

  { - Mthodes publiques de TGAPCurve }
  { ================================= }
  public
  {""""}

  { - constructeur et destructeur - }
  { ------------------------------- }

  constructor Init(pI:PGAPInfo; nIndMaxAbs0,Flags:word);
  { Alloue la mmoire pour pXD, pYD, = array[0..nIndMaxAbs0] of Float
    Selon les Flags, on peut ne pas allouer de mmoire pour pXD ou PYD,
    et dans ce cas, l'utilisateur devra faire pointer pXD ou pYD sur un
    array of Float.
    pI   = NIL => allocation automatique de pInfo, en utilisant
                  glfnNewInfo(0);  fAutoDisposeInfo:=TRUE;

    Si TGAPInfo a t surdfini, on a deux choix :
    1) (Meilleur) : faire pointer glfnNewInfo sur une fonction
       qui alloue et init une information. C.f. NewInfoSKE(...)
       Tout le reste est fait automatiquement.
    2) On peut initialiser avant l'appel de cette Init un objet
       pI, et le passer en tant que pointeur a cette Init.
       La variable fAutoDisposeInfo dcide si l'info sera dsalou
       automatiquement au Done de la courbe ou non.
  -------------------------------------------------------------------------}

  Destructor Done; virtual;
  { Libre la mmoire alloue par le constructeur. }

  procedure GetFamilly( var nbParent:integer;
                        var astrFamilly:array of TSTR30); virtual;
  { Pour connaitre tous les anctres d'un objet.
    c.f. wSKEVar.pas pour voir comment implmenter les descendant.
    OUTPUT :
    nbParent = nombre de membre dans la famille
    astrFamilly = nom des ojbets. }

  procedure AddToGraphic(pGr1:PGAPGraphic; var nErr:integer);
  { Ajoute la courbe au graphique pGr1.
    Utiliser TGAPGraphic.AddCurve au lieu de cette procdure.
    nErr = 0 ou
    errTooManyGraphics
    errTooManyCurves de AddCurve
    errCurveNotInit  de AddCurve
  -------------------------------------------------------------------------}

  procedure RemoveFromGraphic(pGr1:PGAPGraphic);
  { Enlve la courbe du graphique pGr1.
    Utiliser TGAPGraphic.RemoveCurve au lieu de cette procdure }

  procedure CopyXYCurveTo( nLeft,nRight:integer;
                           pCu:PGAPCurve; flags:word); virtual;
  { Copie des donnes pXD^.[nLeft..nRight] et pYD^...
    d'une courbe dans une autre
    flags = 0 => copie les donnes pXD et pYD
    flags = flaNoCopyX = ne copie pas les donnes pXD
    flags = flaNoCopyY = ne copie pas les donnes pYD

    Les Flags <= 255  sont rservs pour l'utilisateur-dveloppeur
  ----------------------------------------------------------------------}

  function CopyCuTo(pCu:PGAPCurve; Flags1:word):PGAPCurve; virtual;
  {===============================================================}
  { Copie une courbe dans une autre, avec le contenu.
    Flags1 = 0 => copie tout
    flags1 = flaNoCopyY = ne copie pas pYD, mais copie aussi les infos
    flags1 = flaNoCopyX = ne copie pas pXD, mais copie aussi les infos
    Si pCu = NIL, cre une nouvelle courbe, et retourne un pointeur dessus.
    sinon         retourne pCu

    Les Flags1 <= 255  sont rservs pour l'utilisateur-dveloppeur
  --------------------------------------------------------------}

  procedure InitForDraw(nIndMax1:integer); virtual;
  { indique que la courbe peut tre dessine, et possde nIndMax1 +1 points }

  procedure DrawCurve(indMin,indMax:integer; pGrBase1:PGraphicBase); virtual;
  { dessine la courbe dans le graphique GrBase1.
    Est appel par TGAPGraphic.DrawCurves }

  function FindIndYMax(ind1, ind2:integer):integer; virtual;
  {========================================================}
  { Retourne le max. de la courbe entre les indices ind1 et ind2, compris }

  procedure PutFieldsCu; virtual;
  {================================}
  { Ne fait rien, est destin  tre redfini, pour
    mettre les paramtres dans des glpFiche^...Field pour les traiter
    dans des boites de dialogues.
  -------------------------------------------------------------------------}

  function IsNearCursor(nX,nY:integer):boolean; virtual;
  {====================================================}
  { retourne TRUE si le point (nX,nY) est trs proche de la courbe,
    et que celle ci soit visible. }

  procedure ComputeLimitsZoomCurveBeg(pGrP:PGAPGraphic); virtual;
  {=============================================================}
  { Par dfaut, ne fait rien.
    Est appel, au dbut de  pGr^.ComputeLimitsZoomCurve,
    Peut tre utile de le redfinir dans le cas particulier ou la courbe est
    compose de plus de 8100 points, qui sont sauv dans un buffer particulier.}

  procedure SaveCurveSignature(var fOut:Text; var nErr:integer); virtual;
  {=====================================================================}
  { Cette procdure est destine a tre redfinie par l'utilisateur.
    Elle va de paire avec la procedure LoadCurveSignatureSKE(fIn, nErr).
    Ne pas appeler le inherited SaveCurveSignature(fOut, nErr);
    Permet d'crire une signature reprsentant le type de donnes, telle que
    donnes  PMD  ou  donnes SKE  ou autre.
  -------------------------------------------------------------------------}

  procedure SaveCurveIndMax(var fOut:Text; var nErr:integer); virtual;
  {==================================================================}
  { Sauve une en-tte qui sera lue sparment, pour connaitre la taille
    de la courbe  charger.
    N'est gnralement pas redfini. }

  procedure SaveCurvePersonnalInfo(var fOut:Text; var nErr:integer); virtual;
  { Cette procdure est destine a tre tendue par l'utilisateur.
    Elle va de paire avec la procedure LoadCurvePersonnalInfo(fIn, nErr).
    Ne pas appeler le inherited SaveCurvePersonnalInfo(fOut, nErr);
    ni le inherited LoadCurvePersonnalInfo(fIn, nErr);
    Sauvegarde d'informations avant les informations habituelles d'une courbe.
    nErr:=IOResult;
  -------------------------------------------------------------------------}

  procedure SaveCurvePersonnalTreatement(var fOut:Text; var nErr:integer); virtual;
  { Cette procdure est destine a tre tendue par l'utilisateur.
    Elle va de paire avec la procedure LoadCurvePersonnalTreatement(fIn, nErr).
    Ne pas appeler le inherited SaveCurvePersonnalTreatement(fOut, nErr);
    ni le inherited LoadCurvePersonnalTreatement(fIn, nErr);
    Sauvegarde d'informations et traitement aprs les informations
    habituelles d'une courbe.
    nErr:=IOResult;
  -------------------------------------------------------------------------}

  procedure SaveCurve(var fOut:Text; var nErr:integer; Flags:word); {virtual}
  { Sauve les informations relative a une courbe.
    Ne pas surdfinir, mais surdfinir :
    SaveCurvePersonnalInfo et SaveCurvePersonnalTreatement.
    1) Signatures et informations de bases sur la courbe.
    2) SaveCurvePersonnalInfo.
    3) Sauve la courbe et d'autres informations la concernant.
    4) SaveCurvePersonnalTreatement
    5) Signature de fin

     Sauve toujours Xmin et XMax.
     Flags = 0 => sauve la proj. X et Y de la courbe.
    (Flags and flaCurveSaveOnlyY) <> 0 => ne sauve que la proj. Y de la courbe

    nErr = IOResult ou
    erreurs de # pInfo^.SaveInfo
               # SaveCurvePersonnalInfo
               # SaveCurvePersonnalTreatement
  -------------------------------------------------------------------------}

{ procedure LoadCurveSignatureSKE(var fIn:Text; var nErr:integer); virtual;
  =====================================================================
  c.f. glfnLoadCurveSignature, car on veut appeler cette mthode,
  sans que la courbe soit dj dfinie.
  C'est une mthode de la classe, pas de l'objet. Vu que cela n'a pas
  t prvu dans borland Pascal, j'utilise un pointeur sur procdure.
  -------------------------------------------------------------------------}

{  procedure LoadCurveIndMax(
  c.f. plus loin. Permet de lire la taille d'une courbe sans l'avoir
  dfinie avant.
  -------------------------------------------------------------------------}

  procedure LoadCurvePersonnalInfo(var fIn:Text; var nErr:integer); virtual;
  { Cette procdure est destine a tre redfinie par l'utilisateur.
    Elle va de paire avec la procedure SaveCurvePersonnalInfo(fIn, nErr).
    Ne pas appeler le inherited SaveCurvePersonnalInfo(fOut, nErr);
    ni le inherited LoadCurvePersonnalInfo(fIn, nErr);
    nErr = IOResult
  -------------------------------------------------------------------------}

  procedure LoadCurvePersonnalTreatement(var fIn:Text; var nErr:integer); virtual;
  { Cette procdure est destine a tre redfinie par l'utilisateur.
    Elle va de paire avec la procedure SaveCurvePersonnalTreatement(fIn, nErr).
    Ne pas appeler le inherited SaveCurvePersonnalTreatement(fOut, nErr);
    ni le inherited LoadCurvePersonnalTreatement(fIn, nErr);
    nErr = IOResult
  -------------------------------------------------------------------------}

  procedure LoadCurve(var fIn:Text; var nErr:integer; Flags:word);
  { Charge les informations relative a une courbe.
    Ne pas surdfinir, mais utiliser :
    LoadCurvePersonnalInfo et LoadCurvePersonnalTreatement.

    ((Flags and flaCurveLoadDefineX) <> 0) => redfini l'axe X  si il n'est
                                              pas sauv.
    nErr = IOResult ou
    errEOFTooEarly
    erreurs de # pInfo^.LoadInfo
               # LoadCurvePersonnalInfo
               # LoadCurvePersonnalTreatement
  -------------------------------------------------------------------------}
  end; { - TGAPCurve = object - }

TGAPGraphic = object
{==================}
  wIdentity        : word;
  { NE PAS MODIFIER.
    = 8347 si l'objet a t init. et n a pas t dtruit par Done.
    Utile pour vrifier si on peut
    accder  cette objet ou non. A utiliser avec IsBadWritePtr.
    A faire des tests }

  pInfo            : pGAPInfo;
  { information li au graphique, tel que commentaire, nom d'utilisateur, ...}

  fAutoDisposeInfo : boolean;
  { indique si au dispose il faut aussi disposer de l'info }

  pGrBase           : PGraphicBase;
  { Graphisme et texte li au graphique }

  pAxes            : PAutoAxes;
  { information sur les axes }

  pGAPWin          : PGAPWindow;
  { fentre contenant ce graphique. }

  apCu             : array[1..VINGT] of PGAPCurve;
  nbCu             : integer;
  { Courbes du graphique }

  pActiveCurve     : PGAPCurve;
  { courbe actif du graphique }

  strWindowTitle   : TStr120;
  { A la lecture du disque, titre de la fentre du graphique }

  strTitle,
  strXLegend,
  strYLegend
                   : TStr120;
  { Titre et lgende des axes }

  { Ceci permet de positionner plus prcismment le titre et les
    lgendes des axes }
  vCharXMoveTitle,   { dplacement en X du titre, en units caractres }
  vCharYMoveTitle,   { dplacement en Y du titre, en units caractres }
  vCharXMoveXLegend, { dplacement en X de la lgende de l'axe X }
  vCharYMoveXLegend, { dplacement en Y de la lgende de l'axe X }
  vCharXMoveYLegend, { dplacement en X de la lgende de l'axe Y }
  vCharYMoveYLegend  { dplacement en Y de la lgende de l'axe Y }
                   : Float;

  sizeTitle,       { taille du titre en points }
  sizeTextGr       { taille du texte en points }
                   : integer;  { en points }
  colTextTitle     : TColorRef;
  { couleur du titre et des lgendes des axes }

  lAxesFlags       : longint;
  { Flags de l'autoaxes, pour le dessin des axes du graphique }

  { indication sur la couleur et le style du graphique,
    est dfini dans l'Init, mais est modifiable }
  styleLineAxes    : TStyle;    {=PS_SOLID, PS_DASH, PS_DOT, PS_DASHDOT, c.f. CreatePen }
  pixWidthLineAxes : integer;   { 0..infinity }
  mmWidthLineAxes  : Float;     { paisseur minimale en milimtres }
  colLineAxes      : TColorRef; { =RGB(0..255, 0..255, 0..255) }
  colTextAxes      : TColorRef; { couleur des labels des axes }

  { indication sur la prsence, couleur etc. d'un cadre de la fentre 1 }
  fDrawBorderWin1  : boolean;
  StyleWin1        : TStyle;  {=PS_SOLID, PS_DASH, PS_DOT, PS_DASHDOT, c.f. CreatePen }
  pixWidthWin1     : integer;
  mmWidthWin1      :Float;
  pcolBorderWin1,  { couleur du cadre de la fentre 1 }
  pcolWin1,        { couleur du fond de la fentre 1. (contenant le graphique) }
  pcolWin2         { couleur du fond du graphique (=fentre 2) }
                   : ^TColorRef;

  { non utilis en principe, mais si on veut un graphique avec des couleurs
    diffrentes des graphiques habituelles, on peut faire pointer pcol... sur
    une de ces valeur. Elle sont charges au load d'un graphique, mais au save,
    se sont les pcol... qui sont sauves. }
  colBorderWin1UnUse,  { couleur du cadre de la fentre 1 }
  colWin1UnUse,        { couleur du fond de la fentre 1. (contenant le graphique) }
  colWin2UnUse         { couleur du fond du graphique (=fentre 2) }
                    : TColorRef;

  { indication si on dessine la grille }
  fDrawGrid        : boolean;

  { --- Variables pour les Zoom --- }
  aindMin,
  aindMax          : array[1..VINGT] of integer;
  { Indices min et max des courbes en cas de zoom.
    Utile pour un affichage graphique plus rapide }

  isZoomOn         : boolean;  { Indique si les donnes sont zoomes }
  ZoomXMin         : Float; { Mmorise les dernire dimensions }
  ZoomXMax         : Float; { du graphique, pour aller plus vite }
  ZoomYMin         : Float; { si demand au display }
  ZoomYMax         : Float;

  fZoomAutoY       : boolean;
  { indique si le zoom en Y se fait automatiquement, ou si il est fix
    par l'utilisateur. Si = TRUE, l'axe Y se calcule automatiquement
    en fonction des courbes. }

  fZoomAutoX       : boolean;
  { indique si le zoom en X se fait automatiquement, ou si il est fix
    par l'utilisateur. Si = TRUE, l'axe X se calcule automatiquement
    en fonction des courbes. }

  { distance en [mm] de la souris aux curseurs de zoom pour qu'ils soient pris }
  mmZoomCursDist   : Float;

  vZoomCursInitXMin,   { en % position initiale du curseur gauche }
  vZoomCursInitYMin,   { en % position initiale du curseur bas }
  vZoomCursInitXMax,   { en % position initiale du curseur droit }
  vZoomCursInitYMax    { en % position initiale du curseur haut }
                   : Float;

  { a mettre  FALSE pour forcer la redfinition de Zoom?Min(Max)
    =TRUE si Zoom(X/Y)Min/Max sont dfini.
    C'est utile pour rafficher plus rapidement, sans refaire le
    calcul des limites du Zoom.
    AutoAxeLocal et donc DisplayData le mettent  TRUE }
{  isZoomDefined    : boolean;??????????}

  { Mmorise les nMaxMemZoom dernier zoom, si on utilise
    des zoom multiples. Permet donc de faire des
    ZoomDataOut et ZoomDataIn }
  avMemZoomXMin,
  avMemZoomXMax,
  avMemZoomYMin,
  avMemZoomYMax     : array[0..TRENTE] of Float;

  { mmorise si l'axe Y est calcul automatiquement }
  afMemZoomAutoY    : array[0..TRENTE] of boolean;

  { mmorise si l'axe X est calcul automatiquement }
  afMemZoomAutoX    : array[0..TRENTE] of boolean;

  nMaxPosMemZoom    : integer; { nb de zoom mmoris }
  nPosMemZoom       : integer; { position actuelle   dans paMemZoom
                                 =0 si graphique non zoom }

//???  pZoomDlg0         : PZoomDlg;

  { mmorise le nom du fichier qui contenait ce graphique }
   strGraphicFilePath : TPathStr;

  fIsNewFile,       { =FALSE si il a dj t sauv une fois }

  { n'est pas mis  jours, car trop d'endroit  contrler! }
  {fIsSave = not fHasChangedGr }
  fHasChangedGr       { =TRUE si il a t modifi depuis le dernier save }
                    : boolean;

  nKind            : integer;
  { Peut tre utilis par des sous objets pour dfinir de
      quel objets il s'agit }

  colMemLineCu        : TColorRef; { =RGB(0..255, 0..255, 0..255) }
  { Mmorise la couleur qu'avait la courbe active, avant d'tre active }

{ !!!!!!!!! A METTRE DANS PRIVATE !!!!! }
  { forme du curseur de la souris. Utile dans les Zoom }
  hCursorNew,
  hCursorOld       : HCursor;

  { indique de quel curseur de Zoom la souris est proche }
  nXNear,nYNear    : integer;

  vXMinZoomCurs : Float;
  vYMinZoomCurs : Float;
  vXMaxZoomCurs : Float;
  vYMaxZoomCurs : Float;

  { ancienne position des curseurs de Zoom }
  vXMinZoomCursOld : Float;
  vYMinZoomCursOld : Float;
  vXMaxZoomCursOld : Float;
  vYMaxZoomCursOld : Float;

  pnZoomDlgLastPosX,
  pnZoomDlgLastPosY : ^integer;
  { Position initiale de la boite de dialogue de Zoom }

  fDoAutoDispose     : boolean;
  { Read Only.
    Indique si il faut librer automatiquement la mmoire alloue
    pour ce graphique au done de la Window qui le contient. }

  fDoDisposeGrBase : boolean;
  { Indique si il faut librer automatiquement la mmoire alloue
    pour  pGrBase : PGraphicBase }

  fDoDisposeAxes : boolean;
  { Indique si il faut librer automatiquement la mmoire alloue
    pour  pAxes : PAutoAxes; }

  { A lire uniquement }
  fMemZoomOnlyX    : boolean;
  { mmorise au ZoomXYDefine si le zoom en Y doit tre automatique.
    Donc le zoom est fait uniquement en X. }

  fMemZoomOnlyY    : boolean;
  { mmorise au ZoomXYDefine que le zoom est fait en Y uniquement. }

  fMemZoomAutoX    : boolean;
  { Pour indiquer si le zoom de l'axe X doit tre enlev quand on ne
    zoom que l'axe Y }

  { - Donnes prives }
  { ----------------- }
  Private
  {"""""}

  fCalled          : boolean;
  { pour viter des boucles d'appels circulaire }

  { - Mthodes publiques de TGAPGraphic }
  { =================================== }
  public
  {""""}

  { - constructeur et destructeur - }
  { ------------------------------- }

  constructor Init( pGAPWin1:PGAPWindow; pI:PGAPInfo;
                    pGr:PGraphicBase; pAx:PAutoAxes; Flags:word);
  { pGapWin1 = pointeur sur la fentre contenant le graphisme.
    pGr  = NIL => allocation automatique de TGraphicBase
    pAx  = NIL => allocation automatique de TAutoAxes

    pI   = NIL => allocation automatique de pInfo, en utilisant
                  glfnNewInfo(0);  fAutoDisposeInfo:=TRUE;

    Si TGAPInfo a t surdfini, on a deux choix :
    1) (meilleur) : faire pointer glfnNewInfo sur une fonction
       qui alloue et init une information. C.f. NewInfoSKE(...)
       Tout le reste est fait automatiquement.
    2) On peut initialiser avant l'appel de cette Init un objet
       pI, et le passer en tant que pointeur a cette Init.
       La variable fAutoDisposeInfo dcide si l'info sera dsalou
       automatiquement au Done du graphique ou non.

    Si TGraphicBase ou TAutoaxes ont t surdfini,
    on peut initialiser avant l'appel de cette Init un objet
    pGr ou pAx, et le passer en tant que pointeur a cette Init.
    Flags indique dans ce cas si il faut librer (Dispose) automatiquement
    la mmoire alloue pour pGr ou pAx.
    C.f. flaAutoDisposeGr et flaAutoDisposeAxes. }

  destructor  Done; virtual;

  procedure GetFamilly( var nbParent:integer;
                        var astrFamilly:array of TSTR30); virtual;
  { Pour connaitre tous les anctres d'un objet.
    c.f. wSKEVar.pas pour voir comment implmenter les descendant
    OUTPUT :
    nbParent = nombre de membre dans la famille
    astrFamilly = nom des ojbets. }

  procedure AddCurve(pCu1:PGAPCurve; var nErr:integer); virtual;
  { ajoute une courbe au graphique, elle peut tre dessine ou non,
    cela dpend de la courbe.
    nErr = 0 ou
    errTooManyCurves
    errCurveNotInit
    errTooManyGraphics  de AddToGraphic
  -------------------------------------------------------------------------}

  function AddNewCurve(nIndMaxAbs0:integer; flags:word):PGAPCurve; virtual;
  { Cre une nouvelle courbe, et l'ajoute au graphique.
    nIndMaxAbs0 = taille des courbes.
    Flags = ceux envoy  la cration de la courbe.

    Retourn NIL si il y a eu une erreur, sinon
    retourn un pointeur sur la courbe cre
  -------------------------------------------------------------------------}

  procedure RemoveCurve(pCu1:PGAPCurve); virtual;
  { Enlve une courbe du graphique }

  procedure MoveCurvePosition(nOldPos,nNewPos:integer); virtual;
  {===================================================}
  { Change l'ordre d'affichage des courbe, en changeant
    l'ordre dans laquelle les courbes sont mmorises dans le graphique. }

  procedure DrawBackGround; virtual;
  {================================}
  { Permet de faire un traitement avant le AutoAxesDraw,
    tel que dessiner le fond du graphique }

  procedure AutoAxesCalc(var fHasOneCurve:boolean); virtual;
  {========================================================}
  { Calcule des axes du graphique.
    Indique dans fHasOneCurve si une courbe sera dessine.
    Fixe les valeurs de vXMinAxe,vXMaxAxe, vYMinAxe,vYMaxAxe.
    Peut tre surcharg ou redfini.
  -------------------------------------------------------------------------}

  procedure AutoAxesDraw(fHaseOneCurve:boolean); virtual;
  {=====================================================}
  { Dessine les axes.
    Est souvant redfini, n'est jamais appel directement.
  ------------------------------------------------------------------------------}

  procedure DrawLegend; virtual;
  {============================}
  { Est souvant redfini, ou surdfini.
    Peut tre appel directement.
    Dessin du Titre, et des lgendes des axes.
  -------------------------------------------------------------------------}

  procedure DrawGrid; virtual;
  {==========================}
  { Est souvant redfini,
    Peut tre appel directement.
    Dessin d'une Grille, avec le style, l'paisseur et la couleur de ligne
    demande. Pour des impressions sur imprimantes, il peut tre utile
    d'exprimer une paisseur minimale de ligne en milimtres. C'est la raison
    pour laquelle l'paisseur est donnes en pixels et en milimtres,
    chacune des deux donnes est une valeur minimale d'paisseur.
  -------------------------------------------------------------------------}

  procedure DrawCurves; virtual;
  {============================}
  { Peut tre redfini,
    Peut tre appel directement.
    Dessin des courbes, on suppose que les axes ont t calcul.
  -------------------------------------------------------------------------}

  procedure DrawInfo; virtual;
  {==========================}
  { Est destin  tre redfini.
    Peut tre appel directement.
    Par dfaut, ne fait rien, mais peut tre utiliser pour afficher
    des informations supplmentaires dans un graphique.
  -------------------------------------------------------------------------}

  procedure DrawGraphic; virtual;
  {=============================}
  { N'est gnralement pas redfini.
    Est destin  tre appel, pour dessiner le graphique.
    Utiliser TGAPWindow.RePaint pour redessiner toutes la fentre.
    Si un device contexte est donn, utiliser DrawGrahicOnGDI.
    Si le device contexte pGrBase^.hDC0 <> 0, dessine le graphique avec ces courbes,
    lgende, titre etc.
    sinon ne fait rien.
  ------------------------------------------------------------------------------}

  procedure DrawGraphicOnGDI(
    hDC1             : HDC;
    Flags            : word
    ); virtual;
  { dessine le graphique avec ces courbes, lgende, titre etc. dans un GDI.
    Si Flags = flaGraphicOnWindow  ou  hDC1 = 0 alors
       Dessine dans la fentre pGAPWin
    Sinon, dessine sur l'imprimante ou le device associ  hDC1
  ------------------------------------------------------------------------------}

  procedure DrawGraphicOnWindow(Flags:word); virtual;

  procedure ComputeLimitsZoomCurve(nn:integer; pCu1:PGAPCurve); virtual;
  { Indique que les limites de Zoom de la courbe pCu1^ doivent
    tres recalcules.
    Si nn = 0, recherche l'indice  nn  t.q. apCu[nn] = pCu1,
    sinon on admet que  apCu[nn] = pCu1, et on vite une recherche innutile. }

  { --- traitement du Zoom --- }
  procedure ZoomSetLineAttrib( var MemROP:integer;
                               var recLineAt:TypeLineAttrib); virtual;
  { met l'attribut de ligne pour le mode zoom, en rcuprant les attributs
    prcdents }

  procedure ZoomRestorLineAttrib(MemROP:integer; recLineAt:TypeLineAttrib); virtual;
  { Restor l'attribut de ligne recu dans ZoomSetLineAttrib }

  procedure ZoomXYDefine(Flags:integer); virtual;
  { dfini un zoom manuellement }

  function ZoomXYIn(Flags:integer):integer; virtual;
  { Si un zoom a t mmoris, permet de rentrer dans ce zoom }

  function ZoomXYOut(Flags:integer):integer; virtual;
  { Revient au niveau de zoom prcdent }

  procedure ZoomCancel; virtual;
  { refuse le nouveau Zoom }

  procedure ZoomDefine(
  {===============================}
    vXMinZoomCurs0,  { min X du zoom }
    vXMaxZoomCurs0,  { max X du zoom }
    vYMinZoomCurs0,  { min Y du zoom }
    vYMaxZoomCurs0   { max Y du zoom }
                     : Float;
    wFlags           : word
    ); virtual;
  { Definie un zoom.
    wFlags <- flaGraphicZoomOnlyX
           => mmorise si on dsir un calcul automatique de l'axe Y
    wFlags <- flaGraphicZoomOnlyY
           => indique que le Zoom ne se fait que sur Y.
  -----------------------------------------------------------------------------}

  procedure ZoomOK; virtual;
  { accepte le nouveau Zoom }

  { traite des messages souris. Utile pour des Zooms et Curseurs }
  procedure WMLButtonDown(var Msg: TMSG); virtual;
  procedure WMLButtonUp(var Msg: TMSG); virtual;

  procedure UpdateCursorPos; virtual;
  { Efface les curseurs  leur ancienne position, et
    redessine les curseurs  leur nouvelle position. }

  procedure WMMouseMove(var Msg: TMSG); virtual;

  procedure Paint;  virtual;
  { pour redessiner aussi les curseurs du zoom }

  function CopyGrTo(pGr:PGAPGraphic; Flags1:word):PGAPGraphic; virtual;
  {===================================================================}
  { Copie un grapihque dans une autre, avec le contenu.
    Flags1 = 0 => copie tout, avec les courbes.
           = flaGrNoCopyCurves =>
             Indication de ne pas copier les courbes du graphique.
    Si pGr = NIL, cre un nouveau graphique, et retourne un pointeur dessus.
    sinon         retourne pGr
  --------------------------------------------------------------}

  procedure PutFieldsGr; virtual;
  {=============================}
  { Ne fait rien, est destin  tre redfini, pour
    mettre les paramtres dans des glpFiche^...Field pour les traiter
    dans des boites de dialogues.
  --------------------------------------------------------------------}

  procedure SetActiveCurve(pCu1:PGAPCurve; var nErr:integer); virtual;
  {==================================================================}
  { Dfini pCu comme la courbe active du graphique.
    Si pCu ne fait pas partie du graphique, nErr = 1 et rien n'est fait.
    Maintient l'ordre des courbes dans apCu, donc celle qui tait
    active va en deuxime position.
    Change la glpActiveCurve, si le graphique est le graphique actif. }

  function GetCurveSelectedByCursor(nX,nY:integer):PGAPCurve; virtual;
  {==================================================================}
  { retourne un pointeur sur la courbe slectionn par le point (nX,nY)
    en coordonne de fentre client.
    Retourne NIL si le point n'est pas proche de la courbe }

  procedure SaveGraphicSignature(var fOut:Text; var nErr:integer); virtual;
  {=============================================================}
  { Cette procdure est destine a tre redfinie par l'utilisateur.
    Elle va de paire avec la procedure LoadGraphicSignature(fIn, nErr).
    Ne pas appeler le inherited SaveGraphicSignature(fOut, nErr);
    Permet d'crire une signature reprsentant le type de donnes, telle que
    donnes  PMD  ou  donnes SKE  ou autre.
  -------------------------------------------------------------------------}

  procedure SaveGraphicPersonnalInfo(var fOut:Text; var nErr:integer); virtual;
  { Cette procdure est destine a tre redfinie par l'utilisateur.
    Elle va de paire avec la procedure LoadGraphicPersonnalInfo(fIn, nErr).
    Ne pas appeler le inherited SaveGraphicPersonnalInfo(fOut, nErr);
    ni le inherited LoadGraphicPersonnalInfo(fIn, nErr);
    Sauvegarde d'informations avant les informations habituelles d'un graphique.
    nErr:=IOResult;
  -------------------------------------------------------------------------}

  procedure SaveGraphicPersonnalTreatement(var fOut:Text; var nErr:integer); virtual;
  { Cette procdure est destine a tre redfinie par l'utilisateur.
    Elle va de paire avec la procedure LoadGraphicPersonnalTreatement(fIn, nErr).
    Ne pas appeler le inherited SaveGraphicPersonnalTreatement(fOut, nErr);
    ni le inherited LoadGraphicPersonnalTreatement(fIn, nErr);
    Sauvegarde d'informations et traitement aprs les informations
    habituelles d'un graphique.
    nErr:=IOResult;
  -------------------------------------------------------------------------}

  procedure SaveGraphicCurves(
  {==========================}
    var fOut         : text;
    var nErr         : integer;
        Flags        : word
    ); virtual;
  { Sauve les courbes du graphique.
    N'est gnralement pas tandu ni redfini.
    Flags = 0, les mmes que SaveGraphic.
  -------------------------------------------------------------------------}

  procedure SaveGraphicSKEInfo(var fOut:Text; var nErr:integer); virtual;
  { est destin  tre utilis que dans wSKEVar, pas redfini ni tandu.
    c.f. SaveGraphicPersonnalInfo pour sauver des informations utilisateur. }

  procedure SaveGraphic(var fOut:Text; var nErr:integer; Flags:word); virtual;
  { Sauve les informations relative a un graphique.
    Ne pas surdfinir, mais surdfinir :
    SaveGraphicPersonnalInfo et SaveGraphicPersonnalTreatement.
    (Flags and flaGraphicSaveOnlyDisplayed) <> 0) =>
      se sauve que les courbes affiche du graphique.

    c.f. aussi les flags de SaveCurve(...)

    1) Signatures et informations de bases sur le graphique.
    2) SaveGraphicPersonnalInfo.
    3) Sauve le graphique et d'autres informations le concernant,
       C'est ici que les courbes du graphique sont sauves.
    4) SaveGraphicPersonnalTreatement
    5) Signature de fin

    nErr:=IOResult ou
    erreurs de # pInfo^.SaveInfo
               # SaveGraphicPersonnalInfo
               # apCu[nn]^.SaveCurve
               # SaveGraphicPersonnalTreatement
  -------------------------------------------------------------------------}

  procedure SaveGraphicName(strFilePath:TStrFilePath; var nErr:integer; Flags:word); virtual;
  { Sauve les informations relative a un graphique.
    Ne pas surdfinir, mais utiliser :
    LoadGraphicPersonnalInfo et LoadGraphicPersonnalTreatement.
    Ouvre le fichier strFilePath comme fichier texte,
    puis appel SaveGraphic, avec les mmes erreurs et Flags.
    nErr:=IOResult ou
    erreurs de # SaveGraphic
    -------------------------------------------------------------------------}

  procedure LoadGraphicFirstSignature(var fIn:Text; var nErr:integer); virtual;
  {===========================================================================}
  { Lecture de la premire ligne d'un fichier de donnes.
    Est rdfini par une application qui permet de lire des donnes
    provenant d'autres applications.
  ------------------------------------------------------------------------}

  procedure LoadGraphicSignature(var fIn:Text; var nErr:integer); virtual;
  {=============================================================}
  { Cette procdure est destine a tre redfinie par l'utilisateur.
    Elle va de paire avec la procedure SaveGraphicSignature(fOut, nErr).
    Ne pas appeler le inherited LoadGraphicSignature(fIn, nErr);
    Permet de lire une signature reprsentant le type de donnes, telle que
    donnes  PMD  ou  donnes SKE  ou autre.
    Si pas le bon type de donnes, nErr <> 0.
    La gestion de message d'erreur doit se faire dans cette procdure, et
    nErr < 0 en cas d'erreurs de signature.
  -------------------------------------------------------------------------}

  procedure LoadGraphicPersonnalInfo(var fIn:Text; var nErr:integer); virtual;
  { Cette procdure est destine a tre redfinie par l'utilisateur.
    Elle va de paire avec la procedure SaveGraphicPersonnalInfo(fOut, nErr).
    Ne pas appeler le inherited SaveGraphicPersonnalInfo(fOut, nErr);
    ni le inherited LoadGraphicPersonnalInfo(fIn, nErr);
    nErr:=IOResult;
  -------------------------------------------------------------------------}

  procedure LoadGraphicPersonnalTreatement(var fIn:Text; var nErr:integer); virtual;
  { Cette procdure est destine a tre redfinie par l'utilisateur.
    Elle va de paire avec la procedure SaveGraphicPersonnalTreatement(fOut, nErr).
    Ne pas appeler le inherited SaveGraphicPersonnalTreatement(fOut, nErr);
    ni le inherited LoadGraphicPersonnalTreatement(fIn, nErr);
    nErr:=IOResult;
  -------------------------------------------------------------------------}

  procedure LoadGraphicSKEInfo(var fIn:Text; var nErr:integer); virtual;
  { est destin  tre utilis que dans wSKEVar, pas redfini ni tandu.
    c.f. LoadGraphicPersonnalInfo pour charger des informations utilisateur. }

  procedure LoadGraphicCurves(
  {==========================}
    var fIn          : text;
        nVersion,
        nbCurves     : integer;
    var nErr         : integer;
        Flags        : word
    ); virtual;
  { Charge les courbes du graphique.
    N'est gnralement pas tandu ni redfini.
    nVersion  <= 104, ancienne manire, on avait pas de version
                      spcifique  LoadGraphicCurves.
    Flags = 0, les mmes que LoadGraphic.
  -------------------------------------------------------------------------}

  procedure LoadGraphic(var fIn:Text; var nErr:integer; Flags:word); virtual;
  { Charge les informations relative a une courbe.
    Ne pas surdfinir, mais utiliser :
    LoadGraphicPersonnalInfo et LoadGraphicPersonnalTreatement.
    OUTPUT :
    nErr =    0 => pas d'erreurs
         = errEOFTooEarly
         = nErr de LoadInfo
         = nErr de IOResult
         = nErr de LoadGraphicPersonnalInfo
         = nErr de LoadGraphicPersonnalTreatement

    INPUT :
    Flags = 0
  -------------------------------------------------------------------------}

  procedure LoadGraphicColumn(var fIn:text; var nErr:integer; Flags:word); virtual;
  {===============================================================================}
  { Essaie de charger des colonnes de nombres comme graphique.
    retourn nErr = errBadFileGraphic, si pas une table de colonnes de nombres.
  ----------------------------------------------------------------}

  procedure LoadGraphicName(strFilePath:TStrFilePath; var nErr:integer; Flags:word); virtual;
  { Charge les informations relative a un graphique.
    Ne pas surdfinir, mais utiliser :
    LoadGraphicPersonnalInfo et LoadGraphicPersonnalTreatement.
    Ouvre le fichier strFilePath comme fichier texte,
    puis appel LoadGraphic, avec les mmes erreurs et Flags.
    nErr = IOResult ou
         = nErr de LoadGraphic
    Flags = 0 ou
    Flags = flaNoChangeWindowTitle
    Flags = flaNoLoadOtherData
    -------------------------------------------------------------------------}

  end; { - TGAPGraphic = object - }

TGAPWindow = object(TWindow)
{==========================}
  wIdentity        : word;
  { NE PAS MODIFIER.
    = 13269 si l'objet a t init. et n a pas t dtruit par Done.
    Utile pour vrifier si on peut
    accder  cette objet ou non. A utiliser avec IsBadWritePtr.
    A faire des tests }

  { Il contiend des graphiques, et du texte. }
  pGrBaseW         :  PGraphicBase;  { Graphisme et texte de la fentre }

  { graphiques de la fentre }
  apGr             : array[1..DIX] of PGAPGraphic;
  nbGr             : integer;

  pActiveGraphic : PGAPGraphic;
  { Graphique actif de la fentre }

  { Indique si il faut librer automatiquement la mmoire alloue
    pour  pGrBaseW : PGraphicBase }
  fDoDisposeGrBaseW : boolean;

  ppglWindow       : ^PGAPWindow;
  { pointe sur la variable globale qui pointe sur cette fentre.
    Ceci est utile pour mettre  NIL la variable globale pointant sur
    cette fentre, quand on dtruit cette fentre.
    Ne peut tre utilis que dans l'application finale, mais est
    assign dans  wGlobal.InitGenGraphic(..) }

  nKind            : integer;
  { Peut tre utilis par des sous objets pour dfinir de
      quel objets il s'agit }

  { Informations pour copier une courbe d'un graphique dans un autre }
  {------------------------------------------------------------------}
  fIsCurveToCopy   : boolean;
  { Indique si il y a une courbe  copier }

  pCuToCopy        : PGapCurve;
  { courbe  copier }

  nCopyMove        : integer;
  { = 0 si on fait une copie de courbe, =1 si on fait un move }

  { Curseurs en cas de copie d'une courbe d'un graphique dans un autre }
  hCursOld,
  hCursCopy,
  hCursMove,
  hCursLast      : HCursor;

  { - Donnes prives }
  { ----------------- }
  Private
  {"""""}

  { Si <> NIL, indique  quel TGAPGraphic il faut envoyer les informations
    d'actions de la souris }
  pGAPGrMouseWM    : PGAPGraphic;

  { indique si la fentre  captur la souris }
  fMouseCaptured   : boolean;

  { - Mthodes publiques de TGAPWindow }
  { ================================== }
  public
  {""""}

  { - Mthodes de coordonnes utilisateurs et de dfinition de fentres graphiques }
  { ------------------------------------------------------------------------------ }

  { - constructeur et destructeur - }
  { ------------------------------- }
  constructor Init( pWin1:PWindow0; strTitle:string;
                    pGr:PGraphicBase; Flags0:word);
  { Initialisation habituelle d'une fentre.
    pWin1 = pointeur sur la fentre parent.
          = NIL si pas de parent.
    strTitle = titre de la fentre.
    pGr  = NIL => allocation automatique de TGraphicBase
    Si TGraphicBase a t surdfini, on peut initialiser
    avant l'appel de cette Init un objet pGr, et le passer
    en tant que pointeur a cette Init.
    Flags0 indique dans ce cas si il faut librer (Dispose) automatiquement
    la mmoire alloue pour pGr.
    C.f. flaAutoDisposeGrBase. }

{  NE MARCHE PAS!
   procedure GetWindowClass(var AWndClass:TWndClass); virtual; }

  procedure WinCreate(strWinClass:ShortString); virtual;
  { La fentre est cre, mais pas encore dessine.
    C'est le bonne endroit pour dfinir la fentre de dessin graphique }

  destructor  Done; virtual;

  { - Mthodes divers - }
  { ------------------- }
  procedure RepaintDelayed; virtual;
  { pour envoyer un message demandant de redessiner la fentre, mais
    elle ne sera pas redessin immdiatement. (attend que les messages soient traits }

  procedure Repaint; virtual;
  { pour redessiner la fentre }

  procedure SetCapture0; virtual;
  { Capture la souris dans cette fentre }

  procedure ReleaseCapture0; virtual;
  { libre la capture de la souris }

  Procedure SelectCurveUnderCursor(wX,wY,wKeys:word); virtual;
  {==========================================================}
  { Selectionne la courbe qui passe par le point (nX,nY) en coordonne
    d'cran. wKeys = tat du clavier, pour tester le Shift. }

  Procedure CopySelectedCurve(var Msg: TMSG); virtual;
  {======================================================}
  { Est destin  tre surclass }

  procedure WMPaint(var Msg: TMSG); virtual;
  procedure WMSize(var Msg: TMSG); virtual;
  procedure WMLButtonDown(var Msg: TMSG); virtual;
  procedure WMLButtonUp(var Msg: TMSG); virtual;
  procedure WMMouseMove(var Msg: TMSG); virtual;
  Procedure WmKeyDown(Var Msg:TMSG);  Virtual;
  Procedure WmKeyUp(Var Msg:TMSG);  Virtual;

  procedure AddGraphic(pGr1:PGAPGraphic; var nErr:integer); virtual;
  { ajoute un graphique  une Window.
    nErr = 0 ou
    errTooManyGraphicsInWin.
  ------------------------------------}

  function AddNewGraphic(nbCurves,nIndMaxAbs0:integer; Flags0:word):PGAPGraphic;
  {===========================================================================}
  { Cre un nouveau graphique, avec de nouvelle courbes dedant.
    nbCurves    = nombre de courbes dans le graphique
    nIndMaxAbs0 = taille des courbes.

    Flags0 sera utilis  la cration des courbes et des graphiques

    retourn NIL en cas de problme, sinon
    retourn un pointeur sur le graphique.
  -----------------------------------------------------------------}

  procedure RemoveGraphic(pGr1:PGAPGraphic); virtual;
  { Enlve le graphique de la Window }

  procedure InitAfterNewWindow; virtual;
  { Est souvant redfini.
    Est appel dans wSKEVar.TSKEMDIWindow.CMFileOpen aprs qu'un fentre ait
    t cre et que un graphique ait t charg, et lui a t assign.
    Peut tre utile pour :
    - Changer le titre de la fentre en fonction du graphique qu'il contient
    - Changer les flags d'un menu spcifique  cette fentre.
  -------------------------------------------------------------------------}

  procedure WMActivate(var Msg: TMSG); virtual;
  {======================================================================}
  { Msg.wParam = 0 => la fentre est dsactivate,
    sinon          => la fentre est active
    WMActivate est appel avant WinCreate.
    dfini dans glpActive..., la fentre, le graphic et la courbe actifs.
  -------------------------------------------------------------------------}

  function GetGrBaseForPrinting(Flags1:word):PGraphicBase; virtual;
  {===============================================================}
  { Est appel pour demander le graphique de base servant  l'impression.
    Par dfaut retourne le device contexte du graphique actif. car c'est
    gnralement lui que l'on veut imprimer. Si il n'y a pas de
    graphique actif, retourn NIL. Cela signifie que l'on annule
    la demande d'impression.
    Le device contexte  GrBase.hDC0  doit tre = 0, i.e. none ouvert.
    Flags1 = 1 => impression
    Flags1 = 2 => prvisualisation
  -----------------------------------------------------------------------}

  procedure OutputForPrinter(pGrBase2:PGraphicBase; Flags1:word); virtual;
  {======================================================================}
  { par dfaut n'imprime que le grahique, peut tre tandu ou redfini.
    Est appel pour faire une impression ou une prvisualisation
    d'impression.
    pGrBase1^.hDC0 = un device contexte valide pour dessiner.
    Flags1 = 1 => impression
    Flags1 = 2 => prvisualisation
  -----------------------------------------------------------------------}

  function CopyWinTo(pWin:PGAPWindow; Flags1:word):PGAPWindow; virtual;
  {===================================================================}
  { Copie une fentre dans une autre, avec le contenu.
    Flags1 = 0 => copie tout, avec les graphes et courbes.
           = flaWinNoCopyGr =>
             Indication de ne pas copier les graphiques
           = flaGrNoCopyCurves =>
             Indication de ne pas copier les courbes des graphiques
    Si pWin = NIL, cre une nouvelle fentre, et retourne un pointeur dessus.
    sinon          retourne pWin
  --------------------------------------------------------------}

  function GetGraphicSelectedByCursor(nX,nY:integer):PGAPGraphic; virtual;
  {======================================================================}
  { retourne un pointeur sur le graphique contenant le point (nX,nY)
    en coordonne de fentre client }

  function WMUGetObjectType:LRESULT;
  {================================}
  { Ne pas redfinir cet mthode, mais utiliser nKind, pour savoir
    quelle est le degr de descendance.
    nKind =  0 pour TGAPWindow
    nKind = 10 pour TSKEWindow
    nKind = 21 pour TMONOSKEWindow
    nKind = 22 pour TMDISKEWindow
    nKind >= 30 pour TUser...  est conseill.
    Retourne cteTypeTGAPWindow dans Msg.Result,
    pour indiquer le type de fentre de cet objet.
    cteType... est dfini dans wConst.pas.
  -----------------------------------------------------}

  function WindowProcFirst(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  // Handles messages for the library, before calling  WindowProc
  // It is usually not overriden

  function WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  // Handles all the messages

  end; { - TGAPWindow = object - }
(*???
TZoomDlg = object(TGAPDlg)
{========================}
{ sous-dialogue de TGAPDlg, pour traiter le dialogue non modale de Zoom }

  pGr              : PGAPGraphic; { graphic zoom }
  pDlgFiche        : PFiche;   { fiche correspondante au dialogue }
  fMemoriseMove    : boolean;  { indique si il faut mmoriser les pos. de
                                 la boite de dialogue }

  Constructor MSGInit(AParent: PWindowsObject ; aMsgID: Word; Var AFiche:PFiche);
  { Initialise le dialogue , ainsi que les objets associs:
    - Lecture du bloc dans le fichier de message et construction d'une collection de lignes.
    - Construction des collections d'objets, commandes, directives, definitions.
    - Applique les directives sur le dialogue.
    - Init des objets et definitions.
    - Applique les dfinitions sur les objets et dfinitions.
   Ceci se fait en appelant dans l'ordre : Init_1  Init_4 }

  Constructor Init(Aparent:PWindowsObject; strTitle0:TStr160);
  { Initialise le dialogue, de manire classique,   part que strTitle0
    est bien le titre du dialogue, et pas un nom de resource }

  Destructor Done; virtual;
  { Libre ici la mmoire alloue pour pDlgFiche }

  Procedure SetUpWindow; Virtual;
  {!  ne pas appeller !}
  { positionne la fentre au mme endroit que la dernire fois }

  Procedure Ok (Var Msg : TMSG); Virtual Id_First + Id_Ok;
  { On ferme le dialogu, et on ne fait rien, les var du prog
    sont dja  jour  chaque fois que le focus est perdu }

  Procedure Cancel (Var Msg : TMSG); Virtual Id_First + Id_Cancel;
  { On ferme le dialogu, et on remet les copies dans les var du prog }

  Procedure UpDateAllVar0;
  {  appeler pour remettre les champs  jours }

  Procedure WmUUpDateVar(Var Msg : TMSG); Virtual Wm_First + WmU_UpDateVar;
  { ne pas appeller.
  { Indication qu'un variable est remise  jours, donc qu'il faut
    remettre les curseurs de zoom  jours }

  procedure WMMove(var Msg: TMSG); virtual wm_First + wm_Move;

  end; { - TZoomDlg = object(TGAPDlg) }
???*)
procedure LoadCurveIndMax(
{========================}
  var fIn:Text;
  var nIndMax, nIndMaxAbs : integer;
  var fDraw               : boolean;
  var nErr:integer
  );
{ Lit l'indice maximal (=nb de points -1) d'une courbe,
  pour allouer dynamiquement en mmoire la place ncssaire, avant le chargement.
-------------------------------------------------------------------------}

procedure LoadCurveSignatureSKE(var fIn:Text; var nErr:integer);
{================================================================}
{ C'est une mthode de la classe, pas de l'objet. Vu que cela n'a pas
  t prvu dans borland Pascal, j'utilise un pointeur sur procdure.
  c.f. glfnProcLoadCurveSignature
  Cette procdure est destine a tre rcrite par l'utilisateur.
  puis il faut dfinir :
  glfnProcLoadCurveSignature(fIn, nErr) sera donc appel avant d'avoir
  cr une courbe.
  glfnProcLoadCurveSignature:=LoadCurveSignature;  (nouvelle version).
  Elle va de paire avec la procedure SaveCurveSignature(fOut, nErr).
  Permet de lire une signature reprsentant le type de donnes, telle que
  donnes  PMD  ou  donnes SKE  ou autre.
  Si pas le bon type de donnes, nErr <> 0.
  La gestion de message d'erreur doit se faire dans cette procdure, et
  nErr < 0 en cas d'erreurs de signature.
-------------------------------------------------------------------------}

procedure CreateNewGrWindow(
{==========================}
  var pWin         : PGAPWindow;
  var pGr          : PGAPGraphic;
  var pCu          : PGAPCurve;
      indMaxAbs    { indice maximale possible de la courbe }
                   : integer;
      colLineCu0   { Couleur de la courbe, si il y en a une }
                   : TColorRef;
      strTitle0,   { Titre du graphique }
      strXLegend0, { lgende de l'axe X }
      strYLegend0  { lgende de l'axe Y }
                   : TStr160;
  var nErr         : integer);
{ Cration d'une nouvelle fentre, avec un graphique pGr et une courbe pCu,
  dimensionne [0..nIndMaxAbs].
  nErr = 0 si tout est OK.
  nErr <> 0 sinon, avec message explicatif
-------------------------------------------------------------------------}

function InitGrWindow(
{====================}
  var pWin         : PGAPWindow;
      indMax0,     { indice max des donnes pavX^ et pavY^ }
      indMaxAbs    { indice maximale possible de la courbe (>= indMax0) }
                   : integer;
      colLineCu0   { Couleur de la courbe, si il y en a une }
                   : TColorRef;
      pavX,pavY    : PArrayFloat; {Donnes}
      strTitle0,   { Titre du graphique }
      strXLegend0, { lgende de l'axe X }
      strYLegend0  { lgende de l'axe Y }
                   : TStr160;
  var nErr         : integer
      ):PGAPCurve;
{ Si pWin = NIL, Cre la fentre pWin.
  Si il n'y a pas de graphique dedans, lui met un graphique dedant.
  Si (pavX <> NIL) et (pavY <> NIL) et (indMaxAbs > 0),
     met une courbe dans le graphique.
  Dans tous les cas, enlve autres courbes du graphique.
  Si (indMax0 > 0), met les informations pavX^ et pavY^ dans la courbe, et
     init. la courbe pour qu'elle se dessine.

  Retourne la courbe, nil si aucune courbe ajoute au graphique.
  Avec AddInGrWindow, on peut ainsi simplement ajouter des courbes
   un graphique.
----------------------------------------------------------}

function AddInGrWindow(
{=======================}
  var pWin         : PGAPWindow;
      indMax0,     { indice max des donnes pavX^ et pavY^ }
      indMaxAbs    { indice maximale possible de la courbe (>= indMax0) }
                   : integer;
      colLineCu0   { Couleur de la courbe, si il y en a une }
                   : TColorRef;
      pavX,pavY    : PArrayFloat; {Donnes }
  var nErr         : integer
      ):PGAPCurve;
{ Si (pWin = NIL) ou il n'y a pas de graphique dans pWin,
     Appel InitGrWindow, sans titre ni labels. Ne fait rien d'autre.
  Si (pavX <> NIL) et (pavY <> NIL) et (indMaxAbs > 0),
     ajoute une courbe dans le graphique.
  Si (indMax0 > 0), met les informations pavX^ et pavY^ dans la courbe, et
     init. la courbe pour qu'elle se dessine.

  Retourne la courbe, nil si aucune courbe ajoute au graphique.
  Avec AddInGrWindow, on peut ainsi simplement ajouter des courbes
   un graphique.
----------------------------------------------------------}

type
  { c.f. glfnLoadCurveSignature, plus bas }
  TypeProcLoadCurveSignature = procedure(var fIn:Text; var nErr:integer);

const
{ Point sur une fonction qui permet d'allouer et de crer une nouvelle Window.
  Il faut la faire pointer sur une fonction utilisateur qui alloue
  la mmoire et init. une nouvelle Window }
glfnLoadCurveSignature : TypeProcLoadCurveSignature = TypeProcLoadCurveSignature(LoadCurveSignatureSKE);
{-----------------------------------------------------------------------}

function NewInfoSKE(flags:word):PGAPInfo;
{====================================}
{ Exemple de fonctions pour allouer de la mmoire et initialiser une nouvelle
  Information.
  Flags = Flags  l'init d'une nouvelle info.
-------------------------------------------------------------------------}

type
  { c.f. glfnNewInfo, plus bas }
  TypeFuncNewInfo = function(flags:word):PGAPInfo;

const
{ Point sur une fonction qui permet d'allouer et de crer une nouvelle Info.
  Il faut la faire pointer sur une foncion utilisateur qui alloue
  la mmoire et init. une nouvelle Info. }
glfnNewInfo : TypeFuncNewInfo = TypeFuncNewInfo(NewInfoSKE);
{--------------------------------------}

function NewCurveSKE(
{===================}
      nIndMax,         { indice maximal ncssaire pour charger les points
                         de la courbe }
      nIndMaxAbs      { indice maximal qu'avait la courbe au save, ou
                         indice maximal dsir }
                       : integer;
      flags            : word
      ):PGAPCurve;
      { = flags  l'init d'une nouvelle courbe }
{ Exemple de fonctions pour allouer de la mmoire et initialiser une nouvelle
  courbe. }

type
  { c.f. glfnNewCurve, plus bas }
  TypeFuncNewCurve = function(nIndMax, nIndMaxAbs:integer; flags:word):PGAPCurve;

const
{ Point sur une fonction qui permet d'allouer et de crer une nouvelle courbe.
  Il faut la faire pointer sur une foncion utilisateur qui alloue
  la mmoire et init. une nouvelle courbe. }
glfnNewCurve : TypeFuncNewCurve = TypeFuncNewCurve(NewCurveSKE);
{-----------------------------------------}

function NewGraphicSKE(pGAPWin1:PGAPWindow; Flags:word):PGAPGraphic;
{===============================================================}
{ Exemple de fonctions pour allouer de la mmoire et initialiser un nouveau
  graphique.
  pGAPWin1 = pointeur sur la fentre contenant le graphique.
  Flags = 0, rserv pour dvelop. future
-------------------------------------------------------------------------}

type
  { c.f. glfnNewGraphic, plus bas }
  TypeFuncNewGraphic = function(pGAPWin1:PGAPWindow; Flags:word):PGAPGraphic;

const
{ Point sur une fonction qui permet d'allouer et de crer un nouveau graphique.
  Il faut la faire pointer sur une foncion utilisateur qui alloue
  la mmoire et init. un nouveau graphique }
glfnNewGraphic : TypeFuncNewGraphic = TypeFuncNewGraphic(NewGraphicSKE);
{-----------------------------------------}

function NewWindowSKE(Flags0:word):PGAPWindow;
{============================================}
{ Exemple de fonctions pour allouer de la mmoire et initialiser
  une nouvelle Window
  Flags0 = 0, rserv pour dvelop. future
-------------------------------------------------------------------------}

type
  { c.f. glfnNewWindow, plus bas }
  TypeFuncNewWindow = function(Flags0:word):PGAPWindow;

const
{ Point sur une fonction qui permet d'allouer et de crer une nouvelle Window.
  Il faut la faire pointer sur une foncion utilisateur qui alloue
  la mmoire et init. une nouvelle Window }
glfnNewWindow : TypeFuncNewWindow = TypeFuncNewWindow(NewWindowSKE);
{--------------------------------------------}

var
  glpActiveWindow  : PGAPWindow;
  { fentre active }

  glpActiveGraphic : PGAPGraphic;
  { Graphique actif }

  glpActiveCurve   : PGAPCurve;
  { Courbe slectionne }

const
  { par dfaut, les couleurs de bases d'un graphique pointent sur ces couleurs,
    ce qui permet un changement de couleurs de tous les graphiques
    en mme temps. }
  { couleur du bord de la fentre 1. (contenant le graphique) }
  glcolBorderWin1  : TColorRef =   0 + 256*(  0 + 256*255);
                                 { R          G         B}
  { couleur du fond de la fentre 1. (contenant le graphique) }
  glcolWin1        : TColorRef = 192 + 256*(192 + 256*192);
                                 { R          G         B}
  { couleur du fond du graphique (=fentre 2) }
  glcolWin2        : TColorRef = 255 + 256*(255 + 256*255);
                                 { R          G         B}

  { position initiale de la boite de dialogue de zoom,
    Si elle n'a pas dj t dplace }
  glnZoomDlgLastPosX : integer = 50;
  glnZoomDlgLastPosY : integer = 50;

  glfWithColorActiveCurve : boolean = FALSE;
  { Indique si on change la couleur de la courbe active }

IMPLEMENTATION
{""""""""""""}

const
errNoCurvesInTheGraphic                = 1701; { c.f. wSKEVar.pas}

{************************************************************************}
{********** Procdure qui ne sont pas des mthodes d'objects }
{************************************************************************}

function NewInfoSKE(flags:word):PGAPInfo; {far;}
{====================================}
{ Exemple de fonctions pour allouer de la mmoire et initialiser une nouvelle
  Information.
  Flags = 0, rserv pour le future.
-------------------------------------------------------------------------}
begin { - NewInfoSKE - }
NewInfoSKE:=New(PGAPInfo, Init(flags));
end;  { - NewInfoSKE - }

function NewCurveSKE(
{================}
      nIndMax,         { indice maximal ncssaire pour charger les points
                         de la courbe }
      nIndMaxAbs       { indice maximal qu'avait la courbe au save, ou
                         indice maximal dsir }
                       : integer;
      flags            { = 0, rserv pour dvelop. future }
                       : word
      ):PGAPCurve; {far;}
{ Exemple de fonctions pour allouer de la mmoire et initialiser une nouvelle
  courbe. }
begin { - NewCurveSKE - }
NewCurveSKE:=new(PGAPCurve, Init(NIL, nIndMax, flaAutoDisposeSelf));
end;  { - NewCurveSKE - }

function NewGraphicSKE(pGAPWin1:PGAPWindow; Flags:word):PGAPGraphic;{far;}
{===============================================================}
{ Exemple de fonctions pour allouer de la mmoire et initialiser un nouveau
  graphique.
  pGAPWin1 = pointeur sur la fentre contenant le graphique.
  Flags = 0, rserv pour dvelop. future
-------------------------------------------------------------------------}
begin { - NewGraphicSKE - }
NewGraphicSKE:=new(PGAPGraphic, Init(pGAPWin1, NIL, NIL,NIL, flaAutoDisposeSelf));
end;  { - NewGraphicSKE - }

function NewWindowSKE(Flags0:word):PGAPWindow;
{============================================}
{ Exemple de fonctions pour allouer de la mmoire et initialiser
  une nouvelle Window
  Flags0 = 0, rserv pour dvelop. future
-------------------------------------------------------------------------}
var
  pWin             : PGAPWindow;
begin { - NewWindowSKE - }
New(pWin, Init( gglpoMainWindow, GetMsg(msgNewWindowTitle), NIL, 0));

if (GetMsg(10010) = '????10010') then pWin^.wMsgDefaultMenu:=2100030000 // default menu if none has been defined
else                                  pWin^.wMsgDefaultMenu:=10010;

pWin^.WinCreate('');
NewWindowSKE:=PGAPWindow(pWin);
end;  { - NewWindowSKE - }

{************************************************************************}
{*****  TZoomDlg = object(TGAPDlg) *****}
{************************************************************************}
(*???
Constructor TZoomDlg.MSGInit(AParent: PWindowsObject ; aMsgID: Word; Var AFiche:PFiche);
{======================================================================================}
{ pour les mthode virtuelles, il faut redfinir les constructeurs }
begin { - TZoomDlg.MSGInit - }
inherited MSGInit(AParent, aMsgID, AFiche);

pDlgFiche:=AFiche;
fMemoriseMove:=FALSE;
end;  { - TZoomDlg.MSGInit - }

Constructor TZoomDlg.Init(Aparent:PWindowsObject; strTitle0:TStr160);
{===================================================================}
{ pour les mthode virtuelles, il faut redfinir les constructeurs }
begin { - TZoomDlg.Init - }
inherited Init(Aparent, strTitle0);

pDlgFiche:=NIL;
fMemoriseMove:=FALSE;
end;  { - TZoomDlg.Init - }

Destructor TZoomDlg.Done;
{=======================}
begin { - TZoomDlg.Done - }
inherited Done;

{ doit tre fait aprs le Done, car des autres mthodes (WM_...) peuvent
  tres appele juste aprs le inherited Done }
if (pDlgFiche <> NIL) then dispose(pDlgFiche, Done);
pDlgFiche:=NIL;
pGr:=NIL;
end;  { - TZoomDlg.Done - }

Procedure TZoomDlg.Ok(Var Msg : TMSG);
{========================================}
{ On ferme le dialogu, et on ne fait rien, les var du prog
  sont dja  jour  chaque fois que le focus est perdu }
var
  pGr0             : pGAPGraphic;
begin { - TZoomDlg.Ok - }
fMemoriseMove:=FALSE;

{ Test de debuging, c.f. oWindows.pas, wb_Transfer }
{if ((Flags and $1E) <> 0) then begin
   DBW('ERREUR : 0 <> Flags =' + ITS(Flags));
   end;}

pGr0:=pGr;
inherited OK(Msg);
{ ici pGr n'est plus dfini, mais pGr0 est dfini }

pGr0^.ZoomOK;

{ redessine la fentre }
InvalidateRect(pGr0^.pGAPWin^.hWin, NIL, TRUE);
end;  { - TZoomDlg.Ok - }

Procedure TZoomDlg.Cancel(Var Msg : TMSG);
{============================================}
{ On ferme le dialogu, et on remet les copies dans les var du prog }
begin { - TZoomDlg.Cancel - }
fMemoriseMove:=FALSE;

{ Test de debuging, c.f. oWindows.pas, wb_Transfer }
{if ((Flags and $1E) <> 0) then begin
   DBW('ERREUR : 0 <> Flags =' + ITS(Flags));
   end;}

pGr^.ZoomCancel;

{ redessine la fentre }
InvalidateRect(pGr^.pGAPWin^.hWin, NIL, TRUE);

inherited Cancel(Msg);
end;  { - TZoomDlg.Cancel - }

Procedure TZoomDlg.UpDateAllVar0;
{===============================}
Var
  pPos              : PInstructionNode;

Begin { TZoomDlg.UpDateAllVar0 }
  pPos:=pMainDlgInter^.pFirstInstruction;
  While pPos<>Nil Do Begin
    pMainDlgInter^.InitializeObjectValue(pPos);
    pPos:=pPos^.pNext
    End;

End;  { TZoomDlg.UpDateAllVar0 }

Procedure TZoomDlg.WmUUpDateVar(Var Msg : TMSG);
{==================================================}
{ ne pas appeller.
{ Indication qu'un variable est remise  jours, donc qu'il faut
  remettre les curseurs de zoom  jours }
{ Cette mthode peut tre appele aprs le Done ! }
begin { - TZoomDlg.WmUUpDateVar - }
inherited WmUUpdateVar(Msg);

pGr^.UpdateCursorPos;
end;  { - TZoomDlg.WmUUpDateVar - }

procedure TZoomDlg.WMMove(var Msg:TMSG);
{==========================================}
var
  rect             : TRect;

begin { - TZoomDlg.WMMove - }
if fMemoriseMove then begin
   GetWindowRect(hWin, rect);

   { Position initiale de la boite de dialogue de Zoom }
   pGr^.pnZoomDlgLastPosX^ :=rect.Left;
   pGr^.pnZoomDlgLastPosY^ :=rect.Top;
   glnZoomDlgLastPosX :=rect.Left;
   glnZoomDlgLastPosY :=rect.Top;
   end;

DefWndProc(Msg);
end;  { - TZoomDlg.WMMove - }

Procedure TZoomDlg.SetUpWindow;
{=============================}
{ Place la boite de dialogue de zoom au mme endroit que la ou elle
  tait la dernire fois }
var
  rect             : TRect;
  nWidth,
  nHeight          : integer;

Begin { - TZoomDlg.SetUpWindow }
inherited SetupWindow;

{ lit les dimensions du dialogue }
GetWindowRect(hWin, rect);
with rect do begin
   nWidth  :=right - left;
   nHeight :=bottom - top;
   left:=pGr^.pnZoomDlgLastPosX^;
   top :=pGr^.pnZoomDlgLastPosY^;

{   DBW(2, IntToStr(rect.Left,8) + IntToStr(Rect.Top,8));}

   MoveWindow(hWin,left, top, nWidth, nHeight, FALSE);

   { par la suite, mmorise les dplacements de cette fentre,
     pour la rouvrire au mme endroit }
   fMemoriseMove:=TRUE;
   end; { with }

end;  { - TZoomDlg.SetUpWindow }
*)
{************************************************************************}
{*********  OBJECT TGAPInfo }
{************************************************************************}

constructor TGAPInfo.Init(Flags:word);
{=======================================}
begin { - TGAPInfo.Init - }
wIdentity :=7384; { NE PAS MODIFIER. Indique que initialis }

strDate     :=GetdateStr; { date du jours }
strTime     :=GetTimeStr; { heure actuelle }
strUserName :='???';
strComment1 :='';
strComment2 :='';

strFileDir  :='.';
strFileName :='NoName';
strFileExt  :='.SK1';

fHasChangedInfo:=TRUE;

{ Date et heure du jours, sous forme code }
lDateTime:=GetDateTime;

{ - peut tre utilis par des sous objets pour dfinir de
    quel objets il s'agit. Par dfaut = 0 - }
nKind         :=0;
end;  { - TGAPInfo.Init - }

destructor TGAPInfo.Done;
{========================}
begin { - TGAPInfo.Done - }
wIdentity :=0; { NE PAS MODIFIER. Indique que dtruit par Done }
end;  { - TGAPInfo.Done - }

procedure TGAPInfo.Standardize;
{=============================}
{ Standardise le nom de rpertoire strFileDir (termine par un '\',
  et le nom d'extention (commence par un '.' }
var nLen : integer;
begin { - TGAPInfo.Standardize - }
if (length(strFileExt) > 0) and (strFileExt[1] <> '.') then
    StrFileExt:='.' + StrFileExt;
strFileExt:=Copy(StrFileExt, 1, 4); { assure la bonne longueur }

nLen:=length(strFileDir);
if (nLen > 0) then begin
   if (strFileDir[nLen] <> ':') and (strFileDir[nLen] <> '\') then
       strFileDir:=strFileDir + '\';
   end;
end;  { - TGAPInfo.Standardize - }

function TGAPInfo.GetFileNameExt:string;
{======================================}
{ retourne le nom de fichier avec extension }
begin { - TGAPInfo.GetFileNameExt - }
Standardize;
GetFileNameExt:=strFileName + strFileExt;
end;  { - TGAPInfo.GetFileNameExt - }

function TGAPInfo.GetFilePath:TStrFilePath;
{=========================================}
{ retourne le nom de fichier avec extension et rpertoire. }
begin { - TGAPInfo.GetFilePath - }
Standardize;
GetFilePath:=strFileDir + strFileName + strFileExt;
end;  { - TGAPInfo.GetFilePath - }

procedure TGAPInfo.UpdateStrFile(strFilePath:TStrFilePath);
{=========================================================}
{ Met  jours strFileDir, strFileName et strFileExt,
  en fonction de strFilePath }
var
  strDir           : String[120];
  strName          : String[120];
  strExt           : String[20];

begin { - TGAPInfo.UpdateStrFile - }
(*???
FileSplit(AZT(strFilePath), @strDir[1], @strName[1], @strExt[1]);
strFileDir  :=StrPas(@strDir[1]);
strFileName :=StrPas(@strName[1]);
strFileExt  :=StrPas(@strExt[1]);
???*)
FileSplit(strFilePath, strDir, strName, strExt);
strFileDir  :=strDir;
strFileName :=strName;
strFileExt  :=strExt;

Standardize;
{fHasChangedInfo:=TRUE; est fait trop souvant pour tre mis  TRUE }
end;  { - TGAPInfo.UpdateStrFile - }

procedure TGAPInfo.SaveMoreInfo(var fOut:Text; var nErr:integer);
{===========================================================}
{ Cette procdure est destine a tre redfinie par l'utilisateur.
  Elle va de paire avec la procedure LoadMoreInfo(fIn, nErr).
  Ne pas appeler le inherited SaveMoreInfo(fOut, nErr);
  ni le inherited LoadMoreInfo(fIn, nErr);
  nErr = IOResult;
-------------------------------------------------------------------------}
begin { - TGAPInfo.SaveMoreInfo - }
{$i-}
{ version dveloppeur-utilisateur }
writeln(fOut, '# ...Signature : _TGAPInfo More');
writeln(fOut,'# ', 100);
nErr:=IOResult;
{$i+}
end;  { - TGAPInfo.SaveMoreInfo - }

procedure TGAPInfo.SaveInfo(var fOut:Text; var nErr:integer);
{===========================================================}
{ nErr = IOResult }
var
  nErr2            : integer;

begin { - TGAPInfo.SaveInfo - }
{ rend standard les nom de fichier, extension et rpertoires }
Standardize;

{$i-}
writeln(fOut, '#_');
writeln(fOut, '# ...Signature : _TGAPInfo');

{ code de version du dveloppeur de librairie }
writeln(fOut,'# ', 101);

{ Ne pas faire, on conserve la date de l'init. }
{ Sinon, on pert la date de mesure PMD lors d'un nouveau save }
{strDate     :=GetdateStr;  date du jours }
{strTime     :=GetTimeStr;  heure actuelle }

{ informations de base }
writeln(fOut, '# ...BEG _TGAPInfo Library');
writeln(fOut,'#_', strDate);
writeln(fOut,'#_', strTime);
writeln(fOut,'#_', strUserName);
writeln(fOut,'#_', strComment1);
writeln(fOut,'#_', strComment2);

{ Nom pour la sauvegarde sur disque (dpend de la mesure) }
writeln(fOut,'#_', strFileDir);
writeln(fOut,'#_', strFileName);
writeln(fOut,'#_', strFileExt);

{ Date et heure du jours, sous forme code }
lDateTime:=GetDateTime;

writeln(fOut,'# ', lDateTime);

writeln(fOut, '#_');
writeln(fOut, '# ...END _TGAPInfo Library');

fHasChangedInfo:=FALSE;

SaveMoreInfo(fOut, nErr2);

writeln(fOut, '# ...END _TGAPInfo');

nErr:=ioResult;
{$i+}

if (nErr = 0) then nErr:=nErr2;
end;  { - TGAPInfo.SaveInfo - }

procedure TGAPInfo.LoadMoreInfo(var fIn:Text; var nErr:integer);
{==============================================================}
{ Cette procdure est destine a tre redfinie par l'utilisateur.
  Elle va de paire avec la procedure SaveMoreInfo(fOut, nErr).
  Ne pas appeler le inherited SaveMoreInfo(fOut, nErr);
  ni le inherited LoadMoreInfo(fIn, nErr);
  nErr = IOResult;
-------------------------------------------------------------------------}
var  strS : TStr80;
begin { - TGAPInfo.LoadMoreInfo - }
{$i-}
{ version dveloppeur-utilisateur }
readln(fIn, strS);
if (strS = '# ...Signature : _TGAPInfo More') then begin
   readln(fIn);  { ignore la version }
   end;
nErr:=IOResult;
{$i+}
end;  { - TGAPInfo.LoadMoreInfo - }

procedure TGAPInfo.LoadInfo(var fIn :Text; var nErr:integer);
{===========================================================}
{  nErr = IOResult ou
   errEOFTooEarly. }
var
  strS             : string[80];
  nErr2,
  nVersion         : integer;
  c1,c2            : char;

begin { - TGAPInfo.LoadInfo - }
{$i-}
{ cherche le dbut des informations }
repeat
   readln(fIn, strS);
   until (strS = '# ...Signature : _TGAPInfo') or EOF(fIn);

if EOF(fIn) then begin nErr:=IOResult; nErr:= errEOFTooEarly; exit; end;

{ code de version du dveloppeur de librairie }
readln(fIn,c1,c2, nVersion);

{ informations de base }
repeat
   readln(fIn, strS);
   until (strS = '# ...BEG _TGAPInfo Library') or EOF(fIn);

if EOF(fIn) then begin nErr:= errEOFTooEarly; exit; end;

readln(fIn,c1,c2,strDate);
readln(fIn,c1,c2,strTime);
readln(fIn,c1,c2,strUserName);
readln(fIn,c1,c2,strComment1);
readln(fIn,c1,c2,strComment2);

{strDate:=GetDateStr;  date du jours }
{strTime:=GetTimeStr;  heure actuelle }

{ Nom pour la sauvegarde sur disque (dpend de la mesure) }
readln(fIn,c1,c2,strFileDir);
readln(fIn,c1,c2,strFileName);
readln(fIn,c1,c2,strFileExt);

if (nVersion >= 101) then readln(fIn,c1,c2, lDateTime)
else                      lDateTime:=GetDateTimeFromStr(strDate, strTime, 0);

readln(fIn);

repeat
   readln(fIn, strS);
   until (strS = '# ...END _TGAPInfo Library') or EOF(fIn);

if EOF(fIn) then begin nErr:= errEOFTooEarly; exit; end;

fHasChangedInfo:=FALSE;

LoadMoreInfo(fIn, nErr2);

{ cherche la fin des informations }
repeat
  readln(fIn, strS);
  until (strS ='# ...END _TGAPInfo') or EOF(fIn);

nErr:=ioResult;
{$i+}

{ rend standard les nom de fichier, extension et rpertoires }
Standardize;

if (nErr = 0) then nErr:=nErr2;
end;  { - TGAPInfo.LoadInfo - }

procedure TGAPInfo.CopyInfoTo(pInfo:PGAPInfo; Flags:word);
{========================================================}
{ Nouveau, copie toutes les donnes dans pInfo^.
  Flags = 0 => copie tout!
  Flags = 1 => copie sauf lDateTime.
  Flags = 2 => copie sauf strTime.
  Flags = 4 => copie sauf strDate.
  Flags = 8 => ne copie pas le username
    (8=flaInfoCopyNoUserName)
------------------------------------------------------}
begin { - TGAPInfo.CopyInfoTo - }
if ((Flags and 2) = 0) then pInfo^.strTime :=strTime;
if ((Flags and 4) = 0) then pInfo^.strDate :=strDate;

pInfo^.strComment1  :=strComment1;
pInfo^.strComment2  :=strComment2;

pInfo^.strFileDir   :=strFileDir;
pInfo^.strFileName  :=strFileName;
pInfo^.strFileExt   :=strFileExt;
if ((Flags and 1) = 0) then pInfo^.lDateTime    :=lDateTime;

if ((Flags and flaInfoCopyNoUserName) = 0) then
   pInfo^.strUserName:=strUserName;

pInfo^.fHasChangedInfo:=fHasChangedInfo;
end;  { - TGAPInfo.CopyInfoTo - }
(*???
procedure TGAPInfo.PutFields(nFirstNum:integer; pFiche:PFiche);
{=============================================================}
{ Met les paramtres dans  Fiche....Field pour les traiter
  dans des boites de dialogues.
  nFirstNum = 1er numro utilis pour mettre les champs.
--------------------------------------------------------------------}
begin { - TGAPInfo.PutFields - }
with pFiche^ do begin
   StrField(nFirstNum +  0, strDate, SizeOf(strDate));
   StrField(nFirstNum +  1, strTime, SizeOf(strTime));
   StrField(nFirstNum +  2, strUserName, SizeOf(strUserName));
   StrField(nFirstNum +  3, strFileDir, SizeOf(strFileDir));
   StrField(nFirstNum +  4, strFileName, SizeOf(strFileName));
   StrField(nFirstNum +  5, strFileExt, SizeOf(strFileExt));
   StrField(nFirstNum + 11, strComment1, SizeOf(strComment1));
   StrField(nFirstNum + 12, strComment2, SizeOf(strComment2));
   end;
end;  { - TGAPInfo.PutFields - }
???*)
{************************************************************************}
{*********  OBJECT TGAPCurve }
{************************************************************************}

{ - constructeur et destructeur - }
{ ------------------------------- }

constructor TGAPCurve.Init(pI:PGAPInfo; nIndMaxAbs0,Flags:word);
{==============================================================}
{ Alloue la mmoire pour pXD, pYD, = array[0..nIndMaxAbs0] of Float
  Selon les Flags, on peut ne pas allouer de mmoire pour pXD ou PYD,
  et dans ce cas, l'utilisateur devra faire pointer pXD ou pYD sur un
  array of Float. }
var
  nn               : integer;

begin { - TGAPCurve.Init - }
wIdentity :=9725; { NE PAS MODIFIER. Indique que initialis }

{ indique si le constructeur init  t appel.
  Si non, la donnes est inutilisable }
isInit           :=TRUE;

{ indique si la mesure est charge, ou a t faite }
isLoaded         :=FALSE;

fHasChangedCu    :=TRUE;

{ indique si on veut le dessin du graphe }
fDraw            :=FALSE;

{ pour l'instant, pas d'info associs }
if (pI = NIL) then begin
   pInfo:=glfnNewInfo(0);
   fAutoDisposeInfo:=TRUE;
   end
else begin
   pInfo:=pI;
   fAutoDisposeInfo:=FALSE;
   end;

{ test que nIndMaxAbs ne soit pas top grand, ni ngatif }
if (nIndMaxAbs0 < 1) then nIndMaxAbs0:=1;
if (nIndMaxAbs0 > cteIndMaxFloat) then nIndMaxAbs0:=cteIndMaxFloat;

{ Les donnes pXD^ et pYD^, sont des array[0..nIndMaxAbs] of Float }
nIndMaxAbs       :=nIndMaxAbs0;

if ((Flags and flaCurveWithoutAllocateXData) = 0) then begin
   wMemSizeX        :=word((nIndMaxAbs + 1)) * SizeOf(Float);
   GetMem(pXDMem, wMemSizeX);
   end
else begin
   wMemSizeX        :=0;
   pXDMem           :=NIL;
   end;

pXD:=pXDMem;

if ((Flags and flaCurveWithoutAllocateYData) = 0) then begin
   wMemSizeY        :=word((nIndMaxAbs + 1)) * SizeOf(Float);
   GetMem(pYDMem, wMemSizeY);
   end
else begin
   wMemSizeY        :=0;
   pYDMem           :=NIL;
   end;

pYD:=pYDMem;

{ nombre de donne : 0..nIndMax }
nIndMax           :=-1;

{ indique si il faut librer automatiquement la mmoire alloue
  pour cette courbe au Done du dernier graphique qui la contient. }
fDoAutoDispose:=((Flags and flaAutoDisposeSelf) <> 0);

{ indication sur la couleur et le style de la courbe du graphique,
  est dfini dans l'Init, mais est modifiable }
fDrawCurveCu       :=TRUE; { indique qu'il faut dessiner les lignes }
styleLineCu        :=PS_SOLID;
pixWidthLineCu     :=1;   { 0..infinity }
mmWidthLineCu      :=0.1;
colLineCu          :=RGB(0, 0, 0); { noir }

{ Pour des Marques  la place des points }
fDrawMarkCu        :=FALSE; { indique qu'il ne faut pas dessiner les marques }
styleMarkCu        :=PS_SOLID;
pixWidthMarkCu     :=1;
mmWidthMarkCu      :=0.1;
colMarkCu          :=RGB(0, 0, 0); { noir }
sizeMarkCu         :=1;     { = taille de la marque en milimtres }
nMarkStyleCu       :=markPlus;   { Type de marque, c.f. markPlus,... de wGrBase }

strLegend        :='';

{ graphiques contenant la courbe.  }
for nn:=1 to DIX do apGr[nn]:=NIL;
nbGr:=0;

fNoXOrder:=FALSE;
{ donnes en X sont ordonnes croissantes ou dcroissantes. Utilis dans le zoom }

{ pour viter des boucles infinies d'appels }
fCalled:=FALSE;


{ pour le formattage des donnes pXD^ et pYD^  la sauvegarde dans des
  fichiers }
{ writeln(pXD^[nn]:rXFmt:dXFmt, pYD^[nn]:rYFmt:dYFmt); }
{ si dYFmt = -1 alors format : pYD^[nn]:rYFmt }
rXFmt  := 0; { pas de formattage, crit le nombre complet }
dXFmt  := 6; { non utilis }
rYFmt  := 0; { pas de formattage, crit le nombre complet }
dYFmt  := 6; { non utilis }

{ - peut tre utilis par des sous objets pour dfinir de
    quel objets il s'agit - }
nKind  :=0;
end;  { - TGAPCurve.Init - }

Destructor TGAPCurve.Done;
{========================}
{ Libre la mmoire alloue par le constructeur. }
var
  mm,nn         : integer;

begin { - TGAPCurve.Done - }
if (glpActiveCurve = @Self) then glpActiveCurve:=NIL;

{ Enlve la rfrence aux graphiques qui contiennent cette courbe }
{ Parmis tous les graphiques contenant cette courbe }
for mm:=1 to nbGr do
   if (apGr[mm] <> NIL) and
      ( not IsBadWritePtr(apGr[mm], 1)) and
      (apGr[mm]^.wIdentity = 8347) then apGr[mm]^.RemoveCurve(@Self);

if fAutoDisposeInfo and (pInfo <> NIL) and (pInfo^.wIdentity = 7384) then begin
   dispose(pInfo, Done); { dispose de l'info associe  cette courbe }
   end; { if (pInfo <> NIL) and ... }

{ libre la mmoire alloue pour les points des courbes }
if (wMemSizeY > 0) then FreeMem(pYDMem, wMemSizeY);
if (wMemSizeX > 0) then FreeMem(pXDMem, wMemSizeX);

wMemSizeY:=0;
wMemSizeX:=0;
pYDMem:=NIL;
pXDMem:=NIL;

nIndMax   :=-1;
isLoaded :=FALSE;
fDraw    :=FALSE;

{ graphiques contenant la courbe. }
for nn:=1 to DIX do apGr[nn]:=NIL;
nbGr:=0;

{ indique si le constructeur init  t appel.
  Si non, la donnes est inutilisable }
isInit           :=FALSE;

fDoAutoDispose:=FALSE;

wIdentity :=0; { NE PAS MODIFIER. Indique que dtruit par Done }
end;  { - TGAPCurve.Done - }

procedure TGAPCurve.GetFamilly( var nbParent:integer;
{=============================} var astrFamilly:array of TSTR30);
{ Pour connaitre tous les anctres d'un objet.
  c.f. wSKEVar.pas pour voir comment implmenter les descendant
  OUTPUT :
  nbParent = nombre de membre dans la famille
  astrFamilly = nom des ojbets. }

begin { - TGAPCurve.GetFamilly - }
astrFamilly[0]:='TGAPCurve';
nbParent:=1;

{ les descendant feront :
inherited GetFamilly(nbParent, astrFamilly);
astrFamilly[nbParent]:='nom de l'objet';
inc(nbParent); }
end;  { - TGAPCurve.GetFamilly - }

procedure TGAPCurve.AddToGraphic(pGr1:PGAPGraphic; var nErr:integer);
{======================================================================}
{ Ajoute la courbe au graphique pGr1.
  Utiliser TGAPGraphic.AddCurve au lieu de cette procdure
  nErr = 0 ou
  errTooManyGraphics
  errTooManyCurves  de AddCurve
  errCurveNotInit   de AddCurve
-------------------------------------------------------------------------}
begin { - TGAPCurve.AddToGraphic - }
nErr:=0;
if fCalled then exit;  { vite des boucles d'appels infinies }

if (nbGr >= DIX) then begin
   nErr:=errTooManyGraphics;
   ErrorWrite(nErr, 'AddToGraphic');
   exit;
   end;

fCalled:=TRUE;
if (not pGr1^.fCalled) then pGr1^.AddCurve(@Self, nErr);
fCalled:=FALSE;

if (nErr = 0) then begin
   { indique que la courbe fait partie du graphic Gr1. }
   inc(nbGr);
   apGr[nbGr]:=pGr1;
   end;

end;  { - TGAPCurve.AddToGraphic - }

procedure TGAPCurve.RemoveFromGraphic(pGr1:PGAPGraphic);
{======================================================}
{ Enlve la courbe du graphique pGr1.
  Utiliser TGAPGraphic.RemoveCurve au lieu de cette procdure }
var
  nn,kk            : integer;

begin { - TGAPCurve.RemoveFromGraphic - }
if fCalled then exit;  { vite des boucles d'appels infinies }

fCalled:=TRUE;
if (not pGr1^.fCalled) then pGr1^.RemoveCurve(@Self);
fCalled:=FALSE;

{ Enlve la rfrence au graphique }
{ Recherche parmis toutes les gaphiques associs  la courbe }
for nn:=1 to nbGr do begin
   { cherche la rfrence au graphique }
   if (apGr[nn] = pGr1) then begin
      { limine la rfrence  la prsente courbe }
      for kk:=nn to nbGr-1 do apGr[kk]:=apGr[kk+1];

      apGr[nbGr]:=NIL;
      dec(nbGr);
      end; { if (apGr[nn] = pGR1) then begin }
   end; { for nn:=1 to nbGr do begin }
end;  { - TGAPCurve.RemoveFromGraphic - }

procedure TGAPCurve.CopyXYCurveTo( nLeft,nRight:integer;
{================================} pCu:PGAPCurve; flags:word);
{ Copie des donnes pXD^.[nLeft..nRight] et pYD^...
  d'une courbe dans une autre.
  flags = 0 => copie les donnes pXD et pYD
  flags = flaNoCopyX = ne copie pas les donnes pXD
  flags = flaNoCopyY = ne copie pas les donnes pYD

    Les Flags <= 255  sont rservs pour l'utilisateur-dveloppeur
----------------------------------------------------------------------}
var  nn : integer;
begin { - TGAPCurve.CopyXYCurveTo - }
if ((flags and flaNoCopyX) = 0) then begin
   { copie de la courbe active dans la nouvelle courbe }
   for nn:=nLeft to nRight do pCu^.pXD^[nn]:=pXD^[nn];
   end;

if ((flags and flaNoCopyY) = 0) then begin
   { copie de la courbe active dans la nouvelle courbe }
   for nn:=nLeft to nRight do pCu^.pYD^[nn]:=pYD^[nn];
   end;

end;  { - TGAPCurve.CopyXYCurveTo - }

function TGapCurve.CopyCuTo(pCu:PGAPCurve; Flags1:word):PGAPCurve;
{================================================================}
{ Copie une courbe dans une autre, avec le contenu.
  Flags1 = 0 => copie tout
  flags1 = flaNoCopyX = ne copie pas pXD, mais copie aussi les infos
  flags1 = flaNoCopyY = ne copie pas pYD, mais copie aussi les infos
  Si pCu = NIL, cre une nouvelle copurbe, et retourne un pointeur dessus.
  sinon         retourne pCu

  Les Flags1 <= 255  sont rservs pour l'utilisateur-dveloppeur
--------------------------------------------------------------}
begin { - TGapCurve.CopyCuTo - }
CopyCuTo:=pCu;

{ cration d'une nouvelle courbe, si ncssaire }
if (pCu = NIL) then begin
   pCu :=glfnNewCurve(nIndMaxAbs, nIndMaxAbs, 0);
   if (pCu = NIL) then exit; { pas normal }
   end;

CopyCuTo:=pCu;

{ Ne doivent pas tre chang!
wIdentity
isInit
nIndMaxAbs
apGr
nbGr
fAutoDisposeInfo
nKind  }

pInfo^.CopyInfoTo(pCu^.pInfo, 0);

pCu^.nIndMax    :=nIndMax;
if (pCu^.nIndMax > pCu^.nIndMaxAbs) then pCu^.nIndMax :=pCu^.nIndMaxAbs;
if isLoaded then CopyXYCurveTo(0, pCu^.nIndMax, pCu, Flags1);

pCu^.isLoaded        :=isLoaded;
pCu^.fHasChangedCu   :=fHasChangedCu;

pCu^.fDraw           :=fDraw;
pCu^.fDrawCurveCu    :=fDrawCurveCu;
pCu^.styleLineCu     :=styleLineCu;
pCu^.pixWidthLineCu  :=pixWidthLineCu;
pCu^.mmWidthLineCu   :=mmWidthLineCu;
pCu^.colLineCu       :=colLineCu;

pCu^.fDrawMarkCu     :=fDrawMarkCu;
pCu^.styleMarkCu     :=styleMarkCu;
pCu^.pixWidthMarkCu  :=pixWidthMarkCu;
pCu^.mmWidthMarkCu   :=mmWidthMarkCu;
pCu^.colMarkCu       :=colMarkCu;
pCu^.sizeMarkCu      :=sizeMarkCu;
pCu^.nMarkStyleCu    :=nMarkStyleCu;

pCu^.strLegend       :=strLegend;

pCu^.indXMin     :=indXMin;
pCu^.indXMax     :=indXMax;
pCu^.vXMin       :=vXMin;
pCu^.vXMax       :=vXMax;

pCu^.fNoXOrder   :=fNoXOrder;
pCu^.rXFmt       :=rXFmt;
pCu^.dXFmt       :=dXFmt;
pCu^.rYFmt       :=rYFmt;
pCu^.dYFmt       :=dYFmt;
end;  { - TGapCurve.CopyCuTo - }

procedure TGAPCurve.InitForDraw(nIndMax1:integer);
{===============================================}
{ indique que la courbe peut tre dessine, et possde nIndMax1 +1 points }
var
  nn               : integer;
begin { - TGAPCurve.InitForDraw - }
if (nIndMax1 < 0) then nIndMax1:=0;

{fHasChangedCu:=fHasChangedCu or (nIndMax <> nIndMax1); }
nIndMax:=nIndMax1;

isLoaded     :=TRUE;
fDraw        :=TRUE;

{ indique a tous les graphiques contenant cette courbe,
  que le zoom de cette courbe doit tre recalcule. }
for nn:=1 to nbGr do apGr[nn]^.ComputeLimitsZoomCurve(0, @Self);
end;  { - TGAPCurve.InitForDraw - }

procedure TGAPCurve.DrawCurve(indMin,indMax:integer; pGrBase1:PGraphicBase);
{==========================================================================}
{ dessine la courbe en utilisant le graphisme pGrBase1 }
var
  nbPts            : integer;

begin { - TGAPCurve.DrawCurve - }
if not (isInit and isLoaded and fDraw) then exit;

if (indMin < 0)       then indMin:=0;
if (indMax > nIndMax) then indMax:=nIndMax;
if (indMin > indMax)  then exit;

nbPts:=indMax - indMin +1;
with pGrBase1^ do begin
   if fDrawCurveCu then begin
      SetLineAttrib(styleLineCu, pixWidthLineCu, mmWidthLineCu, colLineCu);
      PolyLine0(nbPts, pXD^[indMin], pYD^[indMin]);
      end;

   if fDrawMarkCu then begin
      SetMarkAttrib(styleMarkCu, pixWidthMarkCu, mmWidthMarkCu, colMarkCu, sizeMarkCu);
      PolyMark(nbPts, nMarkStyleCu, pXD^[indMin], pYD^[indMin]);
      end;

   end; { - with pGrBase1^ do begin - }
end;  { - TGAPCurve.DrawCurve - }

function TGAPCurve.FindIndYMax(ind1, ind2:integer):integer;
{=========================================================}
{ Retourne le max. de la courbe entre les indices ind1 et ind2, compris }
var
  nn,indYMax,
  nbMax            : integer; { = nombre de point conscutifs atteignant le max. }
  vYMax            : Float;

begin { - TGAPCurve.FindIndYMax - }
if (ind1 < 0)      then ind1:=0;
if (ind1 > nIndMax) then ind1:=nIndMax;
if (ind2 > nIndMax) then ind2:=nIndMax;

nbMax   :=1;
indYMax :=ind1;
vYMax   :=pYD^[ind1];

{ Find Maximum }
for nn:= ind1 to ind2 do begin
   if (vYMax < pYD^[nn]) then begin
      nbMax    :=1;
      indYMax  :=nn;
      vYMax    := pYD^[nn];
      end
   else if (vYMax = pYD^[nn]) and (nn = indYMax+nbMax) then inc(nbMax);
   end;

FindIndYMax:=indYMax + (nbMax div 2);
end;  { - TGAPCurve.FindIndYMax - }

procedure TGapCurve.PutFieldsCu;
{================================}
{ Ne fait rien, est destin  tre redfini, pour
  mettre les paramtres dans des glpFiche^...Field pour les traiter
  dans des boites de dialogues.
--------------------------------------------------------------------}
begin { - TGapCurve.PutFieldsCu - }
end;  { - TGapCurve.PutFieldsCu - }

function TGAPCurve.IsNearCursor(nX,nY:integer):boolean;
{=====================================================}
{ retourne TRUE si le point (nX,nY) est trs proche de la courbe,
  et que celle ci soit visible. }
var
  nn               : integer;
  vDiffX,vDiffXMM,
  vDiffY,vDiffYMM,
{  vDXMM,vDYMM,}
  vX,vY            : Float;  { point en coordonne graphique }

begin { - TGAPCurve.IsNearCursor - }
IsNearCursor:=FALSE; { par dfaut, courbe non slectionne }
if (fDraw = FALSE) then exit;

{ test pour tous les points, si (nX,nY) est proche de la courbe }
with apGr[1]^.pGrBase^ do begin
 { Convertir le point nX, nY en coordonne du graphique }
 PixToUser(nX,nY, vX,vY);

 for nn:=0 to nIndMax-1 do begin
   { on cherche deux point en X qui entoure le point vX }
   if ((pXD^[nn] <= vX) and (pXD^[nn+1] >= vX)) or
      ((pXD^[nn] >= vX) and (pXD^[nn+1] <= vX)) then begin
      { on test pour voir si proche en Y aussi }
      if (pXD^[nn] <> pXD^[nn+1]) then begin
         { diffrence en Y par rapport  l'interp. linaire }
         vDiffX:= 0;
         vDiffY:= (vX         - pXD^[nn]) * (pYD^[nn+1] - pYD^[nn])/
                  (pXD^[nn+1] - pXD^[nn]) + pYD^[nn] - vY;

         { conversion en milimtres }
         UserToMM(vDiffX, vDiffY, vDiffXMM, vDiffYMM);
{         DBW('YY' + FTS(vDiffXMM) + FTS(vDiffYMM) + ITS(nn));}
         if (Abs(vDiffYMM) < 1{mm}) then begin
            IsNearCursor := TRUE;
            exit;
            end;
         end;
      end;

   { on cherche deux point en Y qui entoure le point vY }
   if ((pYD^[nn] <= vY) and (pYD^[nn+1] >= vY)) or
      ((pYD^[nn] >= vY) and (pYD^[nn+1] <= vY)) then begin
      { on test pour voir si proche en X aussi }
      if (pYD^[nn] <> pYD^[nn+1]) then begin
         { diffrence en X par rapport  l'interp. linaire }
         vDiffY:= 0;
         vDiffX:= (vY         - pYD^[nn]) * (pXD^[nn+1] - pXD^[nn])/
                  (pYD^[nn+1] - pYD^[nn]) + pXD^[nn] - vX;

         { conversion en milimtres }
         UserToMM(vDiffX, vDiffY, vDiffXMM, vDiffYMM);
{         DBW('XX' + FTS(vDiffXMM) + FTS(vDiffYMM) + ITS(nn));}
         if (Abs(vDiffXMM) < 1{mm}) then begin
            IsNearCursor := TRUE;
            exit;
            end;
         end;
      end;
   end; { for nn:=0 to nIndMax-1 do begin }
end; { with apGr[1]^.pGrBase^ do begin }
end;  { - TGAPCurve.IsNearCursor - }

procedure TGAPCurve.ComputeLimitsZoomCurveBeg(pGrP:PGAPGraphic);
{==============================================================}
{ Par dfaut, ne fait rien.
  Est appel, au dbut de  pGr^.ComputeLimitsZoomCurve,
  Peut tre utile de le redfinir dans le cas particulier ou la courbe est
  compose de plus de 8100 points, qui sont sauv dans un buffer particulier.}
begin { - TGAPCurve.ComputeLimitsZoomCurveBeg - }
{ Ne fait rien, mais peut tre redfini }
end;  { - TGAPCurve.ComputeLimitsZoomCurveBeg - }

procedure TGAPCurve.SaveCurveSignature(var fOut:Text; var nErr:integer);
{======================================================================}
{ Cette procdure est destine a tre redfinie par l'utilisateur.
  Elle va de paire avec la procedure LoadCurveSignatureSKE(fIn, nErr).
  Ne pas appeler le inherited SaveCurveSignature(fOut, nErr);
  Permet d'crire une signature reprsentant le type de donnes, telle que
  donnes  PMD  ou  donnes SKE  ou autre.
-------------------------------------------------------------------------}
begin { - TGAPCurve.SaveCurveSignature - }
{$i-}
{ Signature du dveloppeur-utilisateur }
writeln(fOut, '# ...Signature : _TGAPCurve GAPGr');
nErr:=IOResult;
{$i+}
end;  { - TGAPCurve.SaveCurveSignature - }

procedure TGAPCurve.SaveCurveIndMax(var fOut:Text; var nErr:integer);
{===================================================================}
{ Sauve une en-tte qui sera lue sparment, pour connaitre la taille
  de la courbe  charger.
  N'est gnralement pas redfini. }
const
  { positionnement au writeln }
  nFmt             = 6;
begin { - TGAPCurve.SaveCurveIndMax - }
{ Signature commune  toutes les courbes de toutes les applications }
writeln(fOut, '# ...Signature : wGAPGr.pas Data File');

{ Signature personalise de l'application }
SaveCurveSignature(fOut, nErr);
if (nErr <> 0) then exit; { traite l'erreur plus loin }

writeln(fOut, '# ...Signature : _TGAPCurveSize');
{ code de version du dveloppeur utilisateur }
writeln(fOut,'# ', 100, '   = Version pour TGAPCurveSize');

{ Utile d'tre ici au dbut, pour pouvoir tre lu rapidement
  pour avoir des infos sur le nombre de points de la courbe,
  pour allouer la mmoire ncssaire. }
writeln(fOut,'# ',  nIndMaxAbs:nFmt,  '   = nIndMaxAbs'); { taille max. possible }
writeln(fOut,'# ',  nIndMax:nFmt,     '   = nIndMax');    {nb de points - 1}
writeln(fOut,'# ',  byte(fDraw):nFmt, '   = fDraw');
nErr:=IOResult;
end;  { - TGAPCurve.SaveCurveIndMax - }

procedure TGAPCurve.SaveCurvePersonnalInfo(var fOut:Text; var nErr:integer);
{==========================================================================}
{ Cette procdure est destine a tre tendue par l'utilisateur.
  Elle va de paire avec la procedure LoadCurvePersonnalInfo(fIn, nErr).
  Ne pas appeler le inherited SaveCurvePersonnalInfo(fOut, nErr);
  ni le inherited LoadCurvePersonnalInfo(fIn, nErr);
  Sauvegarde d'informations avant les informations habituelles d'une courbe.
  nErr:=IOResult;
-------------------------------------------------------------------------}
begin { - TGAPCurve.SaveCurvePersonnalInfo - }
{$i-}
{ version dveloppeur-utilisateur }
writeln(fOut, '# ...Signature : _TGAPCurve Info');
writeln(fOut,'# ', 100);
nErr:=IOResult;
{$i+}
end;  { - TGAPCurve.SaveCurvePersonnalInfo - }

procedure TGAPCurve.SaveCurvePersonnalTreatement(var fOut:Text; var nErr:integer);
{================================================================================}
{ Cette procdure est destine a tre tendue par l'utilisateur.
  Elle va de paire avec la procedure LoadCurvePersonnalTreatement(fIn, nErr).
  Ne pas appeler le inherited SaveCurvePersonnalTreatement(fOut, nErr);
  ni le inherited LoadCurvePersonnalTreatement(fIn, nErr);
  Sauvegarde d'informations et traitement aprs les informations
  habituelles d'une courbe.
  nErr:=IOResult;
-------------------------------------------------------------------------}
begin { - TGAPCurve.SaveCurvePersonnalTreatement - }
{$i-}
{ version dveloppeur-utilisateur }
writeln(fOut, '# ...Signature : _TGAPCurve Treat');
writeln(fOut,'# ', 100);
nErr:=IOResult;
{$i+}
end;  { - TGAPCurve.SaveCurvePersonnalTreatement - }

procedure TGAPCurve.SaveCurve(var fOut:Text; var nErr:integer; Flags:word);
{=========================================================================}
{ Sauve les informations relative a une courbe.
  Ne pas surdfinir, mais utiliser :
  SaveCurvePersonnalInfo et SaveCurvePersonnalTreatement.
  1) Signatures et informations de bases sur la courbe.
  2) SaveCurvePersonnalInfo.
  3) Sauve la courbe et d'autres informations la concernant.
  4) SaveCurvePersonnalTreatement
  5) Signature de fin
  nErr = IOResult ou
  erreurs de # pInfo^.SaveInfo
             # SaveCurvePersonnalInfo
             # SaveCurvePersonnalTreatement
-------------------------------------------------------------------------}
const
  { positionnement au writeln }
  nFmt             = 6;
  dFmt             = 6;
  rFmt             = nFmt+1+dFmt;

var
  nn               : integer;

begin { - TGAPCurve.SaveCurve - }
nErr:=0;
{$i-}
{ ici on sauve l'information complte sur la courbe. }
writeln(fOut, '# ...Signature : _TGAPCurve');

{ code de version du dveloppeur de librairie }
writeln(fOut,'# ', 100, '   = Version');

{ Sauve les informations de base de la courbe }
writeln(fOut,'# ', nIndMaxAbs, '   = nIndMaxAbs'); { habituellement inutile }
writeln(fOut,'# ', nIndMax, '   = nIndMax');       {nb de points - 1}
writeln(fOut,'# ', byte(fDraw):nFmt, '   = fDraw');

{ Sauve l'information accocie  une courbe }
if (pInfo <> NIL) then begin
   writeln(fOut, '# ...With _TGAPInfo');
   pInfo^.SaveInfo(fOut, nErr);
   if (nErr <> 0) then exit;
   end
else writeln(fOut, '# ...Without _TGAPInfo');

{ information supplmentaire pour le dveloppeur-utilisateur }
writeln(fOut, '# ...BEG _TGAPCurve Personnal Info');
SaveCurvePersonnalInfo(fOut, nErr);  if (nErr <> 0) then exit;

{ information habituelles pour la librairie }
writeln(fOut, '# ...BEG _TGAPCurve Information');

writeln(fOut,'# ', byte(fDrawCurveCu):nFmt, ' =   fDrawCurveCu');
writeln(fOut,'# ', styleLineCu:nFmt);
writeln(fOut,'# ', pixWidthLineCu:nFmt);
writeln(fOut,'# ', mmWidthLineCu:rFmt:dFmt);
writeln(fOut,'# ', colLineCu:nFmt);

  { Pour des Marques  la place des points }
writeln(fOut,'# ', byte(fDrawMarkCu):nFmt, ' =   fDrawMarkCu');
writeln(fOut,'# ', styleMarkCu:nFmt);
writeln(fOut,'# ', pixWidthMarkCu:nFmt);
writeln(fOut,'# ', mmWidthMarkCu:rFmt:dFmt);
writeln(fOut,'# ', colMarkCu:nFmt);
writeln(fOut,'# ', sizeMarkCu:rFmt:dFmt);
writeln(fOut,'# ', nMarkStyleCu:nFmt);

writeln(fOut,'#_', strLegend);

writeln(fOut,'# ', byte(fNoXOrder):nFmt, ' =   fNoXOrder');

nErr:=ioResult;
if (nErr <> 0) then exit;

{ Sauve les donnes X, Y  }
writeln(fOut, '# ...BEG _TGAPCurve Data');

{ sauve XMin et XMax, utile pour recalculer XData si XData espac rgulirement }

SearchMinMax(nIndMax+1, pXD^[0], indXMin, indXMax);

vXMin:=pXD^[indXMin];
vXMax:=pXD^[indXMax];
writeln(fOut,'# ', vXMin, '   = X Min');
writeln(fOut,'# ', vXMax, '   = X Max');

if ((Flags and flaCurveSaveOnlyY) <> 0) then begin
   writeln(fOut, '# ...Y Data');

   if (rYFmt > 0) then
      if (dYFmt >= 0) then for nn:=0 to nIndMax do writeln(fOut, pYD^[nn]:rYFmt:dYFmt)
      else                 for nn:=0 to nIndMax do writeln(fOut, pYD^[nn]:rYFmt)
   else                    for nn:=0 to nIndMax do writeln(fOut, pYD^[nn]);
   end { Y Data }
else if ((Flags and flaCurveSaveNoCurves) = 0) then begin
   writeln(fOut, '# ...XY Data');

   for nn:=0 to nIndMax do begin
      if (rXFmt > 0) then if (dXFmt >= 0) then write(fOut, pXD^[nn]:rXFmt:dXFmt, ' ')
                          else                 write(fOut, pXD^[nn]:rXFmt, ' ')
      else                                     write(fOut, pXD^[nn], ' ');

      if (rYFmt > 0) then if (dYFmt >= 0) then writeln(fOut, pYD^[nn]:rYFmt:dYFmt)
                          else                 writeln(fOut, pYD^[nn]:rYFmt)
      else                                     writeln(fOut, pYD^[nn]);

      end;
   end  { XY Data }
else writeln(fOut, '# ...No Data');

nErr:=ioResult;
if (nErr <> 0) then exit;

{ la courbe vient d'etre sauve, donc elle n'a pas change
  par rapport  sa sauvegarde. }
fHasChangedCu:=FALSE;

writeln(fOut, '# ...BEG _TGAPCurve Personnal Treatement');
SaveCurvePersonnalTreatement(fOut, nErr);  if (nErr <> 0) then exit;

writeln(fOut, '# ...END _TGAPCurve');

nErr:=ioResult;
{$i+}
end;  { - TGAPCurve.SaveCurve - }

procedure LoadCurveSignatureSKE(var fIn:Text; var nErr:integer);
{===========================================================}
{ Cette procdure est destine a tre rcrite par l'utilisateur.
  Elle va de paire avec la procedure SaveCurveSignature(fOut, nErr).
  Ce n'est pas une mthode de courbe, mais une mthode de la classe
  des courbes, qui est accde  travers
  glfnLoadCurveSignature(fIn, nErr);
  Permet de lire une signature reprsentant le type de donnes, telle que
  donnes  PMD  ou  donnes SKE  ou autre.
  Si pas le bon type de donnes, nErr <> 0.
  La gestion de message d'erreur doit se faire dans cette procdure, et
  nErr < 0 en cas d'erreurs de signature.
-------------------------------------------------------------------------}
begin { - LoadCurveSignatureSKE - }
{$i-}
readln(fIn);  { ignore la signature du dveloppeur-utilisateur }
nErr:=IOResult;
{$i+}
end;  { - LoadCurveSignatureSKE - }

procedure LoadCurveIndMax(
{========================}
  var fIn:Text;
  var nIndMax, nIndMaxAbs : integer;
  var fDraw               : boolean;
  var nErr:integer
  );
{ Lit l'indice maximal (=nb de points -1) d'une courbe,
  pour allouer dynamiquement en mmoire la place ncssaire, avant le chargement.
  N'est gnralement pas redfini.
-------------------------------------------------------------------------}
var
  strS             : string[80];
  nVersion         : integer;
  c1,c2            : char;

begin { - LoadCurveIndMax - }
{$i-}
{ Signature commune  toutes les applications WINDOWS utilisant wGAPGr.pas }
{ Doit tre gale   '...Signature : wGAPGr.pas Data File' }
readln(fIn, strS);
if (strS <> '# ...Signature : wGAPGr.pas Data File') then begin
   nErr:=errBadFileGraphic;
   exit;
   end;

{ Permet de lire une signature reprsentant le type de donnes, telle que
  donnes  PMD  ou  donnes SKE  ou autre.
  Si pas le bon type de donnes, nErr <> 0.
  La gestion de message d'erreur doit se faire dans cette procdure, et
  nErr < 0 en cas d'erreurs }
glfnLoadCurveSignature(fIn, nErr);
if (nErr <> 0) then exit; { Traite l'erreur avant si <0 aprs si >0 }

repeat
   readln(fIn, strS);
   until (strS = '# ...Signature : _TGAPCurveSize') or EOF(fIn);

nErr:=errEOFTooEarly;
if EOF(fIn) then exit;  { end of file reached to early }

readln(fIn,c1,c2, nVersion);  { version dveloppeur - utilisateur }  nVersion:=nVersion;

{ mis ici, si on dsir avoir rapidement des infos sur le nombre de
  points de la courbe, pour allouer la mmoire ncssaire }
readln(fIn,c1,c2, nIndMaxAbs); { habituellement inutile }
readln(fIn,c1,c2, nIndMax);    {nb de points - 1}
readln(fIn,c1,c2, byte(fDraw));

nErr:=IOResult;
{$i+}
end;  { - LoadCurveIndMax - }

procedure TGAPCurve.LoadCurvePersonnalInfo(var fIn:Text; var nErr:integer);
{=========================================================================}
{ Cette procdure est destine a tre redfinie par l'utilisateur.
  Elle va de paire avec la procedure SaveCurvePersonnalInfo(fIn, nErr).
  Ne pas appeler le inherited SaveCurvePersonnalInfo(fOut, nErr);
  ni le inherited LoadCurvePersonnalInfo(fIn, nErr);
-------------------------------------------------------------------------}
var  strS : TStr80;
begin { - TGAPCurve.LoadCurvePersonnalInfo - }
{$i-}
{ version dveloppeur-utilisateur }
readln(fIn, strS);
if (strS = '# ...Signature : _TGAPCurve Info') then begin
   readln(fIn);  { ignore la version }
   end;
nErr:=IOResult;
{$i+}
end;  { - TGAPCurve.LoadCurvePersonnalInfo - }

procedure TGAPCurve.LoadCurvePersonnalTreatement(var fIn:Text; var nErr:integer);
{===============================================================================}
{ Cette procdure est destine a tre redfinie par l'utilisateur.
  Elle va de paire avec la procedure SaveCurvePersonnalTreatement(fIn, nErr).
  Ne pas appeler le inherited SaveCurvePersonnalTreatement(fOut, nErr);
  ni le inherited LoadCurvePersonnalTreatement(fIn, nErr);
-------------------------------------------------------------------------}
var  strS : TStr80;
begin { - TGAPCurve.LoadCurvePersonnalTreatement - }
{$i-}
{ version dveloppeur-utilisateur }
readln(fIn, strS);
if (strS = '# ...Signature : _TGAPCurve Treat') then begin
   readln(fIn);  { ignore la version }
   end;
nErr:=IOResult;
{$i+}
end;  { - TGAPCurve.LoadCurvePersonnalTreatement - }

procedure TGAPCurve.LoadCurve(var fIn:Text; var nErr:integer; Flags:word);
{========================================================================}
{ Sauve les informations relative a une courbe.
  Ne pas surdfinir, mais utiliser :
  LoadCurvePersonnalInfo et LoadCurvePersonnalTreatement.

  ((Flags and flaCurveLoadDefineX) <> 0) => redfini l'axe X.
  nErr = IOResult ou
  errEOFTooEarly
  erreurs de # pInfo^.LoadInfo
             # LoadCurvePersonnalInfo
             # LoadCurvePersonnalTreatement
-------------------------------------------------------------------------}
var
  strS             : string[80];
  nn,
  nVersion         : integer;
  vDX              : Float;
  c1,c2            : char;

  function Search(strFind:TStr60):boolean;
  {======================================}
  { Recherche dans le fichier fIn le string strFind.
    retourne TRUE si trouv, FALSE sinon.
    met nErr  errEOFTooEarly si pas trouv.
  -----------------------------------------------------}
  begin { - Search - }
  {$i-}
  repeat
      readln(fIn, strS);
      until (strS = strFind) or EOF(fIn);

  Search:=FALSE;
  nErr:=IOResult;
  if (nErr <> 0) then exit;

  if (strS <> strFind) then begin
     nErr:= errEOFTooEarly; { EOF reached too early }
     exit;
     end;

  Search:=TRUE;
  {$i+}
  end;  { - Search - }

begin { - TGAPCurve.LoadCurve - }
{===============================}
{$i-}
{ On suppose avoir dj appel LoadCurveIndMax(fIn, nErr) }
{ cherche le dbut de la courbe }
if not Search('# ...Signature : _TGAPCurve') then exit;

{ code de version du dveloppeur de librairie }
readln(fIn,c1,c2, nVersion);  nVersion:=nVersion;

{ Lit les informations de bases de la courbe }
readln(fIn,c1,c2, nIndMaxAbs); { habituellement inutile }
readln(fIn,c1,c2, nIndMax);    {nb de points - 1}
readln(fIn,c1,c2, byte(fDraw));

{ Y a-t-il des informations associes }
readln(fIn, strS);

if (pInfo <> NIL) and (strS = '# ...With _TGAPInfo') then begin
   pInfo^.LoadInfo(fIn, nErr);
   if (nErr <> 0) then exit;
   end;

{ informations supplmentaires pour le dveloppeur-utilisateur }
if not Search('# ...BEG _TGAPCurve Personnal Info') then exit;
LoadCurvePersonnalInfo(fIn, nErr);  if (nErr <> 0) then exit;

{ Lecture des information habituelles pour la librairie }
if not Search('# ...BEG _TGAPCurve Information') then exit;

readln(fIn,c1,c2, byte(fDrawCurveCu));
readln(fIn,c1,c2, styleLineCu);
readln(fIn,c1,c2, pixWidthLineCu);
readln(fIn,c1,c2, mmWidthLineCu);
readln(fIn,c1,c2, colLineCu);

  { Pour des Marques  la place des points }
readln(fIn,c1,c2, byte(fDrawMarkCu));
readln(fIn,c1,c2, styleMarkCu);
readln(fIn,c1,c2, pixWidthMarkCu);
readln(fIn,c1,c2, mmWidthMarkCu);
readln(fIn,c1,c2, colMarkCu);
readln(fIn,c1,c2, sizeMarkCu);
readln(fIn,c1,c2, nMarkStyleCu);

readln(fIn,c1,c2, strLegend);

readln(fIn,c1,c2, byte(fNoXOrder));

nErr:=IOResult;
if (nErr <> 0) then exit;

{ Lecture des courbes X et Y }
if not Search('# ...BEG _TGAPCurve Data') then exit;

{ min et max des donnes en X }
readln(fIn,c1,c2, vXMin);
readln(fIn,c1,c2, vXMax);

readln(fIn, strS);

if (strS = '# ...XY Data') then begin
   { lecture des donnes en X et Y }
   for nn:=0 to nIndMax do readln(fIn, pXD^[nn], pYD^[nn]);
   end   { XY Data }
else if (strS = '# ...Y Data') then begin
   { lecture des donnes en Y uniquement }
   for nn:=0 to nIndMax do readln(fIn, pYD^[nn]);

   if ((Flags and flaCurveLoadDefineX) <> 0) then begin
      if (vXMax = vXMin) then vXMax:=vXMin + 1;
      vDX:=(vXMax - vXMin) / nIndMax;
      for nn:=0 to nIndMax do pXD^[nn]:=vXMin + nn * vDX;
      end;
   end;  { Y Data }
//else { strS = '# ...No Data' }

nErr:=IOResult;
if (nErr <> 0) then exit;

{ vient d'etre charg, donc n'a pas chang }
fHasChangedCu:=FALSE;

{ Informations supplmentaires pour le dveloppeur-utilisateur }
if not Search('# ...BEG _TGAPCurve Personnal Treatement') then exit;
LoadCurvePersonnalTreatement(fIn, nErr);  if (nErr <> 0) then exit;

{ recherche de fin }
if not Search('# ...END _TGAPCurve') then exit;

nErr:=ioResult;
{$i+}

{ la donnes est dfinie }
isLoaded:=TRUE;

InitForDraw(nIndMax);
end;  { - TGAPCurve.LoadCurve - }

{************************************************************************}
{*********  OBJECT TGAPGraphic }
{************************************************************************}

{ - constructeur et destructeur - }
{ ------------------------------- }
constructor TGAPGraphic.Init( pGAPWin1:PGAPWindow; pI:PGAPInfo;
                              pGr:PGraphicBase; pAx:PAutoAxes; Flags:word);
{==========================================================================}
{ initialisation, en donnant une fentre par dfaut }
var
  nn               : integer;

begin  { - TGAPGraphic.Init - }
wIdentity :=8347;
{ NE PAS MODIFIER.
  = 8347 si l'objet a t init. et n a pas t dtruit par Done.
  Utile pour vrifier si on peut
  accder  cette objet ou non. A utiliser avec IsBadWritePtr.
  A faire des tests }

{ pour l'instant, pas d'info associs }
if (pI = NIL) then begin
   pInfo:=glfnNewInfo(0);
   fAutoDisposeInfo:=TRUE;
   end
else begin
   pInfo:=pI;
   fAutoDisposeInfo:=FALSE;
   end;

{ Graphisme et texte de la fentre }
if (pGr = NIL) then begin
   new(pGrBase, Init(pGAPWin1));
   fDoDisposeGrBase:=TRUE;
   end
else begin
   pGrBase:=pGr;
   fDoDisposeGrBase:=((Flags and flaAutoDisposeGrBase) <> 0);
   end;

{ init. de l'objet de traitement des axes }
if (pAx = NIL) then begin
   new(pAxes, Init(pGrBase));
   fDoDisposeAxes:=TRUE;
   end
else begin
   pAxes:=pAx;
   fDoDisposeAxes:=((Flags and flaAutoDisposeAxes) <> 0);
   end;

{ Courbes du graphique }
for nn:=1 to VINGT do begin
   apCu[nn]:=NIL;
   aindMin[nn]:=0;
   aindMax[nn]:=32000; { trs grand }
   end;

nbCu:=0;

{ courbe actif du graphique }
pActiveCurve :=NIL;

{ fentre contenant ce graphique }
pGAPWin:=pGAPWin1;

lAxesFlags:=0;

{ A la lecture du disque, titre de la fentre du graphique }
strWindowTitle   :=GetMsg(msgNewWindowTitle);

{ Titre du graphique et lgendes }
strTitle   :='';
strXLegend :='';
strYLegend :='';

{ positionnement du titre et des lgendes }
vCharXMoveTitle   := 0;
vCharYMoveTitle   := 0;
vCharXMoveXLegend := 0;
vCharYMoveXLegend :=-1;
vCharXMoveYLegend := 0;
vCharYMoveYLegend := 0;

{ taille du titre et du reste du texte }
sizeTitle  := 12;
sizeTextGr := 10;

{ couleur du titre et des lgendes des axes }
colTextTitle :=RGB(0,0,0); { noire }

{ indication sur la couleur et le style du graphique,
  est dfini dans l'Init, mais est modifiable }
styleLineAxes    :=PS_SOLID;
pixWidthLineAxes :=1;   { 0..infinity }
mmWidthLineAxes  :=0.1;
colLineAxes      :=RGB(0, 0, 0); { noir }
colTextAxes      :=RGB(0, 0, 0); { noir }

{ indication sur la couleur le style etc. du cadre de la fentre 1 }
fDrawBorderWin1 :=TRUE;
StyleWin1       :=PS_SOLID;
pixWidthWin1    :=1;
mmWidthWin1     :=0.1; {mm}

{ couleur du cadre de la fentre 1 }
pcolBorderWin1   :=@glcolBorderWin1;

{ couleur du fond des fentres 1 et 2 }
pcolWin1        :=@glcolWin1;
pcolWin2        :=@glcolWin2;

{ indication si on dessine la grille }
fDrawGrid       :=FALSE;

{ indique si il faut librer automatiquement la mmoire alloue
  pour ce graphique. }
fDoAutoDispose:=((Flags and flaAutoDisposeSelf) <> 0);

with pGrBase^ do begin
  mmX1Left   := 0.5;
  relX1Left  := 0.0;
  mmY1Top    := 0.5;
  relY1Top   := 0.0;
  mmX1Width  :=-0.5 - mmX1Left;
  relX1Width := 1.0 - relX1Left;
  mmY1Height :=-0.5 - mmY1Top;
  relY1Height:= 1.0 - relY1Top;

  { position de la fentre 2 en combinant des milimtres et coord. relatives }
  mmX2Left    := 20.0;
  relX2Left   :=  0.0;
  mmY2Top     := 15.0;
  relY2Top    :=  0.0;
  mmX2Width   :=-10.0 - mmX2Left;
  relX2Width  :=  1.0 - relX2Left;
  mmY2Height  :=-13.0 - mmY2Top;
  relY2Height :=  1.0 - relY2Top;

  { Position sur papier pour imprimer le graphisme et le texte.
    Les marges gauches et hautes, sont relativement aux bords du papier,
    mais des valeurs minimales sont imposs par les limites de l'imprimante.
    Elles sont testes automatiquement. }
  mmPrinterLeft   :=20;
  relPrinterLeft  :=0;
  mmPrinterTop    :=10;
  relPrinterTop   :=0;
  mmPrinterWidth  :=150;
  relPrinterWidth :=0;
  mmPrinterHeight :=90;
  relPrinterHeight:=0;
  end; { - with pGrBase do begin - }

{ Pour les Zooms }
isZoomOn:=FALSE;
nMaxPosMemZoom :=0;
nPosMemZoom    :=0;

ZoomXMin :=-100000.0;
ZoomXMax := 100000.0;
ZoomYMin :=-100000.0;
ZoomYMax := 100000.0;

for nn:=0 to TRENTE do begin
   avMemZoomXMin[nn]:=-100000.0;
   avMemZoomXMax[nn]:= 100000.0;
   avMemZoomYMin[nn]:=-100000.0;
   avMemZoomYMax[nn]:= 100000.0;
   end;

{ calcul automatique des axes X et Y }
fZoomAutoY:=TRUE;
fZoomAutoX:=TRUE;

{ distance en [mm] de la souris aux curseurs de zoom pour qu'ils soient pris }
mmZoomCursDist:=4; {mm}

vZoomCursInitXMin  :=0.3;   { en % position initiale du curseur gauche }
vZoomCursInitYMin  :=0.3;   { en % position initiale du curseur bas }
vZoomCursInitXMax  :=0.7;   { en % position initiale du curseur droit }
vZoomCursInitYMax  :=0.7;   { en % position initiale du curseur haut }

{ position initiale de la boite de dialogue de Zoom }
pnZoomDlgLastPosX:=@glnZoomDlgLastPosX;
pnZoomDlgLastPosY:=@glnZoomDlgLastPosY;

{ pour viter des boucles infinies d'appels }
fCalled:=FALSE;

{ mmorise le nom du fichier qui contenait ce graphique }
strGraphicFilePath :='';

{ Le fichier est nouveau, et n'a jamais t sauv }
fIsNewFile   :=TRUE;
fHasChangedGr  :=TRUE;

colMemLineCu:=RGB(0,0,0);

{ - peut tre utilis par des sous objets pour dfinir de
    quel objets il s'agit - }
nKind  :=0;
end;  { - TGAPGraphic.Init - }

destructor  TGAPGraphic.Done;
{===========================}
var
  nn            : integer;

begin  { - TGAPGraphic.Done - }
if (glpActiveGraphic = @Self) then begin
   glpActiveGraphic :=NIL;
   glpActiveCurve   :=NIL;
   end;

{ Si le graphique contient une courbe, qui n'est contenue dans aucun autre
  graphique, libre la mmoire alloue pour cette courbe }
for nn:=nbCu downto 1 do begin
   if (apCu[nn] <> NIL) and (not IsBadWritePtr(apCu[nn], 1)) and
      (apCu[nn]^.wIdentity = 9725) then begin
      if (apCu[nn]^.fDoAutoDispose) and (apCu[nn]^.nbGr = 1) then begin
         { la courbe n'est que associe  ce grapique }
         dispose(apCu[nn], Done)
         end
      else RemoveCurve(apCu[nn]); { enlve la courbe de ce graphique }
      end; { if (apCu[nn] <> NIL) and ... }
   end; { for nn:=1 to nbCu do begin }

if fAutoDisposeInfo and (pInfo <> NIL) and (pInfo^.wIdentity = 7384) then begin
   dispose(pInfo, Done); { dispose de l'info associe  cette courbe }
   end; { if (pInfo <> NIL) and ... }

for nn:=1 to nbCu do apCu[nn]:=NIL;
nbCu:=0;

{ Enlve la rfrence au graphique de la fentre qui le contient }
if ( not IsBadWritePtr(pGAPWin, 1)) and
   (pGAPWin^.wIdentity = 13269) then pGAPWin^.RemoveGraphic(@Self);

if fDoDisposeAxes  then dispose(pAxes, Done);
if fDoDisposeGrBase then dispose(pGrBase, Done);

wIdentity :=0; { NE PAS MODIFIER.  indique que dtruit par Done }
end;  { - TGAPGraphic.Done - }

procedure TGAPGraphic.GetFamilly( var nbParent:integer;
{===============================} var astrFamilly:array of TSTR30);
{ Pour connaitre tous les anctres d'un objet.
  c.f. wSKEVar.pas pour voir comment implmenter les descendant
  OUTPUT :
  nbParent = nombre de membre dans la famille
  astrFamilly = nom des ojbets. }
begin { - TGAPGraphic.GetFamilly - }
astrFamilly[0]:='TGAPGraphic';
nbParent:=1;

{ les descendant feront :
inherited GetFamilly(nbParent, astrFamilly);
astrFamilly[nbParent]:='nom de l'objet';
inc(nbParent);}
end;  { - TGAPGraphic.GetFamilly - }

procedure TGAPGraphic.AddCurve(pCu1:PGAPCurve; var nErr:integer);
{==================================================================}
{ ajoute une courbe au graphique, elle peut tre dessine ou non,
  cela dpend de la courbe
  nErr = 0 ou
  errTooManyCurves
  errCurveNotInit
  errTooManyGraphics  de AddToGraphic
-------------------------------------------------------------------------}
begin { - TGAPGraphic.AddCurve - }
nErr:=0;
if fCalled then exit;  { vite des boucles d'appels infinies }

if (nbCu >= VINGT) then begin
   nErr:=errTooManyCurves;
   ErrorWrite(nErr, 'AddCurve');
   exit;
   end;

if not pCu1^.isInit then begin
   nErr:=errCurveNotInit;
   ErrorWrite(nErr, 'AddCurve');
   exit;
   end;

fCalled:=TRUE;
if (not pCu1^.fCalled) then pCu1^.AddToGraphic(@Self, nErr);
fCalled:=FALSE;

if (nErr = 0) then begin
   { ajoute la courbe }
   inc(nbCu);
   apCu[nbCu]:=pCu1;

   { couleur d'origine de la courbe active }
   if glfWithColorActiveCurve and (pActiveCurve <> NIL) then begin
      pActiveCurve^.colLineCu:=colMemLineCu;
      end;

   if (pActiveCurve = NIL) then pActiveCurve:=pCu1;
   if (glpActiveGraphic = @Self) then glpActiveCurve:=pActiveCurve;

   { mmorise la couleur qu'avait la courbe active }
   if (pActiveCurve <> NIL) then begin
      colMemLineCu:=pActiveCurve^.colLineCu;
      end;

   { Si il y a plus de 2 courbes, change la couleur de la courbe active }
   if glfWithColorActiveCurve and
      (nbCu >= 2) and (pActiveCurve <> NIL) then begin
      pActiveCurve^.colLineCu:=RGB(0,0,128);
      end;

   end; { if (nErr = 0) then begin }

end;  { - TGAPGraphic.AddCurve - }

function TGAPGraphic.AddNewCurve(nIndMaxAbs0:integer; flags:word):PGAPCurve;
{==========================================================================}
{ Cre une nouvelle courbe, et l'ajoute au graphique.
  nIndMaxAbs0 = taille des courbes.
  Flags = ceux envoy  la cration de la courbe.

  Retourn NIL si il y a eu une erreur, sinon
  retourn un pointeur sur la courbe cre
-------------------------------------------------------------------------}
var
  pCu              : PGAPCurve;
  nErr             : integer;

begin { - TGAPGraphic.AddNewCurve - }
if (nbCu >= VINGT) then begin AddNewCurve:=NIL; exit; end;

{ Cre la nouvelle courbe, et indique que sa dsalocation sera automatique }
pCu:=glfnNewCurve(nIndMaxAbs0, nIndMaxAbs0, Flags or flaAutoDisposeSelf);

{ Attache la courbe au graphique }
AddCurve(pCu, nErr);

{ normalement, pas d'erreurs }
if (nErr <> 0) then begin
   dispose(pCu, done);
   pCu:=NIL;
   end;

AddNewCurve:=pCu;
end;  { - TGAPGraphic.AddNewCurve - }

procedure TGAPGraphic.RemoveCurve(pCu1:PGAPCurve);
{================================================}
{ Enlve une courbe du graphique }
var
  nn,kk            : integer;

begin { - TGAPGraphic.RemoveCurve - }
if fCalled then exit;  { vite des boucles d'appels infinies }

fCalled:=TRUE;
if (not pCu1^.fCalled) then pCu1^.RemoveFromGraphic(@Self);
fCalled:=FALSE;

{ Enlve la rfrence  la courbe }
{ Recherche parmis toutes les courbes du graphique }
for nn:=1 to nbCu do begin
   { cherche la rfrence  la prsente courbe }
   if (apCu[nn] = pCu1) then begin
      { limine la rfrence  la prsente courbe }
      for kk:=nn to nbCu-1 do apCu[kk]:=apCu[kk+1];

      apCu[nbCu]:=NIL;
      dec(nbCu);

      end; { if (apCu[nn] = pCu1) then begin }
   end; { for nn:=1 to nbCu do begin }

{ Redonne sa couleur d'origine  la courbe }
if glfWithColorActiveCurve and (pActiveCurve <> NIL) then begin
   pActiveCurve^.colLineCu:=colMemLineCu;
   end;

{ Si la courbe active du graphique est pCu1 => changement }
if (pActiveCurve = pCu1) or (pActiveCurve = NIL) then begin
   if (nbCu >= 1) and (apCu[1] <> NIL) then pActiveCurve:=apCu[1]
   else                                     pActiveCurve:=NIL;
   end;

{ Si il y a plus de 2 courbes, change la couleur de la courbe active }
if glfWithColorActiveCurve and (nbCu >= 2) and (pActiveCurve <> NIL) then begin
   { mmorise la couleur qu'avait la courbe active }
   colMemLineCu:=pActiveCurve^.colLineCu;

   { Change la couleur de la courbe active }
   pActiveCurve^.colLineCu:=RGB(0,0,128);
   end;

{ Si la courbe active globale est pCu1 => changement }
if (glpActiveCurve = pCu1) or (glpActiveCurve = NIL) then begin
   if (nbCu >= 1) and (apCu[1] <> NIL) then glpActiveCurve:=apCu[1]
   else                                     glpActiveCurve:=NIL;
   end;
end;  { - TGAPGraphic.RemoveCurve - }

procedure TGAPGraphic.MoveCurvePosition(nOldPos,nNewPos:integer);
{===============================================================}
{ Change l'ordre d'affichage des courbe, en changeant
  l'ordre dans laquelle les courbes sont mmorises dans le graphique. }
var
  nn               : integer;
  pCu0             : PGAPCurve;

begin { - TGAPGraphic.MoveCurvePosition - }
{ Test de validit }
if (nOldPos > nbCu) or (nNewPos > nbCu) then exit;

{ courbe qui doit aller en newPos }
pCu0 :=apCu[nOldPos];

if (nNewPos < nOldPos) then
     for nn:=nOldPos downto nNewPos+1 do apCu[nn]:=apCu[nn-1]
else for nn:=nOldPos     to nNewPos-1 do apCu[nn]:=apCu[nn+1];

apCu[nNewPos]:=pCu0;
end;  { - TGAPGraphic.MoveCurvePosition - }

procedure TGAPGraphic.DrawBackGround;
{===================================}
{ Permet de faire un traitement avant le AutoAxesDraw,
  tel que dessiner le fond du graphique }
var
  hBrNew           : HBrush;

begin { - TGAPGraphic.DrawBackGround - }
with pGrBase^ do begin
   if ( nOutputDevice = cteOutScreen) or
      ((nOutputDevice = cteOutPrinterOneShoot) and (hWindowTemp <> 0)) then begin
      { sur l'cran, on change les couleurs de fond de graphique }
      SetClipping(flaClipWin1);

      { rempli la fentre 1 }
      hBrNew :=CreateSolidBrush(pcolWin1^);
      FillRgn(hDC0, hRgnWin1, hBrNew);
      DeleteObject(hBrNew);

      { rempli la fentre 2 }
      hBrNew :=CreateSolidBrush(pcolWin2^);
      FillRgn(hDC0, hRgnWin2, hBrNew);
      DeleteObject(hBrNew);
      SetClipping(flaClipAuto);
      end; { - if (pGrBase^.nOutputDevice = cteOutScreen) then begin - }
   end; { - with pGrBase^ do begin - }
end;  { - TGAPGraphic.DrawBackGround - }

procedure TGAPGraphic.AutoAxesCalc(var fHasOneCurve:boolean);
{===========================================================}
{ Calcule des axes du graphique.
  Indique dans fHasOneCurve si une courbe sera dessine.
  Fixe les valeurs de vXMinAxe,vXMaxAxe, vYMinAxe,vYMaxAxe.
-------------------------------------------------------------------------}
var
  nn,
  nbPts,
  indMin,
  indMax           : integer;

begin { - TGAPGraphic.AutoAxesCalc - }
pAxes^.ClearLimits;
fHasOneCurve:=FALSE;

if (not isZoomOn) or fZoomAutoY or fZoomAutoX then begin
   { calcule des axes, ici il n'y a pas de zoom en X ou en Y. }
   { Dtermine vXMinAxe, ... }
   for nn:=1 to nbCu do with apCu[nn]^ do begin
      if (isInit and isLoaded and fDraw) then begin
         { si adaptation automatique de l'axe X }
         if fZoomAutoX then begin
            if (pXD^[0] < pXD^[nIndMax]) then begin { croissant }
               aindMin[nn]:=0;
               aindMax[nn]:=nIndMax;
               end
            else begin { dcroissant }
               aindMin[nn]:=0;
               aindMax[nn]:=nIndMax;
               end
            end;

         indMin:=aindMin[nn];
         indMax:=aindMax[nn];
         if (indMin < 0)       then indMin:=0;
         if (indMax > nIndMax) then indMax:=nIndMax;

         nbPts:=indMax - indMin +1;

         pAxes^.AdjustLimits(nbPts, pXD^[indMin], pYD^[indMin]);
         fHasOneCurve:=TRUE;
         end;
      end;
   end; { - if not isZoomOn or fZoomAutoY then begin - }

if isZoomOn then with pAxes^ do begin
   { dfini les limites de Zoom }
   fHasOneCurve:=TRUE;

   if not fZoomAutoX then begin
      vXMinAxe :=ZoomXMin;
      vXMaxAxe :=ZoomXMax;
      end;

   if not fZoomAutoY then begin
      vYMinAxe :=ZoomYMin;
      vYMaxAxe :=ZoomYMax;
      end;
   end; { - if isZoomOn then with pAxes^ do begin - }
end;  { - TGAPGraphic.AutoAxesCalc - }

procedure TGAPGraphic.AutoAxesDraw(fHaseOneCurve:boolean);
{========================================================}
{ Dessine les axes.
  Est souvant redfini, n'est jamais appel directement.
------------------------------------------------------------------------------}
var
  vXX,vYY          : Float;
  lAxesFlagsCopy   : longint;
begin { - TGAPGraphic.AutoAxesDraw - }
vXX:=0;
vYY:=0;
lAxesFlagsCopy:=lAxesFlags;

{ En mode zoome, n'augmente pas les axes X et/ou Y }
if isZoomOn then with pAxes^ do begin
   if not fZoomAutoX then begin
      { l'axe X n'est pas augment }
      lAxesFlagsCopy:=lAxesFlagsCopy and not flaAxesNotSmallX;
      end;

   if not fZoomAutoY then begin
      { l'axe Y n'est pas augment }
      lAxesFlagsCopy:=lAxesFlagsCopy and not flaAxesNotSmallY;
      end;
   end; { - if isZoomOn then with pAxes^ do begin - }

pAxes^.AutoAxes(1, vXX, vYY, flaAxesMultiCurves or lAxesFlagsCopy);

{ Exemple possible :
  Met la graduation aussi en haut  droite, mais sans labels }
{pAxes^.AutoAxes(1, vXX, vYY, flaAxesMultiCurves or lAxesFlags or
                flaAxesInterceptXUp or flaAxesInterceptYRight or
                flaAxesWithoutXLabel or flaAxesWithoutYLabel);}
end;  { - TGAPGraphic.AutoAxesDraw - }

procedure TGAPGraphic.DrawLegend;
{===============================}
{ Est souvant redfini, ou surdfini.
  Peut tre appel directement.
  Dessin du Titre, et des lgendes des axes.
-------------------------------------------------------------------------}
var
  mmXSize,
  mmYSize          : Float;
begin { - TGAPGraphic.DrawLegend - }
with pGrBase^ do begin
   { met les lgendes au graphique et aux axes }
   { Titre du graphique }
   colText:=colTextTitle; { couleur pour le titre et les lgendes des axes }

   sizeText:=sizeTitle; { taille du titre }

   { slectionne la bonne font dans le DC }
   if (hDC0 <> 0) then begin
      fontText.lfHeight :=Round(-sizeText * vPixYSmm * 25.4 / 72);
      SelectFont(hDC0, fontText);
      end;

   GetMMTextSize('W', mmXSize, mmYSize);
   MoveWin1To(0.5, 0.0);
   MoveMMRelTo(vCharXMoveTitle * mmXSize, 2 + vCharYMoveTitle * mmYSize);
   if (strTitle  <> '') then writelnMoveRel(0.5, 0, strTitle);

   sizeText:=sizeTextGr; { taille des lgendes et du reste du texte }

   { slectionne la bonne font dans le DC }
   if (hDC0 <> 0) then begin
      fontText.lfHeight :=Round(-sizeText * vPixYSmm * 25.4 / 72);
      SelectFont(hDC0, fontText);
      end;

   { Lgende de l'axe X }
   MoveWin1To(0.5, 1);
   MoveMMRelTo(vCharXMoveXLegend * mmXSize, mmYSize * vCharYMoveXLegend -1);
   if (strXLegend <> '') then writelnMoveRel(0.5, 0, strXLegend);

   { Lgende de l'axe Y }
   MoveWin1To(0.0, 0.5);
   MoveMMRelTo(2 + vCharXMoveYLegend * mmXSize, mmYSize * vCharYMoveYLegend);
   if (strYLegend <> '') then writelnVertMoveRel(0, 0.5, strYLegend);
   end; { - with pGrBase^ do begin - }
end;  { - TGAPGraphic.DrawLegend - }

procedure TGAPGraphic.DrawGrid;
{=============================}
{ Est souvant redfini,
  Peut tre appel directement.
  Dessin d'une Grille, avec le style, l'paisseur et la couleur de ligne
  demande. Pour des impressions sur imprimantes, il peut tre utile
  d'exprimer une paisseur minimale de ligne en milimtres. C'est la raison
  pour laquelle l'paisseur est donnes en pixels et en milimtres,
  chacune des deux donnes est une valeur minimale d'paisseur.
-------------------------------------------------------------------------}
begin { - TGAPGraphic.DrawGrid - }
if fDrawGrid then begin
   pAxes^.DrawGrid(
     2, 1,{nXBetween,nYBetween}
     PS_DOT,
     1, {pixWidthLineAA}
     0.1, {mmWidthLineAA}
     RGB(196, 196, 196){colLineAA});
   end;
end;  { - TGAPGraphic.DrawGrid - }

procedure TGAPGraphic.DrawCurves;
{===============================}
{ Peut tre redfini,
  Peut tre appel directement.
  Dessin des courbes, on suppose que les axes ont t calcul.
-------------------------------------------------------------------------}
var
  nn               : integer;
begin { - TGAPGraphic.DrawCurves - }
{ - dessin des courbes - }
// A EFFACER DBW(1, ITS(byte(apCu[1]^.isInit)*10000 + byte(apCu[1]^.isLoaded)*100 + byte(apCu[1]^.fDraw)));
for nn:=nbCu downto 1 do with apCu[nn]^ do if (isInit and isLoaded and fDraw) then
    DrawCurve(aindMin[nn], aindMax[nn], pGrBase);
end;  { - TGAPGraphic.DrawCurves - }

procedure TGAPGraphic.DrawInfo;
{=============================}
{ Est destin  tre redfini.
  Peut tre appel directement.
  Par dfaut, ne fait rien, mais peut tre utiliser pour afficher
  des informations supplmentaires dans un graphique.
-------------------------------------------------------------------------}
begin { - TGAPGraphic.DrawInfo - }
{with pGrBase^ do begin ... end;}
end;  { - TGAPGraphic.DrawInfo - }

procedure TGAPGraphic.DrawGraphic;
{================================}
{  Dessine le graphique avec ces courbes,
  lgende, titre etc.
  Si le device contexte pGrBase^.hDC0 = 0, ouvre le device contexte avec GetDC0
------------------------------------------------------------------------------}
var
  fHasOneCurve     : boolean; { indique si une courbe est  dessiner }
  recLineAt        : TypeLineAttrib;
  fDoReleaseDC     : boolean;
  colOld           : TColorRef;

begin { - TGAPGraphic.DrawGraphic - }
if (pGAPWin = NIL) or (pGrBase = NIL) or (pGrBase^.pWnd0 = NIL) then exit;
//if (nbCu = 0) then exit;{dessin d'un graphique, mme sans courbes }

fDoReleaseDC:=(pGrBase^.hDC0 = 0);
if (pGrBase^.hDC0 = 0) then pGrBase^.GetDC0;
if (pGrBase^.hDC0 = 0) then exit; { pas normal }

pGrBase^.GetLineAttribRec(recLineAt);

{ rfrence  la fentre contenant ce graphique }
pGrBase^.pWnd0:=pGAPWin;

{ indique  l'autoaxes, le graphisme  utiliser }
pAxes^.pGrBase:=pGrBase;

colOld :=pGrBase^.colText; { mmorise la couleur d'origine }
pGrBase^.SetLineAttrib(styleLineAxes, pixWidthLineAxes, mmWidthLineAxes, colLineAxes);
pGrBase^.colText:=colTextAxes;
DrawBackGround;
pGrBase^.SetClipping(flaClipNone);
AutoAxesCalc(fHasOneCurve);
AutoAxesDraw(fHasOneCurve);
DrawLegend;

pGrBase^.colText:=colOld; { remet la couleur d'origine }

if fDrawBorderWin1 then
   pGrBase^.BorderWin1( StyleWin1, pixWidthWin1, mmWidthWin1, pcolBorderWin1^);

pGrBase^.SetClipping(flaClipWin2);
DrawGrid;
DrawCurves;

pGrBase^.SetClipping(flaClipWin1);
DrawInfo;
pGrBase^.SetClipping(flaClipAuto);

pGrBase^.SetLineAttribRec(recLineAt);
pGrBase^.colText:=colOld; { remet la couleur d'origine }
if fDoReleaseDC then pGrBase^.ReleaseDC0;
end;  { - TGAPGraphic.DrawGraphic - }

procedure TGAPGraphic.DrawGraphicOnGDI(
{=====================================}
  hDC1             : HDC;
  Flags            : word
  );
{ dessine le graphique avec ces courbes, lgende, titre etc. dans un GDI.
  Si Flags = flaGraphicOnWindow  ou  hDC1 = 0 alors
     Dessine dans la fentre pGAPWin
  Sinon, dessine sur l'imprimante ou le device associ  hDC1
------------------------------------------------------------------------------}
begin { - TGAPGraphic.DrawGraphicOnGDI - }
if (pGAPWin = NIL) or (pGrBase = NIL) or (pGrBase^.pWnd0 = NIL) then exit;
//if (nbCu = 0) then exit;{dessin d'un graphique, mme sans courbes }

pGrBase^.pWnd0:=pGAPWin;
if ((Flags and flaGraphicOnWindow) <> 0) then pGrBase^.SetHWindow(pGAPWin^.hWin);
//??? pGrBase^.SetNewDC0(hDC1); A EFFACER

DrawGraphic;

{ libre le GDI }
//???pGrBase^.ReleaseDC0; A EFFACER
end;  { - TGAPGraphic.DrawGraphicOnGDI - }

procedure TGAPGraphic.DrawGraphicOnWindow(Flags:word);
{=======================================================}
{ Dessine le graphique dans la fentre ou il se trouve }
begin { - TGAPGraphic.DrawGraphicOnWindow - }
DrawGraphicOnGDI(0{hDC}, 0);
end;  { - TGAPGraphic.DrawGraphicOnWindow - }

procedure TGAPGraphic.ComputeLimitsZoomCurve(nn:integer; pCu1:PGAPCurve);
{=======================================================================}
{ Indique que les limites de Zoom de la courbe pCu1^ doivent
  tres recalcules.
  Si nn = 0, recherche l'indice  nn  t.q. apCu[nn] = pCu1,
  sinon on admet que  apCu[nn] = pCu1, et on vite une recherche innutile. }
var
  kk               : integer;
begin { - TGAPGraphic.ComputeLimitsZoomCurve - }
{ cherche la courbe dans la liste }
nn:=0;
if (nn = 0) then begin
   repeat inc(nn) until (nn > nbCu) or (apCu[nn] = pCu1);
   if (nn > nbCu) then begin DBW(5, 'Curve not found{error?}'); exit; end;
   end;

{ si un traitement doit tre fait avant le calc. des indices.
  Par dfaut, ne fait rien }
pCu1^.ComputeLimitsZoomCurveBeg(@Self);

if (not isZoomOn) or (pCu1^.fNoXOrder) or (pCu1^.nIndMax < 0) then begin
   { recalcule les indices correspondant au zoom }
   { nIndMax < 0 si la courbe n'a jamais t prpare pour affichage.
     (aucun appel  initForDraw de fait) }
   aindMin[nn]:=0;
   aindMax[nn]:=32000;
   exit;
   end;

{ la courbe est zoome, cherche les indices min et max de la courbe }
with pCu1^ do begin
   if (pXD^[0] < pXD^[nIndMax]) then begin
      { valeurs en X ordonnes croissantes }
      { recherche de l'indice min }
      kk:=1;
      while (kk < nIndMax) and (pXD^[kk] <= ZoomXMin) do inc(kk);
      aindMin[nn]:=kk-1;

      { recherche de l'indice max }
      kk:=nIndMax-1;
      while (kk > 0) and (pXD^[kk] >= ZoomXMax) do dec(kk);
      aindMax[nn]:=kk+1;
      end
   else begin
      { valeurs en X ordonnes dcroissantes }
      { recherche de l'indice min }
      kk:=1;
      while (kk < nIndMax) and (pXD^[kk] >= ZoomXMax) do inc(kk);
      aindMin[nn]:=kk-1;

      { recherche de l'indice max }
      kk:=nIndMax-1;
      while (kk > 0) and (pXD^[kk] <= ZoomXMin) do dec(kk);
      aindMax[nn]:=kk+1;
      end; { - if - }
   end; { - with - }

{DBW(ITS(nn) + ITS(aindMin[nn]) + ITS(aindMax[nn]) + ITS(pCu1^.nIndMax));}
end;  { - TGAPGraphic.ComputeLimitsZoomCurve - }

procedure TGAPGraphic.ZoomSetLineAttrib( var MemROP:integer;
{======================================} var recLineAt:TypeLineAttrib);
{ met l'attribut de ligne pour le mode zoom, en rcuprant les attributs
  prcdents }
begin { - TGAPGraphic.ZoomSetLineAttrib - }
with pGrBase^ do begin
   { attribut de ligne des curseurs et affichage en  XOR  du graphisme }
   MemROP:=ROP2Mode;
   ROP2Mode:=R2_NOTXORPEN;

   SetLineAttrib2(styleLine, 2{pixWidthLine}, mmWidthLine, RGB(0,0,0), recLineAt);
   end; { with pGrBase^ do begin }
end;  { - TGAPGraphic.ZoomSetLineAttrib - }

procedure TGAPGraphic.ZoomRestorLineAttrib( MemROP:integer;
{=========================================} recLineAt:TypeLineAttrib);
{ Restor l'attribut de ligne recu dans ZoomSetLineAttrib }
begin { - TGAPGraphic.ZoomRestorLineAttrib - }
{ remet les anciens attribut de lignes }
with pGrBase^ do begin
   ROP2Mode:=MemROP;
   SetLineAttribRec(recLineAt);
   end; { with pGrBase^ do begin }
end;  { - TGAPGraphic.ZoomRestorLineAttrib - }

(*???
procedure OpenZoomDialog(pGr1:PGAPGraphic; msgNum:word);
{======================================================}
{ Ouvre la boite de dialogue associe au Zoom }
var
  nErr             : integer;
  pMyFiche         : PFiche;

begin { - OpenZoomDialog - }
New(pMyFiche, Init);

with pMyFiche^, pGr1^ do begin
   FloatField(11,vXMinZoomCurs);
   FloatField(12,vXMaxZoomCurs);
   FloatField(13,vYMinZoomCurs);
   FloatField(14,vYMaxZoomCurs);
   end;

New(pGr1^.pZoomDlg0, MSGInit(pGr1^.pGAPWin, msgNum, pMyFiche));
pGr1^.pZoomDlg0^.DoInterpretation;

{ indique au dialogue quel est le graphique qui est zoom }
pGr1^.pZoomDlg0^.pGr:=pGr1;

Application^.MakeWindow(pGr1^.pZoomDlg0);
pGr1^.pZoomDlg0^.Show(sw_Show);

{ indique qu'il faut mmoriser les positions de la boite de dialogue }
pGr1^.pZoomDlg0^.fMemoriseMove:=TRUE;

{dispose(pGr1^.pDlg, Done);{ ne pas faire, est fait automatiquement}
{dispose(pMyFiche, Done);{ ne pas faire, est fait automatiquement}
end;  { - OpenZoomDialog - }
???*)
procedure TGAPGraphic.ZoomXYDefine(Flags:integer);
{================================================}
{ dfini un zoom manuellement }
var
  MemROP           : integer;
  recLineAt        : TypeLineAttrib;
  msgNum           : word;

begin { - TGAPGraphic.ZoomXYDefine - }
{ mmorise si on dsir un calcul automatique de l'axe Y }
fMemZoomOnlyX:=((Flags and flaGraphicZoomOnlyX) <> 0);

{ indique au ZoomXYDefine que le Zoom ne se fait que sur Y. }
fMemZoomOnlyY :=((Flags and flaGraphicZoomOnlyY) <> 0);

{ indique si le zoom de l'axe X doit-il etre enlev.}
fMemZoomAutoX :=fMemZoomOnlyY and ((Flags and flaGraphicZoomAutoX) <> 0);

{ positon de la souris en coord. utilisateur }
with pGrBase^ do begin
   { attribut de ligne des curseurs et affichage en  XOR  du graphisme }
   ZoomSetLineAttrib(MemROP, recLineAt);

   { dessine les curseurs verticaux }
   if (not fMemZoomOnlyY) then begin
      { position par dfaut des curseurs }
      vXMinZoomCurs := useXMax *      vZoomCursInitXMin +
                       useXMin * (1 - vZoomCursInitXMin);
      vXMaxZoomCurs := useXMax *      vZoomCursInitXMax +
                       useXMin * (1 - vZoomCursInitXMax);

      Line0(vXMinZoomCurs, useYMin, vXMinZoomCurs, useYMax);
      Line0(vXMaxZoomCurs, useYMin, vXMaxZoomCurs, useYMax);
      end
   else begin
      vXMinZoomCurs := useXMin;
      vXMaxZoomCurs := useXMax;
      end;

   { dessine les curseurs horizontaux }
   if (not fMemZoomOnlyX) then begin
      vYMinZoomCurs := useYMax *      vZoomCursInitYMin +
                       useYMin * (1 - vZoomCursInitYMin);
      vYMaxZoomCurs := useYMax *      vZoomCursInitYMax +
                       useYMin * (1 - vZoomCursInitYMax);

      if (vZoomCursInitYMin >= 0) then
         Line0(useXMin, vYMinZoomCurs, useXMax, vYMinZoomCurs);

      Line0(useXMin, vYMaxZoomCurs, useXMax, vYMaxZoomCurs);
      end
   else begin
      vYMinZoomCurs := useYMin;
      vYMaxZoomCurs := useYMax;
      end;

   { position affiche des curseurs }
   vXMinZoomCursOld:=vXMinZoomCurs;
   vXMaxZoomCursOld:=vXMaxZoomCurs;
   vYMinZoomCursOld:=vYMinZoomCurs;
   vYMaxZoomCursOld:=vYMaxZoomCurs;

   { remet les anciens attribut de lignes }
   ZoomRestorLineAttrib(MemROP,recLineAt);
   end; { with pGrBase^ do begin }

{ Indique quel est le graphique qu'il faut zoomer. }
pGAPWin^.pGAPGrMouseWM:=@Self;

{ --- Ouvre une boite de dialogue associe au zoom --- }
msgNum:=msgGAPGrZoomXY;
if fMemZoomOnlyX then msgNum:=msgGAPGrZoomOnlyX;
if fMemZoomOnlyY then msgNum:=msgGAPGrZoomOnlyY;

msgNum:=msgNum;
//???OpenZoomDialog(@Self, msgNum);
end;  { - TGAPGraphic.ZoomXYDefine - }

function TGAPGraphic.ZoomXYIn(Flags:integer):integer;
{===================================================}
{ Si un zoom a t mmoris, permet de rentrer dans ce zoom.
  Retourne le nombre de niveaux qui ont chang. }
var
  nn,
  nPosZoomBeg      : integer; { niveau de zoom au dpart }
begin { - TGAPGraphic.ZoomXYIn - }
{ rien  faire }
ZoomXYIn:=0;
if (Flags <= 0) and (nPosMemZoom = 0)              then exit;
if (Flags >= 0) and (nPosMemZoom = nMaxPosMemZoom) then exit;

{ niveau de zoom avant }
nPosZoomBeg:=nPosMemZoom;

{ change de niveau de zoom }
nPosMemZoom:=nPosMemZoom + Flags;
if (nPosMemZoom > nMaxPosMemZoom) then nPosMemZoom := nMaxPosMemZoom;

ZoomXYIn:=nPosMemZoom - nPosZoomBeg;

if (nPosMemZoom <= 0) then begin
   nPosMemZoom:=0;

   { il n'y a plus de zoom }
   isZoomOn:=FALSE;
   fZoomAutoY:=TRUE; { pas imprortant, car isZoom = FALSE }
   fZoomAutoX:=TRUE; { pas imprortant, car isZoom = FALSE }
   ZoomXYIn:=-nPosZoomBeg;

   { recalcul les limites pour les courbes zoomes }
   for nn:=1 to nbCu do ComputeLimitsZoomCurve(nn, apCu[nn]);

   pGAPWin^.Repaint;
   exit;
   end;

{ Se met  un nouveau niveau de zoom }
isZoomOn:=TRUE;

ZoomXMin:=avMemZoomXMin[nPosMemZoom];
ZoomXMax:=avMemZoomXMax[nPosMemZoom];
ZoomYMin:=avMemZoomYMin[nPosMemZoom];
ZoomYMax:=avMemZoomYMax[nPosMemZoom];
fZoomAutoY:=afMemZoomAutoY[nPosMemZoom];
fZoomAutoX:=afMemZoomAutoX[nPosMemZoom];
{ recalcul les limites pour les courbes zoomes }
for nn:=1 to nbCu do ComputeLimitsZoomCurve(nn, apCu[nn]);
pGAPWin^.Repaint;
end;  { - TGAPGraphic.ZoomXYIn - }

function TGAPGraphic.ZoomXYOut(Flags:integer):integer;
{====================================================}
{ Revient au niveau de zoom prcdent }
begin { - TGAPGraphic.ZoomXYOut - }
ZoomXYOut:=ZoomXYIn(-Flags);
end;  { - TGAPGraphic.ZoomXYOut - }

procedure TGAPGraphic.ZoomCancel;
{===============================}
{ refuse le nouveau Zoom }
{ accepte le nouveau Zoom }
var
  MemROP           : integer;
  recLineAt        : TypeLineAttrib;

begin { - TGAPGraphic.ZoomCancel - }
with pGrBase^ do begin
   { attribut de ligne des curseurs et affichage en  XOR  du graphisme }
   ZoomSetLineAttrib(MemROP, recLineAt);

   { efface les curseurs de zoom }
   if (not fMemZoomOnlyY) then begin
      Line0(vXMinZoomCursOld, useYMin, vXMinZoomCursOld, useYMax);
      Line0(vXMaxZoomCursOld, useYMin, vXMaxZoomCursOld, useYMax);
      end;

   if (not fMemZoomOnlyX) then begin
      if (vZoomCursInitYMin >= 0) then
         Line0(useXMin, vYMinZoomCursOld, useXMax, vYMinZoomCursOld);

      Line0(useXMin, vYMaxZoomCursOld, useXMax, vYMaxZoomCursOld);
      end;

   { remet les anciens attribut de lignes }
   ZoomRestorLineAttrib(MemROP,recLineAt);
   end; { with pGrBase^ do begin }


{ Indique qu'il n'y a plus de zoom }
pGAPWin^.pGAPGrMouseWM:=NIL;
end;  { - TGAPGraphic.ZoomCancel - }

procedure TGAPGraphic.ZoomDefine(
{===============================}
  vXMinZoomCurs0,  { min X du zoom }
  vXMaxZoomCurs0,  { max X du zoom }
  vYMinZoomCurs0,  { min Y du zoom }
  vYMaxZoomCurs0   { max Y du zoom }
                   : Float;
  wFlags           : word
  );
{ Definie un zoom.
  wFlags <- flaGraphicZoomOnlyX
         => mmorise si on dsir un calcul automatique de l'axe Y
  wFlags <- flaGraphicZoomOnlyY
         => indique que le Zoom ne se fait que sur Y.
-----------------------------------------------------------------------------}
var
  nn               : integer;

begin { - TGAPGraphic.ZoomDefine - }
{ Effectue le zoom }
isZoomOn:=TRUE;

{ mmorise si on dsir un calcul automatique de l'axe Y }
fMemZoomOnlyX:=((wFlags and flaGraphicZoomOnlyX) <> 0);

{ indique au ZoomXYDefine que le Zoom ne se fait que sur Y. }
fMemZoomOnlyY:=((wFlags and flaGraphicZoomOnlyY) <> 0);

{ cas ou les min et max sont mal dfini }
if (vXMinZoomCurs0 >= vXMaxZoomCurs0) then begin
    vXMinZoomCurs0:=vXMinZoomCurs0-0.5; vXMaxZoomCurs0:=vXMinZoomCurs0 + 1.0;  end;

if (vYMinZoomCurs0 >= vYMaxZoomCurs0) then begin
vYMinZoomCurs0:=vYMinZoomCurs0-0.5;  vYMaxZoomCurs0:=vYMinZoomCurs0 + 1.0;  end;

ZoomXMin:=vXMinZoomCurs0;
ZoomXMax:=vXMaxZoomCurs0;
if (vZoomCursInitYMin >= 0) then ZoomYMin:=vYMinZoomCurs0
else                             ZoomYMin:=pGrBase^.useYMin;
ZoomYMax:=vYMaxZoomCurs0;

//DBW(2, FloatToStr(vYMinZoomCurs0, 9,3) +  FloatToStr(vYMaxZoomCurs0, 9,3));}

{ mmorise le Zoom, pour effectuer des ZoomIn et ZoomOut }
if (nPosMemZoom < TRENTE) then begin
   { oublie les autres zoom In effectus }
   inc(nPosMemZoom);
   nMaxPosMemZoom :=nPosMemZoom;
   end;

avMemZoomXMin[nPosMemZoom]:=ZoomXMin;
avMemZoomXMax[nPosMemZoom]:=ZoomXMax;
avMemZoomYMin[nPosMemZoom]:=ZoomYMin;
avMemZoomYMax[nPosMemZoom]:=ZoomYMax;
afMemZoomAutoY[nPosMemZoom]:=fMemZoomOnlyX;
afMemZoomAutoX[nPosMemZoom]:=fMemZoomOnlyY;
fZoomAutoY:=fMemZoomOnlyX;
fZoomAutoX:=fMemZoomOnlyY;

{ recalcul les limites pour les courbes zoomes }
for nn:=1 to nbCu do ComputeLimitsZoomCurve(nn, apCu[nn]);
end;  { - TGAPGraphic.ZoomDefine - }

procedure TGAPGraphic.ZoomOK;
{===========================}
var
  nn               : integer;

begin { - TGAPGraphic.ZoomOK - }
ZoomCancel;

{ Effectue le zoom }
isZoomOn:=TRUE;

{ cas ou les min et max sont mal dfini }
if (vXMinZoomCurs >= vXMaxZoomCurs) then begin
    vXMinZoomCurs:=vXMinZoomCurs-0.5; vXMaxZoomCurs:=vXMinZoomCurs + 1.0;  end;

if (vYMinZoomCurs >= vYMaxZoomCurs) then begin
vYMinZoomCurs:=vYMinZoomCurs-0.5;  vYMaxZoomCurs:=vYMinZoomCurs + 1.0;  end;

ZoomXMin:=vXMinZoomCurs;
ZoomXMax:=vXMaxZoomCurs;
if (vZoomCursInitYMin >= 0) then ZoomYMin:=vYMinZoomCurs
else                             ZoomYMin:=pGrBase^.useYMin;
ZoomYMax:=vYMaxZoomCurs;

//DBW(2, FloatToStr(vYMinZoomCurs, 9,3) +  FloatToStr(vYMaxZoomCurs, 9,3));}

{ mmorise le Zoom, pour effectuer des ZoomIn et ZoomOut }
if (nPosMemZoom < TRENTE) then begin
   { oublie les autres zoom In effectus }
   inc(nPosMemZoom);
   nMaxPosMemZoom :=nPosMemZoom;
   end;

avMemZoomXMin[nPosMemZoom]:=ZoomXMin;
avMemZoomXMax[nPosMemZoom]:=ZoomXMax;
avMemZoomYMin[nPosMemZoom]:=ZoomYMin;
avMemZoomYMax[nPosMemZoom]:=ZoomYMax;
afMemZoomAutoY[nPosMemZoom]:=fMemZoomOnlyX;
afMemZoomAutoX[nPosMemZoom]:=fMemZoomAutoX;
fZoomAutoY:=fMemZoomOnlyX;
fZoomAutoX:=fMemZoomAutoX;

{ recalcul les limites pour les courbes zoomes }
for nn:=1 to nbCu do ComputeLimitsZoomCurve(nn, apCu[nn]);

{
nn:=3;
with apCu[3]^ do begin
   DBW(2, 'ind=' + IntToStr(aindMin[nn], 5) + IntToStr(aindMax[nn], 5) +
                        + FloatToStr(pYD^[aindMin[nn]],9,3)
                        + FloatToStr(pYD^[aindMin[nn]-1],9,3)
                          );
   end;}
end;  { - TGAPGraphic.ZoomOK - }

{ --- Traite des messages souris. Utile pour des Zooms et Curseurs }

procedure TGapGraphic.WMLButtonDown(var Msg: TMSG);
{====================================================}
var
{ A faire si le curseur dsir fait partie des ressources de l'application
 winClass          : TWndClass;
  GetWindowClass(winClass); }
  pixXMouse,
  pixYMouse        : integer;
  vXMouse,
  vYMouse          : Float;
  mmXMouse,
  mmYMouse         : Float;

  mmXMinZoomCurs,
  mmYMinZoomCurs,
  mmXMaxZoomCurs,
  mmYMaxZoomCurs
                   : Float;

  mmDistXMin,
  mmDistYMin,
  mmDistXMax,
  mmDistYMax       : Float;

begin { - TGapGraphic.WMLButtonDown - }
{ position de la souris en pixels }
pixXMouse:=integer(LoWORD(Msg.lParam));
pixYMouse:=integer(HiWORD(Msg.lParam));

{ positon de la souris en coord. utilisateur }
with pGrBase^ do begin
   PixToUser(pixXMouse,pixYMouse, vXMouse,vYMouse);
   UserToMM(vXMouse,vYMouse, mmXMouse,mmYMouse);
   UserToMM(vXMinZoomCurs,vYMinZoomCurs, mmXMinZoomCurs, mmYMinZoomCurs);
   UserToMM(vXMaxZoomCurs,vYMaxZoomCurs, mmXMaxZoomCurs, mmYMaxZoomCurs);
   end; { with pGrBase^ do begin }

{ cherche de quel position de curseur la souris est la plus proche }
mmDistXMin:=abs(mmXMinZoomCurs - mmXMouse);
mmDistYMin:=abs(mmYMinZoomCurs - mmYMouse);
mmDistXMax:=abs(mmXMaxZoomCurs - mmXMouse);
mmDistYMax:=abs(mmYMaxZoomCurs - mmYMouse);

{DBW(2, IntToStr(Round(10*mmDistXMin), 9) + IntToStr(Round(10*mmDistXMax), 9));
 DBW(2, IntToStr(Round(10*mmDistYMin), 9) + IntToStr(Round(10*mmDistYMax), 9));}

{ cherche si la souris est proche d'un des deux curseurs verticaux }
nXNear:=0;
if (mmDistXMin < mmDistXMax) then begin
   if (mmDistXMin < mmZoomCursDist) then nXNear:=1;
   end
else begin
   if (mmDistXMax < mmZoomCursDist) then nXNear:=2;
   end;

{ cherche si la souris est proche d'un des deux curseurs horizontaux }
nYNear:=0;
if (mmDistYMin < mmDistYMax) then begin
   if (mmDistYMin < mmZoomCursDist) then nYNear:=1;
   end
else begin
   if (mmDistYMax < mmZoomCursDist) then nYNear:=2;
   end;

{ Si seulement les curseurs de zoom vert. ou horiz. sont affichs }
if fMemZoomOnlyX then nYNear:=0;
if fMemZoomOnlyY then nXNear:=0;

hCursorOld:=0;
if (nXNear = 0) then begin
   if (nYNear = 0) then exit;
   hCursorNew:=LoadCursor(0, IDC_SIZENS);
   end
else begin
   if (nYNear = 0) then begin
      hCursorNew:=LoadCursor(0, IDC_SIZEWE);
      hCursorOld:=SetCursor(hCursorNew);
      pGAPWin^.SetCapture0;
      exit;
      end;

   { Les deux positions sont proches }
   if (nXNear = 1) then begin { proche de gauche }
      if (nYNear = 1) then hCursorNew:=LoadCursor(0, IDC_SIZENESW)
      else                 hCursorNew:=LoadCursor(0, IDC_SIZENWSE);
      end
   else begin {nXNear = 2}
      if (nYNear = 1) then hCursorNew:=LoadCursor(0, IDC_SIZENWSE)
      else                 hCursorNew:=LoadCursor(0, IDC_SIZENESW);
      end;
   end;

hCursorOld:=SetCursor(hCursorNew);

{ Indique qu'il faut capturer la souris }
pGAPWin^.SetCapture0;
end;  { - TGapGraphic.WMLButtonDown - }

procedure TGapGraphic.WMLButtonUp(var Msg: TMSG);
{====================================================}
begin { - TGapGraphic.WMLButtonUp - }
if (hCursorOld <> 0) then SetCursor(hCursorOld);

{ Indique qu'il faut librer la souris }
pGAPWin^.ReleaseCapture0;

nXNear:= 0;
nYNear:= 0;
end;  { - TGapGraphic.WMLButtonUp - }

procedure TGapGraphic.UpdateCursorPos;
{====================================}
{ Efface les curseurs  leur ancienne position, et
  redessine les curseurs  leur nouvelle position. }
var
  MemROP           : integer;
  recLineAt        : TypeLineAttrib;
  vDXMin,
  vDYMin           : Float;

begin { - TGapGraphic.UpdateCursorPos - }
with pGrBase^ do begin
   { attribut de ligne des curseurs et affichage en  XOR  du graphisme }
   ZoomSetLineAttrib(MemROP, recLineAt);

   { efface les anciens curseurs de zoom }
   if (not fMemZoomOnlyY) then begin
      Line0(vXMinZoomCursOld, useYMin, vXMinZoomCursOld, useYMax);
      Line0(vXMaxZoomCursOld, useYMin, vXMaxZoomCursOld, useYMax);
      end;

   if (not fMemZoomOnlyX) then begin
      if (vZoomCursInitYMin >= 0) then
         Line0(useXMin, vYMinZoomCursOld, useXMax, vYMinZoomCursOld);

      Line0(useXMin, vYMaxZoomCursOld, useXMax, vYMaxZoomCursOld);
      end;

   vDXMin:=(useXMax - useXMin) / 200;
   vDYMin:=(useYMax - useYMin) / 100;

   { le curseur gauche ne peut pas aller plus  droite que le curseur droite,
     et rciproquement. }
   if (vXMinZoomCurs + vDXMin > vXMaxZoomCurs) then begin
      if (nXNear = 1) then  vXMaxZoomCurs:=vXMinZoomCurs + vDXMin;
      if (nXNear = 2) then  vXMinZoomCurs:=vXMaxZoomCurs - vDXMin;
      end;

   { idem pour les curseurs verticaux }
   if (vYMinZoomCurs + vDYMin > vYMaxZoomCurs) then begin
      if (nYNear = 1) then  vYMaxZoomCurs:=vYMinZoomCurs + vDYMin;
      if (nYNear = 2) then  vYMinZoomCurs:=vYMaxZoomCurs - vDYMin;
      end;

   { Redessine les nouvelles curseurs de Zoom. }
   if (not fMemZoomOnlyY) then begin
      Line0(vXMinZoomCurs, useYMin, vXMinZoomCurs, useYMax);
      Line0(vXMaxZoomCurs, useYMin, vXMaxZoomCurs, useYMax);
      end;

   if (not fMemZoomOnlyX) then begin
      if (vZoomCursInitYMin >= 0) then
         Line0(useXMin, vYMinZoomCurs, useXMax, vYMinZoomCurs);

      Line0(useXMin, vYMaxZoomCurs, useXMax, vYMaxZoomCurs);
      end;

   { mmorise la position actuelle des curseurs }
   vXMinZoomCursOld:=vXMinZoomCurs;
   vXMaxZoomCursOld:=vXMaxZoomCurs;
   vYMinZoomCursOld:=vYMinZoomCurs;
   vYMaxZoomCursOld:=vYMaxZoomCurs;

   { remet les anciens attribut de lignes }
   ZoomRestorLineAttrib(MemROP,recLineAt);
   end; { with pGrBase^ do begin }
end;  { - TGapGraphic.UpdateCursorPos - }

procedure TGapGraphic.WMMouseMove(var Msg: TMSG);
{==================================================}
const
  pixXMouseLast : integer = 0;
  pixYMouseLast : integer = 0;

var
  pixXMouse,
  pixYMouse        : integer;
  vXMouse,
  vYMouse          : Float;
  mmXMouse,
  mmYMouse         : Float;

{  mmXMinZoomCurs,
  mmYMinZoomCurs,
  mmXMaxZoomCurs,
  mmYMaxZoomCurs
                   : Float;}

  ptMouse          : TPoint;

begin { - TGapGraphic.WMMouseMove - }
if (nXNear = 0) and (nYNear = 0) then exit;

{ position de la souris en pixels }
pixXMouse:=integer(LoWORD(Msg.lParam));
pixYMouse:=integer(HiWORD(Msg.lParam));

{ pas de traitement si la souris ne s'est pas dplace }
if (abs(pixXMouse - pixXMouseLast) <= 1) and
   (abs(pixYMouse - pixYMouseLast) <= 1) then exit;
pixXMouseLast:=pixXMouse;
pixYMouseLast:=pixYMouse;

{ positon de la souris en coord. utilisateur }
with pGrBase^ do begin
   PixToUser(pixXMouse,pixYMouse, vXMouse,vYMouse);
   UserToMM(vXMouse,vYMouse, mmXMouse,mmYMouse);
{   UserToMM(vXMinZoomCurs,vYMinZoomCurs, mmXMinZoomCurs, mmYMinZoomCurs);
   UserToMM(vXMaxZoomCurs,vYMaxZoomCurs, mmXMaxZoomCurs, mmYMaxZoomCurs);EFFACER}

   { la souris ne peut pas sortir de la fentre }
   if (vXMouse > useXMax) then vXMouse:=useXMax;
   if (vXMouse < useXMin) then vXMouse:=useXMin;
   if (vYMouse > useYMax) then vYMouse:=useYMax;
   if (vYMouse < useYMin) then vYMouse:=useYMin;

   UserToPixInt(vXMouse, vYMouse, pixXMouse, pixYMouse);

   { conversion en coordonnes d'cran }
   ptMouse.X:=pixXMouse;
   ptMouse.Y:=pixYMouse;
   ClientToScreen(pGAPWin^.hWin, ptMouse);
   pixXMouse:=ptMouse.X;
   pixYMouse:=ptMouse.Y;

   SetCursorPos(pixXMouse, pixYMouse);

   { Test le curseur pour savoir si c'est le bon move }
   if (nXNear = 1) then vXMinZoomCurs:=vXMouse;
   if (nXNear = 2) then vXMaxZoomCurs:=vXMouse;
   if (nYNear = 1) then vYMinZoomCurs:=vYMouse;
   if (nYNear = 2) then vYMaxZoomCurs:=vYMouse;

   { efface les anciens curseurs de Zoom et met les nouvaux }
   UpdateCursorPos;

(*
     ----------------
   { attribut de ligne des curseurs et affichage en  XOR  du graphisme }
   ZoomSetLineAttrib(MemROP, recLineAt);

   { efface les anciens curseurs de zoom }
   if (not fMemZoomOnlyY) then begin
      Line0(vXMinZoomCurs, useYMin, vXMinZoomCurs, useYMax);
      Line0(vXMaxZoomCurs, useYMin, vXMaxZoomCurs, useYMax);
      end;

   if (not fMemZoomOnlyX) then begin
      Line0(useXMin, vYMinZoomCurs, useXMax, vYMinZoomCurs);
      Line0(useXMin, vYMaxZoomCurs, useXMax, vYMaxZoomCurs);
      end;

   { Test le curseur pour savoir si c'est le bon move }
   if (nXNear = 1) then vXMinZoomCurs:=vXMouse;
   if (nXNear = 2) then vXMaxZoomCurs:=vXMouse;
   if (nYNear = 1) then vYMinZoomCurs:=vYMouse;
   if (nYNear = 2) then vYMaxZoomCurs:=vYMouse;

   { le curseur gauche ne peut pas aller plus  droite que le curseur droite,
     et rciproquement. }
   if (vXMinZoomCurs > vXMaxZoomCurs) then begin
      if (nXNear = 1) then  vXMaxZoomCurs:=vXMinZoomCurs;
      if (nXNear = 2) then  vXMinZoomCurs:=vXMaxZoomCurs;
      end;

   { idem pour les curseurs verticaux }
   if (vYMinZoomCurs > vYMaxZoomCurs) then begin
      if (nYNear = 1) then  vYMaxZoomCurs:=vYMinZoomCurs;
      if (nYNear = 2) then  vYMinZoomCurs:=vYMaxZoomCurs;
      end;

   { Redessine les nouvelles curseurs de Zoom. }
   if (not fMemZoomOnlyY) then begin
      Line0(vXMinZoomCurs, useYMin, vXMinZoomCurs, useYMax);
      Line0(vXMaxZoomCurs, useYMin, vXMaxZoomCurs, useYMax);
      end;

   if (not fMemZoomOnlyX) then begin
      Line0(useXMin, vYMinZoomCurs, useXMax, vYMinZoomCurs);
      Line0(useXMin, vYMaxZoomCurs, useXMax, vYMaxZoomCurs);
      end;

   { remet les anciens attribut de lignes }
   ZoomRestorLineAttrib(MemROP,recLineAt);
*)
   end; { with pGrBase^ do begin }

{ remise  jours des variables dans la boite de dialogue }
//???pZoomDlg0^.UpDateAllVar0;
end;  { - TGapGraphic.WMMouseMove - }

procedure TGapGraphic.Paint;
{==========================}
{ pour redessiner aussi les curseurs du zoom }
var
  MemROP           : integer;
  recLineAt        : TypeLineAttrib;

begin { - TGapGraphic.Paint - }
with pGrBase^ do begin
   { attribut de ligne des curseurs et affichage en  XOR  du graphisme }
   ZoomSetLineAttrib(MemROP, recLineAt);

   { Redessine les curseurs de Zoom. }
   if (not fMemZoomOnlyY) then begin
      Line0(vXMinZoomCursOld, useYMin, vXMinZoomCursOld, useYMax);
      Line0(vXMaxZoomCursOld, useYMin, vXMaxZoomCursOld, useYMax);
      end;

   if (not fMemZoomOnlyX) then begin
      if (vZoomCursInitYMin >= 0) then
         Line0(useXMin, vYMinZoomCursOld, useXMax, vYMinZoomCursOld);

      Line0(useXMin, vYMaxZoomCursOld, useXMax, vYMaxZoomCursOld);
      end;

   { remet les anciens attribut de lignes }
   ZoomRestorLineAttrib(MemROP,recLineAt);
   end; { with pGrBase^ do begin }
end;  { - TGapGraphic.Paint - }

function TGapGraphic.CopyGrTo(pGr:PGAPGraphic; Flags1:word):PGAPGraphic;
{======================================================================}
{ Copie un grapihque dans une autre, avec le contenu.
  Flags1 = 0 => copie tout, avec les courbes.
         = flaGrNoCopyCurves =>
           Indication de ne pas copier les courbes du graphique.
  Si pGr = NIL, cre un nouveau graphique, et retourne un pointeur dessus.
  sinon         retourne pGr
--------------------------------------------------------------}
var
  nn               : integer;

begin { - TGapGraphic.CopyGrTo - }
CopyGrTo:=pGr;

{ cration d'un nouveau graphique, si ncssaire }
if (pGr = NIL) then begin
   if (glpActiveWindow = NIL) then exit;
   pGr :=glfnNewGraphic(glpActiveWindow, 0);
   if (pGr = NIL) then exit; { pas normal }
   end;

CopyGrTo:=pGr;

{ Ne doivent pas tre chang!
wIdentity
fAutoDisposeInfo
pGrBase
pAxes
pGAPWin
pcolBorderWin1
pcolWin1
pcolWin2
pZoomDlg0
hCursorNew
hCursorOld
nXNear,nYNear

vXMinZoomCurs
vYMinZoomCurs
vXMaxZoomCurs
vYMaxZoomCurs

vXMinZoomCursOld
vYMinZoomCursOld
vXMaxZoomCursOld
vYMaxZoomCursOld

pnZoomDlgLastPosX,
pnZoomDlgLastPosY

fDoAutoDispose
fDoDisposeGrBase
fDoDisposeAxes
nKind  }

pInfo^.CopyInfoTo(pGr^.pInfo, 0);

if ((Flags1 and flaGrNoCopyCurves) = 0) then begin
   for nn:=1 to nbCu do begin
     { graphiques de la fentre }
     pGr^.apCu[nn] :=pGr^.AddNewCurve(apCu[nn]^.nIndMaxAbs, 0);
     apCu[nn]^.CopyCuTo(pGr^.apCu[nn], 0);
     end;

   pGr^.nbCu  :=nbCu;
   if (nbCu >= 1) then pGr^.pActiveCurve :=pGr^.apCu[1];
   end
else begin
   pGr^.nbCu  :=0;
   pGr^.pActiveCurve :=NIL;
   end;

pGr^.strWindowTitle:=strWindowTitle;

pGr^.strTitle    :=strTitle;
pGr^.strXLegend  :=strXLegend;
pGr^.strYLegend  :=strYLegend;

pGr^.vCharXMoveTitle   :=vCharXMoveTitle;
pGr^.vCharYMoveTitle   :=vCharYMoveTitle;
pGr^.vCharXMoveXLegend :=vCharXMoveXLegend;
pGr^.vCharYMoveXLegend :=vCharYMoveXLegend;
pGr^.vCharXMoveYLegend :=vCharXMoveYLegend;
pGr^.vCharYMoveYLegend :=vCharYMoveYLegend;

pGr^.sizeTitle  :=sizeTitle;
pGr^.sizeTextGr :=sizeTextGr;

pGr^.colTextTitle :=colTextTitle;

pGr^.lAxesFlags       :=lAxesFlags;
pGr^.styleLineAxes    :=styleLineAxes;
pGr^.pixWidthLineAxes :=pixWidthLineAxes;
pGr^.mmWidthLineAxes  :=mmWidthLineAxes;
pGr^.colLineAxes      :=colLineAxes;
pGr^.colTextAxes      :=colTextAxes;

pGr^.fDrawBorderWin1  :=fDrawBorderWin1;
pGr^.StyleWin1        :=StyleWin1;
pGr^.pixWidthWin1     :=pixWidthWin1;
pGr^.mmWidthWin1      :=mmWidthWin1;

pGr^.colBorderWin1UnUse :=colBorderWin1UnUse;
pGr^.colWin1UnUse       :=colWin1UnUse;
pGr^.colWin2UnUse       :=colWin2UnUse;
pGr^.fDrawGrid          :=fDrawGrid;

for nn:=1 to VINGT do begin
   pGr^.aindMin[nn] :=aindMin[nn];
   pGr^.aindMax[nn] :=aindMax[nn];
   end;

pGr^.isZoomOn  :=isZoomOn;
pGr^.ZoomXMin  :=ZoomXMin;
pGr^.ZoomXMax  :=ZoomXMax;
pGr^.ZoomYMin  :=ZoomYMin;
pGr^.ZoomYMax  :=ZoomYMax;

pGr^.fZoomAutoY        :=fZoomAutoY;
pGr^.fZoomAutoX        :=fZoomAutoX;

pGr^.mmZoomCursDist    :=mmZoomCursDist;

pGr^.vZoomCursInitXMin :=vZoomCursInitXMin;
pGr^.vZoomCursInitYMin :=vZoomCursInitYMin;
pGr^.vZoomCursInitXMax :=vZoomCursInitXMax;
pGr^.vZoomCursInitYMax :=vZoomCursInitYMax;

for nn:=1 to TRENTE do begin
   pGr^.avMemZoomXMin[nn]  :=avMemZoomXMin[nn];
   pGr^.avMemZoomXMax[nn]  :=avMemZoomXMax[nn];
   pGr^.avMemZoomYMin[nn]  :=avMemZoomYMin[nn];
   pGr^.avMemZoomYMax[nn]  :=avMemZoomYMax[nn];

   pGr^.afMemZoomAutoY[nn] :=afMemZoomAutoY[nn];
   pGr^.afMemZoomAutoX[nn] :=afMemZoomAutoX[nn];
   end;

pGr^.nMaxPosMemZoom :=nMaxPosMemZoom;
pGr^.nPosMemZoom    :=nPosMemZoom;

pGr^.fIsNewFile     :=fIsNewFile;

pGr^.fHasChangedGr    :=fHasChangedGr;

pGr^.pGrBase^.CopyGrBaseTo(pGrBase, 0);
end;  { - TGapGraphic.CopyGrTo - }

procedure TGapGraphic.PutFieldsGr;
{================================}
{ Ne fait rien, est destin  tre redfini, pour
  mettre les paramtres dans des glpFiche^...Field pour les traiter
  dans des boites de dialogues.
--------------------------------------------------------------------}
begin { - TGapGraphic.PutFieldsGr - }
end;  { - TGapGraphic.PutFieldsGr - }

procedure TGapGraphic.SetActiveCurve(pCu1:PGAPCurve; var nErr:integer);
{====================================================================}
{ Dfini pCu comme la courbe active du graphique.
  Si pCu ne fait pas partie du graphique, nErr = 1 et rien n'est fait.
  Maintient l'ordre des courbes dans apCu, donc celle qui tait
  active va en deuxime position.
  Change la glpActiveCurve, si le graphique est le graphique actif. }
var
  kk,nn            : integer;

begin { - TGapGraphic.SetActiveCurve - }
if glfWithColorActiveCurve and (pCu1 = NIL) and (pActiveCurve <> NIL) then begin
   { Pour que la courbe active reprenne sa couleur }
   pActiveCurve^.colLineCu:=colMemLineCu;
   exit;
   end;

if (pCu1 = pActiveCurve) then exit;  { il n'y a rien  faire }

if (nbCu = 1) then begin
   { il n'y a que une seule courbe, c'est forcment elle qui est active }
   colMemLineCu:=apCu[1]^.colLineCu;
   end;

{ Cherche la courbe pCu parmis les courbes du graphique }
nn:=1;
while (nn < nbCu) do begin
   inc(nn);
   { cherche la rfrence  la courbe pCu1 }
   if (apCu[nn] = pCu1) then begin
      { dcale les courbes, pour mettre pCu1 en premire position }
      for kk:=nn downto 2 do apCu[kk]:=apCu[kk-1];

      { la courbe qui tait active reprend sa couleur }
      if glfWithColorActiveCurve and (pActiveCurve <> NIL) then
         pActiveCurve^.colLineCu:=colMemLineCu;

      { La courbe pCu1 est la premire de la liste et c'est l'active }
      apCu[1]:=pCu1;
      pActiveCurve:=pCu1;

      { Si on est dans le graphique actif, change la courbe actif globale }
      if (glpActiveGraphic = @Self) then
         glpActiveCurve:=pCu1;

      { mmorise la couleur de la courbe avant de lui donner la couleur
        de la courbe active }
      colMemLineCu:=pCu1^.colLineCu;
      if  glfWithColorActiveCurve then pCu1^.colLineCu:=RGB(0,0,128);

      { recalcul les limites pour les courbes zoomes }
      for kk:=1 to nbCu do ComputeLimitsZoomCurve(kk, apCu[kk]);

      InvalidateRect(pGAPWin^.hWin, NIL, TRUE);
      exit;
      end; { if (apCu[nn] = pCu1) then begin }
   end; { while (nn < nbCu) do begin }
end;  { -TGapGraphic.SetActiveCurve - }

function TGAPGraphic.GetCurveSelectedByCursor(nX,nY:integer):PGAPCurve;
{=====================================================================}
{ retourne un pointeur sur la courbe slectionn par le point (nX,nY)
  en coordonne de fentre client.
  Retourne NIL si le point n'est pas proche de la courbe }
var nn : integer;
begin { - TGAPGraphic.GetCurveSelectedByCursor - }
nn:=nbCu;

{ Test parmis toutes les courbes, si le point (nX,nY) est proche de la
  courbe. Si oui, le pointeur sur la courbe est retourn }
while (nn >= 1) do begin
   if (apCu[nn]^.IsNearCursor(nX,nY)) then begin
      GetCurveSelectedByCursor:=apCu[nn];
      exit;
      end;

   dec(nn);
   end;

GetCurveSelectedByCursor:=NIL;
end;  { - TGAPGraphic.GetCurveSelectedByCursor - }

procedure TGapGraphic.SaveGraphicSignature(var fOut:Text; var nErr:integer);
{==========================================================================}
{ Cette procdure est destine a tre redfinie par l'utilisateur.
  Elle va de paire avec la procedure LoadGraphicSignature(fIn, nErr).
  Ne pas appeler le inherited SaveGraphicSignature(fOut, nErr);
  Permet d'crire une signature reprsentant le type de donnes, telle que
  donnes  PMD  ou  donnes SKE  ou autre.
-------------------------------------------------------------------------}
begin { - TGapGraphic.SaveGraphicSignature - }
{$i-}
{ Signature du dveloppeur-utilisateur }
writeln(fOut, '# ...Signature : _TGAPGraphic GAPGr');
nErr:=IOResult;
{$i+}
end;  { - TGapGraphic.SaveGraphicSignature - }

procedure TGapGraphic.SaveGraphicPersonnalInfo(var fOut:Text; var nErr:integer);
{==============================================================================}
{ Cette procdure est destine a tre redfinie par l'utilisateur.
  Elle va de paire avec la procedure LoadGraphicPersonnalInfo(fIn, nErr).
  Ne pas appeler le inherited SaveGraphicPersonnalInfo(fOut, nErr);
  ni le inherited LoadGraphicPersonnalInfo(fIn, nErr);
  nErr:=IOResult;
-------------------------------------------------------------------------}
begin { - TGapGraphic.SaveGraphicPersonnalInfo - }
if (pInfo <> NIL) then begin
   strWindowTitle :=GetMsg(msgLoadGraphicWinTitle) + pInfo^.GetFilePath;
   SetWindowText(pGAPWin^.hWin, AZT(strWindowTitle));
   end;

{$i-}
{ version dveloppeur-utilisateur }
writeln(fOut, '# ...Signature : _TGAPGraphic Info');
writeln(fOut,'# ', 100);
nErr:=IOResult;
{$i+}
end;  { - TGapGraphic.SaveGraphicPersonnalInfo - }

procedure TGapGraphic.SaveGraphicPersonnalTreatement(
{===================================================}
   var fOut:Text; var nErr:integer);
{ Cette procdure est destine a tre tendue par l'utilisateur.
  Elle va de paire avec la procedure LoadGraphicPersonnalTreatement(fIn, nErr).
  Ne pas appeler le inherited SaveGraphicPersonnalTreatement(fOut, nErr);
  ni le inherited LoadGraphicPersonnalTreatement(fIn, nErr);
-------------------------------------------------------------------------}
begin { - TGapGraphic.SaveGraphicPersonnalTreatement - }
{$i-}
{ version dveloppeur-utilisateur }
writeln(fOut, '# ...Signature : _TGAPGraphic Treat');
writeln(fOut,'# ', 100);
nErr:=IOResult;
{$i+}
end;  { - TGapGraphic.SaveGraphicPersonnalTreatement - }

procedure TGapGraphic.SaveGraphicCurves(
{======================================}
  var fOut         : text;
  var nErr         : integer;
      Flags        : word
  );
{ Sauve les courbes du graphique.
  N'est gnralement pas tandu ni redfini.
  Flags = 0, les mmes que SaveGraphic.
-------------------------------------------------------------------------}
var
  nn               : integer;

begin { - TGapGraphic.SaveGraphicCurves - }
{$i-}
writeln(fOut, '# ...Signature : _TGAPGraphic SaveGraphicCurves');
writeln(fOut, '# 101');

{ couleur d'origine de la courbe active }
if glfWithColorActiveCurve and (pActiveCurve <> NIL) then begin
   pActiveCurve^.colLineCu:=colMemLineCu;
   end;

for nn:=1 to nbCu do begin
   if ((Flags and flaGraphicSaveOnlyDisplayed) = 0) or
      apCu[nn]^.fDraw then begin
      { Sauve une en-tte qui sera lue sparment, pour connaitre la taille
       de la courbe  charger }
      apCu[nn]^.SaveCurveIndMax(fOut, nErr);
      if (nErr <> 0) then exit;

      apCu[nn]^.SaveCurve(fOut, nErr, flags);
      if (nErr <> 0) then exit;
      end;
   end;

nErr:=ioResult;
{$i+}

{ couleur de la courbe active }
if glfWithColorActiveCurve and
   (nbCu >= 2) and (pActiveCurve <> NIL) then begin
   pActiveCurve^.colLineCu:=RGB(0,0,128);
   end;
end;  { - TGapGraphic.SaveGraphicCurves - }

procedure TGAPGraphic.SaveGraphicSKEInfo(var fOut:Text; var nErr:integer);
{========================================================================}
{ est destin  tre utilis que dans wSKEVar, pas redfini ni tandu.
  c.f. SaveGraphicPersonnalInfo pour sauver des informations utilisateur. }
begin { - TGAPGraphic.SaveGraphicSKEInfo - }
{$i-}
writeln(fOut, '# ...Signature : _TSKEGraphic Info');
writeln(fOut,'# ', 100); { version }

nErr:=IOResult;
{$i+}
end;  { - TGAPGraphic.SaveGraphicSKEInfo - }

procedure TGapGraphic.SaveGraphic(var fOut:Text; var nErr:integer; Flags:word);
{=============================================================================}
{ Sauve les informations relative a une courbe.
  Ne pas surdfinir, mais surdfinir :
  SaveGraphicPersonnalInfo et SaveGraphicPersonnalTreatement.
  (Flags and flaGraphicSaveOnlyDisplayed) <> 0) =>
    se sauve que les courbes affiche du graphique.

  nErr:=IOResult ou
  erreurs de # pInfo^.SaveInfo
             # SaveGraphicPersonnalInfo
             # apCu[nn]^.SaveCurve
             # SaveGraphicPersonnalTreatement
-------------------------------------------------------------------------}
const
  { positionnement au writeln }
  nFmt             = 6;
  dFmt             = 6;
  rFmt             = nFmt+1+dFmt;

var
  nn               : integer;
  nbCuDisplayed    : integer;

begin { - TGapGraphic.SaveGraphic - }
nErr:=0;
{$i-}
{ Signature commune  toutes les applications WINDOWS utilisant wGAPGr.pas }
writeln(fOut, '# ...Signature : wGAPGr.pas Data File');

{ Signature personalise de l'application }
SaveGraphicSignature(fOut, nErr);
if (nErr <> 0) then exit; { traite l'erreur plus loin }

{ Lecture d'information  partir d'ici }
writeln(fOut, '# ...Signature : _TGAPGraphic');

{ code de version du dveloppeur de librairie }
writeln(fOut,'# ', 108, '   = Version');

{ Indique le nombre de courbes qui seront sauve }
nbCuDisplayed:=0;
if ((Flags and flaGraphicSaveOnlyDisplayed) <> 0) then begin
   { Compte puis sauve le nombre de courbes affiche }
   for nn:=1 to nbCu do begin
      if apCu[nn]^.fDraw then inc(nbCuDisplayed);
      end;

   writeln(fOut,'# ', nbCuDisplayed:nFmt, '   = nb curves'); {=nombre de courbes sauves }
   end
else writeln(fOut,'# ', nbCu:nFmt, '   = nb curves'); {=nombre de courbes sauves }

{ Sauve l'information accocie  un graphique }
if (pInfo <> NIL) then begin
   writeln(fOut, '# ...With _TGAPInfo');
   pInfo^.SaveInfo(fOut, nErr);
   if (nErr <> 0) then exit;
   end
else writeln(fOut, '# ...Without _TGAPInfo');

{ information supplmentaire pour le dveloppeur-utilisateur }
writeln(fOut, '# ...BEG _TGAPGraphic Personnal Info');
SaveGraphicPersonnalInfo(fOut, nErr);  if (nErr <> 0) then exit;

{ information habituelles pour la librairie }
writeln(fOut, '# ...BEG _TGAPGraphic Information');

{ Titre de la Window contenant le graphique }
writeln(fOut,'#_', pGAPWin^.strWinTitle);

{ Titre et lgende des axes }
writeln(fOut,'#_', strTitle);
writeln(fOut,'#_', strXLegend);
writeln(fOut,'#_', strYLegend);
writeln(fOut,'# ', colTextTitle:9);

{ Flags de l'autoaxes, pour le dessin des axes du graphique }
writeln(fOut,'# ', lAxesFlags:9, '   = lAxesFlags');

{ indication sur la couleur et le style du graphique,
  est dfini dans l'Init, mais est modifiable }
writeln(fOut,'# ', styleLineAxes:nFmt, '   = styleLineAxes');
writeln(fOut,'# ', pixWidthLineAxes:nFmt);
writeln(fOut,'# ', mmWidthLineAxes:rFmt:dFmt);
writeln(fOut,'# ', colLineAxes:9);
writeln(fOut,'# ', colTextAxes:9);

{ indication sur la prsence, couleur etc. d'un cadre de la fentre 1 }
writeln(fOut,'# ', byte(fDrawBorderWin1):nFmt, '   = fDrawBorderWin1');
writeln(fOut,'# ', StyleWin1:nFmt);
writeln(fOut,'# ', pixWidthWin1:nFmt);
writeln(fOut,'# ', mmWidthWin1:rFmt:dFmt);
writeln(fOut,'# ', pcolBorderWin1^:9);
writeln(fOut,'# ', pcolWin1^:9);
writeln(fOut,'# ', pcolWin2^:9);

{ positionnement du titre et des lgendes des axes }
writeln(fOut,'# ',vCharXMoveTitle :7:2);
writeln(fOut,'# ',vCharYMoveTitle :7:2);
writeln(fOut,'# ',vCharXMoveXLegend :7:2);
writeln(fOut,'# ',vCharYMoveXLegend :7:2);
writeln(fOut,'# ',vCharXMoveYLegend :7:2);
writeln(fOut,'# ',vCharYMoveYLegend :7:2);
writeln(fOut,'# ',sizeTitle:6);
writeln(fOut,'# ',sizeTextGr:6);

{ Version 108  ajouter ici :}

nErr:=ioResult;
if (nErr <> 0) then exit;

{ a partir de la version 107, marque pour le dbut de sauvegarde de GrBase }
writeln(fOut, '# ...BEG _TGraphicBase');
pGrBase^.SaveGrBase(fOut, nErr);
if (nErr <> 0) then exit;

writeln(fOut, '# ...BEG _TGraphicSKEInfo');
SaveGraphicSKEInfo(fOut, nErr);  if (nErr <> 0) then exit;

{ Sauve les courbes du graphique (seulement celles visibles si dsir) }
writeln(fOut, '# ...BEG _TGAPGraphic Curves');

{ Sauve les courbes du graphique }
SaveGraphicCurves(fOut, nErr, Flags);

if (nErr <> 0) then exit;

{ Le fichier a t sauv une fois }
fIsNewFile    :=FALSE;
fHasChangedGr :=FALSE;

writeln(fOut, '# ...BEG _TGAPGraphic Personnal Treatement');
SaveGraphicPersonnalTreatement(fOut, nErr);  if (nErr <> 0) then exit;

writeln(fOut, '# ...END _TGAPGraphic');

nErr:=ioResult;
{$i+}
end;  { - TGapGraphic.SaveGraphic - }

procedure TGapGraphic.SaveGraphicName( strFilePath:TStrFilePath;
{=====================================} var nErr:integer; Flags:word);
{ Sauve les informations relative a un graphique.
  Ne pas surdfinir, mais utiliser :
  LoadGraphicPersonnalInfo et LoadGraphicPersonnalTreatement.
  Ouvre le fichier strFilePath comme fichier texte,
  puis appel SaveGraphic, avec les mmes erreurs et Flags.
  nErr:=IOResult ou
  erreurs de # SaveGraphic
-------------------------------------------------------------------------}
var
  nErr2            : integer;
  fOut             : text;
begin { - TGapGraphic.SaveGraphicName - }
if (pInfo <> NIL) then pInfo^.UpdateStrFile(strFilePath);

assign(fOut, strFilePath);
{$i-}
rewrite(fOut);

SaveGraphic(fOut, nErr, Flags);
nErr2:=ioResult; nErr2:=nErr2;
if (nErr > 0) then begin
   ErrorWrite(nErr, strFilePath + ' SaveGraphicName');
   close(fOut);
   nErr2:=ioResult;
   exit;
   end;

close(fOut);
nErr:=ioResult;
if (nErr <> 0) then begin
   ErrorWrite(nErr, strFilePath + ' SaveGraphicName');
   exit;
   end;

{$i+}

{ mmorise le nom du fichier qui contient ce graphique }
strGraphicFilePath:=strFilePath;
end;  { - TGapGraphic.SaveGraphicName - }

procedure TGapGraphic.LoadGraphicFirstSignature(var fIn:Text; var nErr:integer);
{==============================================================================}
{ Lecture de la premire ligne d'un fichier de donnes.
  Est rdfini par une application qui permet de lire des donnes
  provenant d'autres applications.
------------------------------------------------------------------------}
var strS : TStr80;
begin { - TGapGraphic.LoadGraphicFirstSignature - }
{$i-}
{ premire ligne du fichier }
readln(fIn, strS);
nErr:=IOResult;

if (strS <> '# ...Signature : wGAPGr.pas Data File') then begin
   nErr:=errBadFileGraphic;
   exit;
   end;
{$i+}
end;  { - TGapGraphic.LoadGraphicFirstSignature - }

procedure TGapGraphic.LoadGraphicSignature(var fIn:Text; var nErr:integer);
{=========================================================================}
{ Cette procdure est destine a tre redfinie par l'utilisateur.
  Elle va de paire avec la procedure SaveGraphicSignature(fOut, nErr).
  Ne pas appeler le inherited LoadGraphicSignature(fIn, nErr);
  Permet de lire une signature reprsentant le type de donnes, telle que
  donnes  PMD  ou  donnes SKE  ou autre.
  Si pas le bon type de donnes, nErr <> 0.
  La gestion de message d'erreur doit se faire dans cette procdure, et
  nErr < 0 en cas d'erreurs de signature.
-------------------------------------------------------------------------}
begin { -  TGapGraphic.LoadGraphicSignature - }
{$i-}
readln(fIn);  { ignore la signature du dveloppeur-utilisateur }
nErr:=IOResult;
{$i+}
end;  { -  TGapGraphic.LoadGraphicSignature - }

procedure TGapGraphic.LoadGraphicPersonnalInfo(var fIn:Text; var nErr:integer);
{==============================================================================}
{ Cette procdure est destine a tre redfinie par l'utilisateur.
  Elle va de paire avec la procedure SaveGraphicPersonnalInfo(fOut, nErr).
  Ne pas appeler le inherited SaveGraphicPersonnalInfo(fOut, nErr);
  ni le inherited LoadGraphicPersonnalInfo(fIn, nErr);
-------------------------------------------------------------------------}
var
  strS             : TStr80;
  nVersion         : integer;
  c1,c2            : char;

begin { -  TGapGraphic.LoadGraphicPersonnalInfo - }
{$i-}
{ version dveloppeur-utilisateur }
readln(fIn, strS);
if (strS = '# ...Signature : _TGAPGraphic Info') then begin
   readln(fIn, c1,c2, nVersion);  { ignore la version }  nVersion:=nVersion;
   end;

nErr:=IOResult;
{$i+}
end;  { -  TGapGraphic.LoadGraphicPersonnalInfo - }

procedure TGapGraphic.LoadGraphicPersonnalTreatement(var fIn:Text; var nErr:integer);
{==============================================================================}
{ Cette procdure est destine a tre redfinie par l'utilisateur.
  Elle va de paire avec la procedure SaveGraphicPersonnalTreatement(fOut, nErr).
  Ne pas appeler le inherited SaveGraphicPersonnalTreatement(fOut, nErr);
  ni le inherited LoadGraphicPersonnalTreatement(fIn, nErr);
-------------------------------------------------------------------------}
var
  strS             : TStr80;
  nVersion         : integer;
  c1,c2            : char;

begin { - TGapGraphic.LoadGraphicPersonnalTreatement - }
{$i-}
{ version dveloppeur-utilisateur }
readln(fIn, strS);
if (strS = '# ...Signature : _TGAPGraphic Treat') then begin
   readln(fIn, c1,c2, nVersion);  { ignore la version } nVersion:=nVersion;
   end;
nErr:=IOResult;
{$i+}
end;  { - TGapGraphic.LoadGraphicPersonnalTreatement - }

procedure TGapGraphic.LoadGraphicCurves(
{======================================}
  var fIn          : text;
      nVersion,
      nbCurves     : integer;
  var nErr         : integer;
      Flags        : word
  );
{ Charge les courbes du graphique.
  N'est gnralement pas tandu ni redfini.
  nVersion  <= 104, ancienne manire, on avait pas de version
                    spcifique  LoadGraphicCurves.
  Flags = 0, les mmes que LoadGraphic.
-------------------------------------------------------------------------}
var
  strS             : TStr60;
  nVersion2        : integer;

  { info sur une courbe }
  nn,
  nIndMax,
  nIndMaxAbs       : integer;
  fDraw            : boolean;

  pCu              : PGAPCurve;
  c1,c2            : char;

begin { - TGapGraphic.LoadGraphicCurves - }
{$i-}
if (nVersion >= 105) then begin
   readln(fIn, strS);  { signature de LoadGraphicCurves }
                       { = '# ...Signature : _TGAPGraphic SaveGraphicCurves' }
   readln(fIn,c1,c2, nVersion2);  { version de   LoadGraphicCurves } nVersion2:=nVersion2;
   nErr:=IOResult;
   if (nErr <> 0) then exit;
   end;
{$i+}

{ charge les courbes du graphique }
for nn:=1 to nbCurves do begin
   if (nbCu < VINGT) then begin
      { information sur la courbe  charger. Lit l'indice maximal
        (=nb de points -1) d'une courbe, pour allouer dynamiquement
        en mmoire la place ncssaire, avant le chargement. }
      LoadCurveIndMax(fIn, nIndMax, nIndMaxAbs, fDraw, nErr);
      if (nErr <> 0) then exit;

      { alloue et initialise une nouvelle courbe }
      pCu:=glfnNewCurve(nIndMax, nIndMaxAbs, flaAutoDisposeSelf);

      pCu^.LoadCurve(fIn, nErr, flags or flaCurveLoadDefineX);

      if (nErr <> 0) then begin
{         if (nErr > 0) then ErrorWrite(nErr, '');}
         exit;
         end;

      { ajoute la courbe au graphique }
      AddCurve(pCu, nErr);
      if (nErr <> 0) then begin
{         if (nErr > 0) then ErrorWrite(nErr, '');}
         exit;
         end;
      end
   else nErr:=errTooManyCurves; { erreur, trop de courbes charges dans le graphique }

   if (nErr <> 0) then begin
{         if (nErr > 0) then ErrorWrite(nErr, '');}
      exit;
      end;
   end; { - for nn:=1 to nbCurves do begin - }
end;  { - TGapGraphic.LoadGraphicCurves - }

procedure TGAPGraphic.LoadGraphicSKEInfo(var fIn:Text; var nErr:integer);
{=======================================================================}
{ est destin  tre utilis que dans wSKEVar, pas redfini ni tandu.
  c.f. SaveGraphicPersonnalInfo pour sauver des informations utilisateur. }
var
  strS             : TStr60;

begin { - TGAPGraphic.LoadGraphicSKEInfo - }
{$i-}
readln(fIn, strS);
readln(fIn, strS); { = readln(fIn,c1,c2, nVersion);}

nErr:=IOResult;
{$i+}
end;  { - TGAPGraphic.LoadGraphicSKEInfo - }

procedure TGapGraphic.LoadGraphic(var fIn:Text; var nErr:integer; Flags:word);
{============================================================================}
{ Charge les informations relative a une courbe.
  Ne pas surdfinir, mais utiliser :
  LoadGraphicPersonnalInfo et LoadGraphicPersonnalTreatement.
  OUTPUT :
  nErr =    0 => pas d'erreurs
       = errEOFTooEarly => Fin de fichier atteind avant la normale
       = nErr de LoadInfo
       = nErr de IOResult
       = nErr de LoadGraphicPersonnalInfo
       = nErr de LoadGraphicPersonnalTreatement

  INPUT :
  Flags = 0
-------------------------------------------------------------------------}
var
  strS             : string[80];
  nbCurves,
  nVersion         : integer;
  c1,c2            : char;

  function Search(strFind:TStr60):boolean;
  {======================================}
  { Recherche dans le fichier fIn le string strFind.
    retourne TRUE si trouv, FALSE sinon.
    met nErr  errEOFTooEarly si pas trouv.
  -----------------------------------------------------}
  begin { - Search - }
  {$i-}
  repeat
      readln(fIn, strS);
      until (strS = strFind) or EOF(fIn);

  Search:=FALSE;
  nErr:=IOResult;
  if (nErr <> 0) then exit;

  if (strS <> strFind) then begin
     nErr:= errEOFTooEarly; { EOF reached too early }
     exit;
     end;

  Search:=TRUE;
  {$i+}
  end;  { - Search - }

begin { - TGapGraphic.LoadGraphic - }
{===================================}
nErr:=0;
{$i-}

{ Signature commune  toutes les applications WINDOWS utilisant wGAPGr.pas }
{ Doit tre gale   '# ...Signature : wGAPGr.pas Data File' }
LoadGraphicFirstSignature(fIn, nErr);
if (nErr <> 0) then exit;

{ Permet de lire une signature reprsentant le type de donnes, telle que
  donnes  PMD  ou  donnes SKE  ou autre.
  Si pas le bon type de donnes, nErr <> 0.
  La gestion de message d'erreur doit se faire dans cette procdure, et
  nErr < 0 en cas d'erreurs }
LoadGraphicSignature(fIn, nErr);
if (nErr <> 0) then exit;

{ cherche le dbut du graphique }
if not Search('# ...Signature : _TGAPGraphic') then exit;

{ code de version du dveloppeur de librairie }
readln(fIn,c1,c2, nVersion);

{ Lit le nombre de courbes sauves }
readln(fIn,c1,c2, nbCurves);

{ Y a-t-il des informations associes }
readln(fIn, strS);

if (pInfo <> NIL) and (strS = '# ...With _TGAPInfo') then begin
   pInfo^.LoadInfo(fIn, nErr);
   if (nErr <> 0) then exit;
   end;

{ informations supplmentaires pour le dveloppeur-utilisateur }
if not Search('# ...BEG _TGAPGraphic Personnal Info') then exit;
LoadGraphicPersonnalInfo(fIn, nErr);  if (nErr <> 0) then exit;

{ Lecture des information habituelles pour la librairie }
if not Search('# ...BEG _TGAPGraphic Information') then exit;

{ titre de la fentre contenant le graphique }
if (nVersion >= 101) then readln(fIn,c1,c2, strWindowTitle);

{ information habituelles pour la librairie }
{ Titre et lgende des axes }
readln(fIn,c1,c2, strTitle);
readln(fIn,c1,c2, strXLegend);
readln(fIn,c1,c2, strYLegend);
if (nVersion >= 104) then readln(fIn,c1,c2, colTextTitle);

{ Flags de l'autoaxes, pour le dessin des axes du graphique }
readln(fIn,c1,c2, lAxesFlags);

{ indication sur la couleur et le style du graphique,
  est dfini dans l'Init, mais est modifiable }
readln(fIn,c1,c2, styleLineAxes);
readln(fIn,c1,c2, pixWidthLineAxes);
readln(fIn,c1,c2, mmWidthLineAxes);
readln(fIn,c1,c2, colLineAxes);
if (nVersion >= 103) then readln(fIn,c1,c2, colTextAxes);

{ indication sur la prsence, couleur etc. d'un cadre de la fentre 1 }
readln(fIn,c1,c2, byte(fDrawBorderWin1));
readln(fIn,c1,c2, StyleWin1);
readln(fIn,c1,c2, pixWidthWin1);
readln(fIn,c1,c2, mmWidthWin1);
readln(fIn,c1,c2, colBorderWin1UnUse);

if (nVersion >= 102) then begin
   readln(fIn,c1,c2, colWin1UnUse);
   readln(fIn,c1,c2, colWin2UnUse);
   end;

if (nVersion >= 106) then begin
   { positionnement du titre et des lgendes des axes }
   readln(fIn,c1,c2,vCharXMoveTitle);
   readln(fIn,c1,c2,vCharYMoveTitle);
   readln(fIn,c1,c2,vCharXMoveXLegend);
   readln(fIn,c1,c2,vCharYMoveXLegend);
   readln(fIn,c1,c2,vCharXMoveYLegend);
   readln(fIn,c1,c2,vCharYMoveYLegend);
   readln(fIn,c1,c2,sizeTitle);
   readln(fIn,c1,c2,sizeTextGr);
   end;

{ Version 108  ajouter ici :
  if (nVersion >= 108) then begin
  ...
  end;}

nErr:=ioResult;
if (nErr <> 0) then exit;

if (nVersion >= 107) then begin
   if not Search('# ...BEG _TGraphicBase') then exit;
   pGrBase^.LoadGrBase(fIn, nErr);
   if (nErr <> 0) then exit;
   end;

if (nVersion >= 108) then begin
   if not Search('# ...BEG _TGraphicSKEInfo') then exit;
   LoadGraphicSKEInfo(fIn, nErr);
   if (nErr <> 0) then exit;
   end;

if not Search('# ...BEG _TGAPGraphic Curves') then exit;

{ Charge les courbes du graphique. }
LoadGraphicCurves(fIn, nVersion, nbCurves, nErr, Flags);
if (nErr <> 0) then exit;

{ Le fichier a t sauv une fois }
fIsNewFile     :=FALSE;
fHasChangedGr :=FALSE;

{ Informations supplmentaires pour le dveloppeur-utilisateur }
if not Search('# ...BEG _TGAPGraphic Personnal Treatement') then exit;
LoadGraphicPersonnalTreatement(fIn, nErr);  if (nErr <> 0) then exit;

{ recherche de fin }
if not Search('# ...END _TGAPGraphic') then exit;

nErr:=ioResult;
{$i+}
end;  { - TGapGraphic.LoadGraphic - }

procedure TGapGraphic.LoadGraphicColumn(var fIn:text; var nErr:integer; Flags:word);
{==================================================================================}
{ Essaie de charger des colonnes de nombres comme graphique.
  retourn nErr = errBadFileGraphic, si pas une table de colonnes de nombres.
  Flags = 0
----------------------------------------------------------------}
var
  pCu              : PGAPCurve;
  strS             : TStr120;
  nbLineAt0,       { nombre de lignes non valides }
  nbLineAt1,       { nombre de lignes ayant un nombre uniquement }
  nbLineAt2,       { nombre de lignes ayant deux nombres }
  nbVal,           { nombre de valeurs dans la ligne (0,1 ou 2) }
  nbData,          { compteur de points dans la courbe }
  nCpt,            { compteur des premier points }
  nn               : integer;
  vXVal,
  vYVal
                   : Float;
  avX,avY          : array[1..20] of Float;  { premires valeurs lues }
  fTwoCol          : boolean;  { est-ce un fichier  deux colonne ? }

  pavX,pavY        : PArrayFloat;

   procedure GetFirstValues(strS:TStr120; var vXVal,vYVal:Float; var nbVal:integer);
   {===============================================================================}
   { Retourne dans nbVal le nombre de nombre qui se trouve dans strS. (0,1 ou 2)
     Dans vXVal et vYVal, retourne les nombres.
   ------------------------------------------------------------------------}
   var
     nEnd,
     nLen,
     nn               : integer;

   begin { - GetFirstValues - }
   nbVal:=0; { par dfaut, il n'y a aucun nombre dans le string strS }
   nLen:=length(strS);

   { 1) recherche le 1er caractre non blanc et non tabulation }
   nn:=0;
   repeat inc(nn); until (nn > nLen) or
          ((strS[nn] <> ' ') and (strS[nn] <> #9));

   { test si on a trouv un nombre }
   if (nn > nLen) or not (strS[nn]  in ['0'..'9', '-', '+', '.']) then exit;

   { valeur X du nombre }
   vXVal :=GetFloatValue(nn, strS, nEnd);
   if (nEnd = 0) then exit;

   { une valeur trouve }
   nbVal:=1;

   { 2) recherche le 1er caractre non blanc }
   nn:=nEnd-1;
   repeat inc(nn); until (nn > nLen) or
          ((strS[nn] <> ' ') and (strS[nn] <> #9));

   { test si on a trouv un nombre }
   if (nn > nLen) or not (strS[nn]  in ['0'..'9', '-', '+', '.']) then exit;

   { valeur Y du nombre }
   vYVal :=GetFloatValue(nn, strS, nEnd);
   if (nEnd = 0) then exit;

   { une valeur trouve }
   nbVal:=2;
   end;  { - GetFirstValues - }

begin { - TGapGraphic.LoadGraphicColumn - }
{=========================================}
{ Cherche si On peut accepter ce fichier comme une table de nombre, et
  si il faut considrer la table comme ayant une ou deux colonnes. }
{----------------------------------------------------------------------}
nbLineAt0:=0;
nbLineAt1:=0;
nbLineAt2:=0;
nCpt:=0;
{$i-}
repeat
   readln(fIn, strS);
   nErr:=IOResult;
   if (nErr <> 0) then exit;
   GetFirstValues(strS, vXVal, vYVal, nbVal);

   if (nbVal = 0) then begin
      inc(nbLineAt0);

      { Il faut que les lignes trouves soit conscutives }
      nCpt:=0;
      nbLineAt1:=0;
      nbLineAt2:=0;
      end
   else if (nbVal = 1) then begin
      { une seule valeur dans le string strS }
      inc(nbLineAt1);
      inc(nCpt);
      avX[nCpt]:=vXVal;
      avY[nCpt]:=-1.1e34;  { code que Y non valide }
      end
   else { if (nbVal = 2) then } begin
      inc(nbLineAt2);
      inc(nCpt);
      avX[nCpt]:=vXVal;
      avY[nCpt]:=vYVal;
      end

   until EOF(fIn) or (nCpt >= 20) or (nbLineAt0 >= 100);

if (nbLineAt0 >= 100) or
   (EOF(fIn) and (nCpt < 2 + nbLineAt0)) then begin
   { Le fichier  trop de lignes non valides, il est refus comme fichier
     de donnes }
   nErr:=errBadFileGraphic;
   exit;
   end;

{-----------------------------------------------------------------------}
{ ICI le fichier est considr comme contenant une courbe valide. }
{ On dcide si il s'agit d'une description de une ou deux colonnes }
fTwoCol:=(nbLineAt1 < nbLineAt2);

{ alloue la mmoire pour sauvegarder les points lu. }
new(pavX);
new(pavY);
nbData:=-1;

{ premires donnes de la courbe }
if not fTwoCol then begin
   for nn:=1 to nCpt do begin
      inc(nbData);
      pavX^[nbData]:=nbData;
      pavY^[nbData]:=avX[nn];
      end;
   end
else for nn:=1 to nCpt do if (avY[nn] > -1e34) then begin
   inc(nbData);
   pavX^[nbData]:=avX[nn];
   pavY^[nbData]:=avY[nn];
   end;

{ Suite de lecture des donnes de la courbe. }
while (not EOF(fIn)) and (nbLineAt0 < 140) and (nbData < cteIndMaxFloat) do begin
   readln(fIn, strS);
   nErr:=IOResult;
   if (nErr <> 0) then exit;

   GetFirstValues(strS, vXVal, vYVal, nbVal);

   if (nbVal = 0) or (fTwoCol and (nbVal = 1)) then begin
      { ligne non valide }
      inc(nbLineAt0);
      end
   else begin
      { ligne valide }
      inc(nbData);

      if fTwoCol then begin
         pavX^[nbData]:=vXVal;
         pavY^[nbData]:=vYVal;
         end
      else begin
         pavX^[nbData]:=nbData;
         pavY^[nbData]:=vXVal;
         end;
      end; { - if (nbVal = 0) or (fTwoCol and (nbVal = 1)) then begin - }
   end; { - while - }

{$i+}
{ alloue et initialise une nouvelle courbe }
pCu:=glfnNewCurve(nbData, nbData, flaAutoDisposeSelf);

{ Copie des donnes dans la courbe }
for nn:=0 to nbData do begin
   pCu^.pXD^[nn]:=pavX^[nn];
   pCu^.pYD^[nn]:=pavY^[nn];
   end;

dispose(pavY);   dispose(pavX);

AddCurve(pCu, nErr);
pCu^.InitForDraw(nbData);
nErr:=0;
end;  { - TGapGraphic.LoadGraphicColumn - }

procedure TGapGraphic.LoadGraphicName( strFilePath:TStrFilePath;
{====================================} var nErr:integer; Flags:word);
{ Charge les informations relative a un graphique.
  Ne pas surdfinir, mais utiliser :
  LoadGraphicPersonnalInfo et LoadGraphicPersonnalTreatement.
  Ouvre le fichier strFilePath comme fichier texte,
  puis appel LoadGraphic, avec les mmes erreurs et Flags.
  nErr = IOResult ou
       = nErr de LoadGraphic
  Flags = 0 ou
  Flags = flaNoChangeWindowTitle
  Flags = flaNoLoadOtherData
  -------------------------------------------------------------------------}
var
  fIn              : text;
  nErr2,
  nn               : integer;

begin { - TGapGraphic.LoadGraphicName - }
{ mmorise le nom du fichier qui contenait ce graphique }
strGraphicFilePath:=strFilePath;

assign(fIn, strFilePath);
{$i-}
FileMode := 0;  { Set file access to read only }
reset(fIn);
FileMode := 2;  { Set file access to read/write }

LoadGraphic(fIn, nErr, Flags);
nn:=ioResult;
close(fIn);
nn:=ioResult;

if (nErr > 0) and ((Flags and flaNoLoadOtherData) = 0) then begin
   { Essaie de charger une ou des colonnes de chiffres comme courbes. }
   FileMode := 0;  { Set file access to read only }
   reset(fIn);
   FileMode := 2;  { Set file access to read/write }
   LoadGraphicColumn(fIn, nErr2, Flags);
   if (nErr2 = 0) then nErr:=0;
   close(fIn);
   nn:=ioResult;
   end; { - if (nErr > 0) then begin - }

if (nErr > 0) then begin
   ErrorWrite(nErr, strFilePath);
   exit;
   end;

if (nErr <> 0) then exit;

nErr:=nn;
{$i+}

{ change le titre de la fentre, si pas demand autrement explicitement }
if ((Flags and flaNoChangeWindowTitle) = 0) then begin
   strWindowTitle :=GetMsg(msgLoadGraphicWinTitle);
   if (pInfo <> NIL) then begin
      pInfo^.UpdateStrFile(strFilePath);
      strWindowTitle :=strWindowTitle + pInfo^.GetFilePath;
      end;
   end;

if (nErr > 0) then begin
   ErrorWrite(nErr, strFilePath);
   exit;
   end;
end;  { - TGapGraphic.LoadGraphicName - }

{************************************************************************}
{*********  OBJECT TGAPWindow }
{************************************************************************}

{ - constructeur et destructeur - }
{ ------------------------------- }
constructor TGAPWindow.Init(pWin1:PWindow0; strTitle:string;
                            pGr:PGraphicBase; Flags0:word);
{==============================================================}
var
  nn               : integer;

begin { - TGAPWindow.Init - }
inherited Init(strTitle);

wIdentity :=13269; { NE PAS MODIFIER. Indique que initialis }

// indication du parent.
poParent:=pWin1;

// indqiue une nouvelle fentre enfant,  la fentre parent
if (pWin1 <> nil) then pWin1^.AddChildObjectWindow(@self);

// Give a name to this window, to remember its position
strWindowName:='A new Graphic Window';

{ Si = NIL, il sera initialis ici }
pGrBaseW:=pGr;

{ Si <> NIL, indique  quel TGAPGraphic il faut envoyer les informations
  d'actions de la souris }
pGAPGrMouseWM :=NIL;

{ indique si la fentre  captur la souris }
fMouseCaptured := FALSE;

{ graphiques de la fentre }
for nn:=1 to DIX do apGr[nn]:=NIL;
nbGr:=0;

{ Graphique actif de la fentre }
pActiveGraphic :=NIL;

{ pointeur sur pointeur sur cette fentre. }
ppglWindow:=NIL;

{ - peut tre utilis par des sous objets pour dfinir de
    quel objets il s'agit - }
nKind  :=0;

fIsCurveToCopy:=FALSE;
pCuToCopy:=NIL;
end;  { - TGAPWindow.Init - }

procedure TGAPWindow.WinCreate(strWinClass:ShortString);
//=====================================================
// Create the window, and insert an edit box and a status line in it.
var
  wD1,wD2,wD3,wD4,wD5, // data associated with the dialog file name
  wErrorL     : Word32;
begin
if (strWindowName <> '') and (gglpoPrm <> NIL) then begin
   gglpoPrm^.oSDL.GetStringDataW5(strWindowName, wD1,wD2,wD3,wD4,wD5,wErrorL);
   if (wErrorL = 0) then begin
      // Position set by the last position of the window
      // But size remains as computed (or set) otherwise.
      nLeft   :=wD1;
      nTop    :=wD2;
      nWidth  :=wD3;
      nHeight :=wD4;
      wSizeState:=wD5;
      end; // if (wErrorL = 0) then begin
   end; // if (strWindowName <> '') then begin

// here strWinClass=''.
inherited WinCreate(strWinClass);

{ Graphisme et texte de la fentre }
if (pGrBaseW = NIL) then begin
   new(pGrBaseW, Init(@Self));
   fDoDisposeGrBaseW:=TRUE;
   end
else begin
   fDoDisposeGrBaseW:=FALSE;
   end;
end;  // TWindowText0.WinCreate

destructor  TGAPWindow.Done;
{==========================}
var
  nn               : integer;
begin  { - TGAPWindow.Done - }
{ libre la mmoire alloue par TGAPWindow pour les graphique de cette fentre }
for nn:=1 to nbGr do begin
   if (apGr[nn] <> NIL) and
      (not IsBadWritePtr(apGr[nn], 1)) and (apGr[nn]^.wIdentity = 8347) and
      apGr[nn]^.fDoAutoDispose then dispose(apGr[nn], Done);
   end; { for nn:=1 to nbGr do begin }

for nn:=1 to nbGr do apGr[nn]:=NIL;
nbGr:=0;

{ Graphisme et texte de la fentre }
if fDoDisposeGrBaseW and (pGrBaseW <> NIL) then dispose(pGrBaseW, Done);
pGrBaseW:=NIL;

if (glpActiveWindow = @Self) then begin
   glpActiveWindow  :=NIL;
   glpActiveGraphic :=NIL;
   glpActiveCurve   :=NIL;
   end;

wIdentity :=0; { NE PAS MODIFIER. Indique que a t dtruit par Done }

// if (ppglWindow <> nil) then ppglWindow^:=nil; Risque d'erreur, pas une bonne ide, si la variable ppglWindow^ est locale

inherited Done;
end;  { - TGAPWindow.Done - }

procedure TGapWindow.RepaintDelayed;
{==================================}
{ pour envoyer un message demandant de redessiner la fentre, mais
  elle ne sera pas redessin immdiatement. (attend que les messages soient traits }
begin { - TGapWindow.RepaintDelayed - }
InvalidateRect(hWin, NIL, TRUE);
end;  { - TGapWindow.RepaintDelayed - }

procedure TGapWindow.Repaint;
{===========================}
var
  Msg              : TMsg;

begin { - TGapWindow.Repaint - }
InvalidateRect(hWin, NIL, TRUE);

{ pour laisser le Repaint faire sont action de dessiner }
while PeekMessage(Msg, 0, 0, 0, pm_Remove) do begin
   if not IsDialogMessage(0, Msg) then begin
      TranslateMessage(Msg);
      DispatchMessage(Msg);
      end;
   end;
end;  { - TGapWindow.Repaint - }

procedure TGapWindow.WMPaint(var Msg: TMSG);
{==============================================}
{ Peint les graphiques dans la fentre }
(*???
const  fCal : boolean = FALSE;
begin { - TGapWindow.WMPaint - }
{ Mthode radicale et pas joli, pour effacer toute la fentre avant de la redessiner.
  Mais je n'ai pas trouv une autre mtode!!!?? }

{ Si on ne fait pas ainsi, la fentre ne se redessine pas correctement! }
if not fCal then begin
  fCal:=TRUE;
  InvalidateRect(hWin, NIL, TRUE);
  exit;
  end;

fCal:=FALSE;
???*)
var
  hDcPaint    : hdc;
  rPS         : paintstruct;
  nn          : integer;

begin
hDcPaint:=BeginPaint(hWin, @rPS);

// While redrawing the window, tells the basic graphic the usable device context
pGrBaseW^.hDC0:=hDcPaint;

for nn:=1 to nbGr do apGr[nn]^.DrawGraphicOnGDI(hDcPaint, flaGraphicOnWindow);
//???if (pGAPGrMouseWM <> NIL) then pGAPGrMouseWM^.Paint;

EndPaint(hWin, rPS);

pGrBaseW^.hDC0:=0;
end;  { - TGapWindow.WMPaint - }

procedure TGapWindow.SetCapture0;
{===============================}
begin { - TGapWindow.SetCapture0 - }
SetCapture(hWin);
fMouseCaptured:=TRUE;
end;  { - TGapWindow.SetCapture0 - }

procedure TGapWindow.ReleaseCapture0;
{===================================}
begin { - TGapWindow.ReleaseCapture0 - }
if (fMouseCaptured) then ReleaseCapture;
fMouseCaptured:=FALSE;
end;  { - TGapWindow.ReleaseCapture0 - }

procedure TGapWindow.WMSize(var Msg: TMSG);
{============================================}
begin { - TGapWindow.WMSize - }
{ doit tre fait ici, car les dimensions de la fentre ont changes }
//???DefWndProc(Msg);

if (pGrBaseW <> NIL) and (pGrBaseW^.hDC0 <> 0) then pGrBaseW^.UpdateWin12Pos;
end;  { - TGapWindow.WMSize - }

Procedure TGAPWindow.SelectCurveUnderCursor(wX,wY,wKeys:word);
{============================================================}
{ Selectionne la courbe qui passe par le point (wX,wY) en coordonne
  d'cran. wKeys = tat du clavier, pour tester le Shift. }
var
  pGr              : PGAPGraphic;
  nErr             : integer;

begin { - TGAPWindow.SelectCurveUnderCursor - }
{ A chercher la courbe qui a t slectionn par la souris }
pGr:=GetGraphicSelectedByCursor(wX, wY);
if (pGr = NIL) then exit;

pCuToCopy:=pGr^.GetCurveSelectedByCursor( wX, wY);

if (pCuToCopy = NIL) then exit;

pGr^.SetActiveCurve(pCuToCopy, nErr);

{ A tester que l'on est bien dans la fentre 2 d'un graphique de GrBase }
{ A tester de quelle courbe on est le plus proche. et mmoriser cette courbe }
{ Indiquer dans l'infobar ce que l'on peut faire }

{ il y a une courbe  copier }
fIsCurveToCopy:=TRUE;
SetCapture(hWin);

hCursMove :=LoadCursor(hInstance, 'Cursor_Move_Curve');
hCursCopy :=LoadCursor(hInstance, 'Cursor_Copy_Curve');

if ((wKeys and MK_Shift) <> 0) then begin
   nCopyMove:=1;
   hCursOld:=SetCursor(hCursMove);
   end
else begin
   nCopyMove:=0;
   hCursOld:=SetCursor(hCursCopy);
   end;

hCursLast:=hCursOld;
end;  { - TGAPWindow.SelectCurveUnderCursor - }

Procedure TGAPWindow.CopySelectedCurve(var Msg: TMSG);
{========================================================}
{ Est destin  tre surclass }
begin { - TGAPWindow.CopySelectedCurve - }
end;  { - TGAPWindow.CopySelectedCurve - }

procedure TGapWindow.WMLButtonDown(var Msg: TMSG);
{====================================================}
begin { - TGapWindow.WMLButtonDown - }
if (pGAPGrMouseWM <> NIL) then pGAPGrMouseWM ^.WMLButtonDown(Msg)
else SelectCurveUnderCursor(LoWORD(Msg.lParam),HiWORD(Msg.lParam), Msg.wParam);
end;  { - TGapWindow.WMLButtonDown - }

procedure TGapWindow.WMLButtonUp(var Msg: TMSG);
{==================================================}
begin { - TGapWindow.WMLButtonUp - }
if (pGAPGrMouseWM <> NIL) then pGAPGrMouseWM ^.WMLButtonUp(Msg)
else CopySelectedCurve(Msg);
end;  { - TGapWindow.WMLButtonUp - }

procedure TGapWindow.WMMouseMove(var Msg: TMSG);
{==================================================}
begin { - TGapWindow.WMMouseMove - }
if not fMouseCaptured then exit;

if (pGAPGrMouseWM <> NIL) then pGAPGrMouseWM ^.WMMouseMove(Msg);
end;  { - TGapWindow.WMMouseMove - }

Procedure TGAPWindow.WmKeyDown(Var Msg:TMSG);
{===============================================}
{ Si on dplace une courbe d'un graphique dans un autre, change
  le curseur suivant l'tat de la touche shift }
begin { - TGAPWindow.WmKeyDown - }
if (not fIsCurveToCopy) then exit; { rien a copier }
if (Msg.wParam = VK_Shift) and (hCursLast <> hCursMove) then begin
   nCopyMove:=1;
   hCursLast :=hCursMove;
   SetCursor(hCursLast);
   end;
end;  { - TGAPWindow.WmKeyDown - }

Procedure TGAPWindow.WmKeyUp(Var Msg:TMSG);
{=============================================}
{ Si on dplace une courbe d'un graphique dans un autre, change
  le curseur suivant l'tat de la touche shift }
begin { - TGAPWindow.WmKeyUp - }
if (not fIsCurveToCopy) then exit; { rien a copier }
if (Msg.wParam = VK_Shift) and (hCursLast <> hCursCopy) then begin
   nCopyMove:=0;
   hCursLast :=hCursCopy;
   SetCursor(hCursLast);
   end;
end;  { - TGAPWindow.WmKeyUp - }

procedure TGAPWindow.AddGraphic(pGr1:PGAPGraphic; var nErr:integer);
{=====================================================================}
{ ajoute un graphique  une Window.
  nErr = 0 ou
  errTooManyGraphicsInWin.
------------------------------------}
begin { - TGAPWindow.AddGraphic - }
if (nbGr >= DIX) then begin nErr:=errTooManyGraphicsInWin; exit; end;

{ ajoute le graphique }
inc(nbGr);
apGr[nbGr]:=pGr1;

{ si il n'y avait pas de graphique actif dans la fentre,
  ce graphique devient le graphique actif de la fentre }
if (pActiveGraphic = NIL) then pActiveGraphic:=pGr1;

{ Si c'est la fentre active, alors cela peut changer le graphique et la
  courbe actifs }
if (glpActiveWindow = @Self) then begin
   glpActiveGraphic:=pActiveGraphic;
   if (pActiveGraphic <> NIL) then glpActiveCurve:=pActiveGraphic^.pActiveCurve
   else                            glpActiveCurve:=NIL;
   end;

{ indique au graphique dans quel fentre le dessiner }
pGr1^.pGAPWin:=@Self;
pGr1^.pGrBase^.pWnd0:=@Self;
nErr:=0;
end;  { - TGAPWindow.AddGraphic - }

function TGAPWindow.AddNewGraphic(nbCurves,nIndMaxAbs0:integer; Flags0:word):PGAPGraphic;
{======================================================================================}
{ Cre un nouveau graphique, avec de nouvelle courbes dedant.
  nbCurves    = nombre de courbes dans le graphique
  nIndMaxAbs0 = taille des courbes.

  Flags0 sera utilis  la cration des courbes et des graphiques

  retourn NIL en cas de problme, sinon
  retourn un pointeur sur le graphique.
-----------------------------------------------------------------}
var
  pGr              : PGAPGraphic;
  pCu              : PGAPCurve;
  nn,
  nErr             : integer;

begin { - TGAPWindow.AddNewGraphic - }
AddNewGraphic:=NIL;

if (nbGr >= DIX) or (nbCurves > VINGT) then exit;

pGr:=glfnNewGraphic(@Self, Flags0 or flaAutoDisposeSelf);

if (pGr = NIL) then begin
   { Erreur, pas normal }
   DBW(5, 'Erreur dans AddNewGraphic, pGr=NIL');
   exit;
   end;

if (nIndMaxAbs0 > 0) then for nn:=1 to nbCurves do begin
   pCu:=glfnNewCurve(nIndMaxAbs0, nIndMaxAbs0, Flags0 or flaAutoDisposeSelf);

   { Attache la courbe au graphique }
   pGr^.AddCurve(pCu, nErr);

   if (nErr <> 0) then begin
      { Erreur, pas normal }
      DBW(5, 'Erreur dans AddNewGraphic, AddCurve');
      dispose(pGr, done);
      exit;
      end;
   end; { for }

AddGraphic(pGr, nErr);

if (nErr <> 0) then begin
   { Erreur, pas normal }
   DBW(5, 'Erreur dans AddNewGraphic, AddGraphic');
   dispose(pGr, done);
   exit;
   end;

AddNewGraphic:=pGr;
end;  { - TGAPWindow.AddGraphic - }

procedure TGAPWindow.RemoveGraphic(pGr1:PGAPGraphic);
{======================================================}
{ Enlve le graphique de la Window }
var
  nn,kk            : integer;

begin { - TGAPWindow.RemoveGraphic - }
{ Enlve la rfrence au graphique }
{ Recherche parmis toutes les graphiques de la Window }
for nn:=1 to nbGr do begin
   if (apGr[nn] = pGr1) then begin
      { limine la rfrence au graphique Gr1 }
{      DBW(5, 'Rfrence enleve');}
      for kk:=nn to nbGr-1 do apGr[kk]:=apGr[kk+1];

      apGr[nbGr]:=NIL;
      dec(nbGr);
      end; { if (apGr[nn] = @Gr1) then begin }
   end; { for nn:=1 to nbGr do begin }

{ Si on a enlev le graphique actif de la fentre, un autre graphique devient actif }
if (pActiveGraphic = pGr1) then begin
   { Le premier graphique de la liste devient actif. }
   if (nbGr >= 1) then pActiveGraphic:=apGr[1] else pActiveGraphic:=NIL;
   end;

{ Si c'est la fentre active, alors cela peut changer le graphique et la
  courbe actifs }
if (glpActiveWindow = @Self) then begin
   glpActiveGraphic:=pActiveGraphic;
   if (pActiveGraphic <> NIL) then glpActiveCurve:=pActiveGraphic^.pActiveCurve
   else                            glpActiveCurve:=NIL;
   end;

{ Gr1 n'est plus dans une fentre }
pGr1^.pGAPWin:=NIL;
pGr1^.pGrBase^.pWnd0:=NIL;
end;  { - TGAPWindow.RemoveGraphic - }

procedure TGAPWindow.InitAfterNewWindow;
{======================================}
{ Est souvant redfini.
  Est appel dans wSKEVar.TSKEMDIWindow.CMFileOpen aprs qu'un fentre ait
  t cre et que un graphique ait t charg, et lui a t assign.
  Peut tre utile pour :
  - Changer le titre de la fentre en fonction du graphique qu'il contient
  - Changer les flags d'un menu spcifique  cette fentre.
-------------------------------------------------------------------------}
begin  { - TGAPWindow.InitAfterNewWindow - }
if (pActiveGraphic <> NIL) then
   SetWindowText(hWin, AZT(pActiveGraphic^.strWindowTitle));
end;  { - TGAPWindow.InitAfterNewWindow - }

procedure TGAPWindow.WMActivate(var Msg: TMSG);
{===================================================}
{ Msg.wParam = 0 => la fentre est dsactivate,
  sinon          => la fentre est active
  WMActivate est appel avant WinCreate.
  dfini dans glpActive..., la fentre, le graphic et la courbe actifs.
-------------------------------------------------------------------------}
begin { - TSKEMDIChild.WMActivate - }
if (Msg.wParam = 0 {dsactivate}) then begin
//???   glpActiveWinObj  :=NIL;
   glpActiveWindow  :=NIL;
   glpActiveGraphic :=NIL;
   glpActiveCurve   :=NIL;
   end
else begin {activate }
//???   glpActiveWinObj  :=@Self;
   glpActiveWindow  :=@Self;
   glpActiveGraphic :=pActiveGraphic;
   if (pActiveGraphic <> NIL) then glpActiveCurve :=pActiveGraphic^.pActiveCurve
   else                            glpActiveCurve :=NIL;
   end;
end;  { - TGAPWindow.WMActivate - }

function TGAPWindow.GetGrBaseForPrinting(Flags1:word):PGraphicBase;
{==========================================================================}
{ Est appel pour demander le graphique de base servant  l'impression.
  Par dfaut retourne le device contexte du graphique actif. car c'est
  gnralement lui que l'on veut imprimer. Si il n'y a pas de
  graphique actif, retourn NIL. Cela signifie que l'on annule
  la demande d'impression.
  Le device contexte  GrBase.hDC0  doit tre = 0, i.e. none ouvert.
  Flags1 = 1 => impression
  Flags1 = 2 => prvisualisation
-----------------------------------------------------------------------}
begin { - TGAPWindow.GetGrBaseForPrinting - }
if (pActiveGraphic <> NIL) then
     GetGrBaseForPrinting:=pActiveGraphic^.pGrBase
else GetGrBaseForPrinting:=NIL;
end;  { - TGAPWindow.GetGrBaseForPrinting - }

procedure TGAPWindow.OutputForPrinter(pGrBase2:PGraphicBase; Flags1:word);
{========================================================================}
{ par dfaut n'imprime que le grahique, peut tre tandu ou redfini.
  Est appel pour faire une impression ou une prvisualisation
  d'impression.
  pGrBase2^.hDC0 = un device contexte valide pour dessiner.
  Flags1 = 1 => impression
  Flags1 = 2 => prvisualisation
-----------------------------------------------------------------------}
{ Impression du graphique, avec des informations, sur papier }
begin { - TGAPWindow.OutputForPrinter - }
if (glpActiveWindow = NIL) or (glpActiveGraphic = NIL) then exit;

with pGrBase2^ do begin

{DebugInfo(glpActiveGraphic^.pGrBase^.hDC0);}

{ dfini des marges par dfaut }
mmPrinterLeft  :=20;  relPrinterLeft:=0;
mmPrinterTop   :=10;   relPrinterTop:=0;
mmPrinterWidth :=160;    relPrinterWidth:=0;
mmPrinterHeight:=120;   relPrinterHeight:=0;

UpdateWin12Pos; { Tien compte des modifications de mmPrinterTop }

{ impression du graphique }
glpActiveGraphic^.DrawGraphic;

end; { - with pGrBase2^ do begin - }
end;  { - TGAPWindow.OutputForPrinter - }

function TGAPWindow.CopyWinTo(pWin:PGAPWindow; Flags1:word):PGAPWindow;
{=====================================================================}
{ Copie une fentre dans une autre, avec le contenu.
  Flags1 = 0 => copie tout, avec les graphes et courbes.
         = flaWinNoCopyGr =>
           Indication de ne pas copier les graphiques
         = flaGrNoCopyCurves =>
           Indication de ne pas copier les courbes des graphiques
  Si pWin = NIL, cre une nouvelle fentre, et retourne un pointeur dessus.
  sinon          retourne pWin
--------------------------------------------------------------}
var
  pGr              : PGAPGraphic;
  nn               : integer;
  fWinIsZoomed     : boolean;

begin { - TGAPWindow.CopyWinTo - }
fWinIsZoomed:=IsZoomed(hWin);

{ cration d'une nouvelle fentre, si ncssaire }
if (pWin = NIL) then pWin :=glfnNewWindow(0);

CopyWinTo:=pWin;

if (pWin = NIL) then exit; { pas normal }

{ Ne doivent pas tre chang! }
{ wIdentity  }
{ pGrBaseW }
{ fDoDisposeGrBase }
{ nKind  }

if ((Flags1 and flaWinNoCopyGr) = 0) then begin
   for nn:=1 to nbGr do begin
     { graphiques de la fentre }
      pGr :=glfnNewGraphic(pWin, 0); { pGr = NIL -> pas normal }
      if (pGr <> NIL) then pWin^.apGr[nn] :=apGr[nn]^.CopyGrTo(pGr, Flags1);
      end;

   pWin^.nbGr  :=nbGr;

   if (nbGr >= 1) then pWin^.pActiveGraphic :=pWin^.apGr[1];
   end
else begin
   pWin^.nbGr  :=0;
   pWin^.pActiveGraphic :=NIL;
   end;

{ Change sont titre }
pWin^.InitAfterNewWindow;

{ mme taille que la fentre d'origine, mais dcale }

{if IsIconic(hWin) then DBW('iconique');}
if fWinIsZoomed then exit;

{ Si la fentre initiale n'est pas zoome, dcale la copie, mais garde la
  mme taille de fentre. }
//???pWin^.Show(sw_ShowNormal);
MoveWindow(pWin^.hWin, nLeft+20, nTop+20, nWidth, nHeight, TRUE);
end;  { - TGAPWindow.CopyWinTo - }

function TGAPWindow.GetGraphicSelectedByCursor(nX,nY:integer):PGAPGraphic;
{========================================================================}
{ retourne un pointeur sur le graphique contenant le point (nX,nY)
  en coordonne de fentre client }
var
  pGrBase          : PGraphicBase;
  nn               : integer;

begin { - TGAPWindow.GetGraphicSelectedByCursor - }
nn:=0;

while (nn < nbGr) do begin
   inc(nn);
   pGrBase:=apGr[nn]^.pGrBase;

   if (nX >= pGrBase^.pixX1Left) and
      (nX <= pGrBase^.pixX1Left + pGrBase^.pixX1Width) and
      (ny >= pGrBase^.pixY1Top) and
      (ny <= pGrBase^.pixY1Top + pGrBase^.pixY1Height) then begin
      GetGraphicSelectedByCursor:=apGr[nn];
      exit;
      end;

   end; { while (nn < nbGr) do begin }

GetGraphicSelectedByCursor:=NIL;
end;  { - TGAPWindow.GetGraphicSelectedByCursor - }

function TGAPWindow.WMUGetObjectType:LRESULT;
{===========================================}
{ Ne pas redfinir cet mthode, mais utiliser nKind, pour savoir
  quelle est le degr de descendance.
  nKind =  0 pour TGAPWindow
  nKind = 10 pour TSKEWindow
  nKind = 21 pour TMONOSKEWindow
  nKind = 22 pour TMDISKEWindow
  nKind >= 30 pour TUser...  est conseill.
  Retourne cteTypeTGAPWindow dans Msg.Result,
  pour indiquer le type de fentre de cet objet.
  cteType... est dfini dans wConst.pas.
-----------------------------------------------------}
begin { - TGAPWindow.WMUGetObjectType - }
WMUGetObjectType:=cteTypeTGAPWindow;
end;  { - TGAPWindow.WMUGetObjectType - }

function TGAPWindow.WindowProcFirst(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT;
//===========================================================================================
// Handles messages for the library, before calling  WindowProc
var
  wErrorL     : word32;
begin
if (wMsg = WM_NCDestroy) then begin
   // If the window has a name, then its size and position can be associated
   // with it in the String - Data Link file. Save these values
   if (strWindowName <> '') and (gglpoPrm <> NIL) then begin
      gglpoPrm^.oSDL.SetStringDataW5(strWindowName, nLeft,nTop,nWidth,nHeight,wSizeState,wErrorL);
      end; // if (strWindowName <> '') then begin
   end;

WindowProcFirst:=inherited WindowProcFirst(hWindow, wMsg, wPar, lPar);
end;  // TGAPWindow.WindowProcFirst

function TGAPWindow.WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT;
//========================================================================================
// All window messages are send here.
var Msg: TMSG;

Begin
Msg.hwnd:=hWindow;
Msg.message:=wMsg;
Msg.wParam:=wPar;
Msg.lParam:=lPar;
//Msg.time:= type DWORD not used here
//Msg.pt:= type POINT, not used here

Case wMsg Of
  WM_Paint      : WMPaint(Msg); // must redraw the client area part.
  WM_Size       : WMSize(Msg);
  WM_LButtonDown : WMLButtonDown(Msg);
  WM_LButtonUp   : WMLButtonUp(Msg);
  WM_MouseMove   : WMMouseMove(Msg);
  WM_KeyDown     : WmKeyDown(Msg);
  WM_KeyUp       : WmKeyUp(Msg);
  WM_Activate    : WMActivate(Msg);
  WMU_GetObjectType : begin WindowProc:=WMUGetObjectType; exit; end;
  End; // Case wMsg Of

// Default processing of the messages.
WindowProc:=inherited WindowProc(hWindow, wMsg, wPar, lPar);
End;  // TGAPWindow.WindowProc


{************************************************************************}
{******** Procedures non objets }
{************************************************************************}

procedure CreateNewGrWindow(
{==========================}
  var pWin         : PGAPWindow;
  var pGr          : PGAPGraphic;
  var pCu          : PGAPCurve;
      indMaxAbs    { indice maximale possible de la courbe }
                   : integer;
      colLineCu0   { Couleur de la courbe, si il y en a une }
                   : TColorRef;
      strTitle0,   { Titre du graphique }
      strXLegend0, { lgende de l'axe X }
      strYLegend0  { lgende de l'axe Y }
                   : TStr160;
  var nErr         : integer);
{ Cration d'une nouvelle fentre, avec un graphique pGr et une courbe pCu,
  dimensionne [0..nIndMaxAbs].
  nErr = 0 si tout est OK.
  nErr <> 0 sinon, avec message explicatif
-------------------------------------------------------------------------}
begin { - CreateNewGrWindow - }
pWin :=glfnNewWindow(0);
if (pWin = NIL) then begin
   nErr:=errWindowNotCreated;
   ErrorWrite(nErr, '');
   exit;
   end;

pGr :=glfnNewGraphic(pWin, 0);
pWin^.AddGraphic(pGr, nErr);
if (pGr = NIL) or (nErr <> 0) then begin
   nErr:=errInAddNewGraphic;
   ErrorWrite(nErr, '');
   exit;
   end;
pGr^.strTitle    :=strTitle0;
pGr^.strXLegend  :=strXLegend0;
pGr^.strYLegend  :=strYLegend0;

if (indMaxAbs > 0) then begin
   pCu :=glfnNewCurve(indMaxAbs, indMaxAbs, 0);
   pGr^.AddCurve(pCu, nErr);
   if (pCu = NIL) or (nErr <> 0) then begin
      nErr:=errInAddNewCurve;
      ErrorWrite(nErr, '');
      exit;
      end;

   pCu^.colLineCu:=colLineCu0;
   end;

pWin^.InitAfterNewWindow; { initialisation de la fentre aprs sa cration }
nErr:=0;

{ pour mettre  NIL pWin dans le Done de la fentre }
pWin^.ppglWindow:=@pWin;
end;  { - CreateNewGrWindow - }

function InitGrWindow(
{====================}
  var pWin         : PGAPWindow;
      indMax0,     { indice max des donnes pavX^ et pavY^ }
      indMaxAbs    { indice maximale possible de la courbe (>= indMax0) }
                   : integer;
      colLineCu0   { Couleur de la courbe, si il y en a une }
                   : TColorRef;
      pavX,pavY    : PArrayFloat; {Donnes }
      strTitle0,   { Titre du graphique }
      strXLegend0, { lgende de l'axe X }
      strYLegend0  { lgende de l'axe Y }
                   : TStr160;
  var nErr         : integer
      ):PGAPCurve;
{ Si pWin = NIL, Cre la fentre pWin.
  Si il n'y a pas de graphique dedans, lui met un graphique dedant.
  Si (pavX <> NIL) et (pavY <> NIL) et (indMaxAbs > 0),
     met une courbe dans le graphique.
  Dans tous les cas, enlve autres courbes du graphique.
  Si (indMax0 > 0), met les informations pavX^ et pavY^ dans la courbe, et
     init. la courbe pour qu'elle se dessine.

  Retourne la courbe, nil si aucune courbe ajoute au graphique.
  Avec AddInGrWindow, on peut ainsi simplement ajouter des courbes
   un graphique.
----------------------------------------------------------}
var
  n2_1,
  nn               : integer;
  pGr              : PGAPGraphic;
  pCu              : PGAPCurve;

begin { - InitGrWindow - }
nErr:=0;
InitGrWindow:=NIL; { par dfaut, pas de courbes }

{ courbe pour dessin uniquement }
{ cre une nouvelle fentre graphique, avec une courbe dedant }
if (indMaxAbs < indMax0) then indMaxAbs :=indMax0;
if (pavX = NIL) or (pavY = NIL) then indMaxAbs:=0; { pas de courbe cre }

if (pWin = NIL) then begin
   CreateNewGrWindow( pWin, pGr, pCu, indMaxAbs, colLineCu0,
                      strTitle0, strXLegend0, strYLegend0, nErr);
   if (nErr <> 0) then begin
      DBW(1, 'Erreur dans la cration de Fentre InitGenGraphic');
      exit;
      end;
   end;

{ Si ncessaire, ajoute un graphique  la fentre }
if (pWin^.nbGr < 1) then begin
   pGr :=glfnNewGraphic(pWin, 0);
   pWin^.AddGraphic(pGr, nErr);
   if (pGr = NIL) or (nErr <> 0) then begin
      nErr:=errInAddNewGraphic;
      ErrorWrite(nErr, '');
      exit;
      end;
   end;

{ Graphique de la fentre }
pGr :=pWin^.apGr[1];
pGr^.strTitle    :=strTitle0;
pGr^.strXLegend  :=strXLegend0;
pGr^.strYLegend  :=strYLegend0;

{ enlve les courbes qui sont dans le graphique, et libre la mmoire }
if (pGr^.nbCu >= 1) then begin
   pCu :=pGr^.apCu[1];

   { Si la premire courbe a dj la bonne dimension, ne l'enlve pas,
     mais utilise l comme elle est. }
   if (indMaxAbs = pCu^.nIndMaxAbs) then n2_1:=2 else n2_1:=1;

   for nn:=pGr^.nbCu downto n2_1 do
      dispose(pGr^.apCu[nn], Done);  { fait le remove automat. }

   end;

if (indMaxAbs = 0) then exit; { pas de courbes  rajouter au graphique. }

{ si ncessaire, cre une nouvelle courbe, qui est ajoute au graphique }
if (pGr^.nbCu <= 0) then begin
   pCu :=glfnNewCurve(indMaxAbs, indMaxAbs, 0);
   pGr^.AddCurve(pCu, nErr);
   if (pCu = NIL) or (nErr <> 0) then begin
      nErr:=errInAddNewCurve;
      ErrorWrite(nErr, '');
      exit;
      end;
   end;

{ courbe du graphique }
pCu :=pGr^.apCu[1];

{ couleur de la courbe }
pCu^.colLineCu:=colLineCu0;

if (indMax0 > 0) then begin
   { Copie des informations de la courbe dans la courbe du graphique }
   move(pavX^, pCu^.pXD^, (indMax0+1) * word(SizeOf(Float)));
   move(pavY^, pCu^.pYD^, (indMax0+1) * word(SizeOf(Float)));
   { Manire quivalente de faire, mais plus lente :
   with pCu^ do for nn:=0 to indMax0 do begin
      pXD^[nn]:=pavX^[nn];
      pYD^[nn]:=pavY^[nn];
      end;}

   pCu^.InitForDraw(indMax0);
   end;

{ oblige la fentre de se redessiner }
pWin^.RePaintDelayed;

InitGrWindow:=pCu;
end;  { - InitGrWindow - }

function AddInGrWindow(
{=======================}
  var pWin         : PGAPWindow;
      indMax0,     { indice max des donnes pavX^ et pavY^ }
      indMaxAbs    { indice maximale possible de la courbe (>= indMax0) }
                   : integer;
      colLineCu0   { Couleur de la courbe, si il y en a une }
                   : TColorRef;
      pavX,pavY    : PArrayFloat; {Donnes }
  var nErr         : integer
      ):PGAPCurve;
{ Si (pWin = NIL) ou il n'y a pas de graphique dans pWin,
     Appel InitGrWindow, sans titre ni labels. Ne fait rien d'autre.
  Si (pavX <> NIL) et (pavY <> NIL) et (indMaxAbs > 0),
     ajoute une courbe dans le graphique.
  Si (indMax0 > 0), met les informations pavX^ et pavY^ dans la courbe, et
     init. la courbe pour qu'elle se dessine.

  Retourne la courbe, nil si aucune courbe ajoute au graphique.
  Avec AddInGrWindow, on peut ainsi simplement ajouter des courbes
   un graphique.
----------------------------------------------------------}
var
  pGr              : PGAPGraphic;
  pCu              : PGAPCurve;

begin { - AddInGrWindow - }
nErr:=0;
AddInGrWindow:=NIL; { par dfaut }

{ si ncessaire, cre la fentre }
if (pWin = NIL) or (pWin^.nbGr < 1) then begin
   AddInGrWindow:=InitGrWindow( pWin, indMax0, indMaxAbs, colLineCu0, pavX, pavY,
                                '', '', '', nErr);
   exit;
   end;

{ Test si il faut crer une courbe }
if (indMaxAbs < indMax0) then indMaxAbs :=indMax0;
if (pavX = NIL) or (pavY = NIL) or (indMaxAbs = 0) then exit; { rien  faire }

pGr :=pWin^.apGr[1];

{ On ajoute une courbes dans le graphique }
pCu:=pGr^.AddNewCurve(indMaxAbs, 0);
if (pCu = NIL) or (nErr <> 0) then begin
   nErr:=errInAddNewCurve;
   ErrorWrite(nErr, '');
   exit;
   end;

pCu^.colLineCu:=colLineCu0;

{ couleur de la courbe }
pCu^.colLineCu:=colLineCu0;

if (indMax0 > 0) then begin
   { Copie des informations de la courbe dans la courbe du graphique }
   move(pavX^, pCu^.pXD^, (indMax0+1) * word(SizeOf(Float)));
   move(pavY^, pCu^.pYD^, (indMax0+1) * word(SizeOf(Float)));
   { Manire quivalente de faire, mais plus lente :
   with pCu^ do for nn:=0 to indMax0 do begin
      pXD^[nn]:=pavX^[nn];
      pYD^[nn]:=pavY^[nn];
      end;}

   pCu^.InitForDraw(indMax0);
   end;

{ oblige la fentre de se redessiner }
pWin^.RePaintDelayed;

AddInGrWindow:=pCu;
end;  { - AddInGrWindow - }


{ *** UNIT wGraphic0 *** }
end.

